/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/path","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/network","vs/nls","vs/nls!vs/server/remoteExtensionHostAgent","vs/base/common/types","vs/base/common/errors","vs/base/common/strings","vs/base/common/arrays","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/async","vs/base/common/buffer","vs/base/common/objects","vs/base/common/uuid","fs","vs/base/common/resources","os","vs/platform/files/common/files","vs/base/common/map","vs/platform/product/common/product","vs/base/common/cancellation","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/registry/common/platform","child_process","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/configuration/common/configuration","vs/base/common/json","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/server/remoteUriTransformer","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetry","vs/base/parts/ipc/node/ipc.net","vs/base/common/stream","vs/base/common/glob","vs/base/common/marshalling","vs/base/common/performance","util","vs/platform/contextkey/common/contextkey","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/common/iterator","vs/base/common/labels","vs/base/common/uriIpc","vs/editor/common/core/range","vs/platform/environment/node/argv","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","crypto","vs/platform/request/common/request","url","vs/platform/telemetry/common/telemetryUtils","vs/workbench/services/editor/common/editorService","vs/base/node/zip","vs/server/serverEnvironmentService","vs/base/common/functional","vs/base/common/severity","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/node/decoder","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/files/common/fileService","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/workspace/common/workspace","vs/server/remoteExtensionManagement","vs/server/remoteLanguagePacks","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminal","vs/workbench/contrib/terminal/node/terminalEnvironment","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/extensionHostConnection","vs/base/common/assert","vs/base/common/decorators","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/amd","vs/base/common/console","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/mime","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/paths","vs/base/node/extpath","vs/base/node/ports","vs/base/node/watcher","vs/editor/common/modes/languageSelector","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/remoteAgentEnvironmentImpl","vs/nls!vs/server/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/terminal/common/terminal","vs/nls!vs/workbench/contrib/terminal/node/terminalProcess","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/downloadIpc","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/editor/common/modes","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/argvHelper","vs/code/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/log/common/logIpc","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/workspaces/common/workspaces","vs/server/remoteAgentFileSystemImpl","vs/server/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalDataBuffering","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminal","vs/workbench/contrib/terminal/node/terminalProcess","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/api/common/extHostTypeConverters","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/node/extensionPoints","vs/server/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/platform/environment/node/environmentService","vs/server/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/remoteTerminalChannel","vs/server/remoteExtensionHostAgentServer","perf_hooks","string_decoder","path","minimist","assert","cookie","vs/base/common/marked/marked","yauzl","yazl","http","vs/server/remoteExtensionHostAgent"],de=function(Z){for(var e=[],y=0,m=Z.length;y<m;y++)e[y]=he[Z[y]];return e};define(he[107],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function y(m,I){if(!m)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=y}),define(he[108],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function y(g){return(t,R,_)=>{let P=null,v=null;if(typeof _.value=="function"?(P="value",v=_.value):typeof _.get=="function"&&(P="get",v=_.get),!v)throw new Error("not supported");_[P]=g(v,R)}}e.createDecorator=y;let m=0;function I(){const g=`$memoize${m++}`;let t;const R=function(P,v,c){let d=null,S=null;if(typeof c.value=="function"?(d="value",S=c.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",S=c.get),!S)throw new Error("not supported");const b=`${g}:${v}`;c[d]=function(...f){return t=this,this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,f)}),this[b]}};return R.clear=()=>{typeof t!="undefined"&&Object.getOwnPropertyNames(t).forEach(_=>{_.indexOf(g)===0&&delete t[_]})},R}e.createMemoizer=I;function E(g,t,R){return I()(g,t,R)}e.memoize=E;function C(g,t,R){return y((_,P)=>{const v=`$debounce$${P}`,c=`$debounce$result$${P}`;return function(...d){this[c]||(this[c]=R?R():void 0),clearTimeout(this[v]),t&&(this[c]=t(this[c],...d),d=[this[c]]),this[v]=setTimeout(()=>{_.apply(this,d),this[c]=R?R():void 0},g)}})}e.debounce=C;function L(g,t,R){return y((_,P)=>{const v=`$throttle$timer$${P}`,c=`$throttle$result$${P}`,d=`$throttle$lastRun$${P}`,S=`$throttle$pending$${P}`;return function(...b){if(this[c]||(this[c]=R?R():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),t&&(this[c]=t(this[c],...b)),!this[S]){const f=this[d]+g;f<=Date.now()?(this[d]=Date.now(),_.apply(this,[this[c]]),this[c]=R?R():void 0):(this[S]=!0,this[v]=setTimeout(()=>{this[S]=!1,this[d]=Date.now(),_.apply(this,[this[c]]),this[c]=R?R():void 0},f-Date.now()))}}})}e.throttle=L}),define(he[12],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(a=>{a(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}e.ErrorHandler=y,e.errorHandler=new y;function m(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=m;function I(f){g(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=I;function E(f){g(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=E;function C(f){if(f instanceof Error){let{name:u,message:a}=f;const o=f.stacktrace||f.stack;return{$isError:!0,name:u,message:a,stack:o}}return f}e.transformErrorForSerialization=C;const L="Canceled";function g(f){return f instanceof Error&&f.name===L&&f.message===L}e.isPromiseCanceledError=g;class t extends Error{constructor(){super(L);this.name=this.message}}e.CancellationError=t;function R(){const f=new Error(L);return f.name=f.message,f}e.canceled=R;function _(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=_;function P(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=P;function v(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function c(f){const u=new Error(`${f} has been disposed`);return u.name="DISPOSED",u}e.disposed=c;function d(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=d;class S extends Error{constructor(u){super("NotImplemented");u&&(this.message=u)}}e.NotImplementedError=S;class b extends Error{constructor(u){super("NotSupported");u&&(this.message=u)}}e.NotSupportedError=b}),define(he[14],de([0,1,12]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.mergeSort=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function m($,O=0){return $[$.length-(1+O)]}e.tail=m;function I($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=I;function E($,O,F=(j,Q)=>j===Q){if($===O)return!0;if(!$||!O||$.length!==O.length)return!1;for(let j=0,Q=$.length;j<Q;j++)if(!F($[j],O[j]))return!1;return!0}e.equals=E;function C($,O,F){let j=0,Q=$.length-1;for(;j<=Q;){const ne=(j+Q)/2|0,oe=F($[ne],O);if(oe<0)j=ne+1;else if(oe>0)Q=ne-1;else return ne}return-(j+1)}e.binarySearch=C;function L($,O){let F=0,j=$.length;if(j===0)return 0;for(;F<j;){const Q=Math.floor((F+j)/2);O($[Q])?j=Q:F=Q+1}return F}e.findFirstInSorted=L;function g($,O,F){if($=$|0,$>=O.length)throw new TypeError("invalid index");let j=O[Math.floor(O.length*Math.random())],Q=[],ne=[],oe=[];for(let ie of O){const fe=F(ie,j);fe<0?Q.push(ie):fe>0?ne.push(ie):oe.push(ie)}return $<Q.length?g($,Q,F):$<Q.length+oe.length?oe[0]:g($-(Q.length+oe.length),ne,F)}e.quickSelect=g;function t($,O){return _($,O,0,$.length-1,[]),$}e.mergeSort=t;function R($,O,F,j,Q,ne){let oe=F,ie=j+1;for(let fe=F;fe<=Q;fe++)ne[fe]=$[fe];for(let fe=F;fe<=Q;fe++)oe>j?$[fe]=ne[ie++]:ie>Q?$[fe]=ne[oe++]:O(ne[ie],ne[oe])<0?$[fe]=ne[ie++]:$[fe]=ne[oe++]}function _($,O,F,j,Q){if(!(j<=F)){const ne=F+(j-F)/2|0;_($,O,F,ne,Q),_($,O,ne+1,j,Q),!(O($[ne],$[ne+1])<=0)&&R($,O,F,ne,j,Q)}}function P($,O){const F=[];let j;for(const Q of t($.slice(0),O))!j||O(j[0],Q)!==0?(j=[Q],F.push(j)):j.push(Q);return F}e.groupBy=P;function v($,O,F){const j=[];function Q(ie,fe,Ie){if(!(fe===0&&Ie.length===0)){const Pe=j[j.length-1];Pe&&Pe.start+Pe.deleteCount===ie?(Pe.deleteCount+=fe,Pe.toInsert.push(...Ie)):j.push({start:ie,deleteCount:fe,toInsert:Ie})}}let ne=0,oe=0;for(;;){if(ne===$.length){Q(ne,0,O.slice(oe));break}if(oe===O.length){Q(ne,$.length-ne,[]);break}const ie=$[ne],fe=O[oe],Ie=F(ie,fe);Ie===0?(ne+=1,oe+=1):Ie<0?(Q(ne,1,[]),ne+=1):Ie>0&&(Q(ne,0,[fe]),oe+=1)}return j}e.sortedDiff=v;function c($,O,F){const j=v($,O,F),Q=[],ne=[];for(const oe of j)Q.push(...$.slice(oe.start,oe.start+oe.deleteCount)),ne.push(...oe.toInsert);return{removed:Q,added:ne}}e.delta=c;function d($,O,F){if(F===0)return[];const j=$.slice(0,F).sort(O);return b($,O,j,F,$.length),j}e.top=d;function S($,O,F,j,Q){return F===0?Promise.resolve([]):new Promise((ne,oe)=>{(async()=>{const ie=$.length,fe=$.slice(0,F).sort(O);for(let Ie=F,Pe=Math.min(F+j,ie);Ie<ie;Ie=Pe,Pe=Math.min(Pe+j,ie)){if(Ie>F&&await new Promise(Ne=>setTimeout(Ne)),Q&&Q.isCancellationRequested)throw y.canceled();b($,O,fe,Ie,Pe)}return fe})().then(ne,oe)})}e.topAsync=S;function b($,O,F,j,Q){for(const ne=F.length;j<Q;j++){const oe=$[j];if(O(oe,F[ne-1])<0){F.pop();const ie=L(F,fe=>O(oe,fe)<0);F.splice(ie,0,oe)}}}function f($){return $.filter(O=>!!O)}e.coalesce=f;function u($){let O=0;for(let F=0;F<$.length;F++)$[F]&&($[O]=$[F],O+=1);$.length=O}e.coalesceInPlace=u;function a($,O,F){$.splice(F,0,$.splice(O,1)[0])}e.move=a;function o($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=o;function n($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=n;function r($,O){if(!O)return $.filter((j,Q)=>$.indexOf(j)===Q);const F=Object.create(null);return $.filter(j=>{const Q=O(j);return F[Q]?!1:(F[Q]=!0,!0)})}e.distinct=r;function i($){const O=new Set;return $.filter(F=>O.has(F)?!1:(O.add(F),!0))}e.distinctES6=i;function l($){const O=Object.create(null);return F=>{const j=$(F);return O[j]?!1:(O[j]=!0,!0)}}e.uniqueFilter=l;function s($,O){for(let F=$.length-1;F>=0;F--){const j=$[F];if(O(j))return F}return-1}e.lastIndex=s;function p($,O){return $.length>0?$[0]:O}e.firstOrDefault=p;function k($,O,F=(j,Q)=>j===Q){let j=0;for(let Q=0,ne=Math.min($.length,O.length);Q<ne&&F($[Q],O[Q]);Q++)j++;return j}e.commonPrefixLength=k;function w($){return[].concat(...$)}e.flatten=w;function T($,O){let F=typeof O=="number"?$:0;typeof O=="number"?F=$:(F=0,O=$);const j=[];if(F<=O)for(let Q=F;Q<O;Q++)j.push(Q);else for(let Q=F;Q>O;Q--)j.push(Q);return j}e.range=T;function h($,O,F){return $.reduce((j,Q)=>(j[O(Q)]=F?F(Q):Q,j),Object.create(null))}e.index=h;function A($,O){return $.push(O),()=>N($,O)}e.insert=A;function N($,O){const F=$.indexOf(O);if(F>-1)return $.splice(F,1),O}e.remove=N;function B($,O,F){const j=$.slice(0,O),Q=$.slice(O);return j.concat(F,Q)}e.arrayInsert=B;function W($,O){let F;if(typeof O=="number"){let j=O;F=()=>{const Q=Math.sin(j++)*179426549;return Q-Math.floor(Q)}}else F=Math.random;for(let j=$.length-1;j>0;j-=1){const Q=Math.floor(F()*(j+1)),ne=$[j];$[j]=$[Q],$[Q]=ne}}e.shuffle=W;function H($,O){const F=$.indexOf(O);F>-1&&($.splice(F,1),$.unshift(O))}e.pushToStart=H;function K($,O){const F=$.indexOf(O);F>-1&&($.splice(F,1),$.push(O))}e.pushToEnd=K;function re($,O){return Array.isArray($)?$.map(O):O($)}e.mapArrayOrNot=re;function V($){return Array.isArray($)?$:[$]}e.asArray=V;function J($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=J;function ce($,O){for(const F of $){const j=O(F);if(j!==void 0)return j}}e.mapFind=ce}),define(he[69],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(m){const I=this;let E=!1,C;return function(){return E||(E=!0,C=m.apply(I,arguments)),C}}e.once=y}),define(he[53],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(m){function I(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}m.is=I;const E=Object.freeze([]);function C(){return E}m.empty=C;function*L(f){yield f}m.single=L;function g(f){return f||E}m.from=g;function t(f){return!f||f[Symbol.iterator]().next().done===!0}m.isEmpty=t;function R(f){return f[Symbol.iterator]().next().value}m.first=R;function _(f,u){for(const a of f)if(u(a))return!0;return!1}m.some=_;function*P(f,u){for(const a of f)u(a)&&(yield a)}m.filter=P;function*v(f,u){for(const a of f)yield u(a)}m.map=v;function*c(...f){for(const u of f)for(const a of u)yield a}m.concat=c;function*d(f){for(const u of f)for(const a of u)yield a}m.concatNested=d;function*S(f,u,a=f.length){for(u<0&&(u+=f.length),a<0?a+=f.length:a>f.length&&(a=f.length);u<a;u++)yield f[u]}m.slice=S;function b(f,u=Number.POSITIVE_INFINITY){const a=[];if(u===0)return[a,f];const o=f[Symbol.iterator]();for(let n=0;n<u;n++){const r=o.next();if(r.done)return[a,m.empty()];a.push(r.value)}return[a,{[Symbol.iterator](){return o}}]}m.consume=b})(y=e.Iterable||(e.Iterable={}))}),define(he[35],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var m;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(m=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var E;(function(n){n.DEFAULT={allowTrailingComma:!0}})(E=e.ParseOptions||(e.ParseOptions={}));function C(n,r=!1){let i=0,l=n.length,s="",p=0,k=16,w=0;function T(K){let re=0,V=0;for(;re<K;){const J=n.charCodeAt(i);if(J>=48&&J<=57)V=V*16+J-48;else if(J>=65&&J<=70)V=V*16+J-65+10;else if(J>=97&&J<=102)V=V*16+J-97+10;else break;i++,re++}return re<K&&(V=-1),V}function h(K){i=K,s="",p=0,k=16,w=0}function A(){const K=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&t(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&t(n.charCodeAt(i)))for(i++;i<n.length&&t(n.charCodeAt(i));)i++;else return w=3,n.substring(K,i);let re=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&t(n.charCodeAt(i))){for(i++;i<n.length&&t(n.charCodeAt(i));)i++;re=i}else w=3;return n.substring(K,re)}function N(){let K="",re=i;for(;;){if(i>=l){K+=n.substring(re,i),w=2;break}const V=n.charCodeAt(i);if(V===34){K+=n.substring(re,i),i++;break}if(V===92){if(K+=n.substring(re,i),i++,i>=l){w=2;break}switch(n.charCodeAt(i++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const ce=T(4);ce>=0?K+=String.fromCharCode(ce):w=4;break;default:w=5}re=i;continue}if(V>=0&&V<=31)if(g(V)){K+=n.substring(re,i),w=2;break}else w=6;i++}return K}function B(){if(s="",w=0,p=i,i>=l)return p=l,k=17;let K=n.charCodeAt(i);if(L(K)){do i++,s+=String.fromCharCode(K),K=n.charCodeAt(i);while(L(K));return k=15}if(g(K))return i++,s+=String.fromCharCode(K),K===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),k=14;switch(K){case 123:return i++,k=1;case 125:return i++,k=2;case 91:return i++,k=3;case 93:return i++,k=4;case 58:return i++,k=6;case 44:return i++,k=5;case 34:return i++,s=N(),k=10;case 47:const re=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<l&&!g(n.charCodeAt(i));)i++;return s=n.substring(re,i),k=12}if(n.charCodeAt(i+1)===42){i+=2;const V=l-1;let J=!1;for(;i<V;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,J=!0;break}i++}return J||(i++,w=1),s=n.substring(re,i),k=13}return s+=String.fromCharCode(K),i++,k=16;case 45:if(s+=String.fromCharCode(K),i++,i===l||!t(n.charCodeAt(i)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=A(),k=11;default:for(;i<l&&W(K);)i++,K=n.charCodeAt(i);if(p!==i){switch(s=n.substring(p,i),s){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return s+=String.fromCharCode(K),i++,k=16}}function W(K){if(L(K)||g(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let K;do K=B();while(K>=12&&K<=15);return K}return{setPosition:h,getPosition:()=>i,scan:r?H:B,getToken:()=>k,getTokenValue:()=>s,getTokenOffset:()=>p,getTokenLength:()=>i-p,getTokenError:()=>w}}e.createScanner=C;function L(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function g(n){return n===10||n===13||n===8232||n===8233}function t(n){return n>=48&&n<=57}var R;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(R||(R={}));function _(n,r){const i=[],l=new Object;let s;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function w(T,h,A,N){p.value=T,p.offset=h,p.length=A,p.type=N,p.colonOffset=void 0,s=p}try{u(n,{onObjectBegin:(T,h)=>{if(r<=T)throw l;s=void 0,k=r>T,i.push("")},onObjectProperty:(T,h,A)=>{if(r<h||(w(T,h,A,"property"),i[i.length-1]=T,r<=h+A))throw l},onObjectEnd:(T,h)=>{if(r<=T)throw l;s=void 0,i.pop()},onArrayBegin:(T,h)=>{if(r<=T)throw l;s=void 0,i.push(0)},onArrayEnd:(T,h)=>{if(r<=T)throw l;s=void 0,i.pop()},onLiteralValue:(T,h,A)=>{if(r<h||(w(T,h,A,o(T)),r<=h+A))throw l},onSeparator:(T,h,A)=>{if(r<=h)throw l;if(T===":"&&s&&s.type==="property")s.colonOffset=h,k=!1,s=void 0;else if(T===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(k=!0,i[i.length-1]=""),s=void 0}}})}catch(T){if(T!==l)throw T}return{path:i,previousNode:s,isAtPropertyKey:k,matches:T=>{let h=0;for(let A=0;h<T.length&&A<i.length;A++)if(T[h]===i[A]||T[h]==="*")h++;else if(T[h]!=="**")return!1;return h===T.length}}}e.getLocation=_;function P(n,r=[],i=E.DEFAULT){let l=null,s=[];const p=[];function k(T){Array.isArray(s)?s.push(T):l!==null&&(s[l]=T)}return u(n,{onObjectBegin:()=>{const T={};k(T),p.push(s),s=T,l=null},onObjectProperty:T=>{l=T},onObjectEnd:()=>{s=p.pop()},onArrayBegin:()=>{const T=[];k(T),p.push(s),s=T,l=null},onArrayEnd:()=>{s=p.pop()},onLiteralValue:k,onError:(T,h,A)=>{r.push({error:T,offset:h,length:A})}},i),s[0]}e.parse=P;function v(n,r=[],i=E.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(T){l.type==="property"&&(l.length=T-l.offset,l=l.parent)}function p(T){return l.children.push(T),T}u(n,{onObjectBegin:T=>{l=p({type:"object",offset:T,length:-1,parent:l,children:[]})},onObjectProperty:(T,h,A)=>{l=p({type:"property",offset:h,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:T,offset:h,length:A,parent:l})},onObjectEnd:(T,h)=>{l.length=T+h-l.offset,l=l.parent,s(T+h)},onArrayBegin:(T,h)=>{l=p({type:"array",offset:T,length:-1,parent:l,children:[]})},onArrayEnd:(T,h)=>{l.length=T+h-l.offset,l=l.parent,s(T+h)},onLiteralValue:(T,h,A)=>{p({type:o(T),offset:h,length:A,parent:l,value:T}),s(h+A)},onSeparator:(T,h,A)=>{l.type==="property"&&(T===":"?l.colonOffset=h:T===","&&s(h))},onError:(T,h,A)=>{r.push({error:T,offset:h,length:A})}},i);const w=l.children[0];return w&&delete w.parent,w}e.parseTree=v;function c(n,r){if(!!n){let i=n;for(let l of r)if(typeof l=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const p of i.children)if(Array.isArray(p.children)&&p.children[0].value===l){i=p.children[1],s=!0;break}if(!s)return}else{const s=l;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}}e.findNodeAtLocation=c;function d(n){if(!n.parent||!n.parent.children)return[];const r=d(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.getNodePath=d;function S(n){switch(n.type){case"array":return n.children.map(S);case"object":const r=Object.create(null);for(let i of n.children){const l=i.children[1];l&&(r[i.children[0].value]=S(l))}return r;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=S;function b(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.contains=b;function f(n,r,i=!1){if(b(n,r,i)){const l=n.children;if(Array.isArray(l))for(let s=0;s<l.length&&l[s].offset<=r;s++){const p=f(l[s],r,i);if(p)return p}return n}}e.findNodeAtOffset=f;function u(n,r,i=E.DEFAULT){const l=C(n,!1);function s(ne){return ne?()=>ne(l.getTokenOffset(),l.getTokenLength()):()=>!0}function p(ne){return ne?oe=>ne(oe,l.getTokenOffset(),l.getTokenLength()):()=>!0}const k=s(r.onObjectBegin),w=p(r.onObjectProperty),T=s(r.onObjectEnd),h=s(r.onArrayBegin),A=s(r.onArrayEnd),N=p(r.onLiteralValue),B=p(r.onSeparator),W=s(r.onComment),H=p(r.onError),K=i&&i.disallowComments,re=i&&i.allowTrailingComma;function V(){for(;;){const ne=l.scan();switch(l.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:K||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(ne){case 12:case 13:K?J(10):W();break;case 16:J(1);break;case 15:case 14:break;default:return ne}}}function J(ne,oe=[],ie=[]){if(H(ne),oe.length+ie.length>0){let fe=l.getToken();for(;fe!==17;){if(oe.indexOf(fe)!==-1){V();break}else if(ie.indexOf(fe)!==-1)break;fe=V()}}}function ce(ne){const oe=l.getTokenValue();return ne?N(oe):w(oe),V(),!0}function $(){switch(l.getToken()){case 11:let ne=0;try{ne=JSON.parse(l.getTokenValue()),typeof ne!="number"&&(J(2),ne=0)}catch(oe){J(2)}N(ne);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return V(),!0}function O(){return l.getToken()!==10?(J(3,[],[2,5]),!1):(ce(!1),l.getToken()===6?(B(":"),V(),Q()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function F(){k(),V();let ne=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ne||J(4,[],[]),B(","),V(),l.getToken()===2&&re)break}else ne&&J(6,[],[]);O()||J(4,[],[2,5]),ne=!0}return T(),l.getToken()!==2?J(7,[2],[]):V(),!0}function j(){h(),V();let ne=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ne||J(4,[],[]),B(","),V(),l.getToken()===4&&re)break}else ne&&J(6,[],[]);Q()||J(4,[],[4,5]),ne=!0}return A(),l.getToken()!==4?J(8,[4],[]):V(),!0}function Q(){switch(l.getToken()){case 3:return j();case 1:return F();case 10:return ce(!0);default:return $()}}return V(),l.getToken()===17?i.allowEmptyContent?!0:(J(4,[],[]),!1):Q()?(l.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=u;function a(n,r){let i=C(n),l=[],s,p=0,k;do switch(k=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:p!==k&&l.push(n.substring(p,k)),r!==void 0&&l.push(i.getTokenValue().replace(/[^\r\n]/g,r)),p=i.getPosition();break}while(s!==17);return l.join("")}e.stripComments=a;function o(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(he[109],de([0,1,35]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function m(g,t,R){let _,P,v,c,d;if(t){for(c=t.offset,d=c+t.length,v=c;v>0&&!L(g,v-1);)v--;let p=d;for(;p<g.length&&!L(g,p);)p++;P=g.substring(v,p),_=E(P,R)}else P=g,_=0,v=0,c=0,d=g.length;const S=C(R,g);let b=!1,f=0,u;R.insertSpaces?u=I(" ",R.tabSize||4):u="	";const a=y.createScanner(P,!1);let o=!1;function n(){return S+I(u,_+f)}function r(){let p=a.scan();for(b=!1;p===15||p===14;)b=b||p===14,p=a.scan();return o=p===16||a.getTokenError()!==0,p}const i=[];function l(p,k,w){!o&&k<d&&w>c&&g.substring(k,w)!==p&&i.push({offset:k,length:w-k,content:p})}let s=r();if(s!==17){const p=a.getTokenOffset()+v,k=I(u,_);l(k,v,p)}for(;s!==17;){let p=a.getTokenOffset()+a.getTokenLength()+v,k=r(),w="";for(;!b&&(k===12||k===13);){const h=a.getTokenOffset()+v;l(" ",p,h),p=a.getTokenOffset()+a.getTokenLength()+v,w=k===12?n():"",k=r()}if(k===2)s!==1&&(f--,w=n());else if(k===4)s!==3&&(f--,w=n());else{switch(s){case 3:case 1:f++,w=n();break;case 5:case 12:w=n();break;case 13:b?w=n():w=" ";break;case 6:w=" ";break;case 10:if(k===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:k===12||k===13?w=" ":k!==5&&k!==17&&(o=!0);break;case 16:o=!0;break}b&&(k===12||k===13)&&(w=n())}const T=a.getTokenOffset()+v;l(w,p,T),s=k}return i}e.format=m;function I(g,t){let R="";for(let _=0;_<t;_++)R+=g;return R}function E(g,t){let R=0,_=0;const P=t.tabSize||4;for(;R<g.length;){const v=g.charAt(R);if(v===" ")_++;else if(v==="	")_+=P;else break;R++}return Math.floor(_/P)}function C(g,t){for(let R=0;R<t.length;R++){const _=t.charAt(R);if(_==="\r")return R+1<t.length&&t.charAt(R+1)===`
`?`\r
`:"\r";if(_===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=C;function L(g,t){return`\r
`.indexOf(g.charAt(t))!==-1}e.isEOL=L}),define(he[110],de([0,1,35,109,14]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function E(R,_,P){return C(R,_,void 0,P)}e.removeProperty=E;function C(R,_,P,v,c){const d=_.slice(),S=[],b=y.parseTree(R,S);let f,u;for(;d.length>0&&(u=d.pop(),f=y.findNodeAtLocation(b,d),f===void 0&&P!==void 0);)typeof u=="string"?P={[u]:P}:P=[P];if(f)if(f.type==="object"&&typeof u=="string"&&Array.isArray(f.children)){const a=y.findNodeAtLocation(f,[u]);if(a!==void 0)if(P===void 0){if(!a.parent)throw new Error("Malformed AST");const o=f.children.indexOf(a.parent);let n,r=a.parent.offset+a.parent.length;if(o>0){const i=f.children[o-1];n=i.offset+i.length}else n=f.offset+1,f.children.length>1&&(r=f.children[1].offset);return L(R,{offset:n,length:r-n,content:""},v)}else return L(R,{offset:a.offset,length:a.length,content:JSON.stringify(P)},v);else{if(P===void 0)return[];const o=`${JSON.stringify(u)}: ${JSON.stringify(P)}`,n=c?c(f.children.map(i=>i.children[0].value)):f.children.length;let r;if(n>0){const i=f.children[n-1];r={offset:i.offset+i.length,length:0,content:","+o}}else f.children.length===0?r={offset:f.offset+1,length:0,content:o}:r={offset:f.offset+1,length:0,content:o+","};return L(R,r,v)}}else if(f.type==="array"&&typeof u=="number"&&Array.isArray(f.children))if(P!==void 0){const a=`${JSON.stringify(P)}`;let o;if(f.children.length===0||u===0)o={offset:f.offset+1,length:0,content:f.children.length===0?a:a+","};else{const n=u===-1||u>f.children.length?f.children.length:u,r=f.children[n-1];o={offset:r.offset+r.length,length:0,content:","+a}}return L(R,o,v)}else{const a=u,o=f.children[a];let n;if(f.children.length===1)n={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===a){const r=f.children[a-1],i=r.offset+r.length,l=f.offset+f.length;n={offset:i,length:l-2-i,content:""}}else n={offset:o.offset,length:f.children[a+1].offset-o.offset,content:""};return L(R,n,v)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${f.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return L(R,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(P)},v)}}e.setProperty=C;function L(R,_,P){let v=g(R,_),c=_.offset,d=_.offset+_.content.length;if(_.length===0||_.content.length===0){for(;c>0&&!m.isEOL(v,c-1);)c--;for(;d<v.length&&!m.isEOL(v,d);)d++}const S=m.format(v,{offset:c,length:d-c},P);for(let f=S.length-1;f>=0;f--){const u=S[f];v=g(v,u),c=Math.min(c,u.offset),d=Math.max(d,u.offset+u.length),d+=u.content.length-u.length}const b=R.length-(v.length-d)-c;return[{offset:c,length:b,content:v.substring(c,d)}]}e.withFormatting=L;function g(R,_){return R.substring(0,_.offset)+_.content+R.substring(_.offset+_.length)}e.applyEdit=g;function t(R,_){let P=I.mergeSort(_,(c,d)=>{const S=c.offset-d.offset;return S===0?c.length-d.length:S}),v=R.length;for(let c=P.length-1;c>=0;c--){let d=P[c];if(d.offset+d.length<=v)R=g(R,d);else throw new Error("Overlapping edit");v=d.offset}return R}e.applyEdits=t}),define(he[4],de([0,1,69,53]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const I=!1;let E=null;function C(u){E=u}if(e.setDisposableTracker=C,I){const u="__is_disposable_tracked__";E=new class{trackDisposable(a){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[u]||console.log(o)},3e3)}markTracked(a){if(a&&a!==d.None)try{a[u]=!0}catch(o){}}}}function L(u){!E||E.markTracked(u)}function g(u){return E&&E.trackDisposable(u),u}e.trackDisposable=g;class t extends Error{constructor(a){super(`Encounter errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=t;function R(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=R;function _(u){if(m.Iterable.is(u)){let a=[];for(const o of u)if(o){L(o);try{o.dispose()}catch(n){a.push(n)}}if(a.length===1)throw a[0];if(a.length>1)throw new t(a);return Array.isArray(u)?[]:u}else if(u)return L(u),u.dispose(),u}e.dispose=_;function P(...u){return u.forEach(L),v(()=>_(u))}e.combinedDisposable=P;function v(u){const a=g({dispose:()=>{L(a),u()}});return a}e.toDisposable=v;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(L(this),this._isDisposed=!0,this.clear())}clear(){try{_(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return L(a),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new c,g(this)}dispose(){L(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,g(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value&&this._value.dispose(),a&&L(a),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,L(this),this._value&&this._value.dispose(),this._value=void 0}}e.MutableDisposable=S;class b{constructor(){this.references=new Map}acquire(a,...o){let n=this.references.get(a);n||(n={counter:0,object:this.createReferencedObject(a,...o)},this.references.set(a,n));const{object:r}=n,i=y.once(()=>{--n.counter==0&&(this.destroyReferencedObject(a,n.object),this.references.delete(a))});return n.counter++,{object:r,dispose:i}}}e.ReferenceCollection=b;class f{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=f}),define(he[111],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(E){this.element=E,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class m{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(E){return this._insert(E,!1)}push(E){return this._insert(E,!0)}_insert(E,C){const L=new y(E);if(this._first===y.Undefined)this._first=L,this._last=L;else if(C){const t=this._last;this._last=L,L.prev=t,t.next=L}else{const t=this._first;this._first=L,L.next=t,t.prev=L}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(L))}}shift(){if(this._first!==y.Undefined){const E=this._first.element;return this._remove(this._first),E}}pop(){if(this._last!==y.Undefined){const E=this._last.element;return this._remove(this._last),E}}_remove(E){if(E.prev!==y.Undefined&&E.next!==y.Undefined){const C=E.prev;C.next=E.next,E.next.prev=C}else E.prev===y.Undefined&&E.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):E.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):E.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let E=this._first;for(;E!==y.Undefined;)yield E.element,E=E.next}}e.LinkedList=m}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(G,q){for(var U=0;U<q.length;U++){var D=q[U];D.enumerable=D.enumerable||!1,D.configurable=!0,"value"in D&&(D.writable=!0),Object.defineProperty(G,D.key,D)}}function e(G,q,U){return q&&Z(G.prototype,q),U&&Z(G,U),G}function y(G,q){if(!!G){if(typeof G=="string")return m(G,q);var U=Object.prototype.toString.call(G).slice(8,-1);if(U==="Object"&&G.constructor&&(U=G.constructor.name),U==="Map"||U==="Set")return Array.from(G);if(U==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(U))return m(G,q)}}function m(G,q){(q==null||q>G.length)&&(q=G.length);for(var U=0,D=new Array(q);U<q;U++)D[U]=G[U];return D}function I(G,q){var U;if(typeof Symbol=="undefined"||G[Symbol.iterator]==null){if(Array.isArray(G)||(U=y(G))||q&&G&&typeof G.length=="number"){U&&(G=U);var D=0;return function(){return D>=G.length?{done:!0}:{done:!1,value:G[D++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return U=G[Symbol.iterator](),U.next.bind(U)}function E(G,q){return q={exports:{}},G(q,q.exports),q.exports}var C=E(function(G){function q(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function U(D){G.exports.defaults=D}G.exports={defaults:q(),getDefaults:q,changeDefaults:U}}),L=C.defaults,g=C.getDefaults,t=C.changeDefaults,R=/[&<>"']/,_=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(q){return c[q]};function S(G,q){if(q){if(R.test(G))return G.replace(_,d)}else if(P.test(G))return G.replace(v,d);return G}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(G){return G.replace(b,function(q,U){return U=U.toLowerCase(),U==="colon"?":":U.charAt(0)==="#"?U.charAt(1)==="x"?String.fromCharCode(parseInt(U.substring(2),16)):String.fromCharCode(+U.substring(1)):""})}var u=/(^|[^\[])\^/g;function a(G,q){G=G.source||G,q=q||"";var U={replace:function(x,X){return X=X.source||X,X=X.replace(u,"$1"),G=G.replace(x,X),U},getRegex:function(){return new RegExp(G,q)}};return U}var o=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function r(G,q,U){if(G){var D;try{D=decodeURIComponent(f(U)).replace(o,"").toLowerCase()}catch(x){return null}if(D.indexOf("javascript:")===0||D.indexOf("vbscript:")===0||D.indexOf("data:")===0)return null}q&&!n.test(U)&&(U=k(q,U));try{U=encodeURI(U).replace(/%25/g,"%")}catch(x){return null}return U}var i={},l=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,p=/^([^:]+:\/*[^/]*)[\s\S]*$/;function k(G,q){i[" "+G]||(l.test(G)?i[" "+G]=G+"/":i[" "+G]=A(G,"/",!0)),G=i[" "+G];var U=G.indexOf(":")===-1;return q.substring(0,2)==="//"?U?q:G.replace(s,"$1")+q:q.charAt(0)==="/"?U?q:G.replace(p,"$1")+q:G+q}var w={exec:function(){}};function T(G){for(var q=1,U,D;q<arguments.length;q++){U=arguments[q];for(D in U)Object.prototype.hasOwnProperty.call(U,D)&&(G[D]=U[D])}return G}function h(G,q){var U=G.replace(/\|/g,function(X,Y,se){for(var le=!1,we=Y;--we>=0&&se[we]==="\\";)le=!le;return le?"|":" |"}),D=U.split(/ \|/),x=0;if(D.length>q)D.splice(q);else for(;D.length<q;)D.push("");for(;x<D.length;x++)D[x]=D[x].trim().replace(/\\\|/g,"|");return D}function A(G,q,U){var D=G.length;if(D===0)return"";for(var x=0;x<D;){var X=G.charAt(D-x-1);if(X===q&&!U)x++;else if(X!==q&&U)x++;else break}return G.substr(0,D-x)}function N(G,q){if(G.indexOf(q[1])===-1)return-1;for(var U=G.length,D=0,x=0;x<U;x++)if(G[x]==="\\")x++;else if(G[x]===q[0])D++;else if(G[x]===q[1]&&(D--,D<0))return x;return-1}function B(G){G&&G.sanitize&&!G.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(G,q){if(q<1)return"";for(var U="";q>1;)q&1&&(U+=G),q>>=1,G+=G;return U+G}var H={escape:S,unescape:f,edit:a,cleanUrl:r,resolveUrl:k,noopTest:w,merge:T,splitCells:h,rtrim:A,findClosingBracket:N,checkSanitizeDeprecation:B,repeatString:W},K=C.defaults,re=H.rtrim,V=H.splitCells,J=H.escape,ce=H.findClosingBracket;function $(G,q,U){var D=q.href,x=q.title?J(q.title):null,X=G[1].replace(/\\([\[\]])/g,"$1");return G[0].charAt(0)!=="!"?{type:"link",raw:U,href:D,title:x,text:X}:{type:"image",raw:U,href:D,title:x,text:J(X)}}function O(G,q){var U=G.match(/^(\s+)(?:```)/);if(U===null)return q;var D=U[1];return q.split(`
`).map(function(x){var X=x.match(/^\s+/);if(X===null)return x;var Y=X[0];return Y.length>=D.length?x.slice(D.length):x}).join(`
`)}var F=function(){function G(U){this.options=U||K}var q=G.prototype;return q.space=function(D){var x=this.rules.block.newline.exec(D);if(x)return x[0].length>1?{type:"space",raw:x[0]}:{raw:`
`}},q.code=function(D,x){var X=this.rules.block.code.exec(D);if(X){var Y=x[x.length-1];if(Y&&Y.type==="paragraph")return{raw:X[0],text:X[0].trimRight()};var se=X[0].replace(/^ {4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?se:re(se,`
`)}}},q.fences=function(D){var x=this.rules.block.fences.exec(D);if(x){var X=x[0],Y=O(X,x[3]||"");return{type:"code",raw:X,lang:x[2]?x[2].trim():x[2],text:Y}}},q.heading=function(D){var x=this.rules.block.heading.exec(D);if(x)return{type:"heading",raw:x[0],depth:x[1].length,text:x[2]}},q.nptable=function(D){var x=this.rules.block.nptable.exec(D);if(x){var X={type:"table",header:V(x[1].replace(/^ *| *\| *$/g,"")),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:x[3]?x[3].replace(/\n$/,"").split(`
`):[],raw:x[0]};if(X.header.length===X.align.length){var Y=X.align.length,se;for(se=0;se<Y;se++)/^ *-+: *$/.test(X.align[se])?X.align[se]="right":/^ *:-+: *$/.test(X.align[se])?X.align[se]="center":/^ *:-+ *$/.test(X.align[se])?X.align[se]="left":X.align[se]=null;for(Y=X.cells.length,se=0;se<Y;se++)X.cells[se]=V(X.cells[se],X.header.length);return X}}},q.hr=function(D){var x=this.rules.block.hr.exec(D);if(x)return{type:"hr",raw:x[0]}},q.blockquote=function(D){var x=this.rules.block.blockquote.exec(D);if(x){var X=x[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:x[0],text:X}}},q.list=function(D){var x=this.rules.block.list.exec(D);if(x){for(var X=x[0],Y=x[2],se=Y.length>1,le=Y[Y.length-1]===")",we={type:"list",raw:X,ordered:se,start:se?+Y.slice(0,-1):"",loose:!1,items:[]},Te=x[0].match(this.rules.block.item),Le=!1,Ae,$e,He,Ue,Xe,Ke,Qe,Ze=Te.length,qe=0;qe<Ze;qe++)Ae=Te[qe],X=Ae,$e=Ae.length,Ae=Ae.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ae.indexOf(`
 `)&&($e-=Ae.length,Ae=this.options.pedantic?Ae.replace(/^ {1,4}/gm,""):Ae.replace(new RegExp("^ {1,"+$e+"}","gm"),"")),qe!==Ze-1&&(He=this.rules.block.bullet.exec(Te[qe+1])[0],(se?He.length===1||!le&&He[He.length-1]===")":He.length>1||this.options.smartLists&&He!==Y)&&(Ue=Te.slice(qe+1).join(`
`),we.raw=we.raw.substring(0,we.raw.length-Ue.length),qe=Ze-1)),Xe=Le||/\n\n(?!\s*$)/.test(Ae),qe!==Ze-1&&(Le=Ae.charAt(Ae.length-1)===`
`,Xe||(Xe=Le)),Xe&&(we.loose=!0),Ke=/^\[[ xX]\] /.test(Ae),Qe=void 0,Ke&&(Qe=Ae[1]!==" ",Ae=Ae.replace(/^\[[ xX]\] +/,"")),we.items.push({type:"list_item",raw:X,task:Ke,checked:Qe,loose:Xe,text:Ae});return we}},q.html=function(D){var x=this.rules.block.html.exec(D);if(x)return{type:this.options.sanitize?"paragraph":"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):J(x[0]):x[0]}},q.def=function(D){var x=this.rules.block.def.exec(D);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var X=x[1].toLowerCase().replace(/\s+/g," ");return{tag:X,raw:x[0],href:x[2],title:x[3]}}},q.table=function(D){var x=this.rules.block.table.exec(D);if(x){var X={type:"table",header:V(x[1].replace(/^ *| *\| *$/g,"")),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:x[3]?x[3].replace(/\n$/,"").split(`
`):[]};if(X.header.length===X.align.length){X.raw=x[0];var Y=X.align.length,se;for(se=0;se<Y;se++)/^ *-+: *$/.test(X.align[se])?X.align[se]="right":/^ *:-+: *$/.test(X.align[se])?X.align[se]="center":/^ *:-+ *$/.test(X.align[se])?X.align[se]="left":X.align[se]=null;for(Y=X.cells.length,se=0;se<Y;se++)X.cells[se]=V(X.cells[se].replace(/^ *\| *| *\| *$/g,""),X.header.length);return X}}},q.lheading=function(D){var x=this.rules.block.lheading.exec(D);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1]}},q.paragraph=function(D){var x=this.rules.block.paragraph.exec(D);if(x)return{type:"paragraph",raw:x[0],text:x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1]}},q.text=function(D,x){var X=this.rules.block.text.exec(D);if(X){var Y=x[x.length-1];return Y&&Y.type==="text"?{raw:X[0],text:X[0]}:{type:"text",raw:X[0],text:X[0]}}},q.escape=function(D){var x=this.rules.inline.escape.exec(D);if(x)return{type:"escape",raw:x[0],text:J(x[1])}},q.tag=function(D,x,X){var Y=this.rules.inline.tag.exec(D);if(Y)return!x&&/^<a /i.test(Y[0])?x=!0:x&&/^<\/a>/i.test(Y[0])&&(x=!1),!X&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?X=!0:X&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(X=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:x,inRawBlock:X,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):J(Y[0]):Y[0]}},q.link=function(D){var x=this.rules.inline.link.exec(D);if(x){var X=ce(x[2],"()");if(X>-1){var Y=x[0].indexOf("!")===0?5:4,se=Y+x[1].length+X;x[2]=x[2].substring(0,X),x[0]=x[0].substring(0,se).trim(),x[3]=""}var le=x[2],we="";if(this.options.pedantic){var Te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(le);Te?(le=Te[1],we=Te[3]):we=""}else we=x[3]?x[3].slice(1,-1):"";le=le.trim().replace(/^<([\s\S]*)>$/,"$1");var Le=$(x,{href:le&&le.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},x[0]);return Le}},q.reflink=function(D,x){var X;if((X=this.rules.inline.reflink.exec(D))||(X=this.rules.inline.nolink.exec(D))){var Y=(X[2]||X[1]).replace(/\s+/g," ");if(Y=x[Y.toLowerCase()],!Y||!Y.href){var se=X[0].charAt(0);return{type:"text",raw:se,text:se}}var le=$(X,Y,X[0]);return le}},q.strong=function(D,x,X){X===void 0&&(X="");var Y=this.rules.inline.strong.start.exec(D);if(Y&&(!Y[1]||Y[1]&&(X===""||this.rules.inline.punctuation.exec(X)))){x=x.slice(-1*D.length);var se=Y[0]==="**"?this.rules.inline.strong.endAst:this.rules.inline.strong.endUnd;se.lastIndex=0;for(var le;(Y=se.exec(x))!=null;)if(le=this.rules.inline.strong.middle.exec(x.slice(0,Y.index+3)),le)return{type:"strong",raw:D.slice(0,le[0].length),text:D.slice(2,le[0].length-2)}}},q.em=function(D,x,X){X===void 0&&(X="");var Y=this.rules.inline.em.start.exec(D);if(Y&&(!Y[1]||Y[1]&&(X===""||this.rules.inline.punctuation.exec(X)))){x=x.slice(-1*D.length);var se=Y[0]==="*"?this.rules.inline.em.endAst:this.rules.inline.em.endUnd;se.lastIndex=0;for(var le;(Y=se.exec(x))!=null;)if(le=this.rules.inline.em.middle.exec(x.slice(0,Y.index+2)),le)return{type:"em",raw:D.slice(0,le[0].length),text:D.slice(1,le[0].length-1)}}},q.codespan=function(D){var x=this.rules.inline.code.exec(D);if(x){var X=x[2].replace(/\n/g," "),Y=/[^ ]/.test(X),se=X.startsWith(" ")&&X.endsWith(" ");return Y&&se&&(X=X.substring(1,X.length-1)),X=J(X,!0),{type:"codespan",raw:x[0],text:X}}},q.br=function(D){var x=this.rules.inline.br.exec(D);if(x)return{type:"br",raw:x[0]}},q.del=function(D){var x=this.rules.inline.del.exec(D);if(x)return{type:"del",raw:x[0],text:x[1]}},q.autolink=function(D,x){var X=this.rules.inline.autolink.exec(D);if(X){var Y,se;return X[2]==="@"?(Y=J(this.options.mangle?x(X[1]):X[1]),se="mailto:"+Y):(Y=J(X[1]),se=Y),{type:"link",raw:X[0],text:Y,href:se,tokens:[{type:"text",raw:Y,text:Y}]}}},q.url=function(D,x){var X;if(X=this.rules.inline.url.exec(D)){var Y,se;if(X[2]==="@")Y=J(this.options.mangle?x(X[0]):X[0]),se="mailto:"+Y;else{var le;do le=X[0],X[0]=this.rules.inline._backpedal.exec(X[0])[0];while(le!==X[0]);Y=J(X[0]),X[1]==="www."?se="http://"+Y:se=Y}return{type:"link",raw:X[0],text:Y,href:se,tokens:[{type:"text",raw:Y,text:Y}]}}},q.inlineText=function(D,x,X){var Y=this.rules.inline.text.exec(D);if(Y){var se;return x?se=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):J(Y[0]):Y[0]:se=J(this.options.smartypants?X(Y[0]):Y[0]),{type:"text",raw:Y[0],text:se}}},G}(),j=H.noopTest,Q=H.edit,ne=H.merge,oe={newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6}) +([^\n]*?)(?: +#+)? *(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:j,table:j,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html)[^\n]+)*)/,text:/^[^\n]+/};oe._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,oe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,oe.def=Q(oe.def).replace("label",oe._label).replace("title",oe._title).getRegex(),oe.bullet=/(?:[*+-]|\d{1,9}[.)])/,oe.item=/^( *)(bull) ?[^\n]*(?:\n(?!\1bull ?)[^\n]*)*/,oe.item=Q(oe.item,"gm").replace(/bull/g,oe.bullet).getRegex(),oe.list=Q(oe.list).replace(/bull/g,oe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+oe.def.source+")").getRegex(),oe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",oe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,oe.html=Q(oe.html,"i").replace("comment",oe._comment).replace("tag",oe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),oe.paragraph=Q(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",oe._tag).getRegex(),oe.blockquote=Q(oe.blockquote).replace("paragraph",oe.paragraph).getRegex(),oe.normal=ne({},oe),oe.gfm=ne({},oe.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),oe.gfm.nptable=Q(oe.gfm.nptable).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",oe._tag).getRegex(),oe.gfm.table=Q(oe.gfm.table).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",oe._tag).getRegex(),oe.pedantic=ne({},oe.normal,{html:Q(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",oe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *(?:#+ *)?(?:\n+|$)/,fences:j,paragraph:Q(oe.normal._paragraph).replace("hr",oe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",oe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:j,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",strong:{start:/^(?:(\*\*(?=[*punctuation]))|\*\*)(?![\s])|__/,middle:/^\*\*(?:(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)|\*(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)*?\*)+?\*\*$|^__(?![\s])((?:(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)|_(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)*?_)+?)__$/,endAst:/[^punctuation\s]\*\*(?!\*)|[punctuation]\*\*(?!\*)(?:(?=[punctuation_\s]|$))/,endUnd:/[^\s]__(?!_)(?:(?=[punctuation*\s])|$)/},em:{start:/^(?:(\*(?=[punctuation]))|\*)(?![*\s])|_/,middle:/^\*(?:(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)|\*(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)*?\*)+?\*$|^_(?![_\s])(?:(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)|_(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)*?_)+?_$/,endAst:/[^punctuation\s]\*(?!\*)|[punctuation]\*(?!\*)(?:(?=[punctuation_\s]|$))/,endUnd:/[^\s]_(?!_)(?:(?=[punctuation*\s])|$)/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:j,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\s*punctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=Q(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie._blockSkip="\\[[^\\]]*?\\]\\([^\\)]*?\\)|`[^`]*?`|<[^>]*?>",ie._overlapSkip="__[^_]*?__|\\*\\*\\[^\\*\\]*?\\*\\*",ie._comment=Q(oe._comment).replace("(?:-->|$)","-->").getRegex(),ie.em.start=Q(ie.em.start).replace(/punctuation/g,ie._punctuation).getRegex(),ie.em.middle=Q(ie.em.middle).replace(/punctuation/g,ie._punctuation).replace(/overlapSkip/g,ie._overlapSkip).getRegex(),ie.em.endAst=Q(ie.em.endAst,"g").replace(/punctuation/g,ie._punctuation).getRegex(),ie.em.endUnd=Q(ie.em.endUnd,"g").replace(/punctuation/g,ie._punctuation).getRegex(),ie.strong.start=Q(ie.strong.start).replace(/punctuation/g,ie._punctuation).getRegex(),ie.strong.middle=Q(ie.strong.middle).replace(/punctuation/g,ie._punctuation).replace(/overlapSkip/g,ie._overlapSkip).getRegex(),ie.strong.endAst=Q(ie.strong.endAst,"g").replace(/punctuation/g,ie._punctuation).getRegex(),ie.strong.endUnd=Q(ie.strong.endUnd,"g").replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=Q(ie._blockSkip,"g").getRegex(),ie.overlapSkip=Q(ie._overlapSkip,"g").getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=Q(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=Q(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\[<>]?|[^\s<>\\])*>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=Q(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=Q(ie.reflink).replace("label",ie._label).getRegex(),ie.reflinkSearch=Q(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=ne({},ie),ie.pedantic=ne({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Q(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:Q(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=ne({},ie.normal,{escape:Q(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^~+(?=\S)([\s\S]*?\S)~+/,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ie.gfm.url=Q(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=ne({},ie.gfm,{br:Q(ie.br).replace("{2,}","*").getRegex(),text:Q(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:oe,inline:ie},Ie=C.defaults,Pe=fe.block,Ne=fe.inline,ye=H.repeatString;function _e(G){return G.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ce(G){var q="",U,D,x=G.length;for(U=0;U<x;U++)D=G.charCodeAt(U),Math.random()>.5&&(D="x"+D.toString(16)),q+="&#"+D+";";return q}var ze=function(){function G(U){this.tokens=[],this.tokens.links=Object.create(null),this.options=U||Ie,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var D={block:Pe.normal,inline:Ne.normal};this.options.pedantic?(D.block=Pe.pedantic,D.inline=Ne.pedantic):this.options.gfm&&(D.block=Pe.gfm,this.options.breaks?D.inline=Ne.breaks:D.inline=Ne.gfm),this.tokenizer.rules=D}G.lex=function(D,x){var X=new G(x);return X.lex(D)},G.lexInline=function(D,x){var X=new G(x);return X.inlineTokens(D)};var q=G.prototype;return q.lex=function(D){return D=D.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(D,this.tokens,!0),this.inline(this.tokens),this.tokens},q.blockTokens=function(D,x,X){x===void 0&&(x=[]),X===void 0&&(X=!0),D=D.replace(/^ +$/gm,"");for(var Y,se,le,we;D;){if(Y=this.tokenizer.space(D)){D=D.substring(Y.raw.length),Y.type&&x.push(Y);continue}if(Y=this.tokenizer.code(D,x)){D=D.substring(Y.raw.length),Y.type?x.push(Y):(we=x[x.length-1],we.raw+=`
`+Y.raw,we.text+=`
`+Y.text);continue}if(Y=this.tokenizer.fences(D)){D=D.substring(Y.raw.length),x.push(Y);continue}if(Y=this.tokenizer.heading(D)){D=D.substring(Y.raw.length),x.push(Y);continue}if(Y=this.tokenizer.nptable(D)){D=D.substring(Y.raw.length),x.push(Y);continue}if(Y=this.tokenizer.hr(D)){D=D.substring(Y.raw.length),x.push(Y);continue}if(Y=this.tokenizer.blockquote(D)){D=D.substring(Y.raw.length),Y.tokens=this.blockTokens(Y.text,[],X),x.push(Y);continue}if(Y=this.tokenizer.list(D)){for(D=D.substring(Y.raw.length),le=Y.items.length,se=0;se<le;se++)Y.items[se].tokens=this.blockTokens(Y.items[se].text,[],!1);x.push(Y);continue}if(Y=this.tokenizer.html(D)){D=D.substring(Y.raw.length),x.push(Y);continue}if(X&&(Y=this.tokenizer.def(D))){D=D.substring(Y.raw.length),this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(D)){D=D.substring(Y.raw.length),x.push(Y);continue}if(Y=this.tokenizer.lheading(D)){D=D.substring(Y.raw.length),x.push(Y);continue}if(X&&(Y=this.tokenizer.paragraph(D))){D=D.substring(Y.raw.length),x.push(Y);continue}if(Y=this.tokenizer.text(D,x)){D=D.substring(Y.raw.length),Y.type?x.push(Y):(we=x[x.length-1],we.raw+=`
`+Y.raw,we.text+=`
`+Y.text);continue}if(D){var Te="Infinite loop on byte: "+D.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return x},q.inline=function(D){var x,X,Y,se,le,we,Te=D.length;for(x=0;x<Te;x++)switch(we=D[x],we.type){case"paragraph":case"text":case"heading":{we.tokens=[],this.inlineTokens(we.text,we.tokens);break}case"table":{for(we.tokens={header:[],cells:[]},se=we.header.length,X=0;X<se;X++)we.tokens.header[X]=[],this.inlineTokens(we.header[X],we.tokens.header[X]);for(se=we.cells.length,X=0;X<se;X++)for(le=we.cells[X],we.tokens.cells[X]=[],Y=0;Y<le.length;Y++)we.tokens.cells[X][Y]=[],this.inlineTokens(le[Y],we.tokens.cells[X][Y]);break}case"blockquote":{this.inline(we.tokens);break}case"list":{for(se=we.items.length,X=0;X<se;X++)this.inline(we.items[X].tokens);break}}return D},q.inlineTokens=function(D,x,X,Y,se){x===void 0&&(x=[]),X===void 0&&(X=!1),Y===void 0&&(Y=!1),se===void 0&&(se="");var le,we=D,Te;if(this.tokens.links){var Le=Object.keys(this.tokens.links);if(Le.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)Le.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,Te.index)+"["+ye("a",Te[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,Te.index)+"["+ye("a",Te[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;D;){if(le=this.tokenizer.escape(D)){D=D.substring(le.raw.length),x.push(le);continue}if(le=this.tokenizer.tag(D,X,Y)){D=D.substring(le.raw.length),X=le.inLink,Y=le.inRawBlock,x.push(le);continue}if(le=this.tokenizer.link(D)){D=D.substring(le.raw.length),le.type==="link"&&(le.tokens=this.inlineTokens(le.text,[],!0,Y)),x.push(le);continue}if(le=this.tokenizer.reflink(D,this.tokens.links)){D=D.substring(le.raw.length),le.type==="link"&&(le.tokens=this.inlineTokens(le.text,[],!0,Y)),x.push(le);continue}if(le=this.tokenizer.strong(D,we,se)){D=D.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],X,Y),x.push(le);continue}if(le=this.tokenizer.em(D,we,se)){D=D.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],X,Y),x.push(le);continue}if(le=this.tokenizer.codespan(D)){D=D.substring(le.raw.length),x.push(le);continue}if(le=this.tokenizer.br(D)){D=D.substring(le.raw.length),x.push(le);continue}if(le=this.tokenizer.del(D)){D=D.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],X,Y),x.push(le);continue}if(le=this.tokenizer.autolink(D,Ce)){D=D.substring(le.raw.length),x.push(le);continue}if(!X&&(le=this.tokenizer.url(D,Ce))){D=D.substring(le.raw.length),x.push(le);continue}if(le=this.tokenizer.inlineText(D,Y,_e)){D=D.substring(le.raw.length),se=le.raw.slice(-1),x.push(le);continue}if(D){var Ae="Infinite loop on byte: "+D.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return x},e(G,null,[{key:"rules",get:function(){return{block:Pe,inline:Ne}}}]),G}(),je=C.defaults,me=H.cleanUrl,ve=H.escape,Se=function(){function G(U){this.options=U||je}var q=G.prototype;return q.code=function(D,x,X){var Y=(x||"").match(/\S*/)[0];if(this.options.highlight){var se=this.options.highlight(D,Y);se!=null&&se!==D&&(X=!0,D=se)}return Y?'<pre><code class="'+this.options.langPrefix+ve(Y,!0)+'">'+(X?D:ve(D,!0))+`</code></pre>
`:"<pre><code>"+(X?D:ve(D,!0))+`</code></pre>
`},q.blockquote=function(D){return`<blockquote>
`+D+`</blockquote>
`},q.html=function(D){return D},q.heading=function(D,x,X,Y){return this.options.headerIds?"<h"+x+' id="'+this.options.headerPrefix+Y.slug(X)+'">'+D+"</h"+x+`>
`:"<h"+x+">"+D+"</h"+x+`>
`},q.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},q.list=function(D,x,X){var Y=x?"ol":"ul",se=x&&X!==1?' start="'+X+'"':"";return"<"+Y+se+`>
`+D+"</"+Y+`>
`},q.listitem=function(D){return"<li>"+D+`</li>
`},q.checkbox=function(D){return"<input "+(D?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},q.paragraph=function(D){return"<p>"+D+`</p>
`},q.table=function(D,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+D+`</thead>
`+x+`</table>
`},q.tablerow=function(D){return`<tr>
`+D+`</tr>
`},q.tablecell=function(D,x){var X=x.header?"th":"td",Y=x.align?"<"+X+' align="'+x.align+'">':"<"+X+">";return Y+D+"</"+X+`>
`},q.strong=function(D){return"<strong>"+D+"</strong>"},q.em=function(D){return"<em>"+D+"</em>"},q.codespan=function(D){return"<code>"+D+"</code>"},q.br=function(){return this.options.xhtml?"<br/>":"<br>"},q.del=function(D){return"<del>"+D+"</del>"},q.link=function(D,x,X){if(D=me(this.options.sanitize,this.options.baseUrl,D),D===null)return X;var Y='<a href="'+ve(D)+'"';return x&&(Y+=' title="'+x+'"'),Y+=">"+X+"</a>",Y},q.image=function(D,x,X){if(D=me(this.options.sanitize,this.options.baseUrl,D),D===null)return X;var Y='<img src="'+D+'" alt="'+X+'"';return x&&(Y+=' title="'+x+'"'),Y+=this.options.xhtml?"/>":">",Y},q.text=function(D){return D},G}(),ke=function(){function G(){}var q=G.prototype;return q.strong=function(D){return D},q.em=function(D){return D},q.codespan=function(D){return D},q.del=function(D){return D},q.html=function(D){return D},q.text=function(D){return D},q.link=function(D,x,X){return""+X},q.image=function(D,x,X){return""+X},q.br=function(){return""},G}(),Re=function(){function G(){this.seen={}}var q=G.prototype;return q.serialize=function(D){return D.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},q.getNextSafeSlug=function(D,x){var X=D,Y=0;if(this.seen.hasOwnProperty(X)){Y=this.seen[D];do Y++,X=D+"-"+Y;while(this.seen.hasOwnProperty(X))}return x||(this.seen[D]=Y,this.seen[X]=0),X},q.slug=function(D,x){x===void 0&&(x={});var X=this.serialize(D);return this.getNextSafeSlug(X,x.dryrun)},G}(),Fe=C.defaults,We=H.unescape,Be=function(){function G(U){this.options=U||Fe,this.options.renderer=this.options.renderer||new Se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ke,this.slugger=new Re}G.parse=function(D,x){var X=new G(x);return X.parse(D)},G.parseInline=function(D,x){var X=new G(x);return X.parseInline(D)};var q=G.prototype;return q.parse=function(D,x){x===void 0&&(x=!0);var X="",Y,se,le,we,Te,Le,Ae,$e,He,Ue,Xe,Ke,Qe,Ze,qe,nt,tt,ot,dt=D.length;for(Y=0;Y<dt;Y++)switch(Ue=D[Y],Ue.type){case"space":continue;case"hr":{X+=this.renderer.hr();continue}case"heading":{X+=this.renderer.heading(this.parseInline(Ue.tokens),Ue.depth,We(this.parseInline(Ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{X+=this.renderer.code(Ue.text,Ue.lang,Ue.escaped);continue}case"table":{for($e="",Ae="",we=Ue.header.length,se=0;se<we;se++)Ae+=this.renderer.tablecell(this.parseInline(Ue.tokens.header[se]),{header:!0,align:Ue.align[se]});for($e+=this.renderer.tablerow(Ae),He="",we=Ue.cells.length,se=0;se<we;se++){for(Le=Ue.tokens.cells[se],Ae="",Te=Le.length,le=0;le<Te;le++)Ae+=this.renderer.tablecell(this.parseInline(Le[le]),{header:!1,align:Ue.align[le]});He+=this.renderer.tablerow(Ae)}X+=this.renderer.table($e,He);continue}case"blockquote":{He=this.parse(Ue.tokens),X+=this.renderer.blockquote(He);continue}case"list":{for(Xe=Ue.ordered,Ke=Ue.start,Qe=Ue.loose,we=Ue.items.length,He="",se=0;se<we;se++)qe=Ue.items[se],nt=qe.checked,tt=qe.task,Ze="",qe.task&&(ot=this.renderer.checkbox(nt),Qe?qe.tokens.length>0&&qe.tokens[0].type==="text"?(qe.tokens[0].text=ot+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=ot+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:ot}):Ze+=ot),Ze+=this.parse(qe.tokens,Qe),He+=this.renderer.listitem(Ze,tt,nt);X+=this.renderer.list(He,Xe,Ke);continue}case"html":{X+=this.renderer.html(Ue.text);continue}case"paragraph":{X+=this.renderer.paragraph(this.parseInline(Ue.tokens));continue}case"text":{for(He=Ue.tokens?this.parseInline(Ue.tokens):Ue.text;Y+1<dt&&D[Y+1].type==="text";)Ue=D[++Y],He+=`
`+(Ue.tokens?this.parseInline(Ue.tokens):Ue.text);X+=x?this.renderer.paragraph(He):He;continue}default:{var gt='Token with "'+Ue.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}return X},q.parseInline=function(D,x){x=x||this.renderer;var X="",Y,se,le=D.length;for(Y=0;Y<le;Y++)switch(se=D[Y],se.type){case"escape":{X+=x.text(se.text);break}case"html":{X+=x.html(se.text);break}case"link":{X+=x.link(se.href,se.title,this.parseInline(se.tokens,x));break}case"image":{X+=x.image(se.href,se.title,se.text);break}case"strong":{X+=x.strong(this.parseInline(se.tokens,x));break}case"em":{X+=x.em(this.parseInline(se.tokens,x));break}case"codespan":{X+=x.codespan(se.text);break}case"br":{X+=x.br();break}case"del":{X+=x.del(this.parseInline(se.tokens,x));break}case"text":{X+=x.text(se.text);break}default:{var we='Token with "'+se.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}return X},G}(),Ve=H.merge,ae=H.checkSanitizeDeprecation,ge=H.escape,pe=C.getDefaults,Oe=C.changeDefaults,ee=C.defaults;function ue(G,q,U){if(typeof G=="undefined"||G===null)throw new Error("marked(): input parameter is undefined or null");if(typeof G!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(G)+", string expected");if(typeof q=="function"&&(U=q,q=null),q=Ve({},ue.defaults,q||{}),ae(q),U){var D=q.highlight,x;try{x=ze.lex(G,q)}catch(le){return U(le)}var X=function(we){var Te;if(!we)try{Te=Be.parse(x,q)}catch(Le){we=Le}return q.highlight=D,we?U(we):U(null,Te)};if(!D||D.length<3||(delete q.highlight,!x.length))return X();var Y=0;ue.walkTokens(x,function(le){le.type==="code"&&(Y++,setTimeout(function(){D(le.text,le.lang,function(we,Te){if(we)return X(we);Te!=null&&Te!==le.text&&(le.text=Te,le.escaped=!0),Y--,Y===0&&X()})},0))}),Y===0&&X();return}try{var se=ze.lex(G,q);return q.walkTokens&&ue.walkTokens(se,q.walkTokens),Be.parse(se,q)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,q.silent)return"<p>An error occurred:</p><pre>"+ge(le.message+"",!0)+"</pre>";throw le}}ue.options=ue.setOptions=function(G){return Ve(ue.defaults,G),Oe(ue.defaults),ue},ue.getDefaults=pe,ue.defaults=ee,ue.use=function(G){var q=Ve({},G);if(G.renderer&&function(){var D=ue.defaults.renderer||new Se,x=function(se){var le=D[se];D[se]=function(){for(var we=arguments.length,Te=new Array(we),Le=0;Le<we;Le++)Te[Le]=arguments[Le];var Ae=G.renderer[se].apply(D,Te);return Ae===!1&&(Ae=le.apply(D,Te)),Ae}};for(var X in G.renderer)x(X);q.renderer=D}(),G.tokenizer&&function(){var D=ue.defaults.tokenizer||new F,x=function(se){var le=D[se];D[se]=function(){for(var we=arguments.length,Te=new Array(we),Le=0;Le<we;Le++)Te[Le]=arguments[Le];var Ae=G.tokenizer[se].apply(D,Te);return Ae===!1&&(Ae=le.apply(D,Te)),Ae}};for(var X in G.tokenizer)x(X);q.tokenizer=D}(),G.walkTokens){var U=ue.defaults.walkTokens;q.walkTokens=function(D){G.walkTokens(D),U&&U(D)}}ue.setOptions(q)},ue.walkTokens=function(G,q){for(var U=I(G),D;!(D=U()).done;){var x=D.value;switch(q(x),x.type){case"table":{for(var X=I(x.tokens.header),Y;!(Y=X()).done;){var se=Y.value;ue.walkTokens(se,q)}for(var le=I(x.tokens.cells),we;!(we=le()).done;)for(var Te=we.value,Le=I(Te),Ae;!(Ae=Le()).done;){var $e=Ae.value;ue.walkTokens($e,q)}break}case"list":{ue.walkTokens(x.items,q);break}default:x.tokens&&ue.walkTokens(x.tokens,q)}}},ue.parseInline=function(G,q){if(typeof G=="undefined"||G===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof G!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(G)+", string expected");q=Ve({},ue.defaults,q||{}),ae(q);try{var U=ze.lexInline(G,q);return q.walkTokens&&ue.walkTokens(U,q.walkTokens),Be.parseInline(U,q)}catch(D){if(D.message+=`
Please report this to https://github.com/markedjs/marked.`,q.silent)return"<p>An error occurred:</p><pre>"+ge(D.message+"",!0)+"</pre>";throw D}},ue.Parser=Be,ue.parser=Be.parse,ue.Renderer=Se,ue.TextRenderer=ke,ue.Lexer=ze,ue.lexer=ze.lex,ue.Tokenizer=F,ue.Slugger=Re,ue.parse=ue;var Ee=ue;return Ee}),define(he[112],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function y(C,L,g){return Math.min(Math.max(C,L),g)}e.clamp=y;function m(C,L){return(L+C%L)%L}e.rot=m;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class E{constructor(){this._n=1,this._val=0}update(L){return this._val=this._val+(L-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=E});"use strict";function bt(Z){const e=[];typeof Z=="number"&&e.push("code/timeOrigin",Z);function y(I){e.push(I,Date.now())}function m(){const I=[];for(let E=0;E<e.length;E+=2)I.push({name:e[E],startTime:e[E+1]});return I}return{mark:y,getMarks:m}}function qt(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?bt():{mark(Z){performance.mark(Z)},getMarks(){let Z=performance.timeOrigin;typeof Z!="number"&&(Z=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const e=[{name:"code/timeOrigin",startTime:Math.round(Z)}];for(const y of performance.getEntriesByType("mark"))e.push({name:y.name,startTime:Math.round(Z+y.startTime)});return e}};if(typeof process=="object"){const Z=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return bt(Z)}else return console.trace("perf-util loaded in UNKNOWN environment"),bt()}function St(Z){return Z.MonacoPerformanceMarks||(Z.MonacoPerformanceMarks=qt()),Z.MonacoPerformanceMarks}var ht;typeof global=="object"?ht=global:typeof self=="object"?ht=self:ht={},typeof define=="function"?define("vs/base/common/performance",[],function(){return St(ht)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=St(ht):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),ht.perf=St(ht)),define(he[5],de([0,1]),function(Z,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const m="en";let I=!1,E=!1,C=!1,L=!1,g=!1,t=!1,R=!1,_,P=m,v,c;const d=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof process!="undefined"?S=process:typeof d.vscode!="undefined"&&(S=d.vscode.process);const b=typeof((y=S==null?void 0:S.versions)===null||y===void 0?void 0:y.electron)=="string"&&S.type==="renderer";if(e.isElectronSandboxed=b&&(S==null?void 0:S.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=S==null?void 0:S.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!b)c=navigator.userAgent,I=c.indexOf("Windows")>=0,E=c.indexOf("Macintosh")>=0,R=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=c.indexOf("Linux")>=0,t=!0,_=navigator.language,P=_;else if(typeof S=="object"){I=S.platform==="win32",E=S.platform==="darwin",C=S.platform==="linux",L=C&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,_=m,P=m;const s=S.env.VSCODE_NLS_CONFIG;if(s)try{const p=JSON.parse(s),k=p.availableLanguages["*"];_=p.locale,P=k||m,v=p._translationsConfigFile}catch(p){}g=!0}else console.error("Unable to resolve platform.");var f;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function u(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let a=0;E?a=1:I?a=3:C&&(a=2),e.isWindows=I,e.isMacintosh=E,e.isLinux=C,e.isLinuxSnap=L,e.isNative=g,e.isWeb=t,e.isIOS=R,e.platform=a,e.userAgent=c,e.language=P;var o;(function(s){function p(){return e.language}s.value=p;function k(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=k;function w(){return e.language==="en"}s.isDefault=w})(o=e.Language||(e.Language={})),e.locale=_,e.translationsConfigFile=v,e.globals=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let k=[];e.globals.addEventListener("message",T=>{if(T.data&&T.data.vscodeSetImmediateId)for(let h=0,A=k.length;h<A;h++){const N=k[h];if(N.id===T.data.vscodeSetImmediateId){k.splice(h,1),N.callback();return}}});let w=0;return T=>{const h=++w;k.push({id:h,callback:T}),e.globals.postMessage({vscodeSetImmediateId:h},"*")}}if(S)return S.nextTick.bind(S);const p=Promise.resolve();return k=>p.then(k)}();var n;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=E||R?2:I?1:3;let r=!0,i=!1;function l(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,r=new Uint16Array(s.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l}),define(he[36],de([0,1,5]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let m;typeof process!="undefined"?m=process:typeof y.globals.vscode!="undefined"?m={get platform(){return y.globals.vscode.process.platform},get env(){return y.globals.vscode.process.env},nextTick(I){return y.setImmediate(I)},cwd(){return y.globals.vscode.process.env.VSCODE_CWD||y.globals.vscode.process.execPath.substr(0,y.globals.vscode.process.execPath.lastIndexOf(y.globals.vscode.process.platform==="win32"?"\\":"/"))}}:m={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},nextTick(I){return y.setImmediate(I)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=m.cwd,e.env=m.env,e.platform=m.platform,e.nextTick=m.nextTick}),define(he[2],de([0,1,36]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const m=65,I=97,E=90,C=122,L=46,g=47,t=92,R=58,_=63;class P extends Error{constructor(a,o,n){let r;typeof o=="string"&&o.indexOf("not ")===0?(r="must not be",o=o.replace(/^not /,"")):r="must be";const i=a.indexOf(".")!==-1?"property":"argument";let l=`The "${a}" ${i} ${r} of type ${o}`;l+=`. Received type ${typeof n}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function v(u,a){if(typeof u!="string")throw new P(a,"string",u)}function c(u){return u===g||u===t}function d(u){return u===g}function S(u){return u>=m&&u<=E||u>=I&&u<=C}function b(u,a,o,n){let r="",i=0,l=-1,s=0,p=0;for(let k=0;k<=u.length;++k){if(k<u.length)p=u.charCodeAt(k);else{if(n(p))break;p=g}if(n(p)){if(!(l===k-1||s===1))if(s===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==L||r.charCodeAt(r.length-2)!==L){if(r.length>2){const w=r.lastIndexOf(o);w===-1?(r="",i=0):(r=r.slice(0,w),i=r.length-1-r.lastIndexOf(o)),l=k,s=0;continue}else if(r.length!==0){r="",i=0,l=k,s=0;continue}}a&&(r+=r.length>0?`${o}..`:"..",i=2)}else r.length>0?r+=`${o}${u.slice(l+1,k)}`:r=u.slice(l+1,k),i=k-l-1;l=k,s=0}else p===L&&s!==-1?++s:s=-1}return r}function f(u,a){if(a===null||typeof a!="object")throw new P("pathObject","Object",a);const o=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return o?o===a.root?`${o}${n}`:`${o}${u}${n}`:n}e.win32={resolve(...u){let a="",o="",n=!1;for(let r=u.length-1;r>=-1;r--){let i;if(r>=0){if(i=u[r],v(i,"path"),i.length===0)continue}else a.length===0?i=y.cwd():(i=y.env[`=${a}`]||y.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===t)&&(i=`${a}\\`));const l=i.length;let s=0,p="",k=!1;const w=i.charCodeAt(0);if(l===1)c(w)&&(s=1,k=!0);else if(c(w))if(k=!0,c(i.charCodeAt(1))){let T=2,h=T;for(;T<l&&!c(i.charCodeAt(T));)T++;if(T<l&&T!==h){const A=i.slice(h,T);for(h=T;T<l&&c(i.charCodeAt(T));)T++;if(T<l&&T!==h){for(h=T;T<l&&!c(i.charCodeAt(T));)T++;(T===l||T!==h)&&(p=`\\\\${A}\\${i.slice(h,T)}`,s=T)}}}else s=1;else S(w)&&i.charCodeAt(1)===R&&(p=i.slice(0,2),s=2,l>2&&c(i.charCodeAt(2))&&(k=!0,s=3));if(p.length>0)if(a.length>0){if(p.toLowerCase()!==a.toLowerCase())continue}else a=p;if(n){if(a.length>0)break}else if(o=`${i.slice(s)}\\${o}`,n=k,k&&a.length>0)break}return o=b(o,!n,"\\",c),n?`${a}\\${o}`:`${a}${o}`||"."},normalize(u){v(u,"path");const a=u.length;if(a===0)return".";let o=0,n,r=!1;const i=u.charCodeAt(0);if(a===1)return d(i)?"\\":u;if(c(i))if(r=!0,c(u.charCodeAt(1))){let s=2,p=s;for(;s<a&&!c(u.charCodeAt(s));)s++;if(s<a&&s!==p){const k=u.slice(p,s);for(p=s;s<a&&c(u.charCodeAt(s));)s++;if(s<a&&s!==p){for(p=s;s<a&&!c(u.charCodeAt(s));)s++;if(s===a)return`\\\\${k}\\${u.slice(p)}\\`;s!==p&&(n=`\\\\${k}\\${u.slice(p,s)}`,o=s)}}}else o=1;else S(i)&&u.charCodeAt(1)===R&&(n=u.slice(0,2),o=2,a>2&&c(u.charCodeAt(2))&&(r=!0,o=3));let l=o<a?b(u.slice(o),!r,"\\",c):"";return l.length===0&&!r&&(l="."),l.length>0&&c(u.charCodeAt(a-1))&&(l+="\\"),n===void 0?r?`\\${l}`:l:r?`${n}\\${l}`:`${n}${l}`},isAbsolute(u){v(u,"path");const a=u.length;if(a===0)return!1;const o=u.charCodeAt(0);return c(o)||a>2&&S(o)&&u.charCodeAt(1)===R&&c(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let a,o;for(let i=0;i<u.length;++i){const l=u[i];v(l,"path"),l.length>0&&(a===void 0?a=o=l:a+=`\\${l}`)}if(a===void 0)return".";let n=!0,r=0;if(typeof o=="string"&&c(o.charCodeAt(0))){++r;const i=o.length;i>1&&c(o.charCodeAt(1))&&(++r,i>2&&(c(o.charCodeAt(2))?++r:n=!1))}if(n){for(;r<a.length&&c(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(u,a){if(v(u,"from"),v(a,"to"),u===a)return"";const o=e.win32.resolve(u),n=e.win32.resolve(a);if(o===n||(u=o.toLowerCase(),a=n.toLowerCase(),u===a))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===t;)r++;let i=u.length;for(;i-1>r&&u.charCodeAt(i-1)===t;)i--;const l=i-r;let s=0;for(;s<a.length&&a.charCodeAt(s)===t;)s++;let p=a.length;for(;p-1>s&&a.charCodeAt(p-1)===t;)p--;const k=p-s,w=l<k?l:k;let T=-1,h=0;for(;h<w;h++){const N=u.charCodeAt(r+h);if(N!==a.charCodeAt(s+h))break;N===t&&(T=h)}if(h!==w){if(T===-1)return n}else{if(k>w){if(a.charCodeAt(s+h)===t)return n.slice(s+h+1);if(h===2)return n.slice(s+h)}l>w&&(u.charCodeAt(r+h)===t?T=h:h===2&&(T=3)),T===-1&&(T=0)}let A="";for(h=r+T+1;h<=i;++h)(h===i||u.charCodeAt(h)===t)&&(A+=A.length===0?"..":"\\..");return s+=T,A.length>0?`${A}${n.slice(s,p)}`:(n.charCodeAt(s)===t&&++s,n.slice(s,p))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const a=e.win32.resolve(u);if(a.length<=2)return u;if(a.charCodeAt(0)===t){if(a.charCodeAt(1)===t){const o=a.charCodeAt(2);if(o!==_&&o!==L)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(S(a.charCodeAt(0))&&a.charCodeAt(1)===R&&a.charCodeAt(2)===t)return`\\\\?\\${a}`;return u},dirname(u){v(u,"path");const a=u.length;if(a===0)return".";let o=-1,n=0;const r=u.charCodeAt(0);if(a===1)return c(r)?u:".";if(c(r)){if(o=n=1,c(u.charCodeAt(1))){let s=2,p=s;for(;s<a&&!c(u.charCodeAt(s));)s++;if(s<a&&s!==p){for(p=s;s<a&&c(u.charCodeAt(s));)s++;if(s<a&&s!==p){for(p=s;s<a&&!c(u.charCodeAt(s));)s++;if(s===a)return u;s!==p&&(o=n=s+1)}}}}else S(r)&&u.charCodeAt(1)===R&&(o=a>2&&c(u.charCodeAt(2))?3:2,n=o);let i=-1,l=!0;for(let s=a-1;s>=n;--s)if(c(u.charCodeAt(s))){if(!l){i=s;break}}else l=!1;if(i===-1){if(o===-1)return".";i=o}return u.slice(0,i)},basename(u,a){a!==void 0&&v(a,"ext"),v(u,"path");let o=0,n=-1,r=!0,i;if(u.length>=2&&S(u.charCodeAt(0))&&u.charCodeAt(1)===R&&(o=2),a!==void 0&&a.length>0&&a.length<=u.length){if(a===u)return"";let l=a.length-1,s=-1;for(i=u.length-1;i>=o;--i){const p=u.charCodeAt(i);if(c(p)){if(!r){o=i+1;break}}else s===-1&&(r=!1,s=i+1),l>=0&&(p===a.charCodeAt(l)?--l==-1&&(n=i):(l=-1,n=s))}return o===n?n=s:n===-1&&(n=u.length),u.slice(o,n)}for(i=u.length-1;i>=o;--i)if(c(u.charCodeAt(i))){if(!r){o=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":u.slice(o,n)},extname(u){v(u,"path");let a=0,o=-1,n=0,r=-1,i=!0,l=0;u.length>=2&&u.charCodeAt(1)===R&&S(u.charCodeAt(0))&&(a=n=2);for(let s=u.length-1;s>=a;--s){const p=u.charCodeAt(s);if(c(p)){if(!i){n=s+1;break}continue}r===-1&&(i=!1,r=s+1),p===L?o===-1?o=s:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||r===-1||l===0||l===1&&o===r-1&&o===n+1?"":u.slice(o,r)},format:f.bind(null,"\\"),parse(u){v(u,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return a;const o=u.length;let n=0,r=u.charCodeAt(0);if(o===1)return c(r)?(a.root=a.dir=u,a):(a.base=a.name=u,a);if(c(r)){if(n=1,c(u.charCodeAt(1))){let T=2,h=T;for(;T<o&&!c(u.charCodeAt(T));)T++;if(T<o&&T!==h){for(h=T;T<o&&c(u.charCodeAt(T));)T++;if(T<o&&T!==h){for(h=T;T<o&&!c(u.charCodeAt(T));)T++;T===o?n=T:T!==h&&(n=T+1)}}}}else if(S(r)&&u.charCodeAt(1)===R){if(o<=2)return a.root=a.dir=u,a;if(n=2,c(u.charCodeAt(2))){if(o===3)return a.root=a.dir=u,a;n=3}}n>0&&(a.root=u.slice(0,n));let i=-1,l=n,s=-1,p=!0,k=u.length-1,w=0;for(;k>=n;--k){if(r=u.charCodeAt(k),c(r)){if(!p){l=k+1;break}continue}s===-1&&(p=!1,s=k+1),r===L?i===-1?i=k:w!==1&&(w=1):i!==-1&&(w=-1)}return s!==-1&&(i===-1||w===0||w===1&&i===s-1&&i===l+1?a.base=a.name=u.slice(l,s):(a.name=u.slice(l,i),a.base=u.slice(l,s),a.ext=u.slice(i,s))),l>0&&l!==n?a.dir=u.slice(0,l-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let a="",o=!1;for(let n=u.length-1;n>=-1&&!o;n--){const r=n>=0?u[n]:y.cwd();v(r,"path"),r.length!==0&&(a=`${r}/${a}`,o=r.charCodeAt(0)===g)}return a=b(a,!o,"/",d),o?`/${a}`:a.length>0?a:"."},normalize(u){if(v(u,"path"),u.length===0)return".";const a=u.charCodeAt(0)===g,o=u.charCodeAt(u.length-1)===g;return u=b(u,!a,"/",d),u.length===0?a?"/":o?"./":".":(o&&(u+="/"),a?`/${u}`:u)},isAbsolute(u){return v(u,"path"),u.length>0&&u.charCodeAt(0)===g},join(...u){if(u.length===0)return".";let a;for(let o=0;o<u.length;++o){const n=u[o];v(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(u,a){if(v(u,"from"),v(a,"to"),u===a||(u=e.posix.resolve(u),a=e.posix.resolve(a),u===a))return"";const o=1,n=u.length,r=n-o,i=1,l=a.length-i,s=r<l?r:l;let p=-1,k=0;for(;k<s;k++){const T=u.charCodeAt(o+k);if(T!==a.charCodeAt(i+k))break;T===g&&(p=k)}if(k===s)if(l>s){if(a.charCodeAt(i+k)===g)return a.slice(i+k+1);if(k===0)return a.slice(i+k)}else r>s&&(u.charCodeAt(o+k)===g?p=k:k===0&&(p=0));let w="";for(k=o+p+1;k<=n;++k)(k===n||u.charCodeAt(k)===g)&&(w+=w.length===0?"..":"/..");return`${w}${a.slice(i+p)}`},toNamespacedPath(u){return u},dirname(u){if(v(u,"path"),u.length===0)return".";const a=u.charCodeAt(0)===g;let o=-1,n=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===g){if(!n){o=r;break}}else n=!1;return o===-1?a?"/":".":a&&o===1?"//":u.slice(0,o)},basename(u,a){a!==void 0&&v(a,"ext"),v(u,"path");let o=0,n=-1,r=!0,i;if(a!==void 0&&a.length>0&&a.length<=u.length){if(a===u)return"";let l=a.length-1,s=-1;for(i=u.length-1;i>=0;--i){const p=u.charCodeAt(i);if(p===g){if(!r){o=i+1;break}}else s===-1&&(r=!1,s=i+1),l>=0&&(p===a.charCodeAt(l)?--l==-1&&(n=i):(l=-1,n=s))}return o===n?n=s:n===-1&&(n=u.length),u.slice(o,n)}for(i=u.length-1;i>=0;--i)if(u.charCodeAt(i)===g){if(!r){o=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":u.slice(o,n)},extname(u){v(u,"path");let a=-1,o=0,n=-1,r=!0,i=0;for(let l=u.length-1;l>=0;--l){const s=u.charCodeAt(l);if(s===g){if(!r){o=l+1;break}continue}n===-1&&(r=!1,n=l+1),s===L?a===-1?a=l:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||n===-1||i===0||i===1&&a===n-1&&a===o+1?"":u.slice(a,n)},format:f.bind(null,"/"),parse(u){v(u,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return a;const o=u.charCodeAt(0)===g;let n;o?(a.root="/",n=1):n=0;let r=-1,i=0,l=-1,s=!0,p=u.length-1,k=0;for(;p>=n;--p){const w=u.charCodeAt(p);if(w===g){if(!s){i=p+1;break}continue}l===-1&&(s=!1,l=p+1),w===L?r===-1?r=p:k!==1&&(k=1):r!==-1&&(k=-1)}if(l!==-1){const w=i===0&&o?1:i;r===-1||k===0||k===1&&r===l-1&&r===i+1?a.base=a.name=u.slice(w,l):(a.name=u.slice(w,r),a.base=u.slice(w,l),a.ext=u.slice(r,l))}return i>0?a.dir=u.slice(0,i-1):o&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(he[113],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var y;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(y=e.Source||(e.Source={}));var m;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(m=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(E,...C){const L=C.reduce((R,_)=>(R[_]=!0,R),{}),g=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(R=>!L[R]).forEach(R=>{for(let _=0;_<g.length;_++)if(R.search(g[_])!==-1){delete E[R];break}})}e.sanitizeProcessEnvironment=I}),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var m in y)(typeof exports=="object"?exports:Z)[m]=y[m]}}(typeof self!="undefined"?self:this,function(){return function(Z){var e={};function y(m){if(e[m])return e[m].exports;var I=e[m]={i:m,l:!1,exports:{}};return Z[m].call(I.exports,I,I.exports,y),I.l=!0,I.exports}return y.m=Z,y.c=e,y.d=function(m,I,E){y.o(m,I)||Object.defineProperty(m,I,{enumerable:!0,get:E})},y.r=function(m){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(m,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(m,"__esModule",{value:!0})},y.t=function(m,I){if(1&I&&(m=y(m)),8&I||4&I&&typeof m=="object"&&m&&m.__esModule)return m;var E=Object.create(null);if(y.r(E),Object.defineProperty(E,"default",{enumerable:!0,value:m}),2&I&&typeof m!="string")for(var C in m)y.d(E,C,function(L){return m[L]}.bind(null,C));return E},y.n=function(m){var I=m&&m.__esModule?function(){return m.default}:function(){return m};return y.d(I,"a",I),I},y.o=function(m,I){return Object.prototype.hasOwnProperty.call(m,I)},y.p="",y(y.s=0)}([function(Z,e,y){(function(m){var I;e=Z.exports=ie,I=typeof m=="object"&&m.env&&m.env.NODE_DEBUG&&/\bsemver\b/i.test(m.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var E=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,L=e.re=[],g=e.src=[],t=0,R=t++;g[R]="0|[1-9]\\d*";var _=t++;g[_]="[0-9]+";var P=t++;g[P]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=t++;g[v]="("+g[R]+")\\.("+g[R]+")\\.("+g[R]+")";var c=t++;g[c]="("+g[_]+")\\.("+g[_]+")\\.("+g[_]+")";var d=t++;g[d]="(?:"+g[R]+"|"+g[P]+")";var S=t++;g[S]="(?:"+g[_]+"|"+g[P]+")";var b=t++;g[b]="(?:-("+g[d]+"(?:\\."+g[d]+")*))";var f=t++;g[f]="(?:-?("+g[S]+"(?:\\."+g[S]+")*))";var u=t++;g[u]="[0-9A-Za-z-]+";var a=t++;g[a]="(?:\\+("+g[u]+"(?:\\."+g[u]+")*))";var o=t++,n="v?"+g[v]+g[b]+"?"+g[a]+"?";g[o]="^"+n+"$";var r="[v=\\s]*"+g[c]+g[f]+"?"+g[a]+"?",i=t++;g[i]="^"+r+"$";var l=t++;g[l]="((?:<|>)?=?)";var s=t++;g[s]=g[_]+"|x|X|\\*";var p=t++;g[p]=g[R]+"|x|X|\\*";var k=t++;g[k]="[v=\\s]*("+g[p]+")(?:\\.("+g[p]+")(?:\\.("+g[p]+")(?:"+g[b]+")?"+g[a]+"?)?)?";var w=t++;g[w]="[v=\\s]*("+g[s]+")(?:\\.("+g[s]+")(?:\\.("+g[s]+")(?:"+g[f]+")?"+g[a]+"?)?)?";var T=t++;g[T]="^"+g[l]+"\\s*"+g[k]+"$";var h=t++;g[h]="^"+g[l]+"\\s*"+g[w]+"$";var A=t++;g[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=t++;g[N]="(?:~>?)";var B=t++;g[B]="(\\s*)"+g[N]+"\\s+",L[B]=new RegExp(g[B],"g");var W=t++;g[W]="^"+g[N]+g[k]+"$";var H=t++;g[H]="^"+g[N]+g[w]+"$";var K=t++;g[K]="(?:\\^)";var re=t++;g[re]="(\\s*)"+g[K]+"\\s+",L[re]=new RegExp(g[re],"g");var V=t++;g[V]="^"+g[K]+g[k]+"$";var J=t++;g[J]="^"+g[K]+g[w]+"$";var ce=t++;g[ce]="^"+g[l]+"\\s*("+r+")$|^$";var $=t++;g[$]="^"+g[l]+"\\s*("+n+")$|^$";var O=t++;g[O]="(\\s*)"+g[l]+"\\s*("+r+"|"+g[k]+")",L[O]=new RegExp(g[O],"g");var F=t++;g[F]="^\\s*("+g[k]+")\\s+-\\s+("+g[k]+")\\s*$";var j=t++;g[j]="^\\s*("+g[w]+")\\s+-\\s+("+g[w]+")\\s*$";var Q=t++;g[Q]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)I(ne,g[ne]),L[ne]||(L[ne]=new RegExp(g[ne]));function oe(ae,ge){if(ae instanceof ie)return ae;if(typeof ae!="string"||ae.length>E||!(ge?L[i]:L[o]).test(ae))return null;try{return new ie(ae,ge)}catch(pe){return null}}function ie(ae,ge){if(ae instanceof ie){if(ae.loose===ge)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>E)throw new TypeError("version is longer than "+E+" characters");if(!(this instanceof ie))return new ie(ae,ge);I("SemVer",ae,ge),this.loose=ge;var pe=ae.trim().match(ge?L[i]:L[o]);if(!pe)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var ee=+Oe;if(ee>=0&&ee<C)return ee}return Oe}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=oe,e.valid=function(ae,ge){var pe=oe(ae,ge);return pe?pe.version:null},e.clean=function(ae,ge){var pe=oe(ae.trim().replace(/^[=v]+/,""),ge);return pe?pe.version:null},e.SemVer=ie,ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ie.prototype.toString=function(){return this.version},ie.prototype.compare=function(ae){return I("SemVer.compare",this.version,this.loose,ae),ae instanceof ie||(ae=new ie(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},ie.prototype.compareMain=function(ae){return ae instanceof ie||(ae=new ie(ae,this.loose)),Ie(this.major,ae.major)||Ie(this.minor,ae.minor)||Ie(this.patch,ae.patch)},ie.prototype.comparePre=function(ae){if(ae instanceof ie||(ae=new ie(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var ge=0;do{var pe=this.prerelease[ge],Oe=ae.prerelease[ge];if(I("prerelease compare",ge,pe,Oe),pe===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(pe===void 0)return-1;if(pe!==Oe)return Ie(pe,Oe)}while(++ge)},ie.prototype.inc=function(ae,ge){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,ge,pe,Oe){typeof pe=="string"&&(Oe=pe,pe=void 0);try{return new ie(ae,pe).inc(ge,Oe).version}catch(ee){return null}},e.diff=function(ae,ge){if(_e(ae,ge))return null;var pe=oe(ae),Oe=oe(ge);if(pe.prerelease.length||Oe.prerelease.length){for(var ee in pe)if((ee==="major"||ee==="minor"||ee==="patch")&&pe[ee]!==Oe[ee])return"pre"+ee;return"prerelease"}for(var ee in pe)if((ee==="major"||ee==="minor"||ee==="patch")&&pe[ee]!==Oe[ee])return ee},e.compareIdentifiers=Ie;var fe=/^[0-9]+$/;function Ie(ae,ge){var pe=fe.test(ae),Oe=fe.test(ge);return pe&&Oe&&(ae=+ae,ge=+ge),pe&&!Oe?-1:Oe&&!pe?1:ae<ge?-1:ae>ge?1:0}function Pe(ae,ge,pe){return new ie(ae,pe).compare(new ie(ge,pe))}function Ne(ae,ge,pe){return Pe(ae,ge,pe)>0}function ye(ae,ge,pe){return Pe(ae,ge,pe)<0}function _e(ae,ge,pe){return Pe(ae,ge,pe)===0}function Ce(ae,ge,pe){return Pe(ae,ge,pe)!==0}function ze(ae,ge,pe){return Pe(ae,ge,pe)>=0}function je(ae,ge,pe){return Pe(ae,ge,pe)<=0}function me(ae,ge,pe,Oe){var ee;switch(ge){case"===":typeof ae=="object"&&(ae=ae.version),typeof pe=="object"&&(pe=pe.version),ee=ae===pe;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof pe=="object"&&(pe=pe.version),ee=ae!==pe;break;case"":case"=":case"==":ee=_e(ae,pe,Oe);break;case"!=":ee=Ce(ae,pe,Oe);break;case">":ee=Ne(ae,pe,Oe);break;case">=":ee=ze(ae,pe,Oe);break;case"<":ee=ye(ae,pe,Oe);break;case"<=":ee=je(ae,pe,Oe);break;default:throw new TypeError("Invalid operator: "+ge)}return ee}function ve(ae,ge){if(ae instanceof ve){if(ae.loose===ge)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,ge);I("comparator",ae,ge),this.loose=ge,this.parse(ae),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(ae,ge){return Ie(ge,ae)},e.major=function(ae,ge){return new ie(ae,ge).major},e.minor=function(ae,ge){return new ie(ae,ge).minor},e.patch=function(ae,ge){return new ie(ae,ge).patch},e.compare=Pe,e.compareLoose=function(ae,ge){return Pe(ae,ge,!0)},e.rcompare=function(ae,ge,pe){return Pe(ge,ae,pe)},e.sort=function(ae,ge){return ae.sort(function(pe,Oe){return e.compare(pe,Oe,ge)})},e.rsort=function(ae,ge){return ae.sort(function(pe,Oe){return e.rcompare(pe,Oe,ge)})},e.gt=Ne,e.lt=ye,e.eq=_e,e.neq=Ce,e.gte=ze,e.lte=je,e.cmp=me,e.Comparator=ve;var Se={};function ke(ae,ge){if(ae instanceof ke)return ae.loose===ge?ae:new ke(ae.raw,ge);if(ae instanceof ve)return new ke(ae.value,ge);if(!(this instanceof ke))return new ke(ae,ge);if(this.loose=ge,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Re(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Fe(ae,ge,pe,Oe,ee,ue,Ee,G,q,U,D,x,X){return((ge=Re(pe)?"":Re(Oe)?">="+pe+".0.0":Re(ee)?">="+pe+"."+Oe+".0":">="+ge)+" "+(G=Re(q)?"":Re(U)?"<"+(+q+1)+".0.0":Re(D)?"<"+q+"."+(+U+1)+".0":x?"<="+q+"."+U+"."+D+"-"+x:"<="+G)).trim()}function We(ae,ge){for(var pe=0;pe<ae.length;pe++)if(!ae[pe].test(ge))return!1;if(ge.prerelease.length){for(pe=0;pe<ae.length;pe++)if(I(ae[pe].semver),ae[pe].semver!==Se&&ae[pe].semver.prerelease.length>0){var Oe=ae[pe].semver;if(Oe.major===ge.major&&Oe.minor===ge.minor&&Oe.patch===ge.patch)return!0}return!1}return!0}function Be(ae,ge,pe){try{ge=new ke(ge,pe)}catch(Oe){return!1}return ge.test(ae)}function Ve(ae,ge,pe,Oe){var ee,ue,Ee,G,q;switch(ae=new ie(ae,Oe),ge=new ke(ge,Oe),pe){case">":ee=Ne,ue=je,Ee=ye,G=">",q=">=";break;case"<":ee=ye,ue=ze,Ee=Ne,G="<",q="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Be(ae,ge,Oe))return!1;for(var U=0;U<ge.set.length;++U){var D=ge.set[U],x=null,X=null;if(D.forEach(function(Y){Y.semver===Se&&(Y=new ve(">=0.0.0")),x=x||Y,X=X||Y,ee(Y.semver,x.semver,Oe)?x=Y:Ee(Y.semver,X.semver,Oe)&&(X=Y)}),x.operator===G||x.operator===q||(!X.operator||X.operator===G)&&ue(ae,X.semver)||X.operator===q&&Ee(ae,X.semver))return!1}return!0}ve.prototype.parse=function(ae){var ge=this.loose?L[ce]:L[$],pe=ae.match(ge);if(!pe)throw new TypeError("Invalid comparator: "+ae);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new ie(pe[2],this.loose):this.semver=Se},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return I("Comparator.test",ae,this.loose),this.semver===Se||(typeof ae=="string"&&(ae=new ie(ae,this.loose)),me(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,ge){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new ke(ae.value,ge),Be(this.value,pe,ge);if(ae.operator==="")return pe=new ke(this.value,ge),Be(ae.semver,pe,ge);var Oe=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),ee=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),ue=this.semver.version===ae.semver.version,Ee=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),G=me(this.semver,"<",ae.semver,ge)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),q=me(this.semver,">",ae.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Oe||ee||ue&&Ee||G||q},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(ae){var ge=this.loose;ae=ae.trim(),I("range",ae,ge);var pe=ge?L[j]:L[F];ae=ae.replace(pe,Fe),I("hyphen replace",ae),ae=ae.replace(L[O],"$1$2$3"),I("comparator trim",ae,L[O]),ae=(ae=(ae=ae.replace(L[B],"$1~")).replace(L[re],"$1^")).split(/\s+/).join(" ");var Oe=ge?L[ce]:L[$],ee=ae.split(" ").map(function(ue){return function(Ee,G){return I("comp",Ee),Ee=function(q,U){return q.trim().split(/\s+/).map(function(D){return function(x,X){I("caret",x,X);var Y=X?L[J]:L[V];return x.replace(Y,function(se,le,we,Te,Le){var Ae;return I("caret",x,se,le,we,Te,Le),Re(le)?Ae="":Re(we)?Ae=">="+le+".0.0 <"+(+le+1)+".0.0":Re(Te)?Ae=le==="0"?">="+le+"."+we+".0 <"+le+"."+(+we+1)+".0":">="+le+"."+we+".0 <"+(+le+1)+".0.0":Le?(I("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ae=le==="0"?we==="0"?">="+le+"."+we+"."+Te+Le+" <"+le+"."+we+"."+(+Te+1):">="+le+"."+we+"."+Te+Le+" <"+le+"."+(+we+1)+".0":">="+le+"."+we+"."+Te+Le+" <"+(+le+1)+".0.0"):(I("no pr"),Ae=le==="0"?we==="0"?">="+le+"."+we+"."+Te+" <"+le+"."+we+"."+(+Te+1):">="+le+"."+we+"."+Te+" <"+le+"."+(+we+1)+".0":">="+le+"."+we+"."+Te+" <"+(+le+1)+".0.0"),I("caret return",Ae),Ae})}(D,U)}).join(" ")}(Ee,G),I("caret",Ee),Ee=function(q,U){return q.trim().split(/\s+/).map(function(D){return function(x,X){var Y=X?L[H]:L[W];return x.replace(Y,function(se,le,we,Te,Le){var Ae;return I("tilde",x,se,le,we,Te,Le),Re(le)?Ae="":Re(we)?Ae=">="+le+".0.0 <"+(+le+1)+".0.0":Re(Te)?Ae=">="+le+"."+we+".0 <"+le+"."+(+we+1)+".0":Le?(I("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ae=">="+le+"."+we+"."+Te+Le+" <"+le+"."+(+we+1)+".0"):Ae=">="+le+"."+we+"."+Te+" <"+le+"."+(+we+1)+".0",I("tilde return",Ae),Ae})}(D,U)}).join(" ")}(Ee,G),I("tildes",Ee),Ee=function(q,U){return I("replaceXRanges",q,U),q.split(/\s+/).map(function(D){return function(x,X){x=x.trim();var Y=X?L[h]:L[T];return x.replace(Y,function(se,le,we,Te,Le,Ae){I("xRange",x,se,le,we,Te,Le,Ae);var $e=Re(we),He=$e||Re(Te),Ue=He||Re(Le);return le==="="&&Ue&&(le=""),$e?se=le===">"||le==="<"?"<0.0.0":"*":le&&Ue?(He&&(Te=0),Ue&&(Le=0),le===">"?(le=">=",He?(we=+we+1,Te=0,Le=0):Ue&&(Te=+Te+1,Le=0)):le==="<="&&(le="<",He?we=+we+1:Te=+Te+1),se=le+we+"."+Te+"."+Le):He?se=">="+we+".0.0 <"+(+we+1)+".0.0":Ue&&(se=">="+we+"."+Te+".0 <"+we+"."+(+Te+1)+".0"),I("xRange return",se),se})}(D,U)}).join(" ")}(Ee,G),I("xrange",Ee),Ee=function(q,U){return I("replaceStars",q,U),q.trim().replace(L[Q],"")}(Ee,G),I("stars",Ee),Ee}(ue,ge)}).join(" ").split(/\s+/);return this.loose&&(ee=ee.filter(function(ue){return!!ue.match(Oe)})),ee=ee.map(function(ue){return new ve(ue,ge)})},ke.prototype.intersects=function(ae,ge){if(!(ae instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Oe){return ae.set.some(function(ee){return ee.every(function(ue){return Oe.intersects(ue,ge)})})})})},e.toComparators=function(ae,ge){return new ke(ae,ge).set.map(function(pe){return pe.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new ie(ae,this.loose));for(var ge=0;ge<this.set.length;ge++)if(We(this.set[ge],ae))return!0;return!1},e.satisfies=Be,e.maxSatisfying=function(ae,ge,pe){var Oe=null,ee=null;try{var ue=new ke(ge,pe)}catch(Ee){return null}return ae.forEach(function(Ee){ue.test(Ee)&&(Oe&&ee.compare(Ee)!==-1||(ee=new ie(Oe=Ee,pe)))}),Oe},e.minSatisfying=function(ae,ge,pe){var Oe=null,ee=null;try{var ue=new ke(ge,pe)}catch(Ee){return null}return ae.forEach(function(Ee){ue.test(Ee)&&(Oe&&ee.compare(Ee)!==1||(ee=new ie(Oe=Ee,pe)))}),Oe},e.validRange=function(ae,ge){try{return new ke(ae,ge).range||"*"}catch(pe){return null}},e.ltr=function(ae,ge,pe){return Ve(ae,ge,"<",pe)},e.gtr=function(ae,ge,pe){return Ve(ae,ge,">",pe)},e.outside=Ve,e.prerelease=function(ae,ge){var pe=oe(ae,ge);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(ae,ge,pe){return ae=new ke(ae,pe),ge=new ke(ge,pe),ae.intersects(ge)},e.coerce=function(ae){if(ae instanceof ie)return ae;if(typeof ae!="string")return null;var ge=ae.match(L[A]);return ge==null?null:oe((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,y(1))},function(Z,e){var y,m,I=Z.exports={};function E(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function L(S){if(y===setTimeout)return setTimeout(S,0);if((y===E||!y)&&setTimeout)return y=setTimeout,setTimeout(S,0);try{return y(S,0)}catch(b){try{return y.call(null,S,0)}catch(f){return y.call(this,S,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:E}catch(S){y=E}try{m=typeof clearTimeout=="function"?clearTimeout:C}catch(S){m=C}})();var g,t=[],R=!1,_=-1;function P(){R&&g&&(R=!1,g.length?t=g.concat(t):_=-1,t.length&&v())}function v(){if(!R){var S=L(P);R=!0;for(var b=t.length;b;){for(g=t,t=[];++_<b;)g&&g[_].run();_=-1,b=t.length}g=null,R=!1,function(f){if(m===clearTimeout)return clearTimeout(f);if((m===C||!m)&&clearTimeout)return m=clearTimeout,clearTimeout(f);try{m(f)}catch(u){try{return m.call(null,f)}catch(a){return m.call(this,f)}}}(S)}}function c(S,b){this.fun=S,this.array=b}function d(){}I.nextTick=function(S){var b=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)b[f-1]=arguments[f];t.push(new c(S,b)),t.length!==1||R||L(v)},c.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=d,I.addListener=d,I.once=d,I.off=d,I.removeListener=d,I.removeAllListeners=d,I.emit=d,I.prependListener=d,I.prependOnceListener=d,I.listeners=function(S){return[]},I.binding=function(S){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(S){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(he[114],de([0,1,5]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const m=y.globals.performance&&typeof y.globals.performance.now=="function";class I{constructor(C){this._highResolution=m&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new I(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=I}),define(he[6],de([0,1,12,69,4,111,114]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.AsyncEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var L;(function(f){f.None=()=>I.Disposable.None;function u(K){return(re,V=null,J)=>{let ce=!1,$;return $=K(O=>{if(!ce)return $?$.dispose():ce=!0,re.call(V,O)},null,J),ce&&$.dispose(),$}}f.once=u;function a(K,re){return s((V,J=null,ce)=>K($=>V.call(J,re($)),null,ce))}f.map=a;function o(K,re){return s((V,J=null,ce)=>K($=>{re($),V.call(J,$)},null,ce))}f.forEach=o;function n(K,re){return s((V,J=null,ce)=>K($=>re($)&&V.call(J,$),null,ce))}f.filter=n;function r(K){return K}f.signal=r;function i(...K){return(re,V=null,J)=>I.combinedDisposable(...K.map(ce=>ce($=>re.call(V,$),null,J)))}f.any=i;function l(K,re,V){let J=V;return a(K,ce=>(J=re(J,ce),J))}f.reduce=l;function s(K){let re;const V=new P({onFirstListenerAdd(){re=K(V.fire,V)},onLastListenerRemove(){re.dispose()}});return V.event}f.snapshot=s;function p(K,re,V=100,J=!1,ce){let $,O,F,j=0;const Q=new P({leakWarningThreshold:ce,onFirstListenerAdd(){$=K(ne=>{j++,O=re(O,ne),J&&!F&&(Q.fire(O),O=void 0),clearTimeout(F),F=setTimeout(()=>{const oe=O;O=void 0,F=void 0,(!J||j>1)&&Q.fire(oe),j=0},V)})},onLastListenerRemove(){$.dispose()}});return Q.event}f.debounce=p;function k(K){const re=new Date().getTime();return a(u(K),V=>new Date().getTime()-re)}f.stopwatch=k;function w(K){let re=!0,V;return n(K,J=>{const ce=re||J!==V;return re=!1,V=J,ce})}f.latch=w;function T(K,re=!1,V=[]){let J=V.slice(),ce=K(F=>{J?J.push(F):O.fire(F)});const $=()=>{J&&J.forEach(F=>O.fire(F)),J=null},O=new P({onFirstListenerAdd(){ce||(ce=K(F=>O.fire(F)))},onFirstListenerDidAdd(){J&&(re?setTimeout($):$())},onLastListenerRemove(){ce&&ce.dispose(),ce=null}});return O.event}f.buffer=T;class h{constructor(re){this.event=re}map(re){return new h(a(this.event,re))}forEach(re){return new h(o(this.event,re))}filter(re){return new h(n(this.event,re))}reduce(re,V){return new h(l(this.event,re,V))}latch(){return new h(w(this.event))}debounce(re,V=100,J=!1,ce){return new h(p(this.event,re,V,J,ce))}on(re,V,J){return this.event(re,V,J)}once(re,V,J){return u(this.event)(re,V,J)}}function A(K){return new h(K)}f.chain=A;function N(K,re,V=J=>J){const J=(...F)=>O.fire(V(...F)),ce=()=>K.on(re,J),$=()=>K.removeListener(re,J),O=new P({onFirstListenerAdd:ce,onLastListenerRemove:$});return O.event}f.fromNodeEventEmitter=N;function B(K,re,V=J=>J){const J=(...F)=>O.fire(V(...F)),ce=()=>K.addEventListener(re,J),$=()=>K.removeEventListener(re,J),O=new P({onFirstListenerAdd:ce,onLastListenerRemove:$});return O.event}f.fromDOMEventEmitter=B;function W(K){const re=new P;let V=!1;return K.then(void 0,()=>null).then(()=>{V?re.fire(void 0):setTimeout(()=>re.fire(void 0),0)}),V=!0,re.event}f.fromPromise=W;function H(K){return new Promise(re=>u(K)(re))}f.toPromise=H})(L=e.Event||(e.Event={}));class g{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${g._idPool++}`}start(u){this._stopWatch=new C.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}g._idPool=0;let t=-1;function R(f){const u=t;return t=f,{dispose(){t=u}}}e.setGlobalLeakWarningThreshold=R;class _{constructor(u,a=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let a=t;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),!(a<=0||u<a)){this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(o)||0;if(this._stacks.set(o,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let r,i=0;for(const[l,s]of this._stacks)(!r||i<s)&&(r=l,i=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(o)||0;this._stacks.set(o,r-1)}}}}class P{constructor(u){var a;this._disposed=!1,this._options=u,this._leakageMon=t>0?new _(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((a=this._options)===null||a===void 0?void 0:a._profName)?new g(this._options._profName):void 0}get event(){return this._event||(this._event=(u,a,o)=>{var n;this._listeners||(this._listeners=new E.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(a?[u,a]:u);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,a);const l=(n=this._leakageMon)===null||n===void 0?void 0:n.check(this._listeners.size);let s;return s={dispose:()=>{l&&l(),s.dispose=P._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof I.DisposableStore?o.add(s):Array.isArray(o)&&o.push(s),s}),this._event}fire(u){var a,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,u]);for((a=this._perfMon)===null||a===void 0||a.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,r]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,r):n[0].call(n[1],r)}catch(i){y.onUnexpectedError(i)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var u,a,o;(u=this._listeners)===null||u===void 0||u.clear(),(a=this._deliveryQueue)===null||a===void 0||a.clear(),(o=this._leakageMon)===null||o===void 0||o.dispose(),this._disposed=!0}}e.Emitter=P,P._noop=function(){};class v extends P{constructor(u){super(u);this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=u==null?void 0:u.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=v;class c extends P{async fireAsync(u,a,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,u]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[n,r]=this._asyncDeliveryQueue.shift(),i=[],l=Object.assign(Object.assign({},r),{waitUntil:s=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");o&&(s=o(s,typeof n=="function"?n:n[0])),i.push(s)}});try{typeof n=="function"?n.call(void 0,l):n[0].call(n[1],l)}catch(s){y.onUnexpectedError(s);continue}Object.freeze(i),await Promise.all(i).catch(s=>y.onUnexpectedError(s))}}}}e.AsyncEmitter=c;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new P({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const a={event:u,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const o=()=>{this.hasListeners&&this.unhook(a);const n=this.events.indexOf(a);this.events.splice(n,1)};return I.toDisposable(m.once(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(a=>this.emitter.fire(a))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class S{constructor(){this.buffers=[]}wrapEvent(u){return(a,o,n)=>u(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>a.call(o,r)):a.call(o,r)},void 0,n)}bufferEvents(u){const a=[];this.buffers.push(a);const o=u();return this.buffers.pop(),a.forEach(n=>n()),o}}e.EventBufferer=S;class b{constructor(){this.listening=!1,this.inputEvent=L.None,this.inputEventListener=I.Disposable.None,this.emitter=new P({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(he[27],de([0,1,6]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const m=Object.freeze(function(L,g){const t=setTimeout(L.bind(g),0);return{dispose(){clearTimeout(t)}}});var I;(function(L){function g(t){return t===L.None||t===L.Cancelled||t instanceof E?!0:!t||typeof t!="object"?!1:typeof t.isCancellationRequested=="boolean"&&typeof t.onCancellationRequested=="function"}L.isCancellationToken=g,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:m})})(I=e.CancellationToken||(e.CancellationToken={}));class E{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?m:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new E),this._token}cancel(){this._token?this._token instanceof E&&this._token.cancel():this._token=I.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof E&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=C}),define(he[17],de([0,1,27,12,6,4]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(H){return H&&typeof H.then=="function"}e.isThenable=C;function L(H){const K=new y.CancellationTokenSource,re=H(K.token),V=new Promise((J,ce)=>{K.token.onCancellationRequested(()=>{ce(m.canceled())}),Promise.resolve(re).then($=>{K.dispose(),J($)},$=>{K.dispose(),ce($)})});return new class{cancel(){K.cancel()}then(J,ce){return V.then(J,ce)}catch(J){return this.then(void 0,J)}finally(J){return V.finally(J)}}}e.createCancelablePromise=L;function g(H,K,re){return Promise.race([H,new Promise(V=>K.onCancellationRequested(()=>V(re)))])}e.raceCancellation=g;async function t(H){let K=-1;const re=H.map((J,ce)=>J.then($=>(K=ce,$))),V=await Promise.race(re);return H.forEach((J,ce)=>{ce!==K&&J.cancel()}),V}e.raceCancellablePromises=t;function R(H,K,re){let V;const J=setTimeout(()=>{V==null||V(void 0),re==null||re()},K);return Promise.race([H.finally(()=>clearTimeout(J)),new Promise(ce=>V=ce)])}e.raceTimeout=R;function _(H){return new Promise((K,re)=>{const V=H();C(V)?V.then(K,re):K(V)})}e.asPromise=_;class P{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(K){if(this.activePromise){if(this.queuedPromiseFactory=K,!this.queuedPromise){const re=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(re,re).then(V)})}return new Promise((re,V)=>{this.queuedPromise.then(re,V)})}return this.activePromise=K(),new Promise((re,V)=>{this.activePromise.then(J=>{this.activePromise=null,re(J)},J=>{this.activePromise=null,V(J)})})}}e.Throttler=P;class v{constructor(){this.current=Promise.resolve(null)}queue(K){return this.current=this.current.then(()=>K(),()=>K())}}e.Sequencer=v;class c{constructor(){this.promiseMap=new Map}queue(K,re){var V;const ce=((V=this.promiseMap.get(K))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.promiseMap.get(K)===ce&&this.promiseMap.delete(K)});return this.promiseMap.set(K,ce),ce}}e.SequencerByKey=c;class d{constructor(K){this.defaultDelay=K,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(K,re=this.defaultDelay){return this.task=K,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,J)=>{this.doResolve=V,this.doReject=J}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},re),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(m.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=d;class S{constructor(K){this.delayer=new d(K),this.throttler=new P}trigger(K,re){return this.delayer.trigger(()=>this.throttler.queue(K),re)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class b{constructor(){this._isOpen=!1,this._promise=new Promise((K,re)=>{this._completePromise=K})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;function f(H,K){return K?new Promise((re,V)=>{const J=setTimeout(re,H);K.onCancellationRequested(()=>{clearTimeout(J),V(m.canceled())})}):L(re=>f(H,re))}e.timeout=f;function u(H,K=0){const re=setTimeout(H,K);return E.toDisposable(()=>clearTimeout(re))}e.disposableTimeout=u;function a(H){return H.then(void 0,K=>{})}e.ignoreErrors=a;function o(H){const K=[];let re=0;const V=H.length;function J(){return re<V?H[re++]():null}function ce($){$!=null&&K.push($);const O=J();return O?O.then(ce):Promise.resolve(K)}return Promise.resolve(null).then(ce)}e.sequence=o;function n(H,K=V=>!!V,re=null){let V=0;const J=H.length,ce=()=>{if(V>=J)return Promise.resolve(re);const $=H[V++];return Promise.resolve($()).then(F=>K(F)?Promise.resolve(F):ce())};return ce()}e.first=n;function r(H,K=V=>!!V,re=null){if(H.length===0)return Promise.resolve(re);let V=H.length;const J=()=>{var ce,$;V=-1;for(const O of H)($=(ce=O).cancel)===null||$===void 0||$.call(ce)};return new Promise((ce,$)=>{for(const O of H)O.then(F=>{--V>=0&&K(F)?(J(),ce(F)):V===0&&ce(re)}).catch(F=>{--V>=0&&(J(),$(F))})})}e.firstParallel=r;class i{constructor(K){this._size=0,this.maxDegreeOfParalellism=K,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(K){return this._size++,new Promise((re,V)=>{this.outstandingPromises.push({factory:K,c:re,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const K=this.outstandingPromises.shift();this.runningPromises++;const re=K.factory();re.then(K.c,K.e),re.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class l extends i{constructor(){super(1)}}e.Queue=l;class s{constructor(){this.queues=new Map}queueFor(K){const re=K.toString();if(!this.queues.has(re)){const V=new l;V.onFinished(()=>{V.dispose(),this.queues.delete(re)}),this.queues.set(re,V)}return this.queues.get(re)}dispose(){this.queues.forEach(K=>K.dispose()),this.queues.clear()}}e.ResourceQueue=s;class p{constructor(K,re){this._token=-1,typeof K=="function"&&typeof re=="number"&&this.setIfNotSet(K,re)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(K,re){this.cancel(),this._token=setTimeout(()=>{this._token=-1,K()},re)}setIfNotSet(K,re){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,K()},re))}}e.TimeoutTimer=p;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(K,re){this.cancel(),this._token=setInterval(()=>{K()},re)}}e.IntervalTimer=k;class w{constructor(K,re){this.timeoutToken=-1,this.runner=K,this.timeout=re,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(K=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,K)}get delay(){return this.timeout}set delay(K){this.timeout=K}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=w;class T extends w{constructor(K,re){super(K,re);this.units=[]}work(K){this.units.push(K),this.isScheduled()||this.schedule()}doRun(){const K=this.units;this.units=[],this.runner&&this.runner(K)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=K=>{const re=setTimeout(()=>K(H));let V=!1;return{dispose(){V||(V=!0,clearTimeout(re))}}}}else e.runWhenIdle=(H,K)=>{const re=requestIdleCallback(H,typeof K=="number"?{timeout:K}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(re))}}}}();class h{constructor(K){this._didRun=!1,this._executor=()=>{try{this._value=K()}catch(re){this._error=re}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=h;async function A(H,K,re){let V;for(let J=0;J<re;J++)try{return await H()}catch(ce){V=ce,await f(K)}throw V}e.retry=A;class N{hasPending(K){return this._pending?typeof K=="number"?this._pending.taskId===K:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var K;(K=this._pending)===null||K===void 0||K.cancel()}setPending(K,re,V){return this._pending={taskId:K,cancel:()=>V==null?void 0:V(),promise:re},re.then(()=>this.donePending(K),()=>this.donePending(K)),re}donePending(K){this._pending&&K===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const K=this._next;this._next=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}setNext(K){if(this._next)this._next.run=K;else{let re,V;const J=new Promise((ce,$)=>{re=ce,V=$});this._next={run:K,promise:J,promiseResolve:re,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=N;class B{constructor(K){this.interval=K,this.lastIncrementTime=0,this.value=0}increment(){const K=Date.now();return K-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=K,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((K,re)=>{this.completeCallback=K,this.errorCallback=re})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(K){return new Promise(re=>{this.completeCallback(K),this.resolved=!0,re()})}error(K){return new Promise(re=>{this.errorCallback(K),this.rejected=!0,re()})}cancel(){new Promise(K=>{this.errorCallback(m.canceled()),this.rejected=!0,K()})}}e.DeferredPromise=W}),define(he[115],de([0,1,6]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class m{constructor(){this._icons=new Map,this._onDidRegister=new y.Emitter}add(R){const _=this._icons.get(R.id);_?R.description?_.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const I=new m;e.iconRegistry=I;function E(t,R){return new C(t,R)}e.registerCodicon=E;class C{constructor(R,_,P){this.id=R,this.definition=_,this.description=P,I.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function L(t,R){const _=["codicon","codicon-"+t];return R&&_.push("codicon-modifier-"+R),_}e.getClassNamesArray=L;var g;(function(t){t.iconIdRegex=/^(codicon\/)?([a-z\-]+)(?:~([a-z\-]+))?$/i;function R(v){if(v instanceof C)return["codicon","codicon-"+v.id];const c=t.iconIdRegex.exec(v.id);if(!c)return R(C.error);let[,,d,S]=c;const b=["codicon","codicon-"+d];return S&&b.push("codicon-modifier-"+S),b}t.asClassNameArray=R;function _(v){return R(v).join(" ")}t.asClassName=_;function P(v){return"."+R(v).join(".")}t.asCSSSelector=P})(g=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{character:"\\ea60"}),t.plus=new t("plus",{character:"\\ea60"}),t.gistNew=new t("gist-new",{character:"\\ea60"}),t.repoCreate=new t("repo-create",{character:"\\ea60"}),t.lightbulb=new t("lightbulb",{character:"\\ea61"}),t.lightBulb=new t("light-bulb",{character:"\\ea61"}),t.repo=new t("repo",{character:"\\ea62"}),t.repoDelete=new t("repo-delete",{character:"\\ea62"}),t.gistFork=new t("gist-fork",{character:"\\ea63"}),t.repoForked=new t("repo-forked",{character:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{character:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{character:"\\ea64"}),t.recordKeys=new t("record-keys",{character:"\\ea65"}),t.keyboard=new t("keyboard",{character:"\\ea65"}),t.tag=new t("tag",{character:"\\ea66"}),t.tagAdd=new t("tag-add",{character:"\\ea66"}),t.tagRemove=new t("tag-remove",{character:"\\ea66"}),t.person=new t("person",{character:"\\ea67"}),t.personAdd=new t("person-add",{character:"\\ea67"}),t.personFollow=new t("person-follow",{character:"\\ea67"}),t.personOutline=new t("person-outline",{character:"\\ea67"}),t.personFilled=new t("person-filled",{character:"\\ea67"}),t.gitBranch=new t("git-branch",{character:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{character:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{character:"\\ea68"}),t.sourceControl=new t("source-control",{character:"\\ea68"}),t.mirror=new t("mirror",{character:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{character:"\\ea69"}),t.star=new t("star",{character:"\\ea6a"}),t.starAdd=new t("star-add",{character:"\\ea6a"}),t.starDelete=new t("star-delete",{character:"\\ea6a"}),t.starEmpty=new t("star-empty",{character:"\\ea6a"}),t.comment=new t("comment",{character:"\\ea6b"}),t.commentAdd=new t("comment-add",{character:"\\ea6b"}),t.alert=new t("alert",{character:"\\ea6c"}),t.warning=new t("warning",{character:"\\ea6c"}),t.search=new t("search",{character:"\\ea6d"}),t.searchSave=new t("search-save",{character:"\\ea6d"}),t.logOut=new t("log-out",{character:"\\ea6e"}),t.signOut=new t("sign-out",{character:"\\ea6e"}),t.logIn=new t("log-in",{character:"\\ea6f"}),t.signIn=new t("sign-in",{character:"\\ea6f"}),t.eye=new t("eye",{character:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{character:"\\ea70"}),t.eyeWatch=new t("eye-watch",{character:"\\ea70"}),t.circleFilled=new t("circle-filled",{character:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{character:"\\ea71"}),t.closeDirty=new t("close-dirty",{character:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{character:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{character:"\\ea71"}),t.debugHint=new t("debug-hint",{character:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{character:"\\ea72"}),t.edit=new t("edit",{character:"\\ea73"}),t.pencil=new t("pencil",{character:"\\ea73"}),t.info=new t("info",{character:"\\ea74"}),t.issueOpened=new t("issue-opened",{character:"\\ea74"}),t.gistPrivate=new t("gist-private",{character:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{character:"\\ea75"}),t.lock=new t("lock",{character:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{character:"\\ea75"}),t.close=new t("close",{character:"\\ea76"}),t.removeClose=new t("remove-close",{character:"\\ea76"}),t.x=new t("x",{character:"\\ea76"}),t.repoSync=new t("repo-sync",{character:"\\ea77"}),t.sync=new t("sync",{character:"\\ea77"}),t.clone=new t("clone",{character:"\\ea78"}),t.desktopDownload=new t("desktop-download",{character:"\\ea78"}),t.beaker=new t("beaker",{character:"\\ea79"}),t.microscope=new t("microscope",{character:"\\ea79"}),t.vm=new t("vm",{character:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{character:"\\ea7a"}),t.file=new t("file",{character:"\\ea7b"}),t.fileText=new t("file-text",{character:"\\ea7b"}),t.more=new t("more",{character:"\\ea7c"}),t.ellipsis=new t("ellipsis",{character:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{character:"\\ea7c"}),t.mailReply=new t("mail-reply",{character:"\\ea7d"}),t.reply=new t("reply",{character:"\\ea7d"}),t.organization=new t("organization",{character:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{character:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{character:"\\ea7e"}),t.newFile=new t("new-file",{character:"\\ea7f"}),t.fileAdd=new t("file-add",{character:"\\ea7f"}),t.newFolder=new t("new-folder",{character:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{character:"\\ea80"}),t.trash=new t("trash",{character:"\\ea81"}),t.trashcan=new t("trashcan",{character:"\\ea81"}),t.history=new t("history",{character:"\\ea82"}),t.clock=new t("clock",{character:"\\ea82"}),t.folder=new t("folder",{character:"\\ea83"}),t.fileDirectory=new t("file-directory",{character:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{character:"\\ea83"}),t.logoGithub=new t("logo-github",{character:"\\ea84"}),t.markGithub=new t("mark-github",{character:"\\ea84"}),t.github=new t("github",{character:"\\ea84"}),t.terminal=new t("terminal",{character:"\\ea85"}),t.console=new t("console",{character:"\\ea85"}),t.repl=new t("repl",{character:"\\ea85"}),t.zap=new t("zap",{character:"\\ea86"}),t.symbolEvent=new t("symbol-event",{character:"\\ea86"}),t.error=new t("error",{character:"\\ea87"}),t.stop=new t("stop",{character:"\\ea87"}),t.variable=new t("variable",{character:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{character:"\\ea88"}),t.array=new t("array",{character:"\\ea8a"}),t.symbolArray=new t("symbol-array",{character:"\\ea8a"}),t.symbolModule=new t("symbol-module",{character:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{character:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{character:"\\ea8b"}),t.symbolObject=new t("symbol-object",{character:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{character:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{character:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{character:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{character:"\\ea8f"}),t.symbolNull=new t("symbol-null",{character:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{character:"\\ea90"}),t.symbolNumber=new t("symbol-number",{character:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{character:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{character:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{character:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{character:"\\ea92"}),t.symbolKey=new t("symbol-key",{character:"\\ea93"}),t.symbolText=new t("symbol-text",{character:"\\ea93"}),t.symbolReference=new t("symbol-reference",{character:"\\ea94"}),t.goToFile=new t("go-to-file",{character:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{character:"\\ea95"}),t.symbolValue=new t("symbol-value",{character:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{character:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{character:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{character:"\\ea97"}),t.archive=new t("archive",{character:"\\ea98"}),t.arrowBoth=new t("arrow-both",{character:"\\ea99"}),t.arrowDown=new t("arrow-down",{character:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{character:"\\ea9b"}),t.arrowRight=new t("arrow-right",{character:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{character:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{character:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{character:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{character:"\\eaa0"}),t.arrowUp=new t("arrow-up",{character:"\\eaa1"}),t.bell=new t("bell",{character:"\\eaa2"}),t.bold=new t("bold",{character:"\\eaa3"}),t.book=new t("book",{character:"\\eaa4"}),t.bookmark=new t("bookmark",{character:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{character:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{character:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{character:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{character:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{character:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{character:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{character:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{character:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{character:"\\eaab"}),t.briefcase=new t("briefcase",{character:"\\eaac"}),t.broadcast=new t("broadcast",{character:"\\eaad"}),t.browser=new t("browser",{character:"\\eaae"}),t.bug=new t("bug",{character:"\\eaaf"}),t.calendar=new t("calendar",{character:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{character:"\\eab1"}),t.check=new t("check",{character:"\\eab2"}),t.checklist=new t("checklist",{character:"\\eab3"}),t.chevronDown=new t("chevron-down",{character:"\\eab4"}),t.chevronLeft=new t("chevron-left",{character:"\\eab5"}),t.chevronRight=new t("chevron-right",{character:"\\eab6"}),t.chevronUp=new t("chevron-up",{character:"\\eab7"}),t.chromeClose=new t("chrome-close",{character:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{character:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{character:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{character:"\\eabb"}),t.circleOutline=new t("circle-outline",{character:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{character:"\\eabc"}),t.circleSlash=new t("circle-slash",{character:"\\eabd"}),t.circuitBoard=new t("circuit-board",{character:"\\eabe"}),t.clearAll=new t("clear-all",{character:"\\eabf"}),t.clippy=new t("clippy",{character:"\\eac0"}),t.closeAll=new t("close-all",{character:"\\eac1"}),t.cloudDownload=new t("cloud-download",{character:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{character:"\\eac3"}),t.code=new t("code",{character:"\\eac4"}),t.collapseAll=new t("collapse-all",{character:"\\eac5"}),t.colorMode=new t("color-mode",{character:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{character:"\\eac7"}),t.compareChanges=new t("compare-changes",{character:"\\eafd"}),t.creditCard=new t("credit-card",{character:"\\eac9"}),t.dash=new t("dash",{character:"\\eacc"}),t.dashboard=new t("dashboard",{character:"\\eacd"}),t.database=new t("database",{character:"\\eace"}),t.debugContinue=new t("debug-continue",{character:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{character:"\\ead0"}),t.debugPause=new t("debug-pause",{character:"\\ead1"}),t.debugRestart=new t("debug-restart",{character:"\\ead2"}),t.debugStart=new t("debug-start",{character:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{character:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{character:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{character:"\\ead6"}),t.debugStop=new t("debug-stop",{character:"\\ead7"}),t.debug=new t("debug",{character:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{character:"\\ead9"}),t.deviceCamera=new t("device-camera",{character:"\\eada"}),t.deviceMobile=new t("device-mobile",{character:"\\eadb"}),t.diffAdded=new t("diff-added",{character:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{character:"\\eadd"}),t.diffModified=new t("diff-modified",{character:"\\eade"}),t.diffRemoved=new t("diff-removed",{character:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{character:"\\eae0"}),t.diff=new t("diff",{character:"\\eae1"}),t.discard=new t("discard",{character:"\\eae2"}),t.editorLayout=new t("editor-layout",{character:"\\eae3"}),t.emptyWindow=new t("empty-window",{character:"\\eae4"}),t.exclude=new t("exclude",{character:"\\eae5"}),t.extensions=new t("extensions",{character:"\\eae6"}),t.eyeClosed=new t("eye-closed",{character:"\\eae7"}),t.fileBinary=new t("file-binary",{character:"\\eae8"}),t.fileCode=new t("file-code",{character:"\\eae9"}),t.fileMedia=new t("file-media",{character:"\\eaea"}),t.filePdf=new t("file-pdf",{character:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{character:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{character:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{character:"\\eaee"}),t.fileZip=new t("file-zip",{character:"\\eaef"}),t.files=new t("files",{character:"\\eaf0"}),t.filter=new t("filter",{character:"\\eaf1"}),t.flame=new t("flame",{character:"\\eaf2"}),t.foldDown=new t("fold-down",{character:"\\eaf3"}),t.foldUp=new t("fold-up",{character:"\\eaf4"}),t.fold=new t("fold",{character:"\\eaf5"}),t.folderActive=new t("folder-active",{character:"\\eaf6"}),t.folderOpened=new t("folder-opened",{character:"\\eaf7"}),t.gear=new t("gear",{character:"\\eaf8"}),t.gift=new t("gift",{character:"\\eaf9"}),t.gistSecret=new t("gist-secret",{character:"\\eafa"}),t.gist=new t("gist",{character:"\\eafb"}),t.gitCommit=new t("git-commit",{character:"\\eafc"}),t.gitCompare=new t("git-compare",{character:"\\eafd"}),t.gitMerge=new t("git-merge",{character:"\\eafe"}),t.githubAction=new t("github-action",{character:"\\eaff"}),t.githubAlt=new t("github-alt",{character:"\\eb00"}),t.globe=new t("globe",{character:"\\eb01"}),t.grabber=new t("grabber",{character:"\\eb02"}),t.graph=new t("graph",{character:"\\eb03"}),t.gripper=new t("gripper",{character:"\\eb04"}),t.heart=new t("heart",{character:"\\eb05"}),t.home=new t("home",{character:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{character:"\\eb07"}),t.hubot=new t("hubot",{character:"\\eb08"}),t.inbox=new t("inbox",{character:"\\eb09"}),t.issueClosed=new t("issue-closed",{character:"\\eb0a"}),t.issueReopened=new t("issue-reopened",{character:"\\eb0b"}),t.issues=new t("issues",{character:"\\eb0c"}),t.italic=new t("italic",{character:"\\eb0d"}),t.jersey=new t("jersey",{character:"\\eb0e"}),t.json=new t("json",{character:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{character:"\\eb10"}),t.key=new t("key",{character:"\\eb11"}),t.law=new t("law",{character:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{character:"\\eb13"}),t.linkExternal=new t("link-external",{character:"\\eb14"}),t.link=new t("link",{character:"\\eb15"}),t.listOrdered=new t("list-ordered",{character:"\\eb16"}),t.listUnordered=new t("list-unordered",{character:"\\eb17"}),t.liveShare=new t("live-share",{character:"\\eb18"}),t.loading=new t("loading",{character:"\\eb19"}),t.location=new t("location",{character:"\\eb1a"}),t.mailRead=new t("mail-read",{character:"\\eb1b"}),t.mail=new t("mail",{character:"\\eb1c"}),t.markdown=new t("markdown",{character:"\\eb1d"}),t.megaphone=new t("megaphone",{character:"\\eb1e"}),t.mention=new t("mention",{character:"\\eb1f"}),t.milestone=new t("milestone",{character:"\\eb20"}),t.mortarBoard=new t("mortar-board",{character:"\\eb21"}),t.move=new t("move",{character:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{character:"\\eb23"}),t.mute=new t("mute",{character:"\\eb24"}),t.noNewline=new t("no-newline",{character:"\\eb25"}),t.note=new t("note",{character:"\\eb26"}),t.octoface=new t("octoface",{character:"\\eb27"}),t.openPreview=new t("open-preview",{character:"\\eb28"}),t.package_=new t("package",{character:"\\eb29"}),t.paintcan=new t("paintcan",{character:"\\eb2a"}),t.pin=new t("pin",{character:"\\eb2b"}),t.play=new t("play",{character:"\\eb2c"}),t.run=new t("run",{character:"\\eb2c"}),t.plug=new t("plug",{character:"\\eb2d"}),t.preserveCase=new t("preserve-case",{character:"\\eb2e"}),t.preview=new t("preview",{character:"\\eb2f"}),t.project=new t("project",{character:"\\eb30"}),t.pulse=new t("pulse",{character:"\\eb31"}),t.question=new t("question",{character:"\\eb32"}),t.quote=new t("quote",{character:"\\eb33"}),t.radioTower=new t("radio-tower",{character:"\\eb34"}),t.reactions=new t("reactions",{character:"\\eb35"}),t.references=new t("references",{character:"\\eb36"}),t.refresh=new t("refresh",{character:"\\eb37"}),t.regex=new t("regex",{character:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{character:"\\eb39"}),t.remote=new t("remote",{character:"\\eb3a"}),t.remove=new t("remove",{character:"\\eb3b"}),t.replaceAll=new t("replace-all",{character:"\\eb3c"}),t.replace=new t("replace",{character:"\\eb3d"}),t.repoClone=new t("repo-clone",{character:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{character:"\\eb3f"}),t.repoPull=new t("repo-pull",{character:"\\eb40"}),t.repoPush=new t("repo-push",{character:"\\eb41"}),t.report=new t("report",{character:"\\eb42"}),t.requestChanges=new t("request-changes",{character:"\\eb43"}),t.rocket=new t("rocket",{character:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{character:"\\eb45"}),t.rootFolder=new t("root-folder",{character:"\\eb46"}),t.rss=new t("rss",{character:"\\eb47"}),t.ruby=new t("ruby",{character:"\\eb48"}),t.saveAll=new t("save-all",{character:"\\eb49"}),t.saveAs=new t("save-as",{character:"\\eb4a"}),t.save=new t("save",{character:"\\eb4b"}),t.screenFull=new t("screen-full",{character:"\\eb4c"}),t.screenNormal=new t("screen-normal",{character:"\\eb4d"}),t.searchStop=new t("search-stop",{character:"\\eb4e"}),t.server=new t("server",{character:"\\eb50"}),t.settingsGear=new t("settings-gear",{character:"\\eb51"}),t.settings=new t("settings",{character:"\\eb52"}),t.shield=new t("shield",{character:"\\eb53"}),t.smiley=new t("smiley",{character:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{character:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{character:"\\eb56"}),t.splitVertical=new t("split-vertical",{character:"\\eb57"}),t.squirrel=new t("squirrel",{character:"\\eb58"}),t.starFull=new t("star-full",{character:"\\eb59"}),t.starHalf=new t("star-half",{character:"\\eb5a"}),t.symbolClass=new t("symbol-class",{character:"\\eb5b"}),t.symbolColor=new t("symbol-color",{character:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{character:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{character:"\\eb5e"}),t.symbolField=new t("symbol-field",{character:"\\eb5f"}),t.symbolFile=new t("symbol-file",{character:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{character:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{character:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{character:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{character:"\\eb64"}),t.symbolProperty=new t("symbol-property",{character:"\\eb65"}),t.wrench=new t("wrench",{character:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{character:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{character:"\\eb66"}),t.tasklist=new t("tasklist",{character:"\\eb67"}),t.telescope=new t("telescope",{character:"\\eb68"}),t.textSize=new t("text-size",{character:"\\eb69"}),t.threeBars=new t("three-bars",{character:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{character:"\\eb6b"}),t.thumbsup=new t("thumbsup",{character:"\\eb6c"}),t.tools=new t("tools",{character:"\\eb6d"}),t.triangleDown=new t("triangle-down",{character:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{character:"\\eb6f"}),t.triangleRight=new t("triangle-right",{character:"\\eb70"}),t.triangleUp=new t("triangle-up",{character:"\\eb71"}),t.twitter=new t("twitter",{character:"\\eb72"}),t.unfold=new t("unfold",{character:"\\eb73"}),t.unlock=new t("unlock",{character:"\\eb74"}),t.unmute=new t("unmute",{character:"\\eb75"}),t.unverified=new t("unverified",{character:"\\eb76"}),t.verified=new t("verified",{character:"\\eb77"}),t.versions=new t("versions",{character:"\\eb78"}),t.vmActive=new t("vm-active",{character:"\\eb79"}),t.vmOutline=new t("vm-outline",{character:"\\eb7a"}),t.vmRunning=new t("vm-running",{character:"\\eb7b"}),t.watch=new t("watch",{character:"\\eb7c"}),t.whitespace=new t("whitespace",{character:"\\eb7d"}),t.wholeWord=new t("whole-word",{character:"\\eb7e"}),t.window=new t("window",{character:"\\eb7f"}),t.wordWrap=new t("word-wrap",{character:"\\eb80"}),t.zoomIn=new t("zoom-in",{character:"\\eb81"}),t.zoomOut=new t("zoom-out",{character:"\\eb82"}),t.listFilter=new t("list-filter",{character:"\\eb83"}),t.listFlat=new t("list-flat",{character:"\\eb84"}),t.listSelection=new t("list-selection",{character:"\\eb85"}),t.selection=new t("selection",{character:"\\eb85"}),t.listTree=new t("list-tree",{character:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{character:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{character:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{character:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{character:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{character:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{character:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{character:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{character:"\\eb8c"}),t.symbolString=new t("symbol-string",{character:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{character:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{character:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{character:"\\eb90"}),t.callIncoming=new t("call-incoming",{character:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{character:"\\eb93"}),t.menu=new t("menu",{character:"\\eb94"}),t.expandAll=new t("expand-all",{character:"\\eb95"}),t.feedback=new t("feedback",{character:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{character:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{character:"\\eb98"}),t.account=new t("account",{character:"\\eb99"}),t.bellDot=new t("bell-dot",{character:"\\eb9a"}),t.debugConsole=new t("debug-console",{character:"\\eb9b"}),t.library=new t("library",{character:"\\eb9c"}),t.output=new t("output",{character:"\\eb9d"}),t.runAll=new t("run-all",{character:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{character:"\\eb9f"}),t.pinned=new t("pinned",{character:"\\eba0"}),t.githubInverted=new t("github-inverted",{character:"\\eba1"}),t.debugAlt=new t("debug-alt",{character:"\\eb91"}),t.serverProcess=new t("server-process",{character:"\\eba2"}),t.serverEnvironment=new t("server-environment",{character:"\\eba3"}),t.pass=new t("pass",{character:"\\eba4"}),t.stopCircle=new t("stop-circle",{character:"\\eba5"}),t.playCircle=new t("play-circle",{character:"\\eba6"}),t.record=new t("record",{character:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{character:"\\eba8"}),t.vmConnect=new t("vm-connect",{character:"\\eba9"}),t.cloud=new t("cloud",{character:"\\ebaa"}),t.merge=new t("merge",{character:"\\ebab"}),t.exportIcon=new t("export",{character:"\\ebac"}),t.graphLeft=new t("graph-left",{character:"\\ebad"}),t.magnet=new t("magnet",{character:"\\ebae"}),t.notebook=new t("notebook",{character:"\\ebaf"}),t.redo=new t("redo",{character:"\\ebb0"}),t.checkAll=new t("check-all",{character:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{character:"\\ebb2"}),t.passFilled=new t("pass-filled",{character:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{character:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{character:"\\ebb5"}),t.combine=new t("combine",{character:"\\ebb6"}),t.gather=new t("gather",{character:"\\ebb6"}),t.table=new t("table",{character:"\\ebb7"}),t.variableGroup=new t("variable-group",{character:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{character:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{character:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{character:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{character:"\\ebbc"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(he[44],de([0,1,12,4]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.observe=e.transform=e.toReadable=e.toStream=e.peekStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(S){const b=S;return b&&[b.on,b.pause,b.resume,b.destroy].every(f=>typeof f=="function")}e.isReadableStream=I;function E(S){const b=S;return b&&I(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean"}e.isReadableBufferedStream=E;function C(S,b){return new L(S,b)}e.newWriteableStream=C;class L{constructor(b,f){this.reducer=b,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(b instanceof Error?this.error(b):b&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(f=>f(b))}emitError(b){this.listeners.error.length===0?y.onUnexpectedError(b):this.listeners.error.slice(0).forEach(f=>f(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,f){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(b,f){if(!this.state.destroyed){let u;switch(b){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const a=u.indexOf(f);a>=0&&u.splice(a,1)}}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(S,b){const f=[];let u;for(;(u=S.read())!==null;)f.push(u);return b(f)}e.consumeReadable=g;function t(S,b,f){const u=[];let a;for(;(a=S.read())!==null&&u.length<f;)u.push(a);return a===null&&u.length>0?b(u):{read:()=>{if(u.length>0)return u.shift();if(typeof a!="undefined"){const o=a;return a=void 0,o}return S.read()}}}e.peekReadable=t;function R(S,b){return new Promise((f,u)=>{const a=[];S.on("error",o=>u(o)),S.on("end",()=>f(b(a))),S.on("data",o=>a.push(o))})}e.consumeStream=R;function _(S,b){return new Promise((f,u)=>{const a=new m.DisposableStore,o=[],n=l=>{if(o.push(l),o.length>b)return a.dispose(),S.pause(),f({stream:S,buffer:o,ended:!1})};a.add(m.toDisposable(()=>S.removeListener("data",n))),S.on("data",n);const r=l=>u(l);a.add(m.toDisposable(()=>S.removeListener("error",r))),S.on("error",r);const i=()=>f({stream:S,buffer:o,ended:!0});a.add(m.toDisposable(()=>S.removeListener("end",i))),S.on("end",i)})}e.peekStream=_;function P(S,b){const f=C(b);return f.end(S),f}e.toStream=P;function v(S){let b=!1;return{read:()=>b?null:(b=!0,S)}}e.toReadable=v;function c(S,b,f){const u=C(f);return S.on("data",a=>u.write(b.data(a))),S.on("end",()=>u.end()),S.on("error",a=>u.error(b.error?b.error(a):a)),u}e.transform=c;function d(S){const b=Promise.race([new Promise(f=>S.on("end",()=>f())),new Promise(f=>S.on("error",()=>f()))]);return{errorOrEnd(){return S.resume(),b}}}e.observe=d}),define(he[13],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function y(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=y;const m=/{(\d+)}/g;function I(ee,...ue){return ue.length===0?ee:ee.replace(m,function(Ee,G){const q=parseInt(G,10);return isNaN(q)||q<0||q>=ue.length?Ee:ue[q]})}e.format=I;function E(ee){return ee.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=E;function C(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function L(ee,ue){let Ee=0;const G=ue.charCodeAt(0);for(let q=ee.length-1;q>=0;q--)ee.charCodeAt(q)===G&&Ee++;return Ee}e.count=L;function g(ee,ue,Ee="\u2026"){return ee.length<=ue?ee:`${ee.substr(0,ue)}${Ee}`}e.truncate=g;function t(ee,ue=" "){const Ee=R(ee,ue);return _(Ee,ue)}e.trim=t;function R(ee,ue){if(!ee||!ue)return ee;const Ee=ue.length;if(Ee===0||ee.length===0)return ee;let G=0;for(;ee.indexOf(ue,G)===G;)G=G+Ee;return ee.substring(G)}e.ltrim=R;function _(ee,ue){if(!ee||!ue)return ee;const Ee=ue.length,G=ee.length;if(Ee===0||G===0)return ee;let q=G,U=-1;for(;U=ee.lastIndexOf(ue,q-1),!(U===-1||U+Ee!==q);){if(U===0)return"";q=U}return ee.substring(0,q)}e.rtrim=_;function P(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=P;function v(ee){return ee.replace(/\*/g,"")}e.stripWildcards=v;function c(ee,ue,Ee={}){if(!ee)throw new Error("Cannot create regex from empty string");ue||(ee=C(ee)),Ee.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let G="";return Ee.global&&(G+="g"),Ee.matchCase||(G+="i"),Ee.multiline&&(G+="m"),Ee.unicode&&(G+="u"),new RegExp(ee,G)}e.createRegExp=c;function d(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function S(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function b(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=b;function f(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=f;function u(ee){for(let ue=0,Ee=ee.length;ue<Ee;ue++){const G=ee.charCodeAt(ue);if(G!==32&&G!==9)return ue}return-1}e.firstNonWhitespaceIndex=u;function a(ee,ue=0,Ee=ee.length){for(let G=ue;G<Ee;G++){const q=ee.charCodeAt(G);if(q!==32&&q!==9)return ee.substring(ue,G)}return ee.substring(ue,Ee)}e.getLeadingWhitespace=a;function o(ee,ue=ee.length-1){for(let Ee=ue;Ee>=0;Ee--){const G=ee.charCodeAt(Ee);if(G!==32&&G!==9)return Ee}return-1}e.lastNonWhitespaceIndex=o;function n(ee,ue){return ee<ue?-1:ee>ue?1:0}e.compare=n;function r(ee,ue,Ee=0,G=ee.length,q=0,U=ue.length){for(;Ee<G&&q<U;Ee++,q++){let X=ee.charCodeAt(Ee),Y=ue.charCodeAt(q);if(X<Y)return-1;if(X>Y)return 1}const D=G-Ee,x=U-q;return D<x?-1:D>x?1:0}e.compareSubstring=r;function i(ee,ue){return l(ee,ue,0,ee.length,0,ue.length)}e.compareIgnoreCase=i;function l(ee,ue,Ee=0,G=ee.length,q=0,U=ue.length){for(;Ee<G&&q<U;Ee++,q++){let X=ee.charCodeAt(Ee),Y=ue.charCodeAt(q);if(X!==Y){const se=X-Y;if(!(se===32&&p(Y))&&!(se===-32&&p(X)))return s(X)&&s(Y)?se:r(ee.toLowerCase(),ue.toLowerCase(),Ee,G,q,U)}}const D=G-Ee,x=U-q;return D<x?-1:D>x?1:0}e.compareSubstringIgnoreCase=l;function s(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=s;function p(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=p;function k(ee){return s(ee)||p(ee)}function w(ee,ue){return ee.length===ue.length&&T(ee,ue)}e.equalsIgnoreCase=w;function T(ee,ue,Ee=ee.length){for(let G=0;G<Ee;G++){const q=ee.charCodeAt(G),U=ue.charCodeAt(G);if(q!==U){if(k(q)&&k(U)){const D=Math.abs(q-U);if(D!==0&&D!==32)return!1}else if(String.fromCharCode(q).toLowerCase()!==String.fromCharCode(U).toLowerCase())return!1}}return!0}function h(ee,ue){const Ee=ue.length;return ue.length>ee.length?!1:T(ee,ue,Ee)}e.startsWithIgnoreCase=h;function A(ee,ue){let Ee,G=Math.min(ee.length,ue.length);for(Ee=0;Ee<G;Ee++)if(ee.charCodeAt(Ee)!==ue.charCodeAt(Ee))return Ee;return G}e.commonPrefixLength=A;function N(ee,ue){let Ee,G=Math.min(ee.length,ue.length);const q=ee.length-1,U=ue.length-1;for(Ee=0;Ee<G;Ee++)if(ee.charCodeAt(q-Ee)!==ue.charCodeAt(U-Ee))return Ee;return G}e.commonSuffixLength=N;function B(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=B;function W(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=W;function H(ee,ue){return(ee-55296<<10)+(ue-56320)+65536}e.computeCodePoint=H;function K(ee,ue,Ee){const G=ee.charCodeAt(Ee);if(B(G)&&Ee+1<ue){const q=ee.charCodeAt(Ee+1);if(W(q))return H(G,q)}return G}e.getNextCodePoint=K;function re(ee,ue){const Ee=ee.charCodeAt(ue-1);if(W(Ee)&&ue>1){const G=ee.charCodeAt(ue-2);if(B(G))return H(G,Ee)}return Ee}function V(ee,ue){const Ee=pe.getInstance(),G=ue,q=ee.length,U=K(ee,q,ue);ue+=U>=65536?2:1;let D=Ee.getGraphemeBreakType(U);for(;ue<q;){const x=K(ee,q,ue),X=Ee.getGraphemeBreakType(x);if(ae(D,X))break;ue+=x>=65536?2:1,D=X}return ue-G}e.nextCharLength=V;function J(ee,ue){const Ee=pe.getInstance(),G=ue,q=re(ee,ue);ue-=q>=65536?2:1;let U=Ee.getGraphemeBreakType(q);for(;ue>0;){const D=re(ee,ue),x=Ee.getGraphemeBreakType(D);if(ae(x,U))break;ue-=D>=65536?2:1,U=x}return G-ue}e.prevCharLength=J;function ce(ee,ue){const Ee=pe.getInstance(),G=ee.length,q=ue,U=K(ee,G,ue),D=Ee.getGraphemeBreakType(U);ue+=U>=65536?2:1;let x=D;for(;ue<G;){const Y=K(ee,G,ue),se=Ee.getGraphemeBreakType(Y);if(ae(x,se))break;ue+=Y>=65536?2:1,x=se}const X=ue;for(ue=q,x=D;ue>0;){const Y=re(ee,ue),se=Ee.getGraphemeBreakType(Y);if(ae(se,x))break;ue-=Y>=65536?2:1,x=se}return[ue,X]}function $(ee,ue){return ue>0&&W(ee.charCodeAt(ue))?ce(ee,ue-1):ce(ee,ue)}e.getCharContainingOffset=$;function O(ee){const ue=ee.length;let Ee=0,G=0;for(;G<ue;){const D=K(ee,ue,G);G+=D>=65536?2:1,D<128?Ee+=1:D<2048?Ee+=2:D<65536?Ee+=3:Ee+=4}const q=new Uint8Array(Ee);G=0;let U=0;for(;G<ue;){const D=K(ee,ue,G);G+=D>=65536?2:1,D<128?q[U++]=D:D<2048?(q[U++]=192|(D&1984)>>>6,q[U++]=128|(D&63)>>>0):D<65536?(q[U++]=224|(D&61440)>>>12,q[U++]=128|(D&4032)>>>6,q[U++]=128|(D&63)>>>0):(q[U++]=240|(D&1835008)>>>18,q[U++]=128|(D&258048)>>>12,q[U++]=128|(D&4032)>>>6,q[U++]=128|(D&63)>>>0)}return q}e.encodeUTF8=O;function F(ee){const ue=ee.byteLength,Ee=[];let G=0;for(;G<ue;){const q=ee[G];let U;if(q>=240&&G+3<ue?U=(ee[G++]&7)<<18>>>0|(ee[G++]&63)<<12>>>0|(ee[G++]&63)<<6>>>0|(ee[G++]&63)<<0>>>0:q>=224&&G+2<ue?U=(ee[G++]&15)<<12>>>0|(ee[G++]&63)<<6>>>0|(ee[G++]&63)<<0>>>0:q>=192&&G+1<ue?U=(ee[G++]&31)<<6>>>0|(ee[G++]&63)<<0>>>0:U=ee[G++],U>=0&&U<=55295||U>=57344&&U<=65535)Ee.push(String.fromCharCode(U));else if(U>=65536&&U<=1114111){const D=U-65536,x=55296+((D&1047552)>>>10),X=56320+((D&1023)>>>0);Ee.push(String.fromCharCode(x)),Ee.push(String.fromCharCode(X))}else Ee.push(String.fromCharCode(65533))}return Ee.join("")}e.decodeUTF8=F;const j=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(ee){return j.test(ee)}e.containsRTL=Q;const ne=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;function oe(ee){return ne.test(ee)}e.containsEmoji=oe;const ie=/^[\t\n\r\x20-\x7E]*$/;function fe(ee){return ie.test(ee)}e.isBasicASCII=fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ie(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=Ie;function Pe(ee){for(let ue=0,Ee=ee.length;ue<Ee;ue++)if(Ne(ee.charCodeAt(ue)))return!0;return!1}e.containsFullWidthCharacter=Pe;function Ne(ee){return ee=+ee,ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=Ne;function ye(ee){return ee>=127462&&ee<=127487||ee>=9728&&ee<=10175||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129003||ee>=129280&&ee<=129535||ee>=129648&&ee<=129651||ee>=129656&&ee<=129666||ee>=129680&&ee<=129685}e.isEmojiImprecise=ye;function _e(ee,ue){if(ee.length<ue)return ee;const Ee=/\b/g;let G=0;for(;Ee.test(ee)&&!(ee.length-Ee.lastIndex<ue);)G=Ee.lastIndex,Ee.lastIndex+=1;return ee.substring(G).replace(/^\s/,"")}e.lcut=_e;const Ce=/\x1B\x5B[12]?K/g,ze=/\x1b\[\d+m/g,je=/\x1b\[0?m/g;function me(ee){return ee&&(ee=ee.replace(Ce,""),ee=ee.replace(ze,""),ee=ee.replace(je,"")),ee}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ve(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ve;function Se(ee){return ve(ee)?ee.substr(1):ee}e.stripUTF8BOM=Se;function ke(ee,ue){if(!ee||!ue||ee.length<ue.length)return!1;const Ee=ue.length,G=ee.toLowerCase();let q=0,U=-1;for(;q<Ee;){const D=G.indexOf(ue[q],U+1);if(D<0)return!1;U=D,q++}return!0}e.fuzzyContains=ke;function Re(ee,ue=!1){return ee?(ue&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=Re;function Fe(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=Fe;function We(ee,ue=1){if(ue===0)return"";let Ee=-1;do Ee=ee.indexOf(`
`,Ee+1),ue--;while(ue>0&&Ee>=0);return Ee===-1?ee:(ee[Ee-1]==="\r"&&Ee--,ee.substr(0,Ee))}e.getNLines=We;function Be(ee){const ue=90-65+1;return ee=ee%(2*ue),ee<ue?String.fromCharCode(97+ee):String.fromCharCode(65+ee-ue)}e.singleLetterHash=Be;function Ve(ee){return pe.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=Ve;function ae(ee,ue){return ee===0?ue!==5&&ue!==7:ee===2&&ue===3?!1:ee===4||ee===2||ee===3||ue===4||ue===2||ue===3?!0:!(ee===8&&(ue===8||ue===9||ue===11||ue===12)||(ee===11||ee===9)&&(ue===9||ue===10)||(ee===12||ee===10)&&ue===10||ue===5||ue===13||ue===7||ee===1||ee===13&&ue===14||ee===6&&ue===6)}e.breakBetweenGraphemeBreakType=ae;var ge;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class pe{constructor(){this._data=Oe()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const Ee=this._data,G=Ee.length/3;let q=1;for(;q<=G;)if(ue<Ee[3*q])q=2*q;else if(ue>Ee[3*q+1])q=2*q+1;else return Ee[3*q+2];return 0}}pe._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(he[18],de([0,1,13,44]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer!="undefined",E=typeof TextEncoder!="undefined",C=typeof TextDecoder!="undefined";let L,g;class t{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return I?new t(Buffer.allocUnsafe(s)):new t(new Uint8Array(s))}static wrap(s){return I&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new t(s)}static fromString(s,p){return!((p==null?void 0:p.dontUseNodeBuffer)||!1)&&I?new t(Buffer.from(s)):E?(L||(L=new TextEncoder),new t(L.encode(s))):new t(y.encodeUTF8(s))}static concat(s,p){if(typeof p=="undefined"){p=0;for(let T=0,h=s.length;T<h;T++)p+=s[T].byteLength}const k=t.alloc(p);let w=0;for(let T=0,h=s.length;T<h;T++){const A=s[T];k.set(A,w),w+=A.byteLength}return k}toString(){return I?this.buffer.toString():C?(g||(g=new TextDecoder),g.decode(this.buffer)):y.decodeUTF8(this.buffer)}slice(s,p){return new t(this.buffer.subarray(s,p))}set(s,p){s instanceof t?this.buffer.set(s.buffer,p):this.buffer.set(s,p)}readUInt32BE(s){return P(this.buffer,s)}writeUInt32BE(s,p){v(this.buffer,s,p)}readUInt32LE(s){return c(this.buffer,s)}writeUInt32LE(s,p){d(this.buffer,s,p)}readUInt8(s){return S(this.buffer,s)}writeUInt8(s,p){b(this.buffer,s,p)}}e.VSBuffer=t;function R(l,s){return l[s+0]<<0>>>0|l[s+1]<<8>>>0}e.readUInt16LE=R;function _(l,s,p){l[p+0]=s&255,s=s>>>8,l[p+1]=s&255}e.writeUInt16LE=_;function P(l,s){return l[s]*2**24+l[s+1]*2**16+l[s+2]*2**8+l[s+3]}e.readUInt32BE=P;function v(l,s,p){l[p+3]=s,s=s>>>8,l[p+2]=s,s=s>>>8,l[p+1]=s,s=s>>>8,l[p]=s}e.writeUInt32BE=v;function c(l,s){return l[s+0]<<0>>>0|l[s+1]<<8>>>0|l[s+2]<<16>>>0|l[s+3]<<24>>>0}e.readUInt32LE=c;function d(l,s,p){l[p+0]=s&255,s=s>>>8,l[p+1]=s&255,s=s>>>8,l[p+2]=s&255,s=s>>>8,l[p+3]=s&255}e.writeUInt32LE=d;function S(l,s){return l[s]}e.readUInt8=S;function b(l,s,p){l[p]=s}e.writeUInt8=b;function f(l){return m.consumeReadable(l,s=>t.concat(s))}e.readableToBuffer=f;function u(l){return m.toReadable(l)}e.bufferToReadable=u;function a(l){return m.consumeStream(l,s=>t.concat(s))}e.streamToBuffer=a;async function o(l){return l.ended?t.concat(l.buffer):t.concat([...l.buffer,await a(l.stream)])}e.bufferedStreamToBuffer=o;function n(l){return m.toStream(l,s=>t.concat(s))}e.bufferToStream=n;function r(l){return m.transform(l,{data:s=>typeof s=="string"?t.fromString(s):t.wrap(s)},s=>t.concat(s))}e.streamToBufferReadableStream=r;function i(l){return m.newWriteableStream(s=>t.concat(s),l)}e.newWriteableBufferStream=i}),define(he[116],de([0,1,13]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function m(b){return I(b,0)}e.hash=m;function I(b,f){switch(typeof b){case"object":return b===null?E(349,f):Array.isArray(b)?g(b,f):t(b,f);case"string":return L(b,f);case"boolean":return C(b,f);case"number":return E(b,f);case"undefined":return E(937,f);default:return E(617,f)}}e.doHash=I;function E(b,f){return(f<<5)-f+b|0}function C(b,f){return E(b?433:863,f)}function L(b,f){f=E(149417,f);for(let u=0,a=b.length;u<a;u++)f=E(b.charCodeAt(u),f);return f}e.stringHash=L;function g(b,f){return f=E(104579,f),b.reduce((u,a)=>I(a,u),f)}function t(b,f){return f=E(181387,f),Object.keys(b).sort().reduce((u,a)=>(u=L(a,u),I(b[a],u)),f)}class R{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=I(f,this._value),this._value}}e.Hasher=R;var _;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(_||(_={}));function P(b,f,u=32){const a=u-f,o=~((1<<a)-1);return(b<<f|(o&b)>>>a)>>>0}function v(b,f=0,u=b.byteLength,a=0){for(let o=0;o<u;o++)b[f+o]=a}function c(b,f,u="0"){for(;b.length<f;)b=u+b;return b}function d(b,f=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(u=>u.toString(16).padStart(2,"0")).join(""):c((b>>>0).toString(16),f/4)}e.toHexString=d;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const u=f.length;if(u!==0){const a=this._buff;let o=this._buffLen,n=this._leftoverHighSurrogate,r,i;for(n!==0?(r=n,i=-1,n=0):(r=f.charCodeAt(0),i=0);;){let l=r;if(y.isHighSurrogate(r))if(i+1<u){const s=f.charCodeAt(i+1);y.isLowSurrogate(s)?(i++,l=y.computeCodePoint(r,s)):l=65533}else{n=r;break}else y.isLowSurrogate(r)&&(l=65533);if(o=this._push(a,o,l),i++,i<u)r=f.charCodeAt(i);else break}this._buffLen=o,this._leftoverHighSurrogate=n}}_push(f,u,a){return a<128?f[u++]=a:a<2048?(f[u++]=192|(a&1984)>>>6,f[u++]=128|(a&63)>>>0):a<65536?(f[u++]=224|(a&61440)>>>12,f[u++]=128|(a&4032)>>>6,f[u++]=128|(a&63)>>>0):(f[u++]=240|(a&1835008)>>>18,f[u++]=128|(a&258048)>>>12,f[u++]=128|(a&4032)>>>6,f[u++]=128|(a&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=S._bigBlock32,u=this._buffDV;for(let k=0;k<64;k+=4)f.setUint32(k,u.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)f.setUint32(k,P(f.getUint32(k-12,!1)^f.getUint32(k-32,!1)^f.getUint32(k-56,!1)^f.getUint32(k-64,!1),1),!1);let a=this._h0,o=this._h1,n=this._h2,r=this._h3,i=this._h4,l,s,p;for(let k=0;k<80;k++)k<20?(l=o&n|~o&r,s=1518500249):k<40?(l=o^n^r,s=1859775393):k<60?(l=o&n|o&r|n&r,s=2400959708):(l=o^n^r,s=3395469782),p=P(a,5)+l+i+s+f.getUint32(k*4,!1)&4294967295,i=r,r=n,n=P(o,30),o=a,a=p;this._h0=this._h0+a&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(he[70],de([0,1,13]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var m;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(m||(m={})),function(I){const E="error",C="warning",L="warn",g="info";function t(R){return R?y.equalsIgnoreCase(E,R)?I.Error:y.equalsIgnoreCase(C,R)||y.equalsIgnoreCase(L,R)?I.Warning:y.equalsIgnoreCase(g,R)?I.Info:I.Ignore:I.Ignore}I.fromValue=t}(m||(m={})),e.default=m}),define(he[11],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function y(s){return Array.isArray(s)}e.isArray=y;function m(s){return typeof s=="string"}e.isString=m;function I(s){return Array.isArray(s)&&s.every(p=>m(p))}e.isStringArray=I;function E(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=E;function C(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=C;function L(s){return s===!0||s===!1}e.isBoolean=L;function g(s){return typeof s=="undefined"}e.isUndefined=g;function t(s){return!R(s)}e.isDefined=t;function R(s){return g(s)||s===null}e.isUndefinedOrNull=R;function _(s,p){if(!s)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=_;function P(s){if(R(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=P;function v(...s){const p=[];for(let k=0;k<s.length;k++){const w=s[k];if(R(w))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);p.push(w)}return p}e.assertAllDefined=v;const c=Object.prototype.hasOwnProperty;function d(s){if(!E(s))return!1;for(let p in s)if(c.call(s,p))return!1;return!0}e.isEmptyObject=d;function S(s){return typeof s=="function"}e.isFunction=S;function b(...s){return s.length>0&&s.every(S)}e.areFunctions=b;function f(s,p){const k=Math.min(s.length,p.length);for(let w=0;w<k;w++)u(s[w],p[w])}e.validateConstraints=f;function u(s,p){if(m(p)){if(typeof s!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(S(p)){try{if(s instanceof p)return}catch(k){}if(!R(s)&&s.constructor===p||p.length===1&&p.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function a(s){let p=[],k=Object.getPrototypeOf(s);for(;Object.prototype!==k;)p=p.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return p}e.getAllPropertyNames=a;function o(s){const p=[];for(const k of a(s))typeof s[k]=="function"&&p.push(k);return p}e.getAllMethodNames=o;function n(s,p){const k=T=>function(){const h=Array.prototype.slice.call(arguments,0);return p(T,h)};let w={};for(const T of s)w[T]=k(T);return w}e.createProxyObject=n;function r(s){return s===null?void 0:s}e.withNullAsUndefined=r;function i(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=i;function l(s){return class{constructor(){return new Proxy({},{get(p,k){if(p[k])return p[k];throw new Error(`Not Implemented: ${s}->${String(k)}`)}})}}}e.NotImplementedProxy=l}),define(he[28],de([0,1,5,13,2,11]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function L(r){return r.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=L;function g(r,i=I.posix.sep){if(!r)return"";const l=r.length,s=r.charCodeAt(0);if(C(s)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let k=3;const w=k;for(;k<l&&!C(r.charCodeAt(k));k++);if(w!==k&&!C(r.charCodeAt(k+1))){for(k+=1;k<l;k++)if(C(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,i)}}return i}else if(S(s)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<l;p++)if(C(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=g;function t(r){if(!y.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let l=2;const s=l;for(;l<r.length&&(i=r.charCodeAt(l),i!==92);l++);return!(s===l||(i=r.charCodeAt(l+1),isNaN(i)||i===92))}e.isUNC=t;const R=/[\\/:\*\?"<>\|]/g,_=/[\\/]/g,P=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(r,i=y.isWindows){const l=i?R:_;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||i&&P.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=v;function c(r,i,l){const s=r===i;return!l||s?s:!r||!i?!1:m.equalsIgnoreCase(r,i)}e.isEqual=c;function d(r,i,l,s=I.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(l){if(!m.startsWithIgnoreCase(r,i))return!1;if(i.length===r.length)return!0;let k=i.length;return i.charAt(i.length-1)===s&&k--,r.charAt(k)===s}return i.charAt(i.length-1)!==s&&(i+=s),r.indexOf(i)===0}e.isEqualOrParent=d;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function b(r,i){return y.isWindows&&r.endsWith(":")&&(r+=I.sep),I.isAbsolute(r)||(r=I.join(i,r)),r=I.normalize(r),y.isWindows?(r=m.rtrim(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=m.rtrim(r,I.sep),r||(r=I.sep)),r}e.sanitizeFilePath=b;function f(r){const i=I.normalize(r);return y.isWindows?r.length>3?!1:u(i)&&(r.length===2||i.charCodeAt(2)===92):i===I.posix.sep}e.isRootOrDriveLetter=f;function u(r){return y.isWindows?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function a(r){return u(r)?r[0]:void 0}e.getDriveLetter=a;function o(r,i,l){return i.length>r.length?-1:r===i?0:(l&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=o;function n(r){const i=r.split(":");let l,s,p;if(i.forEach(k=>{const w=Number(k);E.isNumber(w)?s===void 0?s=w:p===void 0&&(p=w):l=l?[l,k].join(":"):k}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:s!==void 0?s:void 0,column:p!==void 0?p:s!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(he[19],de([0,1,11]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function m(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const d=Array.isArray(c)?[]:{};return Object.keys(c).forEach(S=>{c[S]&&typeof c[S]=="object"?d[S]=m(c[S]):d[S]=c[S]}),d}e.deepClone=m;function I(c){if(!c||typeof c!="object")return c;const d=[c];for(;d.length>0;){const S=d.shift();Object.freeze(S);for(const b in S)if(E.call(S,b)){const f=S[b];typeof f=="object"&&!Object.isFrozen(f)&&d.push(f)}}return c}e.deepFreeze=I;const E=Object.prototype.hasOwnProperty;function C(c,d){return L(c,d,new Set)}e.cloneAndChange=C;function L(c,d,S){if(y.isUndefinedOrNull(c))return c;const b=d(c);if(typeof b!="undefined")return b;if(y.isArray(c)){const f=[];for(const u of c)f.push(L(u,d,S));return f}if(y.isObject(c)){if(S.has(c))throw new Error("Cannot clone recursive data-structure");S.add(c);const f={};for(let u in c)E.call(c,u)&&(f[u]=L(c[u],d,S));return S.delete(c),f}return c}function g(c,d,S=!0){return y.isObject(c)?(y.isObject(d)&&Object.keys(d).forEach(b=>{b in c?S&&(y.isObject(c[b])&&y.isObject(d[b])?g(c[b],d[b],S):c[b]=d[b]):c[b]=d[b]}),c):d}e.mixin=g;function t(c,d){if(c===d)return!0;if(c==null||d===null||d===void 0||typeof c!=typeof d||typeof c!="object"||Array.isArray(c)!==Array.isArray(d))return!1;let S,b;if(Array.isArray(c)){if(c.length!==d.length)return!1;for(S=0;S<c.length;S++)if(!t(c[S],d[S]))return!1}else{const f=[];for(b in c)f.push(b);f.sort();const u=[];for(b in d)u.push(b);if(u.sort(),!t(f,u))return!1;for(S=0;S<f.length;S++)if(!t(c[f[S]],d[f[S]]))return!1}return!0}e.equals=t;function R(c){const d=new Set;return JSON.stringify(c,(S,b)=>{if(y.isObject(b)||Array.isArray(b)){if(d.has(b))return"[Circular]";d.add(b)}return b})}e.safeStringify=R;function _(c,d,S){const b=d(c);return typeof b=="undefined"?S:b}e.getOrDefault=_;function P(c,d){const S=Object.create(null);return!c||!d||Object.keys(d).forEach(f=>{const u=c[f],a=d[f];t(u,a)||(S[f]=a)}),S}e.distinct=P;function v(c,d){const S=d.toLowerCase(),b=Object.keys(c).find(f=>f.toLowerCase()===S);return b?c[b]:c[d]}e.getCaseInsensitive=v}),define(he[3],de([0,1,5,2]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,E=/^\//,C=/^\/\//;function L(i,l){if(!i.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!I.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!E.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(i,l){return!i&&!l?"file":i}function t(i,l){switch(i){case"https":case"http":case"file":l?l[0]!==_&&(l=_+l):l=_;break}return l}const R="",_="/",P=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(l,s,p,k,w,T=!1){typeof l=="object"?(this.scheme=l.scheme||R,this.authority=l.authority||R,this.path=l.path||R,this.query=l.query||R,this.fragment=l.fragment||R):(this.scheme=g(l,T),this.authority=s||R,this.path=t(this.scheme,p||R),this.query=k||R,this.fragment=w||R,L(this,T))}static isUri(l){return l instanceof v?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return u(this,!1)}with(l){if(!l)return this;let{scheme:s,authority:p,path:k,query:w,fragment:T}=l;return s===void 0?s=this.scheme:s===null&&(s=R),p===void 0?p=this.authority:p===null&&(p=R),k===void 0?k=this.path:k===null&&(k=R),w===void 0?w=this.query:w===null&&(w=R),T===void 0?T=this.fragment:T===null&&(T=R),s===this.scheme&&p===this.authority&&k===this.path&&w===this.query&&T===this.fragment?this:new d(s,p,k,w,T)}static parse(l,s=!1){const p=P.exec(l);return p?new d(p[2]||R,r(p[4]||R),r(p[5]||R),r(p[7]||R),r(p[9]||R),s):new d(R,R,R,R,R)}static file(l){let s=R;if(y.isWindows&&(l=l.replace(/\\/g,_)),l[0]===_&&l[1]===_){const p=l.indexOf(_,2);p===-1?(s=l.substring(2),l=_):(s=l.substring(2,p),l=l.substring(p)||_)}return new d("file",s,l,R,R)}static from(l){return new d(l.scheme,l.authority,l.path,l.query,l.fragment)}static joinPath(l,...s){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return y.isWindows&&l.scheme==="file"?p=v.file(m.win32.join(u(l,!0),...s)).path:p=m.posix.join(l.path,...s),l.with({path:p})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof v)return l;{const s=new d(l);return s._formatted=l.external,s._fsPath=l._sep===c?l.fsPath:null,s}}else return l}}e.URI=v;const c=y.isWindows?1:void 0;class d extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=c),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,l){let s,p=-1;for(let k=0;k<i.length;k++){const w=i.charCodeAt(k);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||l&&w===47)p!==-1&&(s+=encodeURIComponent(i.substring(p,k)),p=-1),s!==void 0&&(s+=i.charAt(k));else{s===void 0&&(s=i.substr(0,k));const T=S[w];T!==void 0?(p!==-1&&(s+=encodeURIComponent(i.substring(p,k)),p=-1),s+=T):p===-1&&(p=k)}}return p!==-1&&(s+=encodeURIComponent(i.substring(p))),s!==void 0?s:i}function f(i){let l;for(let s=0;s<i.length;s++){const p=i.charCodeAt(s);p===35||p===63?(l===void 0&&(l=i.substr(0,s)),l+=S[p]):l!==void 0&&(l+=i[s])}return l!==void 0?l:i}function u(i,l){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?l?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,y.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=u;function a(i,l){const s=l?f:b;let p="",{scheme:k,authority:w,path:T,query:h,fragment:A}=i;if(k&&(p+=k,p+=":"),(w||k==="file")&&(p+=_,p+=_),w){let N=w.indexOf("@");if(N!==-1){const B=w.substr(0,N);w=w.substr(N+1),N=B.indexOf(":"),N===-1?p+=s(B,!1):(p+=s(B.substr(0,N),!1),p+=":",p+=s(B.substr(N+1),!1)),p+="@"}w=w.toLowerCase(),N=w.indexOf(":"),N===-1?p+=s(w,!1):(p+=s(w.substr(0,N),!1),p+=w.substr(N))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const N=T.charCodeAt(1);N>=65&&N<=90&&(T=`/${String.fromCharCode(N+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const N=T.charCodeAt(0);N>=65&&N<=90&&(T=`${String.fromCharCode(N+32)}:${T.substr(2)}`)}p+=s(T,!0)}return h&&(p+="?",p+=s(h,!1)),A&&(p+="#",p+=l?A:b(A,!1)),p}function o(i){try{return decodeURIComponent(i)}catch(l){return i.length>3?i.substr(0,3)+o(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,l=>o(l)):i}}),define(he[117],de([0,1,14,3]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.getUriFromAmdModule=e.getPathFromAmdModule=void 0;function I(L,g){return E(L,g).fsPath}e.getPathFromAmdModule=I;function E(L,g){return m.URI.parse(L.toUrl(g))}e.getUriFromAmdModule=E;class C{static get(){const g=new Map,t=new Map,R=new Map,_=new Map;function P(b,f){b.has(f.detail)||b.set(f.detail,-f.timestamp)}function v(b,f){let u=b.get(f.detail);!u||u>=0||b.set(f.detail,u+f.timestamp)}const c=y.mergeSort(Z.getStats().slice(0),(b,f)=>b.timestamp-f.timestamp);for(const b of c)switch(b.type){case 10:P(g,b);break;case 11:case 12:v(g,b);break;case 21:P(t,b);break;case 22:v(t,b);break;case 33:P(R,b);break;case 34:v(R,b);break;case 31:P(_,b);break;case 32:v(_,b);break}let d=0;R.forEach(b=>d+=b);function S(b){let f=[];return b.forEach((u,a)=>f.push([a,u])),f}return{amdLoad:S(g),amdInvoke:S(t),nodeRequire:S(R),nodeEval:S(_),nodeRequireTotal:d}}static toMarkdownTable(g,t){let R="",_=[];return g.forEach((P,v)=>{_[v]=P.length}),t.forEach(P=>{P.forEach((v,c)=>{typeof v=="undefined"&&(v=P[c]="-");const d=v.toString().length;_[c]=Math.max(d,_[c])})}),g.forEach((P,v)=>{R+=`| ${P+" ".repeat(_[v]-P.toString().length)} `}),R+=`|
`,g.forEach((P,v)=>{R+=`| ${"-".repeat(_[v])} `}),R+=`|
`,t.forEach(P=>{P.forEach((v,c)=>{typeof v!="undefined"&&(R+=`| ${v+" ".repeat(_[c]-v.toString().length)} `)}),R+=`|
`}),R}}e.LoaderStats=C}),define(he[118],de([0,1,3]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function m(t){const R=t;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=m;function I(t){const R=[];let _;try{const P=JSON.parse(t.arguments),v=P[P.length-1];v&&v.__$stack&&(P.pop(),_=v.__$stack),R.push(...P)}catch(P){R.push("Unable to log remote console arguments",t.arguments)}return{args:R,stack:_}}e.parse=I;function E(t){if(typeof t!="string")return E(I(t).stack);const R=t;if(R){const _=C(R),P=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(_||"");if(P&&P.length===4)return{uri:y.URI.file(P[1]),line:Number(P[2]),column:Number(P[3])}}}e.getFirstFrame=E;function C(t){if(!t)return t;const R=t.indexOf(`
`);return R===-1?t:t.substring(0,R)}function L(t,R){const{args:_,stack:P}=I(t),v=typeof _[0]=="string"&&_.length===1;let c=C(P);c&&(c=`(${c.trim()})`);let d=[];if(typeof _[0]=="string"?c&&v?d=[`%c[${R}] %c${_[0]} %c${c}`,g("blue"),g(""),g("grey")]:d=[`%c[${R}] %c${_[0]}`,g("blue"),g(""),..._.slice(1)]:d=[`%c[${R}]%`,g("blue"),..._],c&&!v&&d.push(c),typeof console[t.severity]!="function")throw new Error("Unknown console method");console[t.severity].apply(console,d)}e.log=L;function g(t){return`color: ${t}`}}),define(he[25],de([0,1,3,13]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(f,u,a){let o=f.get(u);return o===void 0&&(o=a,f.set(u,o)),o}e.getOrSet=I;function E(f){const u=[];return f.forEach((a,o)=>{u.push(`${o} => ${a}`)}),`Map(${f.size}) {${u.join(", ")}}`}e.mapToString=E;function C(f){const u=[];return f.forEach(a=>{u.push(a)}),`Set(${f.size}) {${u.join(", ")}}`}e.setToString=C;class L{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const a=u.charCodeAt(0),o=this._value.charCodeAt(this._pos);return a-o}value(){return this._value[this._pos]}}e.StringIterator=L;class g{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?m.compareSubstring(u,this._value,0,u.length,this._from,this._to):m.compareSubstringIgnoreCase(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class t{constructor(u=!0,a=!0){this._splitOnBackslash=u,this._caseSensitive=a}reset(u){return this._value=u.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?m.compareSubstring(u,this._value,0,u.length,this._from,this._to):m.compareSubstringIgnoreCase(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=t;var R;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(R||(R={}));class _{constructor(u){this._ignorePathCasing=u,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new t(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return m.compareIgnoreCase(u,this._value.scheme);if(this._states[this._stateIdx]===2)return m.compareIgnoreCase(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return m.compare(u,this._value.query);if(this._states[this._stateIdx]===5)return m.compare(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=_;class P{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class v{constructor(u){this._iter=u}static forUris(u=()=>!1){return new v(new _(u))}static forPaths(){return new v(new t)}static forStrings(){return new v(new L)}static forConfigKeys(){return new v(new g)}clear(){this._root=void 0}set(u,a){const o=this._iter.reset(u);let n;for(this._root||(this._root=new P,this._root.segment=o.value()),n=this._root;;){const i=o.cmp(n.segment);if(i>0)n.left||(n.left=new P,n.left.segment=o.value()),n=n.left;else if(i<0)n.right||(n.right=new P,n.right.segment=o.value()),n=n.right;else if(o.hasNext())o.next(),n.mid||(n.mid=new P,n.mid.segment=o.value()),n=n.mid;else break}const r=n.value;return n.value=a,n.key=u,r}get(u){var a;return(a=this._getNode(u))===null||a===void 0?void 0:a.value}_getNode(u){const a=this._iter.reset(u);let o=this._root;for(;o;){const n=a.cmp(o.segment);if(n>0)o=o.left;else if(n<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else break}return o}has(u){const a=this._getNode(u);return!((a==null?void 0:a.value)===void 0&&(a==null?void 0:a.mid)===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,a){const o=this._iter.reset(u),n=[];let r=this._root;for(;r;){const i=o.cmp(r.segment);if(i>0)n.push([1,r]),r=r.left;else if(i<0)n.push([-1,r]),r=r.right;else if(o.hasNext())o.next(),n.push([0,r]),r=r.mid;else{for(a?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;n.length>0&&r.isEmpty();){let[l,s]=n.pop();switch(l){case 1:s.left=void 0;break;case 0:s.mid=void 0;break;case-1:s.right=void 0;break}r=s}break}}}findSubstr(u){const a=this._iter.reset(u);let o=this._root,n;for(;o;){const r=a.cmp(o.segment);if(r>0)o=o.left;else if(r<0)o=o.right;else if(a.hasNext())a.next(),n=o.value||n,o=o.mid;else break}return o&&o.value||n}findSuperstr(u){const a=this._iter.reset(u);let o=this._root;for(;o;){const n=a.cmp(o.segment);if(n>0)o=o.left;else if(n<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(u){for(const[a,o]of this)u(o,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(u){u&&(yield*this._entries(u.left),u.value&&(yield[u.key,u.value]),yield*this._entries(u.mid),yield*this._entries(u.right))}}e.TernarySearchTree=v;class c{constructor(u,a){this[Symbol.toStringTag]="ResourceMap",u instanceof c?(this.map=new Map(u.map),this.toKey=a!=null?a:c.defaultToKey):(this.map=new Map,this.toKey=u!=null?u:c.defaultToKey)}set(u,a){return this.map.set(this.toKey(u),a),this}get(u){return this.map.get(this.toKey(u))}has(u){return this.map.has(this.toKey(u))}get size(){return this.map.size}clear(){this.map.clear()}delete(u){return this.map.delete(this.toKey(u))}forEach(u,a){typeof a!="undefined"&&(u=u.bind(a));for(let[o,n]of this.map)u(n,y.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let u of this.map.keys())yield y.URI.parse(u)}*entries(){for(let u of this.map.entries())yield[y.URI.parse(u[0]),u[1]]}*[Symbol.iterator](){for(let u of this.map)yield[y.URI.parse(u[0]),u[1]]}}e.ResourceMap=c,c.defaultToKey=f=>f.toString();var d;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(d=e.Touch||(e.Touch={}));class S{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var u;return(u=this._head)===null||u===void 0?void 0:u.value}get last(){var u;return(u=this._tail)===null||u===void 0?void 0:u.value}has(u){return this._map.has(u)}get(u,a=0){const o=this._map.get(u);if(!!o)return a!==0&&this.touch(o,a),o.value}set(u,a,o=0){let n=this._map.get(u);if(n)n.value=a,o!==0&&this.touch(n,o);else{switch(n={key:u,value:a,next:void 0,previous:void 0},o){case 0:this.addItemLast(n);break;case 1:this.addItemFirst(n);break;case 2:this.addItemLast(n);break;default:this.addItemLast(n);break}this._map.set(u,n),this._size++}return this}delete(u){return!!this.remove(u)}remove(u){const a=this._map.get(u);if(!!a)return this._map.delete(u),this.removeItem(a),this._size--,a.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const u=this._head;return this._map.delete(u.key),this.removeItem(u),this._size--,u.value}}forEach(u,a){const o=this._state;let n=this._head;for(;n;){if(a?u.bind(a)(n.value,n.key,this):u(n.value,n.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const u=this,a=this._state;let o=this._head;const n={[Symbol.iterator](){return n},next(){if(u._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const r={value:o.key,done:!1};return o=o.next,r}else return{value:void 0,done:!0}}};return n}values(){const u=this,a=this._state;let o=this._head;const n={[Symbol.iterator](){return n},next(){if(u._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const r={value:o.value,done:!1};return o=o.next,r}else return{value:void 0,done:!0}}};return n}entries(){const u=this,a=this._state;let o=this._head;const n={[Symbol.iterator](){return n},next(){if(u._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const r={value:[o.key,o.value],done:!1};return o=o.next,r}else return{value:void 0,done:!0}}};return n}[Symbol.iterator](){return this.entries()}trimOld(u){if(!(u>=this.size)){if(u===0){this.clear();return}let a=this._head,o=this.size;for(;a&&o>u;)this._map.delete(a.key),a=a.next,o--;this._head=a,this._size=o,a&&(a.previous=void 0),this._state++}}addItemFirst(u){if(!this._head&&!this._tail)this._tail=u;else if(this._head)u.next=this._head,this._head.previous=u;else throw new Error("Invalid list");this._head=u,this._state++}addItemLast(u){if(!this._head&&!this._tail)this._head=u;else if(this._tail)u.previous=this._tail,this._tail.next=u;else throw new Error("Invalid list");this._tail=u,this._state++}removeItem(u){if(u===this._head&&u===this._tail)this._head=void 0,this._tail=void 0;else if(u===this._head){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this._head=u.next}else if(u===this._tail){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this._tail=u.previous}else{const a=u.next,o=u.previous;if(!a||!o)throw new Error("Invalid list");a.previous=o,o.next=a}u.next=void 0,u.previous=void 0,this._state++}touch(u,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(u===this._head)return;const o=u.next,n=u.previous;u===this._tail?(n.next=void 0,this._tail=n):(o.previous=n,n.next=o),u.previous=void 0,u.next=this._head,this._head.previous=u,this._head=u,this._state++}else if(a===2){if(u===this._tail)return;const o=u.next,n=u.previous;u===this._head?(o.previous=void 0,this._head=o):(o.previous=n,n.next=o),u.next=void 0,u.previous=this._tail,this._tail.next=u,this._tail=u,this._state++}}}toJSON(){const u=[];return this.forEach((a,o)=>{u.push([o,a])}),u}fromJSON(u){this.clear();for(const[a,o]of u)this.set(a,o)}}e.LinkedMap=S;class b extends S{constructor(u,a=1){super();this._limit=u,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(u){this._limit=u,this.checkTrim()}get ratio(){return this._ratio}set ratio(u){this._ratio=Math.min(Math.max(0,u),1),this.checkTrim()}get(u,a=2){return super.get(u,a)}peek(u){return super.get(u,0)}set(u,a){return super.set(u,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=b}),define(he[119],de([0,1,25,13]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...me){return function(ve,Se){for(let ke=0,Re=me.length;ke<Re;ke++){const Fe=me[ke](ve,Se);if(Fe)return Fe}return null}}e.or=I,e.matchesStrictPrefix=E.bind(void 0,!1),e.matchesPrefix=E.bind(void 0,!0);function E(me,ve,Se){if(!Se||Se.length<ve.length)return null;let ke;return me?ke=m.startsWithIgnoreCase(Se,ve):ke=Se.indexOf(ve)===0,ke?ve.length>0?[{start:0,end:ve.length}]:[]:null}function C(me,ve){const Se=ve.toLowerCase().indexOf(me.toLowerCase());return Se===-1?null:[{start:Se,end:Se+me.length}]}e.matchesContiguousSubString=C;function L(me,ve){return g(me.toLowerCase(),ve.toLowerCase(),0,0)}e.matchesSubString=L;function g(me,ve,Se,ke){if(Se===me.length)return[];if(ke===ve.length)return null;if(me[Se]===ve[ke]){let Re=null;return(Re=g(me,ve,Se+1,ke+1))?b({start:ke,end:ke+1},Re):null}return g(me,ve,Se,ke+1)}function t(me){return 97<=me&&me<=122}function R(me){return 65<=me&&me<=90}e.isUpper=R;function _(me){return 48<=me&&me<=57}function P(me){return me===32||me===9||me===10||me===13}const v=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(me=>v.add(me.charCodeAt(0)));function c(me){return P(me)||v.has(me)}function d(me,ve){return me===ve||c(me)&&c(ve)}function S(me){return t(me)||R(me)||_(me)}function b(me,ve){return ve.length===0?ve=[me]:me.end===ve[0].start?ve[0].start=me.start:ve.unshift(me),ve}function f(me,ve){for(let Se=ve;Se<me.length;Se++){const ke=me.charCodeAt(Se);if(R(ke)||_(ke)||Se>0&&!S(me.charCodeAt(Se-1)))return Se}return me.length}function u(me,ve,Se,ke){if(Se===me.length)return[];if(ke===ve.length)return null;if(me[Se]!==ve[ke].toLowerCase())return null;{let Re=null,Fe=ke+1;for(Re=u(me,ve,Se+1,ke+1);!Re&&(Fe=f(ve,Fe))<ve.length;)Re=u(me,ve,Se+1,Fe),Fe++;return Re===null?null:b({start:ke,end:ke+1},Re)}}function a(me){let ve=0,Se=0,ke=0,Re=0,Fe=0;for(let ge=0;ge<me.length;ge++)Fe=me.charCodeAt(ge),R(Fe)&&ve++,t(Fe)&&Se++,S(Fe)&&ke++,_(Fe)&&Re++;const We=ve/me.length,Be=Se/me.length,Ve=ke/me.length,ae=Re/me.length;return{upperPercent:We,lowerPercent:Be,alphaPercent:Ve,numericPercent:ae}}function o(me){const{upperPercent:ve,lowerPercent:Se}=me;return Se===0&&ve>.6}function n(me){const{upperPercent:ve,lowerPercent:Se,alphaPercent:ke,numericPercent:Re}=me;return Se>.2&&ve<.8&&ke>.6&&Re<.2}function r(me){let ve=0,Se=0,ke=0,Re=0;for(let Fe=0;Fe<me.length;Fe++)ke=me.charCodeAt(Fe),R(ke)&&ve++,t(ke)&&Se++,P(ke)&&Re++;return(ve===0||Se===0)&&Re===0?me.length<=30:ve<=5}function i(me,ve){if(!ve||(ve=ve.trim(),ve.length===0)||!r(me)||ve.length>60)return null;const Se=a(ve);if(!n(Se)){if(!o(Se))return null;ve=ve.toLowerCase()}let ke=null,Re=0;for(me=me.toLowerCase();Re<ve.length&&(ke=u(me,ve,0,Re))===null;)Re=f(ve,Re+1);return ke}e.matchesCamelCase=i;function l(me,ve,Se=!1){if(!ve||ve.length===0)return null;let ke=null,Re=0;for(me=me.toLowerCase(),ve=ve.toLowerCase();Re<ve.length&&(ke=s(me,ve,0,Re,Se))===null;)Re=p(ve,Re+1);return ke}e.matchesWords=l;function s(me,ve,Se,ke,Re){if(Se===me.length)return[];if(ke===ve.length)return null;if(d(me.charCodeAt(Se),ve.charCodeAt(ke))){let Fe=null,We=ke+1;if(Fe=s(me,ve,Se+1,ke+1,Re),!Re)for(;!Fe&&(We=p(ve,We))<ve.length;)Fe=s(me,ve,Se+1,We,Re),We++;return Fe===null?null:b({start:ke,end:ke+1},Fe)}else return null}function p(me,ve){for(let Se=ve;Se<me.length;Se++)if(c(me.charCodeAt(Se))||Se>0&&c(me.charCodeAt(Se-1)))return Se;return me.length}const k=I(e.matchesPrefix,i,C),w=I(e.matchesPrefix,i,L),T=new y.LRUCache(1e4);function h(me,ve,Se=!1){if(typeof me!="string"||typeof ve!="string")return null;let ke=T.get(me);ke||(ke=new RegExp(m.convertSimple2RegExpPattern(me),"i"),T.set(me,ke));const Re=ke.exec(ve);return Re?[{start:Re.index,end:Re.index+Re[0].length}]:Se?w(me,ve):k(me,ve)}e.matchesFuzzy=h;function A(me,ve){const Se=Pe(me,me.toLowerCase(),0,ve,ve.toLowerCase(),0,!0);return Se?B(Se):null}e.matchesFuzzy2=A;function N(me,ve,Se,ke,Re,Fe){const We=Pe(me,ve,0,ke,Re,0,!0);if(We)return We;let Be=[],Ve=0,ae=Fe;for(let ge=0;ge<ve.length&&ge<W;++ge){const pe=Re.indexOf(ve.charAt(ge),ae);if(pe>=0)Ve+=1,Be.unshift(pe),ae=pe+1;else if(Be.length>0)break}return[Ve,Fe,...Be]}e.anyScore=N;function B(me){if(typeof me=="undefined")return[];const ve=[],Se=me[1];for(let ke=me.length-1;ke>1;ke--){const Re=me[ke]+Se,Fe=ve[ve.length-1];Fe&&Fe.end===Re?Fe.end=Re+1:ve.push({start:Re,end:Re+1})}return ve}e.createMatches=B;const W=128;function H(){const me=[],ve=[];for(let Se=0;Se<=W;Se++)ve[Se]=0;for(let Se=0;Se<=W;Se++)me.push(ve.slice(0));return me}function K(me){const ve=[];for(let Se=0;Se<=me;Se++)ve[Se]=0;return ve}const re=K(2*W),V=K(2*W),J=H(),ce=H(),$=H(),O=!1;function F(me,ve,Se,ke,Re){function Fe(Be,Ve,ae=" "){for(;Be.length<Ve;)Be=ae+Be;return Be}let We=` |   |${ke.split("").map(Be=>Fe(Be,3)).join("|")}
`;for(let Be=0;Be<=Se;Be++)Be===0?We+=" |":We+=`${ve[Be-1]}|`,We+=me[Be].slice(0,Re+1).map(Ve=>Fe(Ve.toString(),3)).join("|")+`
`;return We}function j(me,ve,Se,ke){me=me.substr(ve),Se=Se.substr(ke),console.log(F(ce,me,me.length,Se,Se.length)),console.log(F($,me,me.length,Se,Se.length)),console.log(F(J,me,me.length,Se,Se.length))}function Q(me,ve){if(ve<0||ve>=me.length)return!1;const Se=me.codePointAt(ve);switch(Se){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!m.isEmojiImprecise(Se)}}function ne(me,ve){if(ve<0||ve>=me.length)return!1;switch(me.charCodeAt(ve)){case 32:case 9:return!0;default:return!1}}function oe(me,ve,Se){return ve[me]!==Se[me]}function ie(me,ve,Se,ke,Re,Fe,We=!1){for(;ve<Se&&Re<Fe;)me[ve]===ke[Re]&&(We&&(re[ve]=Re),ve+=1),Re+=1;return ve===Se}e.isPatternInWord=ie;var fe;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(fe||(fe={}));var Ie;(function(me){me.Default=[-100,0];function ve(Se){return!Se||Se[0]===-100&&Se[1]===0&&Se[2]===0}me.isDefault=ve})(Ie=e.FuzzyScore||(e.FuzzyScore={}));function Pe(me,ve,Se,ke,Re,Fe,We){const Be=me.length>W?W:me.length,Ve=ke.length>W?W:ke.length;if(!(Se>=Be||Fe>=Ve||Be-Se>Ve-Fe)&&!!ie(ve,Se,Be,Re,Fe,Ve,!0)){Ne(Be,Ve,Se,Fe,ve,Re);let ae=1,ge=1,pe=Se,Oe=Fe;const ee=[!1];for(ae=1,pe=Se;pe<Be;ae++,pe++){const U=re[pe],D=V[pe],x=pe+1<Be?V[pe+1]:Ve;for(ge=U-Fe+1,Oe=U;Oe<x;ge++,Oe++){let X=Number.MIN_SAFE_INTEGER,Y=!1;Oe<=D&&(X=ye(me,ve,pe,Se,ke,Re,Oe,Ve,Fe,J[ae-1][ge-1]===0,ee));let se=0;X!==Number.MAX_SAFE_INTEGER&&(Y=!0,se=X+ce[ae-1][ge-1]);const le=Oe>U,we=le?ce[ae][ge-1]+(J[ae][ge-1]>0?-5:0):0,Te=Oe>U+1&&J[ae][ge-1]>0,Le=Te?ce[ae][ge-2]+(J[ae][ge-2]>0?-5:0):0;if(Te&&(!le||Le>=we)&&(!Y||Le>=se))ce[ae][ge]=Le,$[ae][ge]=3,J[ae][ge]=0;else if(le&&(!Y||we>=se))ce[ae][ge]=we,$[ae][ge]=2,J[ae][ge]=0;else if(Y)ce[ae][ge]=se,$[ae][ge]=1,J[ae][ge]=J[ae-1][ge-1]+1;else throw new Error("not possible")}}if(O&&j(me,Se,ke,Fe),!(!ee[0]&&!We)){ae--,ge--;const ue=[ce[ae][ge],Fe];let Ee=0,G=0;for(;ae>=1;){let U=ge;do{const D=$[ae][U];if(D===3)U=U-2;else if(D===2)U=U-1;else break}while(U>=1);Ee>1&&ve[Se+ae-1]===Re[Fe+ge-1]&&!oe(U+Fe-1,ke,Re)&&Ee+1>J[ae][U]&&(U=ge),U===ge?Ee++:Ee=1,G||(G=U),ae--,ge=U-1,ue.push(ge)}Ve===Be&&(ue[0]+=2);const q=G-Be;return ue[0]-=q,ue}}}e.fuzzyScore=Pe;function Ne(me,ve,Se,ke,Re,Fe){let We=me-1,Be=ve-1;for(;We>=Se&&Be>=ke;)Re[We]===Fe[Be]&&(V[We]=Be,We--),Be--}function ye(me,ve,Se,ke,Re,Fe,We,Be,Ve,ae,ge){if(ve[Se]!==Fe[We])return Number.MIN_SAFE_INTEGER;let pe=1,Oe=!1;return We===Se-ke?pe=me[Se]===Re[We]?7:5:oe(We,Re,Fe)&&(We===0||!oe(We-1,Re,Fe))?(pe=me[Se]===Re[We]?7:5,Oe=!0):Q(Fe,We)&&(We===0||!Q(Fe,We-1))?pe=5:(Q(Fe,We-1)||ne(Fe,We-1))&&(pe=5,Oe=!0),pe>1&&Se===ke&&(ge[0]=!0),Oe||(Oe=oe(We,Re,Fe)||Q(Fe,We-1)||ne(Fe,We-1)),Se===ke?We>Ve&&(pe-=Oe?3:5):ae?pe+=Oe?2:0:pe+=Oe?0:1,We+1===Be&&(pe-=Oe?3:5),pe}function _e(me,ve,Se,ke,Re,Fe,We){return ze(me,ve,Se,ke,Re,Fe,!0,We)}e.fuzzyScoreGracefulAggressive=_e;function Ce(me,ve,Se,ke,Re,Fe,We){return ze(me,ve,Se,ke,Re,Fe,!1,We)}e.fuzzyScoreGraceful=Ce;function ze(me,ve,Se,ke,Re,Fe,We,Be){let Ve=Pe(me,ve,Se,ke,Re,Fe,Be);if(Ve&&!We)return Ve;if(me.length>=3){const ae=Math.min(7,me.length-1);for(let ge=Se+1;ge<ae;ge++){const pe=je(me,ge);if(pe){const Oe=Pe(pe,pe.toLowerCase(),Se,ke,Re,Fe,Be);Oe&&(Oe[0]-=3,(!Ve||Oe[0]>Ve[0])&&(Ve=Oe))}}}return Ve}function je(me,ve){if(!(ve+1>=me.length)){const Se=me[ve],ke=me[ve+1];if(Se!==ke)return me.slice(0,ve)+ke+Se+me.slice(ve+2)}}}),define(he[45],de([0,1,13,28,2,25,17]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function L(){return Object.create(null)}e.getEmptyExpression=L;const g="**",t="/",R="[/\\\\]",_="[^/\\\\]",P=/\//g;function v(O){switch(O){case 0:return"";case 1:return`${_}*?`;default:return`(?:${R}|${_}+${R}|${R}${_}+)*?`}}function c(O,F){if(!O)return[];const j=[];let Q=!1,ne=!1,oe="";for(const ie of O){switch(ie){case F:if(!Q&&!ne){j.push(oe),oe="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}oe+=ie}return oe&&j.push(oe),j}e.splitGlobAware=c;function d(O){if(!O)return"";let F="";const j=c(O,t);if(j.every(Q=>Q===g))F=".*";else{let Q=!1;j.forEach((ne,oe)=>{if(ne===g){Q||(F+=v(2),Q=!0);return}let ie=!1,fe="",Ie=!1,Pe="";for(const Ne of ne){if(Ne!=="}"&&ie){fe+=Ne;continue}if(Ie&&(Ne!=="]"||!Pe)){let ye;Ne==="-"?ye=Ne:(Ne==="^"||Ne==="!")&&!Pe?ye="^":Ne===t?ye="":ye=y.escapeRegExpCharacters(Ne),Pe+=ye;continue}switch(Ne){case"{":ie=!0;continue;case"[":Ie=!0;continue;case"}":F+=`(?:${c(fe,",").map(Ce=>d(Ce)).join("|")})`,ie=!1,fe="";break;case"]":F+="["+Pe+"]",Ie=!1,Pe="";break;case"?":F+=_;continue;case"*":F+=v(1);continue;default:F+=y.escapeRegExpCharacters(Ne)}}oe<j.length-1&&(j[oe+1]!==g||oe+2<j.length)&&(F+=R),Q=!1})}return F}const S=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new E.LRUCache(1e4),r=function(){return!1},i=function(){return null};function l(O,F){if(!O)return i;let j;typeof O!="string"?j=O.pattern:j=O,j=j.trim();const Q=`${j}_${!!F.trimForExclusions}`;let ne=n.get(Q);if(ne)return s(ne,O);let oe;if(S.test(j)){const ie=j.substr(4);ne=function(fe,Ie){return typeof fe=="string"&&fe.endsWith(ie)?j:null}}else(oe=b.exec(p(j,F)))?ne=k(oe[1],j):(F.trimForExclusions?u:f).test(j)?ne=w(j,F):(oe=a.exec(p(j,F)))?ne=T(oe[1].substr(1),j,!0):(oe=o.exec(p(j,F)))?ne=T(oe[1],j,!1):ne=h(j);return n.set(Q,ne),s(ne,O)}function s(O,F){return typeof F=="string"?O:function(j,Q){return m.isEqualOrParent(j,F.base)?O(I.relative(F.base,j),Q):null}}function p(O,F){return F.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function k(O,F){const j=`/${O}`,Q=`\\${O}`,ne=function(ie,fe){return typeof ie!="string"?null:fe?fe===O?F:null:ie===O||ie.endsWith(j)||ie.endsWith(Q)?F:null},oe=[O];return ne.basenames=oe,ne.patterns=[F],ne.allBasenames=oe,ne}function w(O,F){const j=$(O.slice(1,-1).split(",").map(fe=>l(fe,F)).filter(fe=>fe!==i),O),Q=j.length;if(!Q)return i;if(Q===1)return j[0];const ne=function(fe,Ie){for(let Pe=0,Ne=j.length;Pe<Ne;Pe++)if(j[Pe](fe,Ie))return O;return null},oe=j.find(fe=>!!fe.allBasenames);oe&&(ne.allBasenames=oe.allBasenames);const ie=j.reduce((fe,Ie)=>Ie.allPaths?fe.concat(Ie.allPaths):fe,[]);return ie.length&&(ne.allPaths=ie),ne}function T(O,F,j){const Q=I.sep===I.posix.sep,ne=Q?O:O.replace(P,I.sep),oe=I.sep+ne,ie=I.posix.sep+O,fe=j?function(Ie,Pe){return typeof Ie=="string"&&(Ie===ne||Ie.endsWith(oe)||!Q&&(Ie===O||Ie.endsWith(ie)))?F:null}:function(Ie,Pe){return typeof Ie=="string"&&(Ie===ne||!Q&&Ie===O)?F:null};return fe.allPaths=[(j?"*/":"./")+O],fe}function h(O){try{const F=new RegExp(`^${d(O)}$`);return function(j){return F.lastIndex=0,typeof j=="string"&&F.test(j)?O:null}}catch(F){return i}}function A(O,F,j){return!O||typeof F!="string"?!1:N(O)(F,void 0,j)}e.match=A;function N(O,F={}){if(!O)return r;if(typeof O=="string"||K(O)){const j=l(O,F);if(j===i)return r;const Q=function(ne,oe){return!!j(ne,oe)};return j.allBasenames&&(Q.allBasenames=j.allBasenames),j.allPaths&&(Q.allPaths=j.allPaths),Q}return J(O,F)}e.parse=N;function B(O){if(!!O){let F;return j=>(F||(F=(O()||Promise.resolve([])).then(Q=>Q?H(Q):{})),F.then(Q=>!!Q[j]))}}e.hasSiblingPromiseFn=B;function W(O){if(!!O){let F;return j=>{if(!F){const Q=O();F=Q?H(Q):{}}return!!F[j]}}}e.hasSiblingFn=W;function H(O){const F={};for(const j of O)F[j]=!0;return F}function K(O){const F=O;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=K;function re(O){return O.allBasenames||[]}e.getBasenameTerms=re;function V(O){return O.allPaths||[]}e.getPathTerms=V;function J(O,F){const j=$(Object.getOwnPropertyNames(O).map(fe=>ce(fe,O[fe],F)).filter(fe=>fe!==i)),Q=j.length;if(!Q)return i;if(!j.some(fe=>!!fe.requiresSiblings)){if(Q===1)return j[0];const fe=function(Ne,ye){for(let _e=0,Ce=j.length;_e<Ce;_e++){const ze=j[_e](Ne,ye);if(ze)return ze}return null},Ie=j.find(Ne=>!!Ne.allBasenames);Ie&&(fe.allBasenames=Ie.allBasenames);const Pe=j.reduce((Ne,ye)=>ye.allPaths?Ne.concat(ye.allPaths):Ne,[]);return Pe.length&&(fe.allPaths=Pe),fe}const ne=function(fe,Ie,Pe){let Ne;for(let ye=0,_e=j.length;ye<_e;ye++){const Ce=j[ye];Ce.requiresSiblings&&Pe&&(Ie||(Ie=I.basename(fe)),Ne||(Ne=Ie.substr(0,Ie.length-I.extname(fe).length)));const ze=Ce(fe,Ie,Ne,Pe);if(ze)return ze}return null},oe=j.find(fe=>!!fe.allBasenames);oe&&(ne.allBasenames=oe.allBasenames);const ie=j.reduce((fe,Ie)=>Ie.allPaths?fe.concat(Ie.allPaths):fe,[]);return ie.length&&(ne.allPaths=ie),ne}function ce(O,F,j){if(F===!1)return i;const Q=l(O,j);if(Q===i)return i;if(typeof F=="boolean")return Q;if(F){const ne=F.when;if(typeof ne=="string"){const oe=(ie,fe,Ie,Pe)=>{if(!Pe||!Q(ie,fe))return null;const Ne=ne.replace("$(basename)",Ie),ye=Pe(Ne);return C.isThenable(ye)?ye.then(_e=>_e?O:null):ye?O:null};return oe.requiresSiblings=!0,oe}}return Q}function $(O,F){const j=O.filter(fe=>!!fe.basenames);if(j.length<2)return O;const Q=j.reduce((fe,Ie)=>{const Pe=Ie.basenames;return Pe?fe.concat(Pe):fe},[]);let ne;if(F){ne=[];for(let fe=0,Ie=Q.length;fe<Ie;fe++)ne.push(F)}else ne=j.reduce((fe,Ie)=>{const Pe=Ie.patterns;return Pe?fe.concat(Pe):fe},[]);const oe=function(fe,Ie){if(typeof fe!="string")return null;if(!Ie){let Ne;for(Ne=fe.length;Ne>0;Ne--){const ye=fe.charCodeAt(Ne-1);if(ye===47||ye===92)break}Ie=fe.substr(Ne)}const Pe=Q.indexOf(Ie);return Pe!==-1?ne[Pe]:null};oe.basenames=Q,oe.patterns=ne,oe.allBasenames=Q;const ie=O.filter(fe=>!fe.basenames);return ie.push(oe),ie}}),define(he[120],de([0,1,119,13]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownUnescapeIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=/(\\)?\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)/gi;function E(d){return d.replace(I,(S,b)=>b?S:`\\${S}`)}e.escapeIcons=E;const C=/\\\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)/gi;function L(d){return d.replace(C,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=L;const g=/(\\)?\$\\\(([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?)\\\)/gi;function t(d){return d.replace(g,(S,b,f)=>b?S:`$(${f})`)}e.markdownUnescapeIcons=t;const R=/(\s)?(\\)?\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)(\s)?/gi;function _(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(R,(S,b,f,u)=>f?S:b||u||"")}e.stripIcons=_;function P(d){const S=d.indexOf(e.iconStartMarker);return S===-1?{text:d}:v(d,S)}e.parseLabelWithIcons=P;function v(d,S){const b=[];let f="";function u(p){if(p){f+=p;for(const k of p)b.push(n)}}let a=-1,o="",n=0,r,i,l=S;const s=d.length;for(u(d.substr(0,S));l<s;)r=d[l],i=d[l+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(a=l,u(o),o=e.iconStartMarker,l++):r===")"&&a!==-1?(n+=l-a+1,a=-1,o=""):a!==-1?/^[a-z0-9\-]$/i.test(r)?o+=r:(u(o),a=-1,o=""):u(r),l++;return u(o),{text:f,iconOffsets:b}}function c(d,S,b=!1){const{text:f,iconOffsets:u}=S;if(!u||u.length===0)return y.matchesFuzzy(d,f,b);const a=m.ltrim(f," "),o=f.length-a.length,n=y.matchesFuzzy(d,a,b);if(n)for(const r of n){const i=u[r.start+o]+o;r.start+=i,r.end+=i}return n}e.matchesFuzzyIconAware=c}),define(he[71],de([0,1,14,120,12]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(d="",S=!1){var b,f;if(this.value=d,typeof this.value!="string")throw I.illegalArgument("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(b=S.isTrusted)!==null&&b!==void 0?b:void 0,this.supportThemeIcons=(f=S.supportThemeIcons)!==null&&f!==void 0?f:!1)}appendText(d,S=0){return this.value+=_(this.supportThemeIcons?m.escapeIcons(d):d).replace(/([ \t]+)/g,(b,f)=>"&nbsp;".repeat(f.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,S){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=C;function L(c){return g(c)?!c.value:Array.isArray(c)?c.every(L):!0}e.isEmptyMarkdownString=L;function g(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=g;function t(c,d){return!c&&!d?!0:!c||!d?!1:Array.isArray(c)&&Array.isArray(d)?y.equals(c,d,R):g(c)&&g(d)?R(c,d):!1}e.markedStringsEquals=t;function R(c,d){return c===d?!0:!c||!d?!1:c.value===d.value&&c.isTrusted===d.isTrusted&&c.supportThemeIcons===d.supportThemeIcons}function _(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=_;function P(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=P;function v(c){const d=[],S=c.split("|").map(f=>f.trim());c=S[0];const b=S[1];if(b){const f=/height=(\d+)/.exec(b),u=/width=(\d+)/.exec(b),a=f?f[1]:"",o=u?u[1]:"",n=isFinite(parseInt(o)),r=isFinite(parseInt(a));n&&d.push(`width="${o}"`),r&&d.push(`height="${a}"`)}return{href:c,dimensions:d}}e.parseHrefAndDimensions=v}),define(he[46],de([0,1,18,13,3]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function E(t){return JSON.stringify(t,L)}e.stringify=E;function C(t){let R=JSON.parse(t);return R=g(R),R}e.parse=C;function L(t,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:m.regExpFlags(R)}:R}function g(t,R=0){if(!t||R>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return I.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof y.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let _=0;_<t.length;++_)t[_]=g(t[_],R+1);else for(const _ in t)Object.hasOwnProperty.call(t,_)&&(t[_]=g(t[_],R+1))}return t}e.revive=g}),define(he[8],de([0,1,3,5]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(L){L.inMemory="inmemory",L.vscode="vscode",L.internal="private",L.walkThrough="walkThrough",L.walkThroughSnippet="walkThroughSnippet",L.http="http",L.https="https",L.file="file",L.mailto="mailto",L.untitled="untitled",L.data="data",L.command="command",L.vscodeRemote="vscode-remote",L.vscodeRemoteResource="vscode-remote-resource",L.userData="vscode-userdata",L.vscodeCustomEditor="vscode-custom-editor",L.vscodeNotebook="vscode-notebook",L.vscodeNotebookCell="vscode-notebook-cell",L.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",L.vscodeSettings="vscode-settings",L.webviewPanel="webview-panel",L.vscodeWebview="vscode-webview",L.vscodeWebviewResource="vscode-webview-resource",L.extension="extension",L.vscodeFileResource="vscode-file"})(I=e.Schemas||(e.Schemas={}));class E{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}set(g,t,R){this._hosts[g]=t,this._ports[g]=R}setConnectionToken(g,t){this._connectionTokens[g]=t}rewrite(g){if(this._delegate)return this._delegate(g);const t=g.authority;let R=this._hosts[t];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const _=this._ports[t],P=this._connectionTokens[t];let v=`path=${encodeURIComponent(g.path)}`;return typeof P=="string"&&(v+=`&tkn=${encodeURIComponent(P)}`),y.URI.from({scheme:m.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${R}:${_}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new E;class C{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(g,t,R){const _=this.toUri(g,t);return _.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(_):m.isNative&&(R||m.isPreferringBrowserCodeLoad)&&_.scheme===I.file?_.with({scheme:I.vscodeFileResource,authority:_.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):_}asFileUri(g,t){const R=this.toUri(g,t);return R.scheme===I.vscodeFileResource?R.with({scheme:I.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(g,t){return y.URI.isUri(g)?g:y.URI.parse(t.toUrl(g))}}e.FileAccess=new C}),define(he[72],de([0,1,25]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const m=new y.LRUCache(1e4);function I(t){return g(t,"NFC",m)}e.normalizeNFC=I;const E=new y.LRUCache(1e4);function C(t){return g(t,"NFD",E)}e.normalizeNFD=C;const L=/[^\u0000-\u0080]/;function g(t,R,_){if(!e.canNormalize||!t)return t;const P=_.get(t);if(P)return P;let v;return L.test(t)?v=t.normalize(R):v=t,_.set(t,v),v}e.removeAccents=function(){if(e.canNormalize){const t=/[\u0300-\u036f]/g;return function(R){return C(R).replace(t,"")}}else return function(t){return t}}()}),define(he[22],de([0,1,28,2,3,13,8,5]),function(Z,e,y,m,I,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(v){return I.uriToFsPath(v,!0)}e.originalFSPath=g;class t{constructor(c){this._ignorePathCasing=c}compare(c,d,S=!1){return c===d?0:E.compare(this.getComparisonKey(c,S),this.getComparisonKey(d,S))}isEqual(c,d,S=!1){return c===d?!0:!c||!d?!1:this.getComparisonKey(c,S)===this.getComparisonKey(d,S)}getComparisonKey(c,d=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,d,S=!1){if(c.scheme===d.scheme){if(c.scheme===C.Schemas.file)return y.isEqualOrParent(g(c),g(d),this._ignorePathCasing(c))&&c.query===d.query&&(S||c.fragment===d.fragment);if(e.isEqualAuthority(c.authority,d.authority))return y.isEqualOrParent(c.path,d.path,this._ignorePathCasing(c),"/")&&c.query===d.query&&(S||c.fragment===d.fragment)}return!1}joinPath(c,...d){return I.URI.joinPath(c,...d)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return m.posix.basename(c.path)}extname(c){return m.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let d;return c.scheme===C.Schemas.file?d=I.URI.file(m.dirname(g(c))).path:(d=m.posix.dirname(c.path),c.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),d="/")),c.with({path:d})}normalizePath(c){if(!c.path.length)return c;let d;return c.scheme===C.Schemas.file?d=I.URI.file(m.normalize(g(c))).path:d=m.posix.normalize(c.path),c.with({path:d})}relativePath(c,d){if(!(c.scheme!==d.scheme||!e.isEqualAuthority(c.authority,d.authority))){if(c.scheme===C.Schemas.file){const f=m.relative(g(c),g(d));return L.isWindows?y.toSlashes(f):f}let S=c.path||"/",b=d.path||"/";if(this._ignorePathCasing(c)){let f=0;for(const u=Math.min(S.length,b.length);f<u&&!(S.charCodeAt(f)!==b.charCodeAt(f)&&S.charAt(f).toLowerCase()!==b.charAt(f).toLowerCase());f++);S=b.substr(0,f)+S.substr(f)}return m.posix.relative(S,b)}}resolvePath(c,d){if(c.scheme===C.Schemas.file){const S=I.URI.file(m.resolve(g(c),d));return c.with({authority:S.authority,path:S.path})}return d.indexOf("/")===-1&&(d=y.toSlashes(d),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d)),c.with({path:m.posix.resolve(c.path,d)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,d){return c===d||E.equalsIgnoreCase(c,d)}hasTrailingPathSeparator(c,d=m.sep){if(c.scheme===C.Schemas.file){const S=g(c);return S.length>y.getRoot(S).length&&S[S.length-1]===d}else{const S=c.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,d=m.sep){return e.hasTrailingPathSeparator(c,d)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,d=m.sep){let S=!1;if(c.scheme===C.Schemas.file){const b=g(c);S=b!==void 0&&b.length===y.getRoot(b).length&&b[b.length-1]===d}else{d="/";const b=c.path;S=b.length===1&&b.charCodeAt(b.length-1)===47}return!S&&!e.hasTrailingPathSeparator(c,d)?c.with({path:c.path+"/"}):c}}e.ExtUri=t,e.extUri=new t(()=>!1),e.extUriBiasedIgnorePathCase=new t(v=>v.scheme===C.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new t(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(v,c){const d=[];for(let S=0;S<v.length;S++){const b=c(v[S]);v.some((f,u)=>u===S?!1:e.isEqualOrParent(b,c(f)))||d.push(v[S])}return d}e.distinctParents=R;var _;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function c(d){const S=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[a,o]=u.split(":");a&&o&&S.set(a,o)});const f=d.path.substring(0,d.path.indexOf(";"));return f&&S.set(v.META_DATA_MIME,f),S}v.parseMetaData=c})(_=e.DataUri||(e.DataUri={}));function P(v,c,d){if(c){let S=v.path;return S&&S[0]!==m.posix.sep&&(S=m.posix.sep+S),v.with({scheme:d,authority:c,path:S})}return v.with({scheme:d})}e.toLocalResource=P}),define(he[54],de([0,1,3,2,13,8,5,22,28]),function(Z,e,y,m,I,E,C,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function t(l,s,p){if(typeof l=="string"&&(l=y.URI.file(l)),p){const w=p.getWorkspaceFolder(l);if(w){const T=p.getWorkspace().folders.length>1;let h;if(L.isEqual(w.uri,l)?h="":h=L.relativePath(w.uri,l),T){const A=w.name?w.name:L.basename(w.uri);h=h?A+" \u2022 "+h:A}return h}}if(l.scheme!==E.Schemas.file&&l.scheme!==E.Schemas.untitled)return l.with({query:null,fragment:null}).toString(!0);if(g.hasDriveLetter(l.fsPath))return m.normalize(_(l.fsPath));let k=m.normalize(l.fsPath);return!C.isWindows&&(s==null?void 0:s.userHome)&&(k=v(k,s.userHome.fsPath)),k}e.getPathLabel=t;function R(l){if(!!l){typeof l=="string"&&(l=y.URI.file(l));const s=L.basename(l)||(l.scheme===E.Schemas.file?l.fsPath:l.path);return C.isWindows&&g.isRootOrDriveLetter(s)?_(s):s}}e.getBaseLabel=R;function _(l){return g.hasDriveLetter(l)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=_;let P=Object.create(null);function v(l,s){if(C.isWindows||!l||!s)return l;let p=P.original===s?P.normalized:void 0;return p||(p=`${I.rtrim(s,m.posix.sep)}${m.posix.sep}`,P={original:s,normalized:p}),(C.isLinux?l.startsWith(p):I.startsWithIgnoreCase(l,p))&&(l=`~/${l.substr(p.length)}`),l}e.tildify=v;function c(l,s){return l.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=c;const d="\u2026",S="\\\\",b="~";function f(l,s=m.sep){const p=new Array(l.length);let k=!1;for(let w=0;w<l.length;w++){let T=l[w];if(T===""){p[w]=`.${s}`;continue}if(!T){p[w]=T;continue}k=!0;let h="";T.indexOf(S)===0?(h=T.substr(0,T.indexOf(S)+S.length),T=T.substr(T.indexOf(S)+S.length)):T.indexOf(s)===0?(h=T.substr(0,T.indexOf(s)+s.length),T=T.substr(T.indexOf(s)+s.length)):T.indexOf(b)===0&&(h=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const A=T.split(s);for(let N=1;k&&N<=A.length;N++)for(let B=A.length-N;k&&B>=0;B--){k=!1;let W=A.slice(B,B+N).join(s);for(let H=0;!k&&H<l.length;H++)if(H!==w&&l[H]&&l[H].indexOf(W)>-1){const K=B+N===A.length,re=B>0&&l[H].indexOf(s)>-1?s+W:W,V=l[H].endsWith(re);k=!K||V}if(!k){let H="";(A[0].endsWith(":")||h!=="")&&(B===1&&(B=0,N++,W=A[0]+s+W),B>0&&(H=A[0]+s),H=h+H),B>0&&(H=H+d+s),H=H+W,B+N<A.length&&(H=H+s+d),p[w]=H}}k&&(p[w]=T)}return p}e.shorten=f;var u;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function a(l,s=Object.create(null)){const p=[];let k=!1,w="";for(const T of l)if(T==="$"||k&&T==="{")w&&p.push({value:w,type:u.TEXT}),w="",k=!0;else if(T==="}"&&k){const h=s[w];if(typeof h=="string")h.length&&p.push({value:h,type:u.VARIABLE});else if(h){const A=p[p.length-1];(!A||A.type!==u.SEPARATOR)&&p.push({value:h.label,type:u.SEPARATOR})}w="",k=!1}else w+=T;return w&&!k&&p.push({value:w,type:u.TEXT}),p.filter((T,h)=>{if(T.type===u.SEPARATOR){const A=p[h-1],N=p[h+1];return[A,N].every(B=>B&&(B.type===u.VARIABLE||B.type===u.TEXT)&&B.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=a;function o(l,s){return C.isMacintosh||s?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):l.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function n(l,s){return C.isMacintosh||s?l.replace(/\(&&\w\)|&&/g,""):C.isWindows?l.replace(/&&|&/g,p=>p==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function r(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=r;function i(l){const s=l.indexOf("/")!==-1?m.posix:m.win32,p=s.basename(l),k=s.dirname(l);return p.length?{name:p,parentPath:k}:{name:k,parentPath:""}}e.splitName=i}),define(he[121],de([0,1,2,13,45,8,22]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let L=[],g=[],t=[];function R(a,o=!1){const n=_(a);L.push(n),n.userConfigured?t.push(n):g.push(n),o&&!n.userConfigured&&L.forEach(r=>{r.mime===n.mime||r.userConfigured||(n.extension&&r.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&r.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&r.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&r.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=R;function _(a){return{id:a.id,mime:a.mime,filename:a.filename,extension:a.extension,filepattern:a.filepattern,firstline:a.firstline,userConfigured:a.userConfigured,filenameLowercase:a.filename?a.filename.toLowerCase():void 0,extensionLowercase:a.extension?a.extension.toLowerCase():void 0,filepatternLowercase:a.filepattern?a.filepattern.toLowerCase():void 0,filepatternOnPath:a.filepattern?a.filepattern.indexOf(y.posix.sep)>=0:!1}}function P(a){a?(L=L.filter(o=>!o.userConfigured),t=[]):(L=[],g=[],t=[])}e.clearTextMimes=P;function v(a,o){let n;if(a)switch(a.scheme){case E.Schemas.file:n=a.fsPath;break;case E.Schemas.data:n=C.DataUri.parseMetaData(a).get(C.DataUri.META_DATA_LABEL);break;default:n=a.path}if(!n)return[e.MIME_UNKNOWN];n=n.toLowerCase();const r=y.basename(n),i=c(n,r,t);if(i)return[i,e.MIME_TEXT];const l=c(n,r,g);if(l)return[l,e.MIME_TEXT];if(o){const s=d(o);if(s)return[s,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=v;function c(a,o,n){let r=null,i=null,l=null;for(let s=n.length-1;s>=0;s--){const p=n[s];if(o===p.filenameLowercase){r=p;break}if(p.filepattern&&(!i||p.filepattern.length>i.filepattern.length)){const k=p.filepatternOnPath?a:o;I.match(p.filepatternLowercase,k)&&(i=p)}p.extension&&(!l||p.extension.length>l.extension.length)&&o.endsWith(p.extensionLowercase)&&(l=p)}return r?r.mime:i?i.mime:l?l.mime:null}function d(a){if(m.startsWithUTF8BOM(a)&&(a=a.substr(1)),a.length>0)for(let o=L.length-1;o>=0;o--){const n=L[o];if(!!n.firstline){const r=a.match(n.firstline);if(r&&r.length>0)return n.mime}}return null}function S(a){return a?typeof a=="string"?a===e.MIME_BINARY||a===e.MIME_TEXT||a===e.MIME_UNKNOWN:a.length===1&&S(a[0]):!0}e.isUnspecific=S;const b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(a){const o=y.extname(a);return b[o.toLowerCase()]}e.getMediaMime=f;function u(a){for(const o in b)if(b[o]===a)return o}e.getExtensionForMimeType=u}),define(he[55],de([0,1,3]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function m(R){return R.toJSON()}class I{constructor(_){this._uriTransformer=_}transformIncoming(_){const P=this._uriTransformer.transformIncoming(_);return P===_?_:m(y.URI.from(P))}transformOutgoing(_){const P=this._uriTransformer.transformOutgoing(_);return P===_?_:m(y.URI.from(P))}transformOutgoingURI(_){const P=this._uriTransformer.transformOutgoing(_);return P===_?_:y.URI.from(P)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function E(R,_,P){if(!R||P>200)return null;if(typeof R=="object"){if(R instanceof y.URI)return _.transformOutgoing(R);for(let v in R)if(Object.hasOwnProperty.call(R,v)){const c=E(R[v],_,P+1);c!==null&&(R[v]=c)}}return null}function C(R,_){const P=E(R,_,0);return P===null?R:P}e.transformOutgoingURIs=C;function L(R,_,P,v){if(!R||v>200)return null;if(typeof R=="object"){if(R.$mid===1)return P?y.URI.revive(_.transformIncoming(R)):_.transformIncoming(R);for(let c in R)if(Object.hasOwnProperty.call(R,c)){const d=L(R[c],_,P,v+1);d!==null&&(R[c]=d)}}return null}function g(R,_){const P=L(R,_,!1,0);return P===null?R:P}e.transformIncomingURIs=g;function t(R,_){const P=L(R,_,!0,0);return P===null?R:P}e.transformAndReviveIncomingURIs=t}),define(he[20],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function m(g){return y.test(g)}e.isUUID=m;const I=new Uint8Array(16),E=[];for(let g=0;g<256;g++)E.push(g.toString(16).padStart(2,"0"));const C=function(g){for(let t=0;t<g.length;t++)g[t]=Math.floor(Math.random()*256);return g};function L(){C(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let g=0,t="";return t+=E[I[g++]],t+=E[I[g++]],t+=E[I[g++]],t+=E[I[g++]],t+="-",t+=E[I[g++]],t+=E[I[g++]],t+="-",t+=E[I[g++]],t+=E[I[g++]],t+="-",t+=E[I[g++]],t+=E[I[g++]],t+="-",t+=E[I[g++]],t+=E[I[g++]],t+=E[I[g++]],t+=E[I[g++]],t+=E[I[g++]],t+=E[I[g++]],t}e.generateUuid=L}),define(he[73],de([0,1,230]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class m{constructor(E="utf8"){this.stringDecoder=new y.StringDecoder(E),this.remaining=null}write(E){const C=[],L=this.remaining?this.remaining+this.stringDecoder.write(E):this.stringDecoder.write(E);if(L.length<1)return C;let g=0,t,R=g;for(;R<L.length;)if(t=L.charCodeAt(R),t===13||t===10){if(C.push(L.substring(g,R)),R++,R<L.length){const _=t;t=L.charCodeAt(R),(_===13&&t===10||_===10&&t===13)&&R++}g=R}else R++;return this.remaining=g<L.length?L.substr(g):null,C}end(){return this.remaining}}e.LineDecoder=m});"use strict";function Bt(Z,e,y,m){function I(b){return new Promise(f=>y.exists(b,f))}function E(b){return new Promise((f,u)=>{const a=new Date;y.utimes(b,a,a,o=>o?u(o):f())})}function C(b){return new Promise((f,u)=>y.lstat(b,(a,o)=>a?u(a):f(o)))}function L(b){return new Promise((f,u)=>y.readdir(b,(a,o)=>a?u(a):f(o)))}function g(b){return new Promise((f,u)=>y.mkdir(b,{recursive:!0},a=>a&&a.code!=="EEXIST"?u(a):f(b)))}function t(b){return new Promise((f,u)=>y.rmdir(b,a=>a?u(a):f(void 0)))}function R(b){return new Promise((f,u)=>y.unlink(b,a=>a?u(a):f(void 0)))}function _(b){return C(b).then(f=>f.isDirectory()&&!f.isSymbolicLink()?L(b).then(u=>Promise.all(u.map(a=>_(e.join(b,a))))).then(()=>t(b)):R(b),f=>{if(f.code!=="ENOENT")throw f})}function P(b){return new Promise(function(f,u){y.readFile(b,"utf8",function(a,o){if(a){u(a);return}f(o)})})}function v(b,f){return new Promise(function(u,a){y.writeFile(b,f,"utf8",function(o){if(o){a(o);return}u()})})}function c(b){const f=e.join(b,"languagepacks.json");try{return Z(f)}catch(u){}}function d(b,f){try{for(;f;){if(b[f])return f;{const u=f.lastIndexOf("-");if(u>0)f=f.substring(0,u);else return}}}catch(u){console.error("Resolving language pack configuration failed.",u)}}function S(b,f,u,a){if(a==="pseudo")return Promise.resolve({locale:a,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:a,availableLanguages:{}});if(a&&(a==="en"||a==="en-us"))return Promise.resolve({locale:a,availableLanguages:{}});const o=a;m.mark("code/willGenerateNls");const n=function(r){return m.mark("code/didGenerateNls"),Promise.resolve({locale:r,availableLanguages:{}})};try{if(!b)return n(o);const r=c(f);if(!r||(a=d(r,a),!a))return n(o);const i=r[a];let l;return!i||typeof i.hash!="string"||!i.translations||typeof(l=i.translations.vscode)!="string"?n(o):I(l).then(s=>{if(!s)return n(o);const p=i.hash+"."+a,k=e.join(f,"clp",p),w=e.join(k,b),T=e.join(k,"tcf.json"),h=e.join(k,"corrupted.info"),A={locale:o,availableLanguages:{"*":a},_languagePackId:p,_translationsConfigFile:T,_cacheRoot:k,_resolvedLanguagePackCoreLocation:w,_corruptedFile:h};return I(h).then(N=>{let B;return N?B=_(k):B=Promise.resolve(void 0),B.then(()=>I(w).then(W=>W?(E(w).catch(()=>{}),m.mark("code/didGenerateNls"),A):g(w).then(()=>Promise.all([P(u),P(l)])).then(H=>{const K=JSON.parse(H[0]),re=JSON.parse(H[1]).contents,V=Object.keys(K.bundles),J=[];for(const ce of V){const $=K.bundles[ce],O=Object.create(null);for(const F of $){const j=K.keys[F],Q=K.messages[F],ne=re[F];let oe;if(ne){oe=[];for(let ie=0;ie<j.length;ie++){const fe=j[ie],Ie=typeof fe=="string"?fe:fe.key;let Pe=ne[Ie];Pe===void 0&&(Pe=Q[ie]),oe.push(Pe)}}else oe=Q;O[F]=oe}J.push(v(e.join(w,ce.replace(/\//g,"!")+".nls.json"),JSON.stringify(O)))}return J.push(v(T,JSON.stringify(i.translations))),Promise.all(J)}).then(()=>(m.mark("code/didGenerateNls"),A)).catch(H=>(console.error("Generating translation files failed.",H),n(a)))))})})}catch(r){return console.error("Generating translation files failed.",r),n(a)}}return{getNLSConfiguration:S}}if(typeof define=="function")define(he[122],de([231,21,47]),function(Z,e,y){return Bt(require.__$__nodeRequire,Z,e,y)});else if(typeof module=="object"&&typeof module.exports=="object"){const Z=require("path"),e=require("fs"),y=require("../common/performance");module.exports=Bt(require,Z,e,y)}else throw new Error("Unknown context");define(he[123],de([0,1,23]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const m=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(L){const g=L.replace(/\-/g,":").toLowerCase();return!m.has(g)}function E(){return new Promise(async(L,g)=>{const t=setTimeout(()=>g("Unable to retrieve mac address (timeout after 10s)"),1e4);try{L(await C())}catch(R){g(R)}finally{clearTimeout(t)}})}e.getMac=E;function C(){return new Promise((L,g)=>{try{const t=y.networkInterfaces();for(const[,R]of Object.entries(t))for(const _ of R)if(I(_.mac))return L(_.mac);g("Unable to retrieve mac address (unexpected format)")}catch(t){g(t)}})}}),define(he[74],de([0,1,12,20,23,25,123]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=E.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,_=0;const P=I.networkInterfaces();for(let v in P)if(Object.prototype.hasOwnProperty.call(P,v))for(const{mac:c,internal:d}of P[v])d||(_+=1,this._isVirtualMachineMacAdress(c.toUpperCase())&&(R+=1));this._value=_>0?R/_:0}return this._value}};let L;async function g(){return L||(L=(async()=>await t()||m.generateUuid())()),L}e.getMachineId=g;async function t(){try{const R=await new Promise((P,v)=>{Z(["crypto"],P,v)}),_=await C.getMac();return R.createHash("sha256").update(_,"utf8").digest("hex")}catch(R){y.onUnexpectedError(R);return}}}),define(he[124],de([0,1,8]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDefaultUserDataPath=void 0;const m=y.FileAccess.asFileUri("paths",Z).fsPath,I=Z.__$__nodeRequire(m);e.getDefaultUserDataPath=I.getDefaultUserDataPath}),define(he[15],de([0,1,21,23,2,17,5,6,48,28,20,72]),function(Z,e,y,m,I,E,C,L,g,t,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.copy=e.move=e.whenDeleted=e.fileExists=e.dirExists=e.readDirsInDir=e.writeFileSync=e.writeFile=e.mkdirp=e.readFile=e.truncate=e.symlink=e.unlink=e.readlink=e.renameIgnoreError=e.rename=e.lstat=e.statLink=e.stat=e.chmod=e.exists=e.readdirSync=e.readdirWithFileTypes=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=e.MAX_HEAP_SIZE=e.MAX_FILE_SIZE=void 0;const P=300*1024*1024,v=16*1024*1024*1024,c=700*1024*1024,d=700*2*1024*1024;e.MAX_FILE_SIZE=process.arch==="ia32"?P:v,e.MAX_HEAP_SIZE=process.arch==="ia32"?c:d;var S;(function(ye){ye[ye.UNLINK=0]="UNLINK",ye[ye.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function b(ye,_e=S.UNLINK){if(t.isRootOrDriveLetter(ye))throw new Error("rimraf - will refuse to recursively delete root");return _e===S.UNLINK?f(ye):u(ye)}e.rimraf=b;async function f(ye){try{const _e=await w(ye);if(_e.isDirectory()&&!_e.isSymbolicLink()){const Ce=await o(ye);await Promise.all(Ce.map(ze=>f(I.join(ye,ze)))),await g.promisify(y.rmdir)(ye)}else{const Ce=_e.mode;return Ce&y.constants.S_IWUSR||await s(ye,Ce|y.constants.S_IWUSR),N(ye)}}catch(_e){if(_e.code!=="ENOENT")throw _e}}async function u(ye){try{const _e=I.join(m.tmpdir(),R.generateUuid());try{await T(ye,_e)}catch(Ce){return f(ye)}f(_e)}catch(_e){if(_e.code!=="ENOENT")throw _e}}function a(ye){if(t.isRootOrDriveLetter(ye))throw new Error("rimraf - will refuse to recursively delete root");try{const _e=y.lstatSync(ye);if(_e.isDirectory()&&!_e.isSymbolicLink())r(ye).map(ze=>a(I.join(ye,ze))),y.rmdirSync(ye);else{const Ce=_e.mode;return Ce&y.constants.S_IWUSR||y.chmodSync(ye,Ce|y.constants.S_IWUSR),y.unlinkSync(ye)}}catch(_e){if(_e.code!=="ENOENT")throw _e}}e.rimrafSync=a;async function o(ye){return i(await g.promisify(y.readdir)(ye))}e.readdir=o;async function n(ye){const _e=await g.promisify(y.readdir)(ye,{withFileTypes:!0});if(C.isMacintosh)for(const Ce of _e)Ce.name=_.normalizeNFC(Ce.name);return _e}e.readdirWithFileTypes=n;function r(ye){return i(y.readdirSync(ye))}e.readdirSync=r;function i(ye){return C.isMacintosh?ye.map(_e=>_.normalizeNFC(_e)):ye}function l(ye){return g.promisify(y.exists)(ye)}e.exists=l;function s(ye,_e){return g.promisify(y.chmod)(ye,_e)}e.chmod=s;function p(ye){return g.promisify(y.stat)(ye)}e.stat=p;async function k(ye){let _e;try{if(_e=await w(ye),!_e.isSymbolicLink())return{stat:_e}}catch(Ce){}try{return{stat:await p(ye),symbolicLink:(_e==null?void 0:_e.isSymbolicLink())?{dangling:!1}:void 0}}catch(Ce){if(Ce.code==="ENOENT"&&_e)return{stat:_e,symbolicLink:{dangling:!0}};if(C.isWindows&&Ce.code==="EACCES"&&_e)try{return{stat:await p(await A(ye)),symbolicLink:_e.isSymbolicLink()?{dangling:!1}:void 0}}catch(ze){if(ze.code==="ENOENT")return{stat:_e,symbolicLink:{dangling:!0}};throw ze}throw Ce}}e.statLink=k;function w(ye){return g.promisify(y.lstat)(ye)}e.lstat=w;function T(ye,_e){return g.promisify(y.rename)(ye,_e)}e.rename=T;function h(ye,_e){return new Promise(Ce=>y.rename(ye,_e,()=>Ce()))}e.renameIgnoreError=h;function A(ye){return g.promisify(y.readlink)(ye)}e.readlink=A;function N(ye){return g.promisify(y.unlink)(ye)}e.unlink=N;function B(ye,_e,Ce){return g.promisify(y.symlink)(ye,_e,Ce)}e.symlink=B;function W(ye,_e){return g.promisify(y.truncate)(ye,_e)}e.truncate=W;function H(ye,_e){return g.promisify(y.readFile)(ye,_e)}e.readFile=H;async function K(ye,_e){return g.promisify(y.mkdir)(ye,{mode:_e,recursive:!0})}e.mkdirp=K;const re=new Map;function V(ye,_e,Ce){const ze=J(ye);return ce(ze).queue(()=>{const je=j(Ce);return new Promise((me,ve)=>O(ye,_e,je,Se=>Se?ve(Se):me()))})}e.writeFile=V;function J(ye){let _e=ye;return(C.isWindows||C.isMacintosh)&&(_e=_e.toLowerCase()),_e}function ce(ye){const _e=re.get(ye);if(_e)return _e;const Ce=new E.Queue;return re.set(ye,Ce),L.Event.once(Ce.onFinished)(()=>{re.delete(ye),Ce.dispose()}),Ce}let $=!0;function O(ye,_e,Ce,ze){if(!$)return y.writeFile(ye,_e,{mode:Ce.mode,flag:Ce.flag},ze);y.open(ye,Ce.flag,Ce.mode,(je,me)=>{if(je)return ze(je);y.writeFile(me,_e,ve=>{if(ve)return y.close(me,()=>ze(ve));y.fdatasync(me,Se=>(Se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Se),$=!1),y.close(me,ke=>ze(ke))))})})}function F(ye,_e,Ce){const ze=j(Ce);if(!$)return y.writeFileSync(ye,_e,{mode:ze.mode,flag:ze.flag});const je=y.openSync(ye,ze.flag,ze.mode);try{y.writeFileSync(je,_e);try{y.fdatasyncSync(je)}catch(me){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",me),$=!1}}finally{y.closeSync(je)}}e.writeFileSync=F;function j(ye){return ye?{mode:typeof ye.mode=="number"?ye.mode:438,flag:typeof ye.flag=="string"?ye.flag:"w"}:{mode:438,flag:"w"}}async function Q(ye){const _e=await o(ye),Ce=[];for(const ze of _e)await ne(I.join(ye,ze))&&Ce.push(ze);return Ce}e.readDirsInDir=Q;async function ne(ye){try{const{stat:_e,symbolicLink:Ce}=await k(ye);return _e.isDirectory()&&(Ce==null?void 0:Ce.dangling)!==!0}catch(_e){}return!1}e.dirExists=ne;async function oe(ye){try{const{stat:_e,symbolicLink:Ce}=await k(ye);return _e.isFile()&&(Ce==null?void 0:Ce.dangling)!==!0}catch(_e){}return!1}e.fileExists=oe;function ie(ye){return new Promise(_e=>{let Ce=!1;const ze=setInterval(()=>{Ce||(Ce=!0,y.exists(ye,je=>{Ce=!1,je||(clearInterval(ze),_e(void 0))}))},1e3)})}e.whenDeleted=ie;async function fe(ye,_e){if(ye!==_e){async function Ce(ze){const je=await w(ze);if(!(je.isDirectory()||je.isSymbolicLink())){const me=await g.promisify(y.open)(ze,"a");try{await g.promisify(y.futimes)(me,je.atime,new Date)}catch(ve){}return g.promisify(y.close)(me)}}try{await T(ye,_e),await Ce(_e)}catch(ze){if(ye.toLowerCase()!==_e.toLowerCase()&&ze.code==="EXDEV"||ye.endsWith("."))await Pe(ye,_e),await b(ye,S.MOVE),await Ce(_e);else throw ze}}}e.move=fe;const Ie=511;async function Pe(ye,_e,Ce){const ze=Ce!=null?Ce:Object.create(null);if(!ze[ye]){ze[ye]=!0;const{stat:je,symbolicLink:me}=await k(ye);if(!(me==null?void 0:me.dangling)){if(!je.isDirectory())return Ne(ye,_e,je.mode&Ie);await K(_e,je.mode&Ie);const ve=await o(ye);for(let Se=0;Se<ve.length;Se++){const ke=ve[Se];await Pe(I.join(ye,ke),I.join(_e,ke),ze)}}}}e.copy=Pe;async function Ne(ye,_e,Ce){return new Promise((ze,je)=>{const me=y.createReadStream(ye),ve=y.createWriteStream(_e,{mode:Ce});let Se=!1;const ke=Re=>{if(!Se){if(Se=!0,Re)return je(Re);y.chmod(_e,Ce,Fe=>Fe?je(Fe):ze())}};me.once("error",Re=>ke(Re)),ve.once("error",Re=>ke(Re)),ve.once("close",()=>ke()),me.pipe(ve)})}}),define(he[125],de([0,1,21,13,2,15,48]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function L(_){const P=I.dirname(_);if(_===P)return _;const v=(I.basename(_)||_).toLowerCase();try{const d=E.readdirSync(P).filter(S=>S.toLowerCase()===v);if(d.length===1){const S=L(P);if(S)return I.join(S,d[0])}else if(d.length>1){const S=d.indexOf(v);if(S>=0){const b=L(P);if(b)return I.join(b,d[S])}}}catch(c){}return null}e.realcaseSync=L;async function g(_){try{return await C.promisify(y.realpath)(_)}catch(P){const v=R(_);return await C.promisify(y.access)(v,y.constants.R_OK),v}}e.realpath=g;function t(_){try{return y.realpathSync(_)}catch(P){const v=R(_);return y.accessSync(v,y.constants.R_OK),v}}e.realpathSync=t;function R(_){return m.rtrim(I.normalize(_),I.sep)}}),define(he[126],de([0,1,75]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function m(){const g=1025;return g+Math.floor((65535-g)*Math.random())}e.randomPort=m;function I(g,t,R){let _=!1;return new Promise(P=>{const v=setTimeout(()=>{if(!_)return _=!0,P(0)},R);E(g,t,c=>{if(!_)return _=!0,clearTimeout(v),P(c)})})}e.findFreePort=I;function E(g,t,R){if(t===0)return R(0);const _=new y.Socket;_.once("connect",()=>(L(_),E(g+1,t-1,R))),_.once("data",()=>{}),_.once("error",P=>(L(_),P.code!=="ECONNREFUSED"?E(g+1,t-1,R):R(g))),_.connect(g,"127.0.0.1")}function C(g,t,R){let _=!1,P,v=1;const c=y.createServer({pauseOnConnect:!0});function d(S,b){_||(_=!0,c.removeAllListeners(),c.close(),P&&clearTimeout(P),b(S))}return new Promise(S=>{P=setTimeout(()=>{d(0,S)},R),c.on("listening",()=>{d(g,S)}),c.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&v<t?(g++,v++,c.listen(g,"127.0.0.1")):d(0,S)}),c.on("close",()=>{d(0,S)}),c.listen(g,"127.0.0.1")})}e.findFreePortFaster=C;function L(g){try{g.removeAllListeners("connect"),g.removeAllListeners("error"),g.end(),g.destroy(),g.unref()}catch(t){console.error(t)}}});var et=this&&this.__await||function(Z){return this instanceof et?(this.v=Z,this):new et(Z)},$t=this&&this.__asyncGenerator||function(Z,e,y){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var m=y.apply(Z,e||[]),I,E=[];return I={},C("next"),C("throw"),C("return"),I[Symbol.asyncIterator]=function(){return this},I;function C(P){m[P]&&(I[P]=function(v){return new Promise(function(c,d){E.push([P,v,c,d])>1||L(P,v)})})}function L(P,v){try{g(m[P](v))}catch(c){_(E[0][3],c)}}function g(P){P.value instanceof et?Promise.resolve(P.value.v).then(t,R):_(E[0][2],P)}function t(P){L("next",P)}function R(P){L("throw",P)}function _(P,v){P(v),E.shift(),E.length&&L(E[0][0],E[0][1])}},wt=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],y;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),y={},m("next"),m("throw"),m("return"),y[Symbol.asyncIterator]=function(){return this},y);function m(E){y[E]=Z[E]&&function(C){return new Promise(function(L,g){C=Z[E](C),I(L,g,C.done,C.value)})}}function I(E,C,L,g){Promise.resolve(g).then(function(t){E({value:t,done:L})},C)}};define(he[76],de([0,1,15,23,2,36]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C="Windows PowerShell",L="Windows PowerShell (x86)",g=/^\d+$/,t=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/,_=process.arch==="x64",P=_||m.arch()==="x64";class v{constructor(i,l,s){this.exePath=i,this.displayName=l,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await y.fileExists(this.exePath)),this.knownToExist}}function c({useAlternateBitness:r=!1}={}){return r?_?E.env["ProgramFiles(x86)"]||null:P&&E.env.ProgramW6432||null:E.env.ProgramFiles||null}function d({useAlternateBitness:r=!1}={}){const i=E.env.windir;return r?_?I.join(i,"SysWOW64"):P?I.join(i,"Sysnative"):I.join(i,"System32"):I.join(i,"System32")}async function S({useAlternateBitness:r=!1,findPreview:i=!1}={}){const l=c({useAlternateBitness:r});if(!l)return null;const s=I.join(l,"PowerShell");if(!await y.dirExists(s))return null;let p=-1,k=null;for(const h of await y.readdir(s)){let A=-1;if(i){const B=h.indexOf("-");if(B<0)continue;const W=h.substring(0,B);if(!g.test(W)||h.substring(B+1)!=="preview")continue;A=parseInt(W,10)}else{if(!g.test(h))continue;A=parseInt(h,10)}if(!(A<=p)){const N=I.join(s,h,"pwsh.exe");!await y.fileExists(N)||(k=N,p=A)}}if(!k)return null;const w=l.includes("x86")?" (x86)":"",T=i?" Preview":"";return new v(k,`PowerShell${T}${w}`,!0)}async function b({findPreview:r}={}){if(!E.env.LOCALAPPDATA)return null;const i=I.join(E.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.dirExists(i))return null;const{pwshMsixDirRegex:l,pwshMsixName:s}=r?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:t,pwshMsixName:"PowerShell (Store)"};for(const p of await y.readdir(i))if(l.test(p)){const k=I.join(i,p,"pwsh.exe");return new v(k,s)}return null}function f(){const r=I.join(m.homedir(),".dotnet","tools","pwsh.exe");return new v(r,".NET Core PowerShell Global Tool")}function u({useAlternateBitness:r=!1}={}){if(!P&&r)return null;const i=d({useAlternateBitness:r}),l=I.join(i,"WindowsPowerShell","v1.0","powershell.exe");let s;return _?s=r?L:C:P?s=r?C:L:s=L,new v(l,s,!0)}function a(){return $t(this,arguments,function*(){let i=yield et(S());i&&(yield yield et(i)),i=yield et(S({useAlternateBitness:!0})),i&&(yield yield et(i)),i=yield et(b()),i&&(yield yield et(i)),i=f(),i&&(yield yield et(i)),i=yield et(S({findPreview:!0})),i&&(yield yield et(i)),i=yield et(b({findPreview:!0})),i&&(yield yield et(i)),i=yield et(S({useAlternateBitness:!0,findPreview:!0})),i&&(yield yield et(i)),i=u(),i&&(yield yield et(i)),i=u({useAlternateBitness:!0}),i&&(yield yield et(i))})}function o(){return $t(this,arguments,function*(){var i,l;try{for(var s=wt(a()),p;p=yield et(s.next()),!p.done;){const k=p.value;(yield et(k.exists()))&&(yield yield et(k))}}catch(k){i={error:k}}finally{try{p&&!p.done&&(l=s.return)&&(yield et(l.call(s)))}finally{if(i)throw i.error}}})}e.enumeratePowerShellInstallations=o;async function n(){var r,i;try{for(var l=wt(o()),s;s=await l.next(),!s.done;)return s.value}catch(p){r={error:p}}finally{try{s&&!s.done&&(i=l.return)&&await i.call(l)}finally{if(r)throw r.error}}return null}e.getFirstAvailablePowerShellInstallation=n}),define(he[77],de([0,1,32,8]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function I(C){return new Promise((L,g)=>{let t;const R=new Map;function _(c,d,S,b,f){const u=R.get(d);if(c===C||u){const a={name:P(S),cmd:S,pid:c,ppid:d,load:b,mem:f};R.set(c,a),c===C&&(t=a),u&&(u.children||(u.children=[]),u.children.push(a),u.children.length>1&&(u.children=u.children.sort((o,n)=>o.pid-n.pid)))}}function P(c){const d=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,f=/\\pipe\\winpty-control/,u=/conhost\.exe/,a=/--type=([a-zA-Z-]+)/;if(S.exec(c))return"watcherService ";if(b.exec(c))return"electron-crash-reporter";if(f.exec(c))return"winpty-process";if(u.exec(c))return"console-window-host (Windows internal process)";let o=a.exec(c);if(o&&o.length===2)return o[1]==="renderer"?d.exec(c)?"shared-process":"window":o[1];const n=/[a-zA-Z-]+\.js/g;let r="";do o=n.exec(c),o&&(r+=o+" ");while(o);return r&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron_node ${r}`:c}if(process.platform==="win32"){const c=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,S)=>{Z(["windows-process-tree"],d,S)}).then(d=>{d.getProcessList(C,S=>{d.getProcessCpuUsage(S,b=>{const f=new Map;b.forEach(u=>{const a=c(u.commandLine||"");f.set(u.pid,{name:P(a),cmd:a,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),t=f.get(C),t?(f.forEach(u=>{const a=f.get(u.ppid);a&&(a.children||(a.children=[]),a.children.push(u))}),f.forEach(u=>{u.children&&(u.children=u.children.sort((a,o)=>a.pid-o.pid))}),L(t)):g(new Error(`Root process ${C} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{function v(){let c=[t];const d=[];for(;c.length;){const b=c.shift();b&&(d.push(b.pid),b.children&&(c=c.concat(b.children)))}let S=JSON.stringify(m.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Z).fsPath);S+=" "+d.join(" "),y.exec(S,{},(b,f,u)=>{if(b||u)g(b||new Error(u.toString()));else{const a=f.toString().split(`
`);for(let o=0;o<d.length;o++){const n=R.get(d[o]);n.load=parseFloat(a[o])}if(!t){g(new Error(`Root process ${C} not found`));return}L(t)}})}y.exec("which ps",{},(c,d,S)=>{if(c||S)if(process.platform!=="linux")g(c||new Error(S.toString()));else{const b=JSON.stringify(m.FileAccess.asFileUri("vs/base/node/ps.sh",Z).fsPath);y.exec(b,{},(f,u,a)=>{f||a?g(f||new Error(a.toString())):(E(u,_),v())})}else{const b=d.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";y.exec(`${b} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,a,o)=>{u||o&&!o.includes("screen size is bogus")?g(u||new Error(o.toString())):(E(a,_),process.platform==="linux"?v():t?L(t):g(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=I;function E(C,L){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,t=C.toString().split(`
`);for(const R of t){const _=g.exec(R.trim());_&&_.length===6&&L(parseInt(_[1]),parseInt(_[2]),_[5],parseFloat(_[3]),parseFloat(_[4]))}}}),define(he[127],de([0,1,2,21,5,72,4,15]),function(Z,e,y,m,I,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function g(_,P,v){return R({path:_,isDirectory:!1},P,v)}e.watchFile=g;function t(_,P,v){return R({path:_,isDirectory:!0},P,v)}e.watchFolder=t,e.CHANGE_BUFFER_DELAY=100;function R(_,P,v){const c=y.basename(_.path),d=new Map;let S=!1,b=[C.toDisposable(()=>{d.forEach(f=>C.dispose(f)),d.clear()})];try{const f=m.watch(_.path);b.push(C.toDisposable(()=>{f.removeAllListeners(),f.close()}));const u=new Set;_.isDirectory&&L.readdir(_.path).then(a=>a.forEach(o=>u.add(o))),f.on("error",(a,o)=>{S||v(`Failed to watch ${_.path} for changes using fs.watch() (${a}, ${o})`)}),f.on("change",(a,o)=>{if(!S){let n="";if(o&&(n=o.toString(),I.isMacintosh&&(n=E.normalizeNFC(n))),!(!n||a!=="change"&&a!=="rename")){const r=_.isDirectory?y.join(_.path,n):_.path;if(_.isDirectory)if(a==="rename"){const i=d.get(r);i&&C.dispose(i);const l=setTimeout(async()=>{d.delete(r);const s=await L.exists(r);if(!S){let p;s?u.has(n)?p="changed":(p="added",u.add(n)):(u.delete(n),p="deleted"),P(p,r)}},e.CHANGE_BUFFER_DELAY);d.set(r,C.toDisposable(()=>clearTimeout(l)))}else{let i;u.has(n)?i="changed":(i="added",u.add(n)),P(i,r)}else if(a==="rename"||n!==c){const i=setTimeout(async()=>{const l=await L.exists(r);S||(l?(P("changed",r),b=[R(_,P,v)]):P("deleted",r))},e.CHANGE_BUFFER_DELAY);C.dispose(b),b=[C.toDisposable(()=>clearTimeout(i))]}else P("changed",r)}}})}catch(f){L.exists(_.path).then(u=>{u&&!S&&v(`Failed to watch ${_.path} for changes using fs.watch() (${f.toString()})`)})}return C.toDisposable(()=>{S=!0,b=C.dispose(b)})}}),define(he[37],de([0,1,6,4,17,27,12,18,14,11,46,13]),function(Z,e,y,m,I,E,C,L,g,t,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.createChannelSender=e.createChannelReceiver=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var P;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(P=e.RequestType||(e.RequestType={}));function v(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(c=e.ResponseType||(e.ResponseType={}));function d(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(S||(S={}));class b{constructor(F){this.buffer=F,this.pos=0}read(F){const j=this.buffer.slice(this.pos,this.pos+F);return this.pos+=j.byteLength,j}}class f{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var u;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(u||(u={}));function a(O){const F=L.VSBuffer.alloc(4);return F.writeUInt32BE(O,0),F}function o(O){return O.read(4).readUInt32BE(0)}function n(O){const F=L.VSBuffer.alloc(1);return F.writeUInt8(O,0),F}const r={Undefined:n(u.Undefined),String:n(u.String),Buffer:n(u.Buffer),VSBuffer:n(u.VSBuffer),Array:n(u.Array),Object:n(u.Object)},i=typeof Buffer!="undefined";function l(O,F){if(typeof F=="undefined")O.write(r.Undefined);else if(typeof F=="string"){const j=L.VSBuffer.fromString(F);O.write(r.String),O.write(a(j.byteLength)),O.write(j)}else if(i&&Buffer.isBuffer(F)){const j=L.VSBuffer.wrap(F);O.write(r.Buffer),O.write(a(j.byteLength)),O.write(j)}else if(F instanceof L.VSBuffer)O.write(r.VSBuffer),O.write(a(F.byteLength)),O.write(F);else if(Array.isArray(F)){O.write(r.Array),O.write(a(F.length));for(const j of F)l(O,j)}else{const j=L.VSBuffer.fromString(JSON.stringify(F));O.write(r.Object),O.write(a(j.byteLength)),O.write(j)}}function s(O){switch(O.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return O.read(o(O)).toString();case u.Buffer:return O.read(o(O)).buffer;case u.VSBuffer:return O.read(o(O));case u.Array:{const j=o(O),Q=[];for(let ne=0;ne<j;ne++)Q.push(s(O));return Q}case u.Object:return JSON.parse(O.read(o(O)).toString())}}class p{constructor(F,j,Q=null,ne=1e3){this.protocol=F,this.ctx=j,this.logger=Q,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(oe=>this.onRawMessage(oe)),this.sendResponse({type:200})}registerChannel(F,j){this.channels.set(F,j),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const j=this.send([F.type]);this.logger&&this.logger.logOutgoing(j,0,1,d(F.type));return}case 201:case 202:case 204:case 203:{const j=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(j,F.id,1,d(F.type),F.data);return}}}send(F,j=void 0){const Q=new f;return l(Q,F),l(Q,j),this.sendBuffer(Q.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(j){return 0}}onRawMessage(F){const j=new b(F),Q=s(j),ne=s(j),oe=Q[0];switch(oe){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,Q[1],1,`${v(oe)}: ${Q[2]}.${Q[3]}`,ne),this.onPromise({type:oe,id:Q[1],channelName:Q[2],name:Q[3],arg:ne});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,Q[1],1,`${v(oe)}: ${Q[2]}.${Q[3]}`,ne),this.onEventListen({type:oe,id:Q[1],channelName:Q[2],name:Q[3],arg:ne});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,Q[1],1,`${v(oe)}`),this.disposeActiveRequest({type:oe,id:Q[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,Q[1],1,`${v(oe)}`),this.disposeActiveRequest({type:oe,id:Q[1]})}}onPromise(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const Q=new E.CancellationTokenSource;let ne;try{ne=j.call(this.ctx,F.name,F.arg,Q.token)}catch(fe){ne=Promise.reject(fe)}const oe=F.id;ne.then(fe=>{this.sendResponse({id:oe,data:fe,type:201}),this.activeRequests.delete(F.id)},fe=>{fe instanceof Error?this.sendResponse({id:oe,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.sendResponse({id:oe,data:fe,type:203}),this.activeRequests.delete(F.id)});const ie=m.toDisposable(()=>Q.cancel());this.activeRequests.set(F.id,ie)}onEventListen(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const Q=F.id,oe=j.listen(this.ctx,F.name,F.arg)(ie=>this.sendResponse({id:Q,data:ie,type:204}));this.activeRequests.set(F.id,oe)}disposeActiveRequest(F){const j=this.activeRequests.get(F.id);j&&(j.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let j=this.pendingRequests.get(F.channelName);j||(j=[],this.pendingRequests.set(F.channelName,j));const Q=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:F,timeoutTimer:Q})}flushPendingRequests(F){const j=this.pendingRequests.get(F);if(j){for(const Q of j)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.onPromise(Q.request);break;case 102:this.onEventListen(Q.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=p;var k;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(F,j=null){this.protocol=F,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=j}getChannel(F){const j=this;return{call(Q,ne,oe){return j.isDisposed?Promise.reject(C.canceled()):j.requestPromise(F,Q,ne,oe)},listen(Q,ne){return j.isDisposed?Promise.reject(C.canceled()):j.requestEvent(F,Q,ne)}}}requestPromise(F,j,Q,ne=E.CancellationToken.None){const oe=this.lastRequestId++,fe={id:oe,type:100,channelName:F,name:j,arg:Q};if(ne.isCancellationRequested)return Promise.reject(C.canceled());let Ie;return new Promise((Ne,ye)=>{if(ne.isCancellationRequested)return ye(C.canceled());const _e=()=>{const me=ve=>{switch(ve.type){case 201:this.handlers.delete(oe),Ne(ve.data);break;case 202:this.handlers.delete(oe);const Se=new Error(ve.data.message);Se.stack=ve.data.stack,Se.name=ve.data.name,ye(Se);break;case 203:this.handlers.delete(oe),ye(ve.data);break}};this.handlers.set(oe,me),this.sendRequest(fe)};let Ce=null;this.state===S.Idle?_e():(Ce=I.createCancelablePromise(me=>this.whenInitialized()),Ce.then(()=>{Ce=null,_e()}));const ze=()=>{Ce?(Ce.cancel(),Ce=null):this.sendRequest({id:oe,type:101}),ye(C.canceled())},je=ne.onCancellationRequested(ze);Ie=m.combinedDisposable(m.toDisposable(ze),je),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(F,j,Q){const ne=this.lastRequestId++,ie={id:ne,type:102,channelName:F,name:j,arg:Q};let fe=null;const Ie=new y.Emitter({onFirstListenerAdd:()=>{fe=I.createCancelablePromise(Ne=>this.whenInitialized()),fe.then(()=>{fe=null,this.activeRequests.add(Ie),this.sendRequest(ie)})},onLastListenerRemove:()=>{fe?(fe.cancel(),fe=null):(this.activeRequests.delete(Ie),this.sendRequest({id:ne,type:103}))}}),Pe=Ne=>Ie.fire(Ne.data);return this.handlers.set(ne,Pe),Ie.event}sendRequest(F){switch(F.type){case 100:case 102:{const j=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(j,F.id,0,`${v(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const j=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(j,F.id,0,v(F.type));return}}}send(F,j=void 0){const Q=new f;return l(Q,F),l(Q,j),this.sendBuffer(Q.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(j){return 0}}onBuffer(F){const j=new b(F),Q=s(j),ne=s(j),oe=Q[0];switch(oe){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,d(oe)),this.onResponse({type:Q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,Q[1],0,d(oe),ne),this.onResponse({type:Q[0],id:Q[1],data:ne})}}onResponse(F){if(F.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(F.id);j&&j(F)}whenInitialized(){return this.state===S.Idle?Promise.resolve():y.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelClient=w;class T{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:j,onDidClientDisconnect:Q})=>{y.Event.once(j.onMessage)(oe=>{const ie=new b(oe),fe=s(ie),Ie=new p(j,fe),Pe=new w(j);this.channels.forEach((ye,_e)=>Ie.registerChannel(_e,ye));const Ne={channelServer:Ie,channelClient:Pe,ctx:fe};this._connections.add(Ne),this._onDidAddConnection.fire(Ne),Q(()=>{Ie.dispose(),Pe.dispose(),this._connections.delete(Ne),this._onDidRemoveConnection.fire(Ne)})})})}get connections(){const F=[];return this._connections.forEach(j=>F.push(j)),F}getChannel(F,j){const Q=this;return{call(ne,oe,ie){let fe;if(t.isFunction(j)){let Pe=g.getRandomElement(Q.connections.filter(j));fe=Pe?Promise.resolve(Pe):y.Event.toPromise(y.Event.filter(Q.onDidAddConnection,j))}else fe=j.routeCall(Q,ne,oe);const Ie=fe.then(Pe=>Pe.channelClient.getChannel(F));return A(Ie).call(ne,oe,ie)},listen(ne,oe){if(t.isFunction(j))return Q.getMulticastEvent(F,j,ne,oe);const ie=j.routeEvent(Q,ne,oe).then(fe=>fe.channelClient.getChannel(F));return A(ie).listen(ne,oe)}}}getMulticastEvent(F,j,Q,ne){const oe=this;let ie=new m.DisposableStore;const fe=new y.Emitter({onFirstListenerAdd:()=>{ie=new m.DisposableStore;const Ie=new y.EventMultiplexer,Pe=new Map,Ne=_e=>{const ze=_e.channelClient.getChannel(F).listen(Q,ne),je=Ie.add(ze);Pe.set(_e,je)},ye=_e=>{const Ce=Pe.get(_e);!Ce||(Ce.dispose(),Pe.delete(_e))};oe.connections.filter(j).forEach(Ne),y.Event.filter(oe.onDidAddConnection,j)(Ne,void 0,ie),oe.onDidRemoveConnection(ye,void 0,ie),Ie.event(fe.fire,fe,ie),ie.add(Ie)},onLastListenerRemove:()=>{ie.dispose()}});return fe.event}registerChannel(F,j){this.channels.set(F,j),this._connections.forEach(Q=>{Q.channelServer.registerChannel(F,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class h{constructor(F,j,Q=null){const ne=new f;l(ne,j),F.send(ne.buffer),this.channelClient=new w(F,Q),this.channelServer=new p(F,j,Q)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,j){this.channelServer.registerChannel(F,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=h;function A(O){return{call(F,j,Q){return O.then(ne=>ne.call(F,j,Q))},listen(F,j){const Q=new y.Relay;return O.then(ne=>Q.input=ne.listen(F,j)),Q.event}}}e.getDelayedChannel=A;function N(O){let F=!1;return{call(j,Q,ne){return F?O.call(j,Q,ne):I.timeout(0).then(()=>F=!0).then(()=>O.call(j,Q,ne))},listen(j,Q){if(F)return O.listen(j,Q);const ne=new y.Relay;return I.timeout(0).then(()=>F=!0).then(()=>ne.input=O.listen(j,Q)),ne.event}}}e.getNextTickChannel=N;class B{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const j of F.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await y.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=B;function W(O,F){const j=O,Q=F&&F.disableMarshalling,ne=new Map;for(const oe in j)K(oe)&&ne.set(oe,y.Event.buffer(j[oe],!0));return new class{listen(oe,ie){const fe=ne.get(ie);if(fe)return fe;throw new Error(`Event not found: ${ie}`)}call(oe,ie,fe){const Ie=j[ie];if(typeof Ie=="function"){if(!Q&&Array.isArray(fe))for(let Pe=0;Pe<fe.length;Pe++)fe[Pe]=R.revive(fe[Pe]);return Ie.apply(j,fe)}throw new Error(`Method not found: ${ie}`)}}}e.createChannelReceiver=W;function H(O,F){const j=F&&F.disableMarshalling;return new Proxy({},{get(Q,ne){var oe;if(typeof ne=="string")return((oe=F==null?void 0:F.properties)===null||oe===void 0?void 0:oe.has(ne))?F.properties.get(ne):K(ne)?O.listen(ne):async function(...ie){let fe;F&&!t.isUndefinedOrNull(F.context)?fe=[F.context,...ie]:fe=ie;const Ie=await O.call(ne,fe);return j?Ie:R.revive(Ie)};throw new Error(`Property not found: ${String(ne)}`)}})}e.createChannelSender=H;function K(O){return O[0]==="o"&&O[1]==="n"&&_.isUpperAsciiLetter(O.charCodeAt(2))}const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){let F=O.toString();if(F!=="[object Object]")return F}return O}function J(O){return Array.isArray(O)?O.map(V):V(O)}function ce(O,F,j,Q,ne,oe,ie){ie=J(ie);const fe=re[ne],Ie=fe[Q%fe.length];let Pe=[`%c[${O}]%c[${String(F).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(oe)?(Pe=Pe.concat(ie),Pe.push(")")):Pe.push(ie),console.log.apply(console,Pe)}e.logWithColors=ce;class ${constructor(F,j){this._outgoingPrefix=F,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,j,Q,ne,oe){this._totalOutgoing+=F,ce(this._outgoingPrefix,this._totalOutgoing,F,j,Q,ne,oe)}logIncoming(F,j,Q,ne,oe){this._totalIncoming+=F,ce(this._incomingPrefix,this._totalIncoming,F,j,Q,ne,oe)}}e.IPCLogger=$}),define(he[78],de([0,1,6,37,4,18,5,36]),function(Z,e,y,m,I,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let g=null;function t(){return g||(g=E.VSBuffer.alloc(0)),g}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,l){if(i===0)return t();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const w=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=i),w}if(this._chunks[0].byteLength>i){const w=this._chunks[0].slice(0,i);return l&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),w}let s=E.VSBuffer.alloc(i),p=0,k=0;for(;i>0;){const w=this._chunks[k];if(w.byteLength>i){const T=w.slice(0,i);s.set(T,p),p+=i,l&&(this._chunks[k]=w.slice(i),this._totalLength-=i),i-=i}else s.set(w,p),p+=w.byteLength,l?(this._chunks.shift(),this._totalLength-=w.byteLength):k++,i-=w.byteLength}return s}}e.ChunkStream=R;var _;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(_||(_={}));var P;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(P=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(i,l,s,p){this.type=i,this.id=l,this.ack=s,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends I.Disposable{constructor(i){super();this._onMessage=this._register(new y.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const s=this._state.messageType,p=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new v(s,p,k,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(!this._isDisposed){i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=E.VSBuffer.alloc(13);l.writeUInt8(i.type,0),l.writeUInt32BE(i.id,1),l.writeUInt32BE(i.ack,5),l.writeUInt32BE(i.data.byteLength,9),this._writeSoon(l,i.data)}}_bufferAdd(i,l){const s=this._totalLength===0;return this._data.push(i,l),this._totalLength+=i.byteLength+l.byteLength,s}_bufferTake(){const i=E.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,l){this._bufferAdd(i,l)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends I.Disposable{constructor(i){super();this._onMessage=new y.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new v(1,0,0,i))}}e.Protocol=S;class b extends m.IPCClient{constructor(i,l,s=null){super(i,l,s);this.protocol=i}static fromSocket(i,l){return new b(new S(i),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=b;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new y.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,L.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class u{constructor(i){this.data=i,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],l=0,s=this._first;for(;s;)i[l++]=s.data,s=s.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const l=new u(i);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class o{constructor(){this.lastRuns=[];const i=Date.now();for(let l=0;l<o._HISTORY_LENGTH;l++)this.lastRuns[l]=i-1e3*l;setInterval(()=>{for(let l=o._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const i=Date.now(),l=(1+o._HISTORY_LENGTH)*1e3;let s=0;for(let p=0;p<o._HISTORY_LENGTH;p++)i-this.lastRuns[p]<=l&&s++;return 1-s/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class n{constructor(i,l=null){this._loadEstimator=o.getInstance(),this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=I.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new v(5,0,0,t());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const l=new v(4,0,0,t());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,l){this._isReconnecting=!0,this._socketDisposables=I.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let l=0,s=i.length;l<s;l++)this._socketWriter.write(i[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new v(6,0,0,t())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const l=this._outgoingUnackMsg.toArray();for(let s=0,p=l.length;s<p;s++)this._socketWriter.write(l[s]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new v(1,l,this._incomingAckId,i);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(i){const l=new v(2,0,0,i);this._socketWriter.write(l)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const i=this._outgoingUnackMsg.peek(),l=Date.now()-i.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const i=new v(3,0,this._incomingAckId,t());this._socketWriter.write(i)}}}e.PersistentProtocol=n}),define(he[79],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class y{constructor(I,E){this.lineNumber=I,this.column=E}with(I=this.lineNumber,E=this.column){return I===this.lineNumber&&E===this.column?this:new y(I,E)}delta(I=0,E=0){return this.with(this.lineNumber+I,this.column+E)}equals(I){return y.equals(this,I)}static equals(I,E){return!I&&!E?!0:!!I&&!!E&&I.lineNumber===E.lineNumber&&I.column===E.column}isBefore(I){return y.isBefore(this,I)}static isBefore(I,E){return I.lineNumber<E.lineNumber?!0:E.lineNumber<I.lineNumber?!1:I.column<E.column}isBeforeOrEqual(I){return y.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,E){return I.lineNumber<E.lineNumber?!0:E.lineNumber<I.lineNumber?!1:I.column<=E.column}static compare(I,E){let C=I.lineNumber|0,L=E.lineNumber|0;if(C===L){let g=I.column|0,t=E.column|0;return g-t}return C-L}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new y(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=y}),define(he[56],de([0,1,79]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class m{constructor(E,C,L,g){E>L||E===L&&C>g?(this.startLineNumber=L,this.startColumn=g,this.endLineNumber=E,this.endColumn=C):(this.startLineNumber=E,this.startColumn=C,this.endLineNumber=L,this.endColumn=g)}isEmpty(){return m.isEmpty(this)}static isEmpty(E){return E.startLineNumber===E.endLineNumber&&E.startColumn===E.endColumn}containsPosition(E){return m.containsPosition(this,E)}static containsPosition(E,C){return!(C.lineNumber<E.startLineNumber||C.lineNumber>E.endLineNumber||C.lineNumber===E.startLineNumber&&C.column<E.startColumn||C.lineNumber===E.endLineNumber&&C.column>E.endColumn)}containsRange(E){return m.containsRange(this,E)}static containsRange(E,C){return!(C.startLineNumber<E.startLineNumber||C.endLineNumber<E.startLineNumber||C.startLineNumber>E.endLineNumber||C.endLineNumber>E.endLineNumber||C.startLineNumber===E.startLineNumber&&C.startColumn<E.startColumn||C.endLineNumber===E.endLineNumber&&C.endColumn>E.endColumn)}strictContainsRange(E){return m.strictContainsRange(this,E)}static strictContainsRange(E,C){return!(C.startLineNumber<E.startLineNumber||C.endLineNumber<E.startLineNumber||C.startLineNumber>E.endLineNumber||C.endLineNumber>E.endLineNumber||C.startLineNumber===E.startLineNumber&&C.startColumn<=E.startColumn||C.endLineNumber===E.endLineNumber&&C.endColumn>=E.endColumn)}plusRange(E){return m.plusRange(this,E)}static plusRange(E,C){let L,g,t,R;return C.startLineNumber<E.startLineNumber?(L=C.startLineNumber,g=C.startColumn):C.startLineNumber===E.startLineNumber?(L=C.startLineNumber,g=Math.min(C.startColumn,E.startColumn)):(L=E.startLineNumber,g=E.startColumn),C.endLineNumber>E.endLineNumber?(t=C.endLineNumber,R=C.endColumn):C.endLineNumber===E.endLineNumber?(t=C.endLineNumber,R=Math.max(C.endColumn,E.endColumn)):(t=E.endLineNumber,R=E.endColumn),new m(L,g,t,R)}intersectRanges(E){return m.intersectRanges(this,E)}static intersectRanges(E,C){let L=E.startLineNumber,g=E.startColumn,t=E.endLineNumber,R=E.endColumn,_=C.startLineNumber,P=C.startColumn,v=C.endLineNumber,c=C.endColumn;return L<_?(L=_,g=P):L===_&&(g=Math.max(g,P)),t>v?(t=v,R=c):t===v&&(R=Math.min(R,c)),L>t||L===t&&g>R?null:new m(L,g,t,R)}equalsRange(E){return m.equalsRange(this,E)}static equalsRange(E,C){return!!E&&!!C&&E.startLineNumber===C.startLineNumber&&E.startColumn===C.startColumn&&E.endLineNumber===C.endLineNumber&&E.endColumn===C.endColumn}getEndPosition(){return m.getEndPosition(this)}static getEndPosition(E){return new y.Position(E.endLineNumber,E.endColumn)}getStartPosition(){return m.getStartPosition(this)}static getStartPosition(E){return new y.Position(E.startLineNumber,E.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(E,C){return new m(this.startLineNumber,this.startColumn,E,C)}setStartPosition(E,C){return new m(E,C,this.endLineNumber,this.endColumn)}collapseToStart(){return m.collapseToStart(this)}static collapseToStart(E){return new m(E.startLineNumber,E.startColumn,E.startLineNumber,E.startColumn)}static fromPositions(E,C=E){return new m(E.lineNumber,E.column,C.lineNumber,C.column)}static lift(E){return E?new m(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn):null}static isIRange(E){return E&&typeof E.startLineNumber=="number"&&typeof E.startColumn=="number"&&typeof E.endLineNumber=="number"&&typeof E.endColumn=="number"}static areIntersectingOrTouching(E,C){return!(E.endLineNumber<C.startLineNumber||E.endLineNumber===C.startLineNumber&&E.endColumn<C.startColumn||C.endLineNumber<E.startLineNumber||C.endLineNumber===E.startLineNumber&&C.endColumn<E.startColumn)}static areIntersecting(E,C){return!(E.endLineNumber<C.startLineNumber||E.endLineNumber===C.startLineNumber&&E.endColumn<=C.startColumn||C.endLineNumber<E.startLineNumber||C.endLineNumber===E.startLineNumber&&C.endColumn<=E.startColumn)}static compareRangesUsingStarts(E,C){if(E&&C){const t=E.startLineNumber|0,R=C.startLineNumber|0;if(t===R){const _=E.startColumn|0,P=C.startColumn|0;if(_===P){const v=E.endLineNumber|0,c=C.endLineNumber|0;if(v===c){const d=E.endColumn|0,S=C.endColumn|0;return d-S}return v-c}return _-P}return t-R}return(E?1:0)-(C?1:0)}static compareRangesUsingEnds(E,C){return E.endLineNumber===C.endLineNumber?E.endColumn===C.endColumn?E.startLineNumber===C.startLineNumber?E.startColumn-C.startColumn:E.startLineNumber-C.startLineNumber:E.endColumn-C.endColumn:E.endLineNumber-C.endLineNumber}static spansMultipleLines(E){return E.endLineNumber>E.startLineNumber}}e.Range=m}),define(he[128],de([0,1,45,2]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(E,C,L,g){if(Array.isArray(E)){let t=0;for(const R of E){const _=I(R,C,L,g);if(_===10)return _;_>t&&(t=_)}return t}else{if(typeof E=="string")return g?E==="*"?5:E===L?10:0:0;if(E){const{language:t,pattern:R,scheme:_,hasAccessToAllModels:P}=E;if(!g&&!P)return 0;let v=0;if(_)if(_===C.scheme)v=10;else if(_==="*")v=5;else return 0;if(t)if(t===L)v=10;else if(t==="*")v=Math.max(v,5);else return 0;if(R){let c;if(typeof R=="string"?c=R:c=Object.assign(Object.assign({},R),{base:m.normalize(R.base)}),c===C.fsPath||y.match(c,C.fsPath))v=10;else return 0}return v}else return 0}}e.score=I}),define(he[129],de([0,1,6,4]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class I{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,L){return this._map.set(C,L),this.fire([C]),m.toDisposable(()=>{this._map.get(C)===L&&(this._map.delete(C),this.fire([C]))})}registerPromise(C,L){let g=null,t=!1;return this._promises.set(C,L.then(R=>{this._promises.delete(C),!(t||!R)&&(g=this.register(C,R))})),m.toDisposable(()=>{t=!0,g&&g.dispose()})}getPromise(C){const L=this.get(C);if(L)return Promise.resolve(L);const g=this._promises.get(C);return g?g.then(t=>this.get(C)):null}get(C){return this._map.get(C)||null}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=I}),define(he[130],de([9,10]),function(Z,e){return Z.create("vs/base/common/actions",e)}),define(he[131],de([0,1,130,4,6]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.ActionWithMenuAction=e.Separator=e.RadioGroup=e.ActionRunner=e.Action=void 0;class E extends m.Disposable{constructor(c,d="",S="",b=!0,f){super();this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._checked=!1,this._id=c,this._label=d,this._cssClass=S,this._enabled=b,this._actionCallback=f}get id(){return this._id}get label(){return this._label}set label(c){this._setLabel(c)}_setLabel(c){this._label!==c&&(this._label=c,this._onDidChange.fire({label:c}))}get tooltip(){return this._tooltip||""}set tooltip(c){this._setTooltip(c)}_setTooltip(c){this._tooltip!==c&&(this._tooltip=c,this._onDidChange.fire({tooltip:c}))}get class(){return this._cssClass}set class(c){this._setClass(c)}_setClass(c){this._cssClass!==c&&(this._cssClass=c,this._onDidChange.fire({class:c}))}get enabled(){return this._enabled}set enabled(c){this._setEnabled(c)}_setEnabled(c){this._enabled!==c&&(this._enabled=c,this._onDidChange.fire({enabled:c}))}get checked(){return this._checked}set checked(c){this._setChecked(c)}_setChecked(c){this._checked!==c&&(this._checked=c,this._onDidChange.fire({checked:c}))}run(c,d){return this._actionCallback?this._actionCallback(c):Promise.resolve(!0)}}e.Action=E;class C extends m.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new I.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new I.Emitter),this.onDidRun=this._onDidRun.event}async run(c,d){if(!c.enabled)return Promise.resolve(null);this._onBeforeRun.fire({action:c});try{const S=await this.runAction(c,d);this._onDidRun.fire({action:c,result:S})}catch(S){this._onDidRun.fire({action:c,error:S})}}runAction(c,d){const S=d?c.run(d):c.run();return Promise.resolve(S)}}e.ActionRunner=C;class L extends m.Disposable{constructor(c){super();this.actions=c;for(const d of c)this._register(d.onDidChange(S=>{if(S.checked&&d.checked)for(const b of c)b!==d&&(b.checked=!1)}))}}e.RadioGroup=L;class g extends E{constructor(c){super(g.ID,c,c?"separator text":"separator");this.checked=!1,this.enabled=!1}}e.Separator=g,g.ID="vs.actions.separator";class t extends E{constructor(c,d,S,b,f,u){super(c,S,b,f,u);this._actions=d}get actions(){return this._actions}}e.ActionWithMenuAction=t;class R{constructor(c,d,S,b){this.tooltip="",this.enabled=!0,this.checked=!1,this.id=c,this.label=d,this.class=b,this._actions=S}dispose(){}get actions(){return this._actions}async run(){}}e.SubmenuAction=R;class _ extends E{constructor(){super(_.ID,y.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=_,_.ID="vs.actions.empty";function P(v){var c,d;return{id:v.id,label:v.label,class:void 0,enabled:(c=v.enabled)!==null&&c!==void 0?c:!0,checked:(d=v.checked)!==null&&d!==void 0?d:!1,run:async()=>v.run(),tooltip:v.label,dispose:()=>{}}}e.toAction=P}),define(he[132],de([9,10]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(he[133],de([0,1,132]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const m=60,I=m*60,E=I*24,C=E*7,L=E*30,g=E*365;function t(_,P){typeof _!="number"&&(_=_.getTime());const v=Math.round((new Date().getTime()-_)/1e3);if(v<-30)return y.localize(0,null,t(new Date().getTime()+v*1e3,!1));if(v<30)return y.localize(1,null);let c;return v<m?(c=v,P?c===1?y.localize(2,null,c):y.localize(3,null,c):c===1?y.localize(4,null,c):y.localize(5,null,c)):v<I?(c=Math.floor(v/m),P?c===1?y.localize(6,null,c):y.localize(7,null,c):c===1?y.localize(8,null,c):y.localize(9,null,c)):v<E?(c=Math.floor(v/I),P?c===1?y.localize(10,null,c):y.localize(11,null,c):c===1?y.localize(12,null,c):y.localize(13,null,c)):v<C?(c=Math.floor(v/E),P?c===1?y.localize(14,null,c):y.localize(15,null,c):c===1?y.localize(16,null,c):y.localize(17,null,c)):v<L?(c=Math.floor(v/C),P?c===1?y.localize(18,null,c):y.localize(19,null,c):c===1?y.localize(20,null,c):y.localize(21,null,c)):v<g?(c=Math.floor(v/L),P?c===1?y.localize(22,null,c):y.localize(23,null,c):c===1?y.localize(24,null,c):y.localize(25,null,c)):(c=Math.floor(v/g),P?c===1?y.localize(26,null,c):y.localize(27,null,c):c===1?y.localize(28,null,c):y.localize(29,null,c))}e.fromNow=t;function R(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(he[134],de([9,10]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(he[39],de([0,1,134,11,14]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function E(t,R){return R&&(t.stack||t.stacktrace)?y.localize(0,null,L(t),C(t.stack)||C(t.stacktrace)):L(t)}function C(t){return Array.isArray(t)?t.join(`
`):t}function L(t){return typeof t.code=="string"&&typeof t.errno=="number"&&typeof t.syscall=="string"?y.localize(1,null,t.message):t.message||y.localize(2,null)}function g(t=null,R=!1){if(!t)return y.localize(3,null);if(Array.isArray(t)){const _=I.coalesce(t),P=g(_[0],R);return _.length>1?y.localize(4,null,P,_.length):P}if(m.isString(t))return t;if(t.detail){const _=t.detail;if(_.error)return E(_.error,R);if(_.exception)return E(_.exception,R)}return t.stack?E(t,R):t.message?t.message:y.localize(5,null)}e.toErrorMessage=g}),define(he[135],de([9,10]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(he[136],de([0,1,135]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function m(I){switch(I){case 1:return y.localize(0,null);case 2:return y.localize(1,null);case 3:return y.localize(2,null);case 4:return y.localize(3,null);case 5:return y.localize(4,null);case 6:return y.localize(5,null);case 7:return y.localize(6,null);case 8:return y.localize(7,null);case 9:return y.localize(8,null);default:return""}}e.getParseErrorMessage=m}),define(he[137],de([9,10]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(he[80],de([0,1,2,21,48,32,137,11,19,28,5,73,8]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function v(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(a,o){if(R.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};o&&(n.cwd=o);const r=E.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],n);return new Promise(i=>{r.once("error",l=>{i({success:!1,error:l})}),r.once("exit",(l,s)=>{i(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?v(n.status):1})}else if(R.isLinux||R.isMacintosh)try{const n=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(r=>{E.execFile(n,[a.pid.toString()],{encoding:"utf8",shell:!0},(i,l,s)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function d(a=process.env){return a.comspec||"cmd.exe"}e.getWindowsShell=d;class S{constructor(o,n,r,i){if(n!==void 0&&r!==void 0&&i!==void 0)this.cmd=o,this.args=n,this.shell=r,this.options=i;else{const l=o;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(process.env).forEach(s=>{l[s]=process.env[s]}),Object.keys(this.options.env).forEach(s=>{l[s]=this.options.env[s]}),this.options.env=l}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const n=o.lastIndexOf(y.sep);return n!==-1&&(o=o.substring(n+1)),S.WellKnowCommands[o]?o:"other"}start(o){return R.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(process.cwd()))?Promise.reject(new Error(C.localize(0,null))):this.useExec().then(n=>{let r,i;const l=new Promise((s,p)=>{r=s,i=p});if(n){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=E.exec(s,this.options,(p,k,w)=>{this.childProcess=null;const T=p;T&&T.killed?i({killed:this.terminateRequested,stdout:k.toString(),stderr:w.toString()}):this.handleExec(r,o,p,k,w)})}else{let s=null;const p=k=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(k,r,o,i);const w={terminated:this.terminateRequested};L.isNumber(k)&&(w.cmdCode=k),r(w)};if(this.shell&&R.isWindows){const k=g.deepClone(this.options);k.windowsVerbatimArguments=!0,k.detached=!1;let w=!1,T=!1;const h=[];let A=this.ensureQuotes(this.cmd);h.push(A.value),w=A.quoted,this.args&&this.args.forEach(B=>{A=this.ensureQuotes(B),h.push(A.value),T=T&&A.quoted});const N=["/s","/c"];w?T?N.push('"'+h.join(" ")+'"'):h.length>1?N.push('"'+h[0]+'" '+h.slice(1).join(" ")):N.push('"'+h[0]+'"'):N.push(h.join(" ")),s=E.spawn(d(),N,k)}else this.cmd&&(s=E.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(L.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",k=>{this.childProcess=null,i({terminated:this.terminateRequested,error:k})}),s.pid&&(this.childProcess.on("close",p),this.handleSpawn(s,r,o,i,!0)))}return l})}handleClose(o,n,r,i){}ensureQuotes(o){return S.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,c(o,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!R.isWindows)return o(!1);const n=E.spawn(d(),["/s","/c"]);n.on("error",r=>o(!0)),n.on("exit",r=>o(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class b extends S{constructor(o,n,r,i){super(o,n,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,n,r,i,l){[i,l].forEach((s,p)=>{const k=new _.LineDecoder;k.write(s).forEach(h=>{n({line:h,source:p===0?0:1})});const T=k.end();T&&n({line:T,source:p===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,n,r,i,l){const s=new _.LineDecoder,p=new _.LineDecoder;o.stdout.on("data",k=>{s.write(k).forEach(T=>r({line:T,source:0}))}),o.stderr.on("data",k=>{p.write(k).forEach(T=>r({line:T,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=p}handleClose(o,n,r,i){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&r({line:l,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&r({line:s,source:1})}}e.LineProcess=b;function f(a){let o=[],n=!1;const r=function(i){if(n){o.push(i);return}(!a.send(i,s=>{if(s&&console.error(s),n=!1,o.length>0){const p=o.slice(0);o=[],p.forEach(k=>r(k))}})||R.isWindows)&&(n=!0)};return{send:r}}e.createQueuedSender=f;var u;(function(a){async function o(n,r,i){if(y.isAbsolute(n))return n;if(r===void 0&&(r=process.cwd()),y.dirname(n)!=="."||(i===void 0&&L.isString(process.env.PATH)&&(i=process.env.PATH.split(y.delimiter)),i===void 0||i.length===0))return y.join(r,n);async function s(p){return await I.promisify(m.exists)(p)?!(await I.promisify(m.stat)(p)).isDirectory():!1}for(let p of i){let k;if(y.isAbsolute(p)?k=y.join(p,n):k=y.join(r,p,n),await s(k))return k;let w=k+".com";if(await s(w)||(w=k+".exe",await s(w)))return w}return y.join(r,n)}a.findExecutable=o})(u=e.win32||(e.win32={}))}),define(he[81],de([0,1,23,5,76,80]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function C(v,c=process.env){return v===3?m.isWindows?_():E.getWindowsShell(c):t(v,c)}e.getSystemShell=C;function L(v,c=process.env){return v===3?m.isWindows?P(c):E.getWindowsShell(c):t(v,c)}e.getSystemShellSync=L;let g=null;function t(v,c){if(m.isLinux&&v===1||m.isMacintosh&&v===2)return"/bin/bash";if(!g){let d;if(m.isWindows)d="/bin/bash";else{if(d=c.SHELL,!d)try{d=y.userInfo().shell}catch(S){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}g=d}return g}let R=null;async function _(){return R||(R=(await I.getFirstAvailablePowerShellInstallation()).exePath),R}function P(v){if(R)return R;const c=m.isWindows&&parseFloat(y.release())>=10,d=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${v.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?S:E.getWindowsShell(v)}}),define(he[82],de([0,1,32,4,17,19,6,80,37,118,27,12,18,5]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends g.ChannelServer{constructor(b){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch(u){}},onMessage:C.Event.fromNodeEventEmitter(process,"message",f=>P.VSBuffer.wrap(Buffer.from(f,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=c;class d{constructor(b,f){this.modulePath=b,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new I.Delayer(u),this.child=null,this._client=null}getChannel(b){const f=this;return{call(u,a,o){return f.requestPromise(b,u,a,o)},listen(u,a){return f.requestEvent(b,u,a)}}}requestPromise(b,f,u,a=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(_.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(b),n=I.createCancelablePromise(l=>o.call(f,u,l)),r=a.onCancellationRequested(()=>n.cancel()),i=m.toDisposable(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(b,f,u){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let a;const o=new C.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(b).listen(f,u)(o.fire,o),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env=Object.assign(Object.assign({},E.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(f.env=Object.assign(Object.assign({},f.env),this.options.env)),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.isMacintosh&&f.env&&delete f.env.DYLD_LIBRARY_PATH,this.child=y.fork(this.modulePath,b,f);const u=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if(t.isRemoteConsoleLog(s)){t.log(s,`IPC Library: ${this.options.serverName}`);return}u.fire(P.VSBuffer.wrap(Buffer.from(s,"base64")))});const o=this.options.useQueue?L.createQueuedSender(this.child):this.child,n=s=>this.child&&this.child.connected&&o.send(s.buffer.toString("base64")),r=u.event,i={send:n,onMessage:r};this._client=new g.ChannelClient(i);const l=()=>this.disposeClient();process.once("exit",l),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,p)=>{process.removeListener("exit",l),this.activeRequests.forEach(k=>m.dispose(k)),this.activeRequests.clear(),s!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+p),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:p})})}return this._client}getCachedChannel(b){let f=this.channels.get(b);return f||(f=this.client.getChannel(b),this.channels.set(b,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=d}),define(he[138],de([9,10]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(he[139],de([9,10]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(he[140],de([9,10]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(he[141],de([9,10]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(he[142],de([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(he[143],de([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(he[144],de([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(he[145],de([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(he[146],de([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(he[147],de([9,10]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(he[148],de([9,10]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(he[149],de([9,10]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(he[150],de([9,10]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(he[151],de([9,10]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(he[152],de([9,10]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(he[153],de([9,10]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(he[154],de([9,10]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(he[155],de([9,10]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(he[156],de([9,10]),function(Z,e){return Z.create("vs/server/remoteAgentEnvironmentImpl",e)}),define(he[157],de([9,10]),function(Z,e){return Z.create("vs/server/serverEnvironmentService",e)}),define(he[158],de([9,10]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(he[159],de([9,10]),function(Z,e){return Z.create("vs/workbench/contrib/terminal/common/terminal",e)}),define(he[160],de([9,10]),function(Z,e){return Z.create("vs/workbench/contrib/terminal/node/terminalProcess",e)}),define(he[161],de([9,10]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(he[162],de([9,10]),function(Z,e){return Z.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(he[163],de([0,1,6,4]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class I{constructor(){this._onCloseEmitter=new y.Emitter,this._onReloadEmitter=new y.Emitter,this._onTerminateEmitter=new y.Emitter,this._onAttachEmitter=new y.Emitter}call(L,g,t){switch(g){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:t[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:t[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:t[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:t[0],port:t[1],subId:t[2]}))}throw new Error("Method not implemented.")}listen(L,g,t){switch(g){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=I,I.ChannelName="extensionhostdebugservice";class E extends m.Disposable{constructor(L){super();this.channel=L}reload(L){this.channel.call("reload",[L])}get onReload(){return this.channel.listen("reload")}close(L){this.channel.call("close",[L])}get onClose(){return this.channel.listen("close")}attachSession(L,g,t){this.channel.call("attach",[L,g,t])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(L,g){this.channel.call("terminate",[L,g])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(L,g,t){return this.channel.call("openExtensionDevelopmentHostWindow",[L,g,t])}}e.ExtensionHostDebugChannelClient=E}),define(he[164],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=void 0;function y(m){return!!m.hostName&&!!m.errorMessage}e.isRemoteDiagnosticError=y}),define(he[165],de([0,1,3]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class m{constructor(C){this.service=C}listen(C,L,g){throw new Error("Invalid listen")}call(C,L,g){switch(L){case"download":return this.service.download(y.URI.revive(g[0]),y.URI.revive(g[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=m;class I{constructor(C,L){this.channel=C,this.getUriTransformer=L}async download(C,L){const g=this.getUriTransformer();g&&(C=g.transformOutgoingURI(C),L=g.transformOutgoingURI(L)),await this.channel.call("download",[C,L])}}e.DownloadServiceChannelClient=I}),define(he[57],de([0,1,232,140,5]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const E={o:m.localize(0,null),e:m.localize(1,null),t:m.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:m.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:m.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:m.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:m.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:m.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:m.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:m.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:m.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:m.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:m.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:m.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:m.localize(14,null)},category:{type:"string",cat:"e",description:m.localize(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:m.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:m.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:m.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:m.localize(19,null)},verbose:{type:"boolean",cat:"t",description:m.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:m.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:m.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:m.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:m.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:m.localize(25,null)},sync:{type:"string",cat:"t",description:m.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:m.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:m.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:m.localize(29,null)},"max-memory":{type:"string",cat:"t",description:m.localize(30,null)},telemetry:{type:"boolean",cat:"t",description:m.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{}};function L(c,d,S=C){const b={},f=[],u=[];for(let r in d){const i=d[r];i.alias&&(b[r]=i.alias),i.type==="string"||i.type==="string[]"?(f.push(r),i.deprecates&&f.push(i.deprecates)):i.type==="boolean"&&(u.push(r),i.deprecates&&u.push(i.deprecates))}const a=y(c,{string:f,boolean:u,alias:b}),o={},n=a;o._=a._.map(r=>String(r)).filter(r=>r.length>0),delete n._;for(let r in d){const i=d[r];i.alias&&delete n[i.alias];let l=n[r];i.deprecates&&n.hasOwnProperty(i.deprecates)&&(l||(l=n[i.deprecates]),delete n[i.deprecates]),typeof l!="undefined"&&(i.type==="string[]"?l&&!Array.isArray(l)&&(l=[l]):i.type==="string"&&Array.isArray(l)&&(l=l.pop(),S.onMultipleValues(r,l)),o[r]=l),delete n[r]}for(let r in n)S.onUnknownOption(r);return o}e.parseArgs=L;function g(c,d){let S="";return d.args&&(Array.isArray(d.args)?S=` <${d.args.join("> <")}>`:S=` <${d.args}>`),d.alias?`-${d.alias} --${c}${S}`:`--${c}${S}`}function t(c,d){let S=0,b=[];for(const o in c){const n=c[o],r=g(o,n);S=Math.max(S,r.length),b.push([r,n.description])}let f=S+2+1;if(d-f<25)return b.reduce((o,n)=>o.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let u=d-f-1,a=[];for(const o of b){let n=o[0],r=_(o[1],u),i=R(f-n.length-2);a.push("  "+n+i+r[0]);for(let l=1;l<r.length;l++)a.push(R(f)+r[l])}return a}e.formatOptions=t;function R(c){return" ".repeat(c)}function _(c,d){let S=[];for(;c.length;){let b=c.length<d?c.length:c.lastIndexOf(" ",d),f=c.slice(0,b).trim();c=c.slice(b),S.push(f)}return S}function P(c,d,S,b,f=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${c} ${S}`];a.push(""),a.push(`${m.localize(32,null)}: ${d} [${m.localize(33,null)}][${m.localize(34,null)}...]`),a.push(""),f&&(I.isWindows?a.push(m.localize(35,null,d)):a.push(m.localize(36,null,d)),a.push(""));const o={};for(const n in b){const r=b[n];if(r.description&&r.cat){let i=o[r.cat];i||(o[r.cat]=i={}),i[n]=r}}for(let n in o){const r=n;let i=o[r];i&&(a.push(E[r]),a.push(...t(i,u)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=P;function v(c,d){return`${c||m.localize(37,null)}
${d||m.localize(38,null)}
${process.arch}`}e.buildVersionMessage=v}),define(he[166],de([0,1,6,3,55,19,4]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function L(c,d){return m.URI.revive(d?d.transformIncoming(c):c)}function g(c,d){return d?d.transformOutgoingURI(c):c}function t(c,d){d=d||I.DefaultURITransformer;const S=c.manifest,b=I.transformAndReviveIncomingURIs(Object.assign(Object.assign({},c),{manifest:void 0}),d);return Object.assign(Object.assign({},b),{manifest:S})}function R(c,d){return d?E.cloneAndChange(c,S=>S instanceof m.URI?d.transformOutgoingURI(S):void 0):c}class _{constructor(d,S){this.service=d,this.getUriTransformer=S,this.onInstallExtension=y.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtension=y.Event.buffer(d.onDidInstallExtension,!0),this.onUninstallExtension=y.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,S){const b=this.getUriTransformer(d);switch(S){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return y.Event.map(this.onDidInstallExtension,f=>Object.assign(Object.assign({},f),{local:f.local?R(f.local,b):f.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,S,b){const f=this.getUriTransformer(d);switch(S){case"zip":return this.service.zip(t(b[0],f)).then(u=>g(u,f));case"unzip":return this.service.unzip(L(b[0],f));case"install":return this.service.install(L(b[0],f));case"getManifest":return this.service.getManifest(L(b[0],f));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(t(b[0],f),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(t(b[0],f));case"getInstalled":return this.service.getInstalled(b[0]).then(u=>u.map(a=>R(a,f)));case"updateMetadata":return this.service.updateMetadata(t(b[0],f),b[1]).then(u=>R(u,f));case"updateExtensionScope":return this.service.updateExtensionScope(t(b[0],f),b[1]).then(u=>R(u,f));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=_;class P extends C.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new y.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new y.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new y.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new y.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(S=>this._onInstallExtension.fire(S))),this._register(this.channel.listen("onDidInstallExtension")(S=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},S),{local:S.local?t(S.local,null):S.local})))),this._register(this.channel.listen("onUninstallExtension")(S=>this._onUninstallExtension.fire(S))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this._onDidUninstallExtension.fire(S)))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(S=>m.URI.revive(S)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d){return Promise.resolve(this.channel.call("install",[d])).then(S=>t(S,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}async canInstall(d){return!0}installFromGallery(d,S){return Promise.resolve(this.channel.call("installFromGallery",[d,S])).then(b=>t(b,null))}uninstall(d,S){return Promise.resolve(this.channel.call("uninstall",[d,S]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null){return Promise.resolve(this.channel.call("getInstalled",[d])).then(S=>S.map(b=>t(b,null)))}updateMetadata(d,S){return Promise.resolve(this.channel.call("updateMetadata",[d,S])).then(b=>t(b,null))}updateExtensionScope(d,S){return Promise.resolve(this.channel.call("updateExtensionScope",[d,S])).then(b=>t(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=P;class v{constructor(d){this.service=d}listen(d,S){throw new Error("Invalid listen")}call(d,S,b){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(m.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(he[167],de([0,1,19]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const m=/^%([\w\d.-]+)%$/i;function I(E,C){const L=g=>{if(typeof g=="string"){const t=m.exec(g);if(!!t)return C[t[1]]||g}};return y.cloneAndChange(E,L)}e.localizeManifest=I}),define(he[58],de([0,1,147]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const m=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function I(_){return _=_.trim(),_==="*"||m.test(_)}e.isValidVersionStr=I;function E(_){if(!I(_))return null;if(_=_.trim(),_==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let P=_.match(m);return P?{hasCaret:P[1]==="^",hasGreaterEquals:P[1]===">=",majorBase:P[2]==="x"?0:parseInt(P[2],10),majorMustEqual:P[2]!=="x",minorBase:P[4]==="x"?0:parseInt(P[4],10),minorMustEqual:P[4]!=="x",patchBase:P[6]==="x"?0:parseInt(P[6],10),patchMustEqual:P[6]!=="x",preRelease:P[8]||null}:null}e.parseVersion=E;function C(_){if(!_)return null;let P=_.majorBase,v=_.majorMustEqual,c=_.minorBase,d=_.minorMustEqual,S=_.patchBase,b=_.patchMustEqual;return _.hasCaret&&(P===0||(d=!1),b=!1),{majorBase:P,majorMustEqual:v,minorBase:c,minorMustEqual:d,patchBase:S,patchMustEqual:b,isMinimum:_.hasGreaterEquals}}e.normalizeVersion=C;function L(_,P){let v;typeof _=="string"?v=C(E(_)):v=_;let c;if(typeof P=="string"?c=C(E(P)):c=P,!v||!c)return!1;let d=v.majorBase,S=v.minorBase,b=v.patchBase,f=c.majorBase,u=c.minorBase,a=c.patchBase,o=c.majorMustEqual,n=c.minorMustEqual,r=c.patchMustEqual;return c.isMinimum?d>f?!0:d<f?!1:S>u?!0:S<u?!1:b>=a:(d===1&&f===0&&(!o||!n||!r)&&(f=1,u=0,a=0,o=!0,n=!1,r=!1),d<f?!1:d>f?!o:S<u?!1:S>u?!n:b<a?!1:b>a?!r:!0)}e.isValidVersion=L;function g(_,P,v){return P.isBuiltin||typeof P.main=="undefined"?!0:R(_,P.engines.vscode,v)}e.isValidExtensionVersion=g;function t(_,P){return _==="*"||R(P,_)}e.isEngineValid=t;function R(_,P,v=[]){let c=C(E(P));if(!c)return v.push(y.localize(0,null,P)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return v.push(y.localize(1,null,P)),!1}else if(!c.majorMustEqual)return v.push(y.localize(2,null,P)),!1;return L(_,c)?!0:(v.push(y.localize(3,null,_,P)),!1)}e.isVersionValid=R}),define(he[168],de([0,1,37,82,4,8]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class C extends I.Disposable{constructor(g,t,R,_){super();this.folders=g,this.onDidFilesChange=t,this.onLogMessage=R,this.verboseLogging=_,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new m.Client(E.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=C.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.createChannelSender(y.getNextTickChannel(g.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(t=>!this.isDisposed&&this.onDidFilesChange(t))),this._register(this.service.onDidLogMessage(t=>this.onLogMessage(t))),this.setFolders(this.folders)}setVerboseLogging(g){this.verboseLogging=g,!this.isDisposed&&this.service&&this.service.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${g}`})}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=C,C.MAX_RESTARTS=5}),define(he[169],de([0,1,37,82,4,8]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class C extends I.Disposable{constructor(g,t,R,_,P={}){super();this.folders=g,this.onDidFilesChange=t,this.onLogMessage=R,this.verboseLogging=_,this.watcherOptions=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new m.Client(E.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=C.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.createChannelSender(y.getNextTickChannel(g.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(t=>!this.isDisposed&&this.onDidFilesChange(t))),this._register(this.service.onDidLogMessage(t=>this.onLogMessage(t))),this.service.setRoots(this.folders)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${g}`})}setVerboseLogging(g){this.verboseLogging=g,this.service&&this.service.setVerboseLogging(g)}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=C,C.MAX_RESTARTS=5}),define(he[170],de([0,1,32,73,45,8]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class C{constructor(g,t,R,_,P){this.watchedFolder=g,this.eventCallback=R,this.logCallback=_,this.verboseLogging=P,this.restartCounter=0,Array.isArray(t)?this.ignored=t.map(v=>I.parse(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${g}`),this.startWatcher()}startWatcher(){const g=[this.watchedFolder];this.verboseLogging&&g.push("-verbose"),this.handle=y.spawn(E.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",Z).fsPath,g);const t=new m.LineDecoder;this.handle.stdout.on("data",R=>{const _=[];t.write(R).forEach(P=>{const v=P.split("|");if(v.length===2){const c=Number(v[0]),d=v[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(S=>S(d))){this.verboseLogging&&this.log(d);return}_.push({type:C.changeTypeMap[c],path:d})}else this.log(v[1])}}),_.length>0&&this.eventCallback(_)}),this.handle.on("error",R=>this.onError(R)),this.handle.stderr.on("data",R=>this.onError(R)),this.handle.on("exit",(R,_)=>this.onExit(R,_))}onError(g){this.error("process error: "+g.toString())}onExit(g,t){this.handle&&(this.error(`terminated unexpectedly (code: ${g}, signal: ${t})`),this.restartCounter<=C.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(g){this.logCallback({type:"error",message:`[File Watcher (C#)] ${g}`})}log(g){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${g}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=C,C.MAX_RESTARTS=5,C.changeTypeMap=[0,1,2]}),define(he[171],de([0,1,170,2,13]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E{constructor(L,g,t,R){this.onDidFilesChange=g,this.onLogMessage=t,this.verboseLogging=R,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(m.posix.sep)&&(this.folder.path=I.rtrim(this.folder.path,m.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new y.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=E}),define(he[59],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class y{constructor(E,C=[],L=!1){this.ctor=E,this.staticArguments=C,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=y;const m=(I,...E)=>new y(I,E);e.createSyncDescriptor=m}),define(he[172],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(E){this.incoming=new Map,this.outgoing=new Map,this.data=E}}e.Node=y;class m{constructor(E){this._hashFn=E,this._nodes=new Map}roots(){const E=[];for(let C of this._nodes.values())C.outgoing.size===0&&E.push(C);return E}insertEdge(E,C){const L=this.lookupOrInsertNode(E),g=this.lookupOrInsertNode(C);L.outgoing.set(this._hashFn(C),g),g.incoming.set(this._hashFn(E),L)}removeNode(E){const C=this._hashFn(E);this._nodes.delete(C);for(let L of this._nodes.values())L.outgoing.delete(C),L.incoming.delete(C)}lookupOrInsertNode(E){const C=this._hashFn(E);let L=this._nodes.get(C);return L||(L=new y(E),this._nodes.set(C,L)),L}lookup(E){return this._nodes.get(this._hashFn(E))}isEmpty(){return this._nodes.size===0}toString(){let E=[];for(let[C,L]of this._nodes)E.push(`${C}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return E.join(`
`)}}e.Graph=m}),define(he[7],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function L(g){return g[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=L})(y=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function m(C,L,g,t){L[y.DI_TARGET]===L?L[y.DI_DEPENDENCIES].push({id:C,index:g,optional:t}):(L[y.DI_DEPENDENCIES]=[{id:C,index:g,optional:t}],L[y.DI_TARGET]=L)}function I(C){if(y.serviceIds.has(C))return y.serviceIds.get(C);const L=function(g,t,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");m(L,g,R,!1)};return L.toString=()=>C,y.serviceIds.set(C,L),L}e.createDecorator=I;function E(C){return function(L,g,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");m(C,L,t,!0)}}e.optional=E}),define(he[173],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=y.createDecorator("modelService");function m(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=m}),define(he[174],de([0,1,6,116,4,25,112,128,173]),function(Z,e,y,m,I,E,C,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function t(P){return typeof P=="string"?!1:Array.isArray(P)?P.every(t):!!P.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new y.Emitter}get onDidChange(){return this._onDidChange.event}register(v,c){let d={selector:v,provider:c,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),I.toDisposable(()=>{if(d){let S=this._entries.indexOf(d);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const c=[];for(let d of this._entries)d._score>0&&c.push(d.provider);return c}ordered(v){const c=[];return this._orderedForEach(v,d=>c.push(d.provider)),c}orderedGroups(v){const c=[];let d,S;return this._orderedForEach(v,b=>{d&&S===b._score?d.push(b.provider):(S=b._score,d=[b.provider],c.push(d))}),c}_orderedForEach(v,c){if(!!v){this._updateScores(v);for(const d of this._entries)d._score>0&&c(d)}}_updateScores(v){let c={uri:v.uri.toString(),language:v.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let d of this._entries)if(d._score=L.score(d.selector,v.uri,v.getLanguageIdentifier().language,g.shouldSynchronizeModel(v)),t(d.selector)&&d._score>0){for(let S of this._entries)S._score=0;d._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(v,c){return v._score<c._score?1:v._score>c._score?-1:v._time<c._time?1:v._time>c._time?-1:0}}e.LanguageFeatureRegistry=R;class _{constructor(v,c,d=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=c,this.max=d,this._cache=new E.LRUCache(50,.7)}_key(v){return v.id+m.hash(this._registry.all(v))}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const c=this._key(v),d=this._cache.get(c);return this._clamp(d==null?void 0:d.value)}update(v,c){const d=this._key(v);let S=this._cache.get(d);return S||(S=new C.MovingAverage,this._cache.set(d,S)),S.update(c),this.get(v)}}e.LanguageFeatureRequestDelays=_}),define(he[175],de([0,1,3,56,174,129,115]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var L;(function(w){w[w.Null=0]="Null",w[w.PlainText=1]="PlainText"})(L=e.LanguageId||(e.LanguageId={}));class g{constructor(T,h){this.language=T,this.id=h}}e.LanguageIdentifier=g;var t;(function(w){w[w.NotSet=-1]="NotSet",w[w.None=0]="None",w[w.Italic=1]="Italic",w[w.Bold=2]="Bold",w[w.Underline=4]="Underline"})(t=e.FontStyle||(e.FontStyle={}));var R;(function(w){w[w.None=0]="None",w[w.DefaultForeground=1]="DefaultForeground",w[w.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var _;(function(w){w[w.Other=0]="Other",w[w.Comment=1]="Comment",w[w.String=2]="String",w[w.RegEx=4]="RegEx"})(_=e.StandardTokenType||(e.StandardTokenType={}));var P;(function(w){w[w.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",w[w.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",w[w.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",w[w.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",w[w.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",w[w.ITALIC_MASK=2048]="ITALIC_MASK",w[w.BOLD_MASK=4096]="BOLD_MASK",w[w.UNDERLINE_MASK=8192]="UNDERLINE_MASK",w[w.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",w[w.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",w[w.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",w[w.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",w[w.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",w[w.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",w[w.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",w[w.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",w[w.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",w[w.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(P=e.MetadataConsts||(e.MetadataConsts={}));class v{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&1792)>>>8}static getFontStyle(T){return(T&14336)>>>11}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){let h=this.getForeground(T),A="mtk"+h,N=this.getFontStyle(T);return N&1&&(A+=" mtki"),N&2&&(A+=" mtkb"),N&4&&(A+=" mtku"),A}static getInlineStyleFromMetadata(T,h){const A=this.getForeground(T),N=this.getFontStyle(T);let B=`color: ${h[A]};`;return N&1&&(B+="font-style: italic;"),N&2&&(B+="font-weight: bold;"),N&4&&(B+="text-decoration: underline;"),B}}e.TokenMetadata=v;var c;(function(w){w[w.Method=0]="Method",w[w.Function=1]="Function",w[w.Constructor=2]="Constructor",w[w.Field=3]="Field",w[w.Variable=4]="Variable",w[w.Class=5]="Class",w[w.Struct=6]="Struct",w[w.Interface=7]="Interface",w[w.Module=8]="Module",w[w.Property=9]="Property",w[w.Event=10]="Event",w[w.Operator=11]="Operator",w[w.Unit=12]="Unit",w[w.Value=13]="Value",w[w.Constant=14]="Constant",w[w.Enum=15]="Enum",w[w.EnumMember=16]="EnumMember",w[w.Keyword=17]="Keyword",w[w.Text=18]="Text",w[w.Color=19]="Color",w[w.File=20]="File",w[w.Reference=21]="Reference",w[w.Customcolor=22]="Customcolor",w[w.Folder=23]="Folder",w[w.TypeParameter=24]="TypeParameter",w[w.User=25]="User",w[w.Issue=26]="Issue",w[w.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let w=Object.create(null);return w[0]="symbol-method",w[1]="symbol-function",w[2]="symbol-constructor",w[3]="symbol-field",w[4]="symbol-variable",w[5]="symbol-class",w[6]="symbol-struct",w[7]="symbol-interface",w[8]="symbol-module",w[9]="symbol-property",w[10]="symbol-event",w[11]="symbol-operator",w[12]="symbol-unit",w[13]="symbol-value",w[14]="symbol-constant",w[15]="symbol-enum",w[16]="symbol-enum-member",w[17]="symbol-keyword",w[27]="symbol-snippet",w[18]="symbol-text",w[19]="symbol-color",w[20]="symbol-file",w[21]="symbol-reference",w[22]="symbol-customcolor",w[23]="symbol-folder",w[24]="symbol-type-parameter",w[25]="account",w[26]="issues",function(T){const h=w[T];let A=h&&C.iconRegistry.get(h);return A||(console.info("No codicon found for CompletionItemKind "+T),A=C.Codicon.symbolProperty),A.classNames}}(),e.completionKindFromString=function(){let w=Object.create(null);return w.method=0,w.function=1,w.constructor=2,w.field=3,w.variable=4,w.class=5,w.struct=6,w.interface=7,w.module=8,w.property=9,w.event=10,w.operator=11,w.unit=12,w.value=13,w.constant=14,w.enum=15,w["enum-member"]=16,w.enumMember=16,w.keyword=17,w.snippet=27,w.text=18,w.color=19,w.file=20,w.reference=21,w.customcolor=22,w.folder=23,w["type-parameter"]=24,w.typeParameter=24,w.account=25,w.issue=26,function(T,h){let A=w[T];return typeof A=="undefined"&&!h&&(A=9),A}}();var d;(function(w){w[w.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(w){w[w.KeepWhitespace=1]="KeepWhitespace",w[w.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(w){w[w.Invoke=0]="Invoke",w[w.TriggerCharacter=1]="TriggerCharacter",w[w.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var f;(function(w){w[w.Auto=1]="Auto",w[w.Manual=2]="Manual"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(w){w[w.Invoke=1]="Invoke",w[w.TriggerCharacter=2]="TriggerCharacter",w[w.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(w){w[w.Text=0]="Text",w[w.Read=1]="Read",w[w.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(w){return w&&y.URI.isUri(w.uri)&&m.Range.isIRange(w.range)&&(m.Range.isIRange(w.originSelectionRange)||m.Range.isIRange(w.targetSelectionRange))}e.isLocationLink=o;var n;(function(w){w[w.File=0]="File",w[w.Module=1]="Module",w[w.Namespace=2]="Namespace",w[w.Package=3]="Package",w[w.Class=4]="Class",w[w.Method=5]="Method",w[w.Property=6]="Property",w[w.Field=7]="Field",w[w.Constructor=8]="Constructor",w[w.Enum=9]="Enum",w[w.Interface=10]="Interface",w[w.Function=11]="Function",w[w.Variable=12]="Variable",w[w.Constant=13]="Constant",w[w.String=14]="String",w[w.Number=15]="Number",w[w.Boolean=16]="Boolean",w[w.Array=17]="Array",w[w.Object=18]="Object",w[w.Key=19]="Key",w[w.Null=20]="Null",w[w.EnumMember=21]="EnumMember",w[w.Struct=22]="Struct",w[w.Event=23]="Event",w[w.Operator=24]="Operator",w[w.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var r;(function(w){w[w.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(w){const T=new Map;T.set("file",0),T.set("module",1),T.set("namespace",2),T.set("package",3),T.set("class",4),T.set("method",5),T.set("property",6),T.set("field",7),T.set("constructor",8),T.set("enum",9),T.set("interface",10),T.set("function",11),T.set("variable",12),T.set("constant",13),T.set("string",14),T.set("number",15),T.set("boolean",16),T.set("array",17),T.set("object",18),T.set("key",19),T.set("null",20),T.set("enum-member",21),T.set("struct",22),T.set("event",23),T.set("operator",24),T.set("type-parameter",25);const h=new Map;h.set(0,"file"),h.set(1,"module"),h.set(2,"namespace"),h.set(3,"package"),h.set(4,"class"),h.set(5,"method"),h.set(6,"property"),h.set(7,"field"),h.set(8,"constructor"),h.set(9,"enum"),h.set(10,"interface"),h.set(11,"function"),h.set(12,"variable"),h.set(13,"constant"),h.set(14,"string"),h.set(15,"number"),h.set(16,"boolean"),h.set(17,"array"),h.set(18,"object"),h.set(19,"key"),h.set(20,"null"),h.set(21,"enum-member"),h.set(22,"struct"),h.set(23,"event"),h.set(24,"operator"),h.set(25,"type-parameter");function A(W){return T.get(W)}w.fromString=A;function N(W){return h.get(W)}w.toString=N;function B(W,H){const K=h.get(W);let re=K&&C.iconRegistry.get("symbol-"+K);return re||(console.info("No codicon found for SymbolKind "+W),re=C.Codicon.symbolProperty),`${H?"inline":"block"} ${re.classNames}`}w.toCssClassName=B})(i=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(T){this.value=T}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var s;(function(w){w[w.Collapsed=0]="Collapsed",w[w.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(w){w[w.Editing=0]="Editing",w[w.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new E.TokenizationRegistryImpl;var k;(function(w){w[w.None=0]="None",w[w.Option=1]="Option",w[w.Default=2]="Default",w[w.Preferred=3]="Preferred"})(k=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(he[49],de([0,1,13,7,5]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let E=I.userAgent||"";const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",I.isMacintosh),C.set("isLinux",I.isLinux),C.set("isWindows",I.isWindows),C.set("isWeb",I.isWeb),C.set("isMacNative",I.isMacintosh&&!I.isWeb),C.set("isEdge",E.indexOf("Edg/")>=0),C.set("isFirefox",E.indexOf("Firefox")>=0),C.set("isChrome",E.indexOf("Chrome")>=0),C.set("isSafari",E.indexOf("Safari")>=0),C.set("isIPad",E.indexOf("iPad")>=0);const L=Object.prototype.hasOwnProperty;var g;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(g=e.ContextKeyExprType||(e.ContextKeyExprType={}));class t{static false(){return _.INSTANCE}static true(){return P.INSTANCE}static has(h){return v.create(h)}static equals(h,A){return c.create(h,A)}static notEquals(h,A){return b.create(h,A)}static regex(h,A){return r.create(h,A)}static in(h,A){return d.create(h,A)}static not(h){return f.create(h)}static and(...h){return l.create(h)}static or(...h){return s.create(h)}static greater(h,A){return u.create(h,A)}static less(h,A){return o.create(h,A)}static deserialize(h,A=!1){if(!!h)return this._deserializeOrExpression(h,A)}static _deserializeOrExpression(h,A){let N=h.split("||");return s.create(N.map(B=>this._deserializeAndExpression(B,A)))}static _deserializeAndExpression(h,A){let N=h.split("&&");return l.create(N.map(B=>this._deserializeOne(B,A)))}static _deserializeOne(h,A){if(h=h.trim(),h.indexOf("!=")>=0){let N=h.split("!=");return b.create(N[0].trim(),this._deserializeValue(N[1],A))}if(h.indexOf("==")>=0){let N=h.split("==");return c.create(N[0].trim(),this._deserializeValue(N[1],A))}if(h.indexOf("=~")>=0){let N=h.split("=~");return r.create(N[0].trim(),this._deserializeRegexValue(N[1],A))}if(h.indexOf(" in ")>=0){let N=h.split(" in ");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(h)){const N=h.split(">=");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(h)){const N=h.split(">");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(h)){const N=h.split("<=");return n.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(h)){const N=h.split("<");return o.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(h)?f.create(h.substr(1).trim()):v.create(h)}static _deserializeValue(h,A){if(h=h.trim(),h==="true")return!0;if(h==="false")return!1;let N=/^'([^']*)'$/.exec(h);return N?N[1].trim():h}static _deserializeRegexValue(h,A){if(y.isFalsyOrWhitespace(h)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=h.indexOf("/"),B=h.lastIndexOf("/");if(N===B||N<0){if(A)throw new Error(`bad regexp-value '${h}', missing /-enclosure`);return console.warn(`bad regexp-value '${h}', missing /-enclosure`),null}let W=h.slice(N+1,B),H=h[B+1]==="i"?"i":"";try{return new RegExp(W,H)}catch(K){if(A)throw new Error(`bad regexp-value '${h}', parse error: ${K}`);return console.warn(`bad regexp-value '${h}', parse error: ${K}`),null}}}e.ContextKeyExpr=t;function R(T,h){return T.cmp(h)}class _{constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return P.INSTANCE}}e.ContextKeyFalseExpr=_,_.INSTANCE=new _;class P{constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return _.INSTANCE}}e.ContextKeyTrueExpr=P,P.INSTANCE=new P;class v{constructor(h){this.key=h,this.type=2}static create(h){const A=C.get(h);return typeof A=="boolean"?A?P.INSTANCE:_.INSTANCE:new v(h)}cmp(h){return h.type!==this.type?this.type-h.type:k(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return f.create(this.key)}}e.ContextKeyDefinedExpr=v;class c{constructor(h,A){this.key=h,this.value=A,this.type=4}static create(h,A){if(typeof A=="boolean")return A?v.create(h):f.create(h);const N=C.get(h);return typeof N=="boolean"?A===(N?"true":"false")?P.INSTANCE:_.INSTANCE:new c(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class d{constructor(h,A){this.key=h,this.valueKey=A,this.type=10}static create(h,A){return new d(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}evaluate(h){const A=h.getValue(this.valueKey),N=h.getValue(this.key);return Array.isArray(A)?A.indexOf(N)>=0:typeof N=="string"&&typeof A=="object"&&A!==null?L.call(A,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=d;class S{constructor(h){this._actual=h,this.type=11}static create(h){return new S(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new S(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class b{constructor(h,A){this.key=h,this.value=A,this.type=5}static create(h,A){if(typeof A=="boolean")return A?f.create(h):v.create(h);const N=C.get(h);return typeof N=="boolean"?A===(N?"true":"false")?_.INSTANCE:P.INSTANCE:new b(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class f{constructor(h){this.key=h,this.type=3}static create(h){const A=C.get(h);return typeof A=="boolean"?A?_.INSTANCE:P.INSTANCE:new f(h)}cmp(h){return h.type!==this.type?this.type-h.type:k(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return v.create(this.key)}}e.ContextKeyNotExpr=f;class u{constructor(h,A){this.key=h,this.value=A,this.type=12}static create(h,A){return new u(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return n.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class a{constructor(h,A){this.key=h,this.value=A,this.type=13}static create(h,A){return new a(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=a;class o{constructor(h,A){this.key=h,this.value=A,this.type=14}static create(h,A){return new o(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerExpr=o;class n{constructor(h,A){this.key=h,this.value=A,this.type=15}static create(h,A){return new n(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=n;class r{constructor(h,A){this.key=h,this.regexp=A,this.type=7}static create(h,A){return new r(h,A)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const A=this.regexp?this.regexp.source:"",N=h.regexp?h.regexp.source:"";return A<N?-1:A>N?1:0}equals(h){if(h.type===this.type){const A=this.regexp?this.regexp.source:"",N=h.regexp?h.regexp.source:"";return this.key===h.key&&A===N}return!1}evaluate(h){let A=h.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(h){this._actual=h,this.type=8}static create(h){return new i(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new i(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class l{constructor(h){this.expr=h,this.type=6}static create(h){return l._normalizeArr(h)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let A=0,N=this.expr.length;A<N;A++){const B=R(this.expr[A],h.expr[A]);if(B!==0)return B}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let A=0,N=this.expr.length;A<N;A++)if(!this.expr[A].equals(h.expr[A]))return!1;return!0}return!1}evaluate(h){for(let A=0,N=this.expr.length;A<N;A++)if(!this.expr[A].evaluate(h))return!1;return!0}static _normalizeArr(h){const A=[];let N=!1;for(const B of h)if(!!B){if(B.type===1){N=!0;continue}if(B.type===0)return _.INSTANCE;if(B.type===6){A.push(...B.expr);continue}A.push(B)}if(A.length===0&&N)return P.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(R);A.length>1;){const B=A[A.length-1];if(B.type!==9)break;A.pop();const W=A.pop(),H=s.create(B.expr.map(K=>l.create([K,W])));H&&(A.push(H),A.sort(R))}return A.length===1?A[0]:new l(A)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(let A of this.expr)h.push(...A.keys());return h}map(h){return new l(this.expr.map(A=>A.map(h)))}negate(){let h=[];for(let A of this.expr)h.push(A.negate());return s.create(h)}}e.ContextKeyAndExpr=l;class s{constructor(h){this.expr=h,this.type=9}static create(h){const A=s._normalizeArr(h);if(A.length!==0)return A.length===1?A[0]:new s(A)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let A=0,N=this.expr.length;A<N;A++){const B=R(this.expr[A],h.expr[A]);if(B!==0)return B}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let A=0,N=this.expr.length;A<N;A++)if(!this.expr[A].equals(h.expr[A]))return!1;return!0}return!1}evaluate(h){for(let A=0,N=this.expr.length;A<N;A++)if(this.expr[A].evaluate(h))return!0;return!1}static _normalizeArr(h){let A=[],N=!1;if(h){for(let B=0,W=h.length;B<W;B++){const H=h[B];if(!!H){if(H.type===0){N=!0;continue}if(H.type===1)return[P.INSTANCE];if(H.type===9){A=A.concat(H.expr);continue}A.push(H)}}if(A.length===0&&N)return[_.INSTANCE];A.sort(R)}return A}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(let A of this.expr)h.push(...A.keys());return h}map(h){return new s(this.expr.map(A=>A.map(h)))}negate(){let h=[];for(let N of this.expr)h.push(N.negate());const A=N=>N.type===9?N.expr:[N];for(;h.length>1;){const N=h.shift(),B=h.shift(),W=[];for(const H of A(N))for(const K of A(B))W.push(t.and(H,K));h.unshift(t.or(...W))}return h[0]}}e.ContextKeyOrExpr=s;class p extends v{constructor(h,A){super(h);this._defaultValue=A}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return t.not(this.key)}isEqualTo(h){return t.equals(this.key,h)}notEqualsTo(h){return t.notEquals(this.key,h)}}e.RawContextKey=p,e.IContextKeyService=m.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function k(T,h){return T<h?-1:T>h?1:0}function w(T,h,A,N){return T<A?-1:T>A?1:h<N?-1:h>N?1:0}}),define(he[83],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=y.createDecorator("downloadService")}),define(he[29],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=y.createDecorator("environmentService"),e.INativeEnvironmentService=y.createDecorator("nativeEnvironmentService")}),define(he[30],de([0,1,142,7,8]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function E(_){return _&&typeof _=="object"&&typeof _.id=="string"&&(!_.uuid||typeof _.uuid=="string")}e.isIExtensionIdentifier=E;var C;(function(_){_[_.NoneOrRelevance=0]="NoneOrRelevance",_[_.LastUpdatedDate=1]="LastUpdatedDate",_[_.Title=2]="Title",_[_.PublisherName=3]="PublisherName",_[_.InstallCount=4]="InstallCount",_[_.PublishedDate=5]="PublishedDate",_[_.AverageRating=6]="AverageRating",_[_.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var L;(function(_){_[_.Default=0]="Default",_[_.Ascending=1]="Ascending",_[_.Descending=2]="Descending"})(L=e.SortOrder||(e.SortOrder={}));var g;(function(_){_.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var t;(function(_){_[_.None=0]="None",_[_.Install=1]="Install",_[_.Update=2]="Update"})(t=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=m.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(P,v){super(P);this.code=v}}e.ExtensionManagementError=R,e.IExtensionManagementService=m.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=m.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=m.createDecorator("IExtensionTipsService"),e.DefaultIconPath=I.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=y.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=y.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=m.createDecorator("IExtensionManagementCLIService")}),define(he[40],de([0,1,13,7]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function I(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"];var E;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class C{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,_){if(typeof R=="undefined"||R===null)return typeof _=="undefined"||_===null;if(typeof _=="undefined"||_===null)return!1;if(typeof R=="string"||typeof _=="string"){let P=typeof R=="string"?R:R.value,v=typeof _=="string"?_:_.value;return y.equalsIgnoreCase(P,v)}return R._lower===_._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}e.ExtensionIdentifier=C;function L(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function g(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=g,e.IBuiltinExtensionsScannerService=m.createDecorator("IBuiltinExtensionsScannerService")}),define(he[33],de([0,1,13,40]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(v,c){return v.uuid&&c.uuid?v.uuid===c.uuid:v.id===c.id?!0:y.compareIgnoreCase(v.id,c.id)===0}e.areSameExtensions=I;class E{constructor(c,d){this.version=d,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof E?I(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=E;function C(v,c){return`${v}.${c}`}e.getExtensionId=C;function L(v){return v.toLocaleLowerCase()}e.adoptToGalleryExtensionId=L;function g(v,c){return L(C(v,c))}e.getGalleryExtensionId=g;function t(v,c){const d=[],S=b=>{for(const f of d)if(f.some(u=>I(c(u),c(b))))return f;return null};for(const b of v){const f=S(b);f?f.push(b):d.push([b])}return d}e.groupByExtension=t;function R(v){return{id:v.identifier.id,name:v.manifest.name,galleryId:null,publisherId:v.publisherId,publisherName:v.manifest.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:v.manifest.extensionDependencies&&v.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function _(v){return Object.assign({id:v.identifier.id,name:v.name,galleryId:v.identifier.uuid,publisherId:v.publisherId,publisherName:v.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:!!(v.properties.dependencies&&v.properties.dependencies.length>0)},v.telemetryData)}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new m.ExtensionIdentifier("pprice.better-merge");function P(v){const c=new Set;for(const d of v)d.malicious&&c.add(d.id.id);return c}e.getMaliciousExtensionsSet=P}),define(he[176],de([0,1,4,2,40,15]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class C extends y.Disposable{constructor(g,t){super();this.environmentService=g,this.extensionsManifestCache=m.join(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(t.onDidInstallExtension(R=>this.onDidInstallExtension(R))),this._register(t.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtension(g){g.error||this.invalidate()}onDidUnInstallExtension(g){g.error||this.invalidate()}invalidate(){E.rimraf(this.extensionsManifestCache,E.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=C}),define(he[24],de([0,1,149,2,3,7,13,11,25]),function(Z,e,y,m,I,E,C,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=E.createDecorator("fileService");var t;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var R;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash"})(R=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=_;function P(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=P;function v(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function c(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=c;var d;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(B,W){super(B);this.code=W}}e.FileSystemProviderError=S;function b(N,B){const W=new S(N.toString(),B);return u(W,B),W}e.createFileSystemProviderError=b;function f(N){return N||b(y.localize(0,null),d.Unknown)}e.ensureFileSystemProviderError=f;function u(N,B){return N.name=B?`${B} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=u;function a(N){if(!N)return d.Unknown;if(N instanceof S)return N.code;const B=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!B)return d.Unknown;switch(B[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=a;function o(N){if(N instanceof p)return N.fileOperationResult;switch(a(N)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var n;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(B,W,H){this.resource=B,this.operation=W,this.target=H}isOperation(B){return this.operation===B}}e.FileOperationEvent=r;var i;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class l{constructor(B,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const H of B)switch(H.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(H.resource,H);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(H.resource,H);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(H.resource,H);break}}contains(B,...W){return this.doContains(B,{includeChildren:!1},...W)}affects(B,...W){return this.doContains(B,{includeChildren:!0},...W)}doContains(B,W,...H){var K,re,V,J,ce,$;if(!B)return!1;const O=H.length>0;return!!((!O||H.includes(1))&&(((K=this.added)===null||K===void 0?void 0:K.get(B))||W.includeChildren&&((re=this.added)===null||re===void 0?void 0:re.findSuperstr(B)))||(!O||H.includes(0))&&(((V=this.updated)===null||V===void 0?void 0:V.get(B))||W.includeChildren&&((J=this.updated)===null||J===void 0?void 0:J.findSuperstr(B)))||(!O||H.includes(2))&&(((ce=this.deleted)===null||ce===void 0?void 0:ce.findSubstr(B))||W.includeChildren&&(($=this.deleted)===null||$===void 0?void 0:$.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const W=[],H=B===1?this.added:B===0?this.updated:this.deleted;if(H)for(const[,K]of H)W.push(K);return W}filter(B){return new l(this.changes.filter(W=>B(W)),this.ignorePathCasing)}}e.FileChangesEvent=l;function s(N,B,W){return!N||!B||N===B||B.length>N.length?!1:(B.charAt(B.length-1)!==m.sep&&(B+=m.sep),W?C.startsWithIgnoreCase(N,B):N.indexOf(B)===0)}e.isParent=s;class p extends Error{constructor(B,W,H){super(B);this.fileOperationResult=W,this.options=H}static isFileOperationError(B){return B instanceof Error&&!L.isUndefinedOrNull(B.fileOperationResult)}}e.FileOperationError=p;var k;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_READ_ONLY=5]="FILE_READ_ONLY",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(k=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var w;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(w=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=T;async function h(N,B){if(!B.canHandleResource(I.URI.from({scheme:N.scheme})))return new Promise(W=>{const H=B.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===N.scheme&&K.added&&(H.dispose(),W())})})}e.whenProviderRegistered=h,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class A{static formatSize(B){return L.isNumber(B)||(B=0),B<A.KB?y.localize(1,null,B.toFixed(0)):B<A.MB?y.localize(2,null,(B/A.KB).toFixed(2)):B<A.GB?y.localize(3,null,(B/A.MB).toFixed(2)):B<A.TB?y.localize(4,null,(B/A.GB).toFixed(2)):y.localize(5,null,(B/A.TB).toFixed(2))}}e.ByteSize=A,A.KB=1024,A.MB=A.KB*A.KB,A.GB=A.MB*A.KB,A.TB=A.GB*A.KB}),define(he[177],de([0,1,233,141,24,57]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function C(P,v){const c={onUnknownOption:S=>{console.warn(m.localize(0,null,S))},onMultipleValues:(S,b)=>{console.warn(m.localize(1,null,S,b))}},d=E.parseArgs(P,E.OPTIONS,v?c:void 0);return d.goto&&d._.forEach(S=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),m.localize(2,null))),d["max-memory"]&&y(parseInt(d["max-memory"])>=I.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${I.MIN_MAX_MEMORY_SIZE_MB} MB.`),d}function L(P){const v=P.findIndex(c=>!/^-/.test(c));if(v>-1)return[...P.slice(0,v),...P.slice(v+1)]}function g(P){let[,...v]=P;process.env.VSCODE_DEV&&(v=L(v)||[]);const c=!_(process.env);return C(v,c)}e.parseMainProcessArgv=g;function t(P){const[,,...v]=P;return C(v,!0)}e.parseCLIProcessArgv=t;function R(P,...v){const c=P.indexOf("--");return c===-1?P.push(...v):P.splice(c,0,...v),P}e.addArg=R;function _(P){return P.VSCODE_CLI==="1"}e.isLaunchedFromCli=_}),define(he[178],de([0,1,32,20,5,177,39,81]),function(Z,e,y,m,I,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function g(_,P,v){return P["force-disable-user-env"]?(_.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(_.trace("resolveShellEnv(): skipped (Windows)"),{}):E.isLaunchedFromCli(v)&&!P["force-user-env"]?(_.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(E.isLaunchedFromCli(v)?_.trace("resolveShellEnv(): running (--force-user-env)"):_.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=R(_)),t)}e.resolveShellEnv=g;let t;async function R(_){const P=new Promise(async(v,c)=>{const d=process.env.ELECTRON_RUN_AS_NODE;_.trace("getUnixShellEnvironment#runAsNode",d);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;_.trace("getUnixShellEnvironment#noAttach",S);const b=m.generateUuid().replace(/-/g,"").substr(0,12),f=new RegExp(b+"(.*)"+b),u=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),a=`'${process.execPath}' -p '"${b}" + JSON.stringify(process.env) + "${b}"'`;_.trace("getUnixShellEnvironment#env",u),_.trace("getUnixShellEnvironment#spawn",a);const o=await L.getSystemShell(I.platform),n=y.spawn(o,["-ilc",a],{detached:!0,stdio:["ignore","pipe",process.stderr],env:u}),r=[];n.on("error",()=>v({})),n.stdout.on("data",i=>r.push(i)),n.on("close",i=>{if(i!==0)return c(new Error("Failed to get environment"));const l=Buffer.concat(r).toString("utf8");_.trace("getUnixShellEnvironment#raw",l);const s=f.exec(l),p=s?s[1]:"{}";try{const k=JSON.parse(p);d?k.ELECTRON_RUN_AS_NODE=d:delete k.ELECTRON_RUN_AS_NODE,S?k.ELECTRON_NO_ATTACH_CONSOLE=S:delete k.ELECTRON_NO_ATTACH_CONSOLE,delete k.XDG_RUNTIME_DIR,_.trace("getUnixShellEnvironment#result",k),v(k)}catch(k){_.error("getUnixShellEnvironment#error",k),c(k)}})});try{return await P}catch(v){return _.error("getUnixShellEnvironment#error",C.toErrorMessage(v)),{}}}}),define(he[84],de([0,1,150,18,24,12]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(R,_,P,v,c,d){let S;try{await L(R,_,P,v,c,d)}catch(b){S=b}finally{S&&c.errorTransformer&&(S=c.errorTransformer(S)),P.end(S)}}e.readFileIntoStream=C;async function L(R,_,P,v,c,d){g(d);const S=await R.open(_,{create:!1});try{g(d);let b=0,f=0,u=c&&typeof c.length=="number"?c.length:void 0,a=m.VSBuffer.alloc(Math.min(c.bufferSize,typeof u=="number"?u:c.bufferSize)),o=c&&typeof c.position=="number"?c.position:0,n=0;do f=await R.read(S,o,a.buffer,n,a.byteLength-n),o+=f,n+=f,b+=f,typeof u=="number"&&(u-=f),n===a.byteLength&&(await P.write(v(a)),a=m.VSBuffer.alloc(Math.min(c.bufferSize,typeof u=="number"?u:c.bufferSize)),n=0);while(f>0&&(typeof u!="number"||u>0)&&g(d)&&t(b,c));if(n>0){let r=n;typeof u=="number"&&(r=Math.min(n,u)),P.write(v(a.slice(0,r)))}}catch(b){throw I.ensureFileSystemProviderError(b)}finally{await R.close(S)}}function g(R){if(R.isCancellationRequested)throw E.canceled();return!0}function t(R,_){if(_==null?void 0:_.limits){if(typeof _.limits.memory=="number"&&R>_.limits.memory)throw I.createFileSystemProviderError(y.localize(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof _.limits.size=="number"&&R>_.limits.size)throw I.createFileSystemProviderError(y.localize(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(he[85],de([0,1,3,24,5]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function E(g){return g.map(t=>({type:t.type,resource:y.URI.file(t.path)}))}e.toFileChanges=E;function C(g){const t=new L;for(const R of g)t.processEvent(R);return t.normalize()}e.normalizeFileChanges=C;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(t){const R=this.mapPathToChange.get(t.path);if(R){const _=R.type,P=t.type;_===1&&P===2?(this.mapPathToChange.delete(t.path),this.normalized.splice(this.normalized.indexOf(R),1)):_===2&&P===1?R.type=0:_===1&&P===0||(R.type=P)}else this.normalized.push(t),this.mapPathToChange.set(t.path,t)}normalize(){const t=[],R=[];return this.normalized.filter(_=>_.type!==2?(t.push(_),!1):!0).sort((_,P)=>_.path.length-P.path.length).filter(_=>R.some(P=>m.isParent(_.path,P,!I.isLinux))?!1:(R.push(_.path),!0)).concat(t)}}}),define(he[179],de([0,1,85,4,15,125,127,17,2]),function(Z,e,y,m,I,E,C,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class t extends m.Disposable{constructor(_,P,v,c){super();this.path=_,this.onDidFilesChange=P,this.onLogMessage=v,this.verboseLogging=c,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(C.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(_){this.verboseLogging=_}async startWatching(){try{const{stat:_,symbolicLink:P}=await I.statLink(this.path);if(this.isDisposed)return;let v=this.path;if(P)try{v=await E.realpath(v)}catch(c){this.onError(c)}_.isDirectory()?this._register(C.watchFolder(v,(c,d)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:g.join(this.path,g.basename(d))})},c=>this.onError(c))):this._register(C.watchFile(v,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(_){this.onError(_)}}onFileChange(_){this.fileChangesBuffer.push(_),this.verboseLogging&&this.onVerbose(`${_.type===1?"[ADDED]":_.type===2?"[DELETED]":"[CHANGED]"} ${_.path}`),this.fileChangesDelayer.trigger(async()=>{const P=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=y.normalizeFileChanges(P);this.verboseLogging&&v.forEach(c=>{this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`)}),v.length>0&&this.onDidFilesChange(v)})}onError(_){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${_}`})}onVerbose(_){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${_}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=t}),define(he[60],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...I){this._entries=new Map;for(let[E,C]of I)this.set(E,C)}set(I,E){const C=this._entries.get(I);return this._entries.set(I,E),C}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=y}),define(he[86],de([0,1,12,172,59,7,60,17]),function(Z,e,y,m,I,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const g=!1;class t extends Error{constructor(c){super("cyclic dependency between services");this.message=c.toString()}}class R{constructor(c=new C.ServiceCollection,d=!1,S){this._activeInstantiations=new Set,this._services=c,this._strict=d,this._parent=S,this._services.set(E.IInstantiationService,this)}createChild(c){return new R(c,this._strict,this)}invokeFunction(c,...d){let S=P.traceInvocation(c),b=!1;try{return c({get:(u,a)=>{if(b)throw y.illegalState("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(u,S);if(!o&&a!==E.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return o}},...d)}finally{b=!0,S.stop()}}createInstance(c,...d){let S,b;return c instanceof I.SyncDescriptor?(S=P.traceCreation(c.ctor),b=this._createInstance(c.ctor,c.staticArguments.concat(d),S)):(S=P.traceCreation(c),b=this._createInstance(c,d,S)),S.stop(),b}_createInstance(c,d=[],S){let b=E._util.getServiceDependencies(c).sort((a,o)=>a.index-o.index),f=[];for(const a of b){let o=this._getOrCreateServiceInstance(a.id,S);if(!o&&this._strict&&!a.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${a.id}.`);f.push(o)}let u=b.length>0?b[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${d.length} static arguments`);let a=u-d.length;a>0?d=d.concat(new Array(a)):d=d.slice(0,u)}return new c(...[...d,...f])}_setServiceInstance(c,d){if(this._services.get(c)instanceof I.SyncDescriptor)this._services.set(c,d);else if(this._parent)this._parent._setServiceInstance(c,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let d=this._services.get(c);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):d}_getOrCreateServiceInstance(c,d){let S=this._getServiceInstanceOrDescriptor(c);return S instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,S,d.branch(c,!0)):(d.branch(c,!1),S)}_safeCreateAndCacheServiceInstance(c,d,S){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,d,S)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,d,S){const b=new m.Graph(a=>a.id.toString());let f=0;const u=[{id:c,desc:d,_trace:S}];for(;u.length;){const a=u.pop();if(b.lookupOrInsertNode(a),f++>1e3)throw new t(b);for(let o of E._util.getServiceDependencies(a.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(o.id);if(!n&&!o.optional&&console.warn(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`),n instanceof I.SyncDescriptor){const r={id:o.id,desc:n,_trace:a._trace.branch(o.id,!0)};b.insertEdge(a,r),u.push(r)}}}for(;;){const a=b.roots();if(a.length===0){if(!b.isEmpty())throw new t(b);break}for(const{data:o}of a){if(this._getServiceInstanceOrDescriptor(o.id)instanceof I.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}b.removeNode(o)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,d,S=[],b,f){if(this._services.get(c)instanceof I.SyncDescriptor)return this._createServiceInstance(d,S,b,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,d,S,b,f);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(c,d=[],S,b){if(S){const f=new L.IdleValue(()=>this._createInstance(c,d,b));return new Proxy(Object.create(null),{get(u,a){if(a in u)return u[a];let o=f.value,n=o[a];return typeof n!="function"||(n=n.bind(o),u[a]=n),n},set(u,a,o){return f.value[a]=o,!0}})}else return this._createInstance(c,d,b)}}e.InstantiationService=R;var _;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(_||(_={}));class P{constructor(c,d){this.type=c,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return g?new P(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):P._None}static traceCreation(c){return g?new P(0,c.name):P._None}branch(c,d){let S=new P(2,c.toString());return this._dep.push([c,d,S]),S}stop(){let c=Date.now()-this._start;P._totals+=c;let d=!1;function S(f,u){let a=[],o=new Array(f+1).join("	");for(const[n,r,i]of u._dep)if(r&&i){d=!0,a.push(`${o}CREATES -> ${n}`);let l=S(f+1,i);l&&a.push(l)}else a.push(`${o}uses -> ${n}`);return a.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${P._totals.toFixed(2)}ms)`];(c>2||d)&&console.log(b.join(`
`))}}P._None=new class extends P{constructor(){super(-1,null)}stop(){}branch(){return this}},P._totals=0}),define(he[180],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=y.createDecorator("labelService")}),define(he[50],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=y.createDecorator("localizationsService");function m(I){if(typeof I.languageId!="string"||!Array.isArray(I.translations)||I.translations.length===0)return!1;for(const E of I.translations)if(typeof E.id!="string"||typeof E.path!="string")return!1;return!(I.languageName&&typeof I.languageName!="string"||I.localizedLanguageName&&typeof I.localizedLanguageName!="string")}e.isValidLocalization=m});var De=this&&this.__decorate||function(Z,e,y,m){var I=arguments.length,E=I<3?e:m===null?m=Object.getOwnPropertyDescriptor(e,y):m,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")E=Reflect.decorate(Z,e,y,m);else for(var L=Z.length-1;L>=0;L--)(C=Z[L])&&(E=(I<3?C(E):I>3?C(e,y,E):C(e,y))||E);return I>3&&E&&Object.defineProperty(e,y,E),E},xe=this&&this.__param||function(Z,e){return function(y,m){e(y,m,Z)}};define(he[87],de([0,1,143,12,3,51,30,33,40,54,27,8,50]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const v=u=>y.localize(0,null,u),c=y.localize(1,null,"ms-dotnettools.csharp");function d(u,a){return a?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}const S=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function b(u){const a=S.exec(u);return a&&a[1]?[L.adoptToGalleryExtensionId(a[1]),a[2]]:[L.adoptToGalleryExtensionId(u),void 0]}e.getIdAndVersion=b;let f=class{constructor(a,o,n){this.extensionManagementService=a,this.extensionGalleryService=o,this.localizationsService=n}get location(){}async listExtensions(a,o,n=console){let r=await this.extensionManagementService.getInstalled(1);const i=g.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){n.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}r=r.filter(s=>s.manifest.categories?s.manifest.categories.map(k=>k.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){n.log("Possible Categories: "),i.forEach(s=>{n.log(s)});return}this.location&&n.log(y.localize(2,null,this.location)),r=r.sort((s,p)=>s.identifier.id.localeCompare(p.identifier.id));let l;for(let s of r)l!==s.identifier.id&&(l=s.identifier.id,n.log(d(s.manifest,a)))}async installExtensions(a,o,n,r,i=console){const l=[],s=[];a.length&&i.log(this.location?y.localize(3,null,this.location):y.localize(4,null));const p=await this.extensionManagementService.getInstalled(1),k=(h,A)=>{const N=p.find(B=>L.areSameExtensions(B.identifier,{id:h}));if(N){if(!A&&!r)return i.log(y.localize(5,null,h,N.manifest.version,h)),!1;if(A&&N.manifest.version===A)return i.log(y.localize(6,null,`${h}@${A}`)),!1}return!0},w=[],T=[];for(const h of a)if(h instanceof I.URI)w.push(h);else{const[A,N]=b(h);k(A,N)&&T.push({id:A,version:N,installOptions:{isBuiltin:!1,isMachineScoped:n}})}for(const h of o){const[A,N]=b(h);k(A,N)&&T.push({id:A,version:N,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(w.length&&await Promise.all(w.map(async h=>{try{const A=await this.installVSIX(h,r,i);A&&s.push(A)}catch(A){i.error(A.message||A.stack||A),l.push(h.toString())}})),T.length){const h=await this.getGalleryExtensions(T);await Promise.all(T.map(async A=>{const N=h.get(A.id.toLowerCase());if(N)try{const B=await this.installFromGallery(A,N,p,r,i);B&&s.push(B)}catch(B){i.error(B.message||B.stack||B),l.push(A.id)}else i.error(`${v(A.version?`${A.id}@${A.version}`:A.id)}
${c}`),l.push(A.id)}))}if(s.some(h=>g.isLanguagePackExtension(h))&&await this.updateLocalizationsCache(),l.length)throw new Error(y.localize(7,null,l.join(", ")))}async installVSIX(a,o,n){const r=await this.extensionManagementService.getManifest(a);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,o,n))try{return await this.extensionManagementService.install(a),n.log(y.localize(8,null,t.getBaseLabel(a))),r}catch(l){if(m.isPromiseCanceledError(l))return n.log(y.localize(9,null,t.getBaseLabel(a))),null;throw l}return null}async getGalleryExtensions(a){const o=a.filter(({version:i})=>i===void 0).map(({id:i})=>i),n=a.filter(({version:i})=>i!==void 0),r=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(o,R.CancellationToken.None)).forEach(l=>r.set(l.identifier.id.toLowerCase(),l))})(),Promise.all(n.map(async({id:i,version:l})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},l);s&&r.set(s.identifier.id.toLowerCase(),s)}))]),r}async installFromGallery({id:a,version:o,installOptions:n},r,i,l,s){const p=await this.extensionGalleryService.getManifest(r,R.CancellationToken.None);if(p&&!this.validateExtensionKind(p,s))return null;const k=i.find(w=>L.areSameExtensions(w.identifier,r.identifier));if(k){if(r.version===k.manifest.version)return s.log(y.localize(10,null,o?`${a}@${o}`:a)),null;s.log(y.localize(11,null,a,r.version))}try{return n.isBuiltin?s.log(y.localize(12,null,a,r.version)):s.log(y.localize(13,null,a,r.version)),await this.extensionManagementService.installFromGallery(r,n),s.log(y.localize(14,null,a,r.version)),p}catch(w){if(m.isPromiseCanceledError(w))return s.log(y.localize(15,null,a)),null;throw w}}validateExtensionKind(a,o){return!0}async validateVSIX(a,o,n){const r={id:L.getGalleryExtensionId(a.publisher,a.name)},l=(await this.extensionManagementService.getInstalled(1)).find(s=>L.areSameExtensions(r,s.identifier)&&E.gt(s.manifest.version,a.version));return l&&!o?(n.log(y.localize(16,null,l.identifier.id,l.manifest.version,a.version)),!1):this.validateExtensionKind(a,n)}async uninstallExtensions(a,o,n=console){const r=async l=>{if(l instanceof I.URI){const s=await this.extensionManagementService.getManifest(l);return d(s)}return l},i=[];for(const l of a){const s=await r(l),k=(await this.extensionManagementService.getInstalled()).filter(w=>L.areSameExtensions(w.identifier,{id:s}));if(!k.length)throw new Error(`${this.notInstalled(s)}
${c}`);if(k.some(w=>w.type===0)){n.log(y.localize(17,null,s));return}if(!o&&k.some(w=>w.isBuiltin)){n.log(y.localize(18,null,s));return}n.log(y.localize(19,null,s));for(const w of k)await this.extensionManagementService.uninstall(w),i.push(w);this.location?n.log(y.localize(20,null,s,this.location)):n.log(y.localize(21,null,s))}i.some(l=>g.isLanguagePackExtension(l.manifest))&&await this.updateLocalizationsCache()}async locateExtension(a,o=console){const n=await this.extensionManagementService.getInstalled();a.forEach(r=>{n.forEach(i=>{if(i.identifier.id===r&&i.location.scheme===_.Schemas.file){o.log(i.location.fsPath);return}})})}updateLocalizationsCache(){return this.localizationsService.update()}notInstalled(a){return this.location?y.localize(22,null,a,this.location):y.localize(23,null,a)}};f=De([xe(0,C.IExtensionManagementService),xe(1,C.IExtensionGalleryService),xe(2,P.ILocalizationsService)],f),e.ExtensionManagementCLIService=f}),define(he[16],de([0,1,7,4,5,6,39]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.DelegatedLogService=e.MultiplexLogService=e.ConsoleLogInMainService=e.LogServiceAdapter=e.ConsoleLogService=e.ConsoleLogMainService=e.AbstractLogService=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=y.createDecorator("logService"),e.ILoggerService=y.createDecorator("loggerService");function L(){return new Date().toISOString()}var g;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;class t extends m.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogService=t;class R extends t{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!I.isWindows}trace(o,...n){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,o,...n):console.log(`[main ${L()}]`,o,...n))}debug(o,...n){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,o,...n):console.log(`[main ${L()}]`,o,...n))}info(o,...n){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,o,...n):console.log(`[main ${L()}]`,o,...n))}warn(o,...n){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,o,...n):console.warn(`[main ${L()}]`,o,...n))}error(o,...n){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,o,...n):console.error(`[main ${L()}]`,o,...n))}critical(o,...n){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,o,...n):console.error(`[main ${L()}]`,o,...n))}dispose(){}flush(){}}e.ConsoleLogMainService=R;class _ extends t{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...n){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",o,...n)}debug(o,...n){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...n)}info(o,...n){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",o,...n)}warn(o,...n){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",o,...n)}error(o,...n){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",o,...n)}critical(o,...n){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...n)}dispose(){}flush(){}}e.ConsoleLogService=_;class P extends t{constructor(o,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(n)}trace(o,...n){this.getLevel()<=g.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(o),...n])}debug(o,...n){this.getLevel()<=g.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(o),...n])}info(o,...n){this.getLevel()<=g.Info&&this.adapter.consoleLog("info",[this.extractMessage(o),...n])}warn(o,...n){this.getLevel()<=g.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(o),...n])}error(o,...n){this.getLevel()<=g.Error&&this.adapter.consoleLog("error",[this.extractMessage(o),...n])}critical(o,...n){this.getLevel()<=g.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(o),...n])}extractMessage(o){return typeof o=="string"?o:C.toErrorMessage(o,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.LogServiceAdapter=P;class v extends P{constructor(o,n=e.DEFAULT_LOG_LEVEL){super({consoleLog:(r,i)=>o.consoleLog(r,i)},n)}}e.ConsoleLogInMainService=v;class c extends t{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const n of this.logServices)n.setLevel(o);super.setLevel(o)}trace(o,...n){for(const r of this.logServices)r.trace(o,...n)}debug(o,...n){for(const r of this.logServices)r.debug(o,...n)}info(o,...n){for(const r of this.logServices)r.info(o,...n)}warn(o,...n){for(const r of this.logServices)r.warn(o,...n)}error(o,...n){for(const r of this.logServices)r.error(o,...n)}critical(o,...n){for(const r of this.logServices)r.critical(o,...n)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=c;class d extends m.Disposable{constructor(o){super();this.logService=o,this._register(o)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(o){this.logService.setLevel(o)}getLevel(){return this.logService.getLevel()}trace(o,...n){this.logService.trace(o,...n)}debug(o,...n){this.logService.debug(o,...n)}info(o,...n){this.logService.info(o,...n)}warn(o,...n){this.logService.warn(o,...n)}error(o,...n){this.logService.error(o,...n)}critical(o,...n){this.logService.critical(o,...n)}flush(){this.logService.flush()}}e.DelegatedLogService=d;class S{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(o){}getLevel(){return g.Info}trace(o,...n){}debug(o,...n){}info(o,...n){}warn(o,...n){}error(o,...n){}critical(o,...n){}dispose(){}flush(){}}e.NullLogService=S;function b(a){if(a.verbose)return g.Trace;if(typeof a.logLevel=="string"){const o=f(a.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function f(a){switch(a){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=f;function u(a){switch(a){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=u}),define(he[181],de([0,1,4,15,24,30,29,3,22,33,16,20,51,5]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let d=class extends y.Disposable{constructor(b,f,u,a){super();this.fileService=f,this.extensionGalleryService=u,this.logService=a,this.extensionsDownloadDir=L.URI.file(b.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(b,f){await this.cleanUpPromise;const u=this.getName(b),a=g.joinPath(this.extensionsDownloadDir,u);if(!await this.fileService.exists(a)){const o=g.joinPath(this.extensionsDownloadDir,`.${u}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(b,o,f),await this.rename(o,a,Date.now()+2*60*1e3)}return a}async delete(b){}async rename(b,f,u){try{await m.rename(b.fsPath,f.fsPath)}catch(a){if(v.isWindows&&a&&a.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${b} to ${f} with 'EPERM' error. Trying again...`),this.rename(b,f,u);throw a}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const b=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(b.children){const f=[],u=[];for(const n of b.children){const r=this.parse(n.name);r&&u.push([r,n])}const a=t.groupByExtension(u,([n])=>n),o=[];for(const n of a)n.sort((r,i)=>P.rcompare(r[0].version,i[0].version)),f.push(...n.slice(1).map(r=>r[1].resource)),o.push(n[0][1]);o.sort((n,r)=>n.mtime-r.mtime),f.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(n=>n.resource)),await Promise.all(f.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(b){this.logService.error(b)}}getName(b){return this.cache?new t.ExtensionIdentifierWithVersion(b.identifier,b.version).key().toLowerCase():_.generateUuid()}parse(b){const f=c.exec(b);return f&&f[1]&&f[2]?new t.ExtensionIdentifierWithVersion({id:f[1]},f[2]):null}};d=De([xe(0,C.INativeEnvironmentService),xe(1,I.IFileService),xe(2,E.IExtensionGalleryService),xe(3,R.ILogService)],d),e.ExtensionsDownloader=d}),define(he[182],de([0,1,4,16,32,39,2,17,6,8,15,29]),function(Z,e,y,m,I,E,C,L,g,t,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let P=class extends y.Disposable{constructor(c,d){super();this.environmentService=c,this.logService=d,this.processesLimiter=new L.Limiter(5)}async postUninstall(c){const d=this.parseScript(c,"uninstall");return d&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${S}`)))),R.rimraf(this.getExtensionStoragePath(c)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(c,d){const S=`vscode:${d}`;if(c.location.scheme===t.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[S]=="string"){const b=c.manifest.scripts[S].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${S} should be a node script`),null):{script:C.join(c.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(c,d,S,b,f){return new Promise((u,a)=>{const o=this.start(c,d,S,f);let n;const r=i=>{n&&(clearTimeout(n),n=null),i?a(i):u(void 0)};o.on("error",i=>{r(E.toErrorMessage(i)||"Unknown")}),o.on("exit",(i,l)=>{r(i?`post-${d} process exited with code ${i}`:void 0)}),b&&(n=setTimeout(()=>{n=null,o.kill(),a("timed out")},5e3))})}start(c,d,S,b){const f={silent:!0,execArgv:void 0},u=I.fork(c,[`--type=extension-post-${d}`,...S],f);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const a=g.Event.fromNodeEventEmitter(u.stdout,"data"),o=g.Event.fromNodeEventEmitter(u.stderr,"data");a(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${d}`,i)),o(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${d}`,i));const n=g.Event.any(g.Event.map(a,i=>({data:`%c${i}`,format:[""]})),g.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return g.Event.debounce(n,(i,l)=>i?{data:i.data+l.data,format:[...i.format,...l.format]}:{data:l.data,format:l.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),u}getExtensionStoragePath(c){return C.join(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};P=De([xe(0,_.IEnvironmentService),xe(1,m.ILogService)],P),e.ExtensionsLifecycle=P}),define(he[88],de([0,1,148,47,4,24,6,22,25,14,16,18,44,17,27,8,84,53]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends I.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(a,o){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);m.mark(`code/registerFilesystem/${a}`),this.provider.set(a,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:o});const n=new I.DisposableStore;return n.add(o.onDidChangeFile(r=>this._onDidFilesChange.fire(new E.FileChangesEvent(r,!this.isPathCaseSensitive(o))))),n.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:a}))),typeof o.onDidErrorOccur=="function"&&n.add(o.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),I.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:o}),this.provider.delete(a),I.dispose(n)})}async activateProvider(a){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(n){n&&o.push(n)}}),!this.provider.has(a)&&await Promise.all(o)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,o){const n=this.provider.get(a.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return b.Iterable.map(this.provider,([a,o])=>({scheme:a,capabilities:o.capabilities}))}async withProvider(a){if(!L.isAbsolutePath(a))throw new E.FileOperationError(y.localize(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const o=this.provider.get(a.scheme);if(!o){const n=new Error;throw n.name="ENOPRO",n.message=y.localize(1,null,a.toString()),n}return o}async withReadProvider(a){const o=await this.withProvider(a);if(E.hasOpenReadWriteCloseCapability(o)||E.hasReadWriteCapability(o)||E.hasFileReadStreamCapability(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const o=await this.withProvider(a);if(E.hasOpenReadWriteCloseCapability(o)||E.hasReadWriteCapability(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,o){try{return await this.doResolveFile(a,o)}catch(n){throw E.toFileSystemProviderErrorCode(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError(y.localize(2,null,this.resourceForError(a)),1):E.ensureFileSystemProviderError(n)}}async doResolveFile(a,o){const n=await this.withProvider(a),r=this.isPathCaseSensitive(n),i=o==null?void 0:o.resolveTo,l=o==null?void 0:o.resolveSingleChildDescendants,s=o==null?void 0:o.resolveMetadata,p=await n.stat(a);let k;return this.toFileStat(n,a,p,void 0,!!s,(w,T)=>(k||(k=g.TernarySearchTree.forUris(()=>!r),k.set(a,!0),t.isNonEmptyArray(i)&&i.forEach(h=>k.set(h,!0))),Boolean(k.findSuperstr(w.resource)||k.get(w.resource))?!0:w.isDirectory&&l?T===1:!1))}async toFileStat(a,o,n,r,i,l){const{providerExtUri:s}=this.getExtUri(a),p={resource:o,name:s.basename(o),isFile:(n.type&E.FileType.File)!=0,isDirectory:(n.type&E.FileType.Directory)!=0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,etag:E.etag({mtime:n.mtime,size:n.size})};if(p.isDirectory&&l(p,r)){try{const k=await a.readdir(o),w=await Promise.all(k.map(async([T,h])=>{try{const A=s.joinPath(o,T),N=i?await a.stat(A):{type:h};return await this.toFileStat(a,A,N,k.length,i,l)}catch(A){return this.logService.trace(A),null}}));p.children=t.coalesce(w)}catch(k){this.logService.trace(k),p.children=[]}return p}return p}async resolveAll(a){return Promise.all(a.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(a){const o=await this.withProvider(a);try{return!!await o.stat(a)}catch(n){return!1}}async canCreateFile(a,o){try{await this.doValidateCreateFile(a,o)}catch(n){return n}return!0}async doValidateCreateFile(a,o){if(!(o==null?void 0:o.overwrite)&&await this.exists(a))throw new E.FileOperationError(y.localize(3,null,this.resourceForError(a)),3,o)}async createFile(a,o=_.VSBuffer.fromString(""),n){await this.doValidateCreateFile(a,n);const r=await this.writeFile(a,o);return this._onDidRunOperation.fire(new E.FileOperationEvent(a,0,r)),r}async writeFile(a,o,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,a,n)||await this.mkdirp(r,i.dirname(a));let s;if(E.hasReadWriteCapability(r)&&!(o instanceof _.VSBuffer))if(P.isReadableStream(o)){const p=await P.peekStream(o,3);p.ended?s=_.VSBuffer.concat(p.buffer):s=p}else s=P.peekReadable(o,p=>_.VSBuffer.concat(p),3);else s=o;!E.hasOpenReadWriteCloseCapability(r)||E.hasReadWriteCapability(r)&&s instanceof _.VSBuffer?await this.doWriteUnbuffered(r,a,s):await this.doWriteBuffered(r,a,s instanceof _.VSBuffer?_.bufferToReadable(s):s)}catch(l){throw new E.FileOperationError(y.localize(4,null,this.resourceForError(a),E.ensureFileSystemProviderError(l).toString()),E.toFileOperationResult(l),n)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,o,n){let r;try{r=await a.stat(o)}catch(i){return}if((r.type&E.FileType.Directory)!=0)throw new E.FileOperationError(y.localize(5,null,this.resourceForError(o)),0,n);if(n&&typeof n.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==E.etag({mtime:n.mtime,size:r.size}))throw new E.FileOperationError(y.localize(6,null),3,n);return r}async readFile(a,o){const n=await this.withReadProvider(a),r=await this.doReadAsFileStream(n,a,Object.assign(Object.assign({},o),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await _.streamToBuffer(r.value)})}async readFileStream(a,o){const n=await this.withReadProvider(a);return this.doReadAsFileStream(n,a,o)}async doReadAsFileStream(a,o,n){const r=new c.CancellationTokenSource,i=this.validateReadFile(o,n).then(s=>s,s=>{throw r.cancel(),s});let l;try{n&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&await i;let s;!(E.hasOpenReadWriteCloseCapability(a)||E.hasFileReadStreamCapability(a))||E.hasReadWriteCapability(a)&&(n==null?void 0:n.preferUnbuffered)?s=this.readFileUnbuffered(a,o,n):E.hasFileReadStreamCapability(a)?s=this.readFileStreamed(a,o,r.token,n):s=this.readFileBuffered(a,o,r.token,n),l=P.observe(s);const p=await i;return Object.assign(Object.assign({},p),{value:s})}catch(s){throw l&&await l.errorOrEnd(),new E.FileOperationError(y.localize(7,null,this.resourceForError(o),E.ensureFileSystemProviderError(s).toString()),E.toFileOperationResult(s),n)}}readFileStreamed(a,o,n,r=Object.create(null)){const i=a.readFileStream(o,r,n);return P.transform(i,{data:l=>l instanceof _.VSBuffer?l:_.VSBuffer.wrap(l),error:l=>new E.FileOperationError(y.localize(8,null,this.resourceForError(o),E.ensureFileSystemProviderError(l).toString()),E.toFileOperationResult(l),r)},l=>_.VSBuffer.concat(l))}readFileBuffered(a,o,n,r=Object.create(null)){const i=_.newWriteableBufferStream();return S.readFileIntoStream(a,o,i,l=>l,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:l=>new E.FileOperationError(y.localize(9,null,this.resourceForError(o),E.ensureFileSystemProviderError(l).toString()),E.toFileOperationResult(l),r)}),n),i}readFileUnbuffered(a,o,n){const r=P.newWriteableStream(i=>_.VSBuffer.concat(i));return(async()=>{try{let i=await a.readFile(o);n&&typeof n.position=="number"&&(i=i.slice(n.position)),n&&typeof n.length=="number"&&(i=i.slice(0,n.length)),this.validateReadFileLimits(o,i.byteLength,n),r.end(_.VSBuffer.wrap(i))}catch(i){r.error(i)}})(),r}async validateReadFile(a,o){const n=await this.resolve(a,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError(y.localize(10,null,this.resourceForError(a)),0,o);if(o&&typeof o.etag=="string"&&o.etag!==E.ETAG_DISABLED&&o.etag===n.etag)throw new E.FileOperationError(y.localize(11,null),2,o);return this.validateReadFileLimits(a,n.size,o),n}validateReadFileLimits(a,o,n){if(n==null?void 0:n.limits){let r;if(typeof n.limits.memory=="number"&&o>n.limits.memory&&(r=9),typeof n.limits.size=="number"&&o>n.limits.size&&(r=7),typeof r=="number")throw new E.FileOperationError(y.localize(12,null,this.resourceForError(a)),r)}}async canMove(a,o,n){return this.doCanMoveCopy(a,o,"move",n)}async canCopy(a,o,n){return this.doCanMoveCopy(a,o,"copy",n)}async doCanMoveCopy(a,o,n,r){if(a.toString()!==o.toString())try{const i=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,a,l,o,n,r)}catch(i){return i}return!0}async move(a,o,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),l=await this.doMoveCopy(r,a,i,o,"move",!!n),s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(a,l==="move"?2:3,s)),s}async copy(a,o,n){const r=await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),l=await this.doMoveCopy(r,a,i,o,"copy",!!n),s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(a,l==="copy"?3:2,s)),s}async doMoveCopy(a,o,n,r,i,l){if(o.toString()===r.toString())return i;const{exists:s,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(a,o,n,r,i,l);if(s&&!p&&l&&await this.del(r,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r)),i==="copy"){if(a===n&&E.hasFileFolderCopyCapability(a))await a.copy(o,r,{overwrite:l});else{const k=await this.resolve(o);k.isDirectory?await this.doCopyFolder(a,k,n,r):await this.doCopyFile(a,o,n,r)}return i}else return a===n?(await a.rename(o,r,{overwrite:l}),i):(await this.doMoveCopy(a,o,n,r,"copy",l),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(a,o,n,r){if(E.hasOpenReadWriteCloseCapability(a)&&E.hasOpenReadWriteCloseCapability(n))return this.doPipeBuffered(a,o,n,r);if(E.hasOpenReadWriteCloseCapability(a)&&E.hasReadWriteCapability(n))return this.doPipeBufferedToUnbuffered(a,o,n,r);if(E.hasReadWriteCapability(a)&&E.hasOpenReadWriteCloseCapability(n))return this.doPipeUnbufferedToBuffered(a,o,n,r);if(E.hasReadWriteCapability(a)&&E.hasReadWriteCapability(n))return this.doPipeUnbuffered(a,o,n,r)}async doCopyFolder(a,o,n,r){await n.mkdir(r),Array.isArray(o.children)&&await Promise.all(o.children.map(async i=>{const l=this.getExtUri(n).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(a,await this.resolve(i.resource),n,l):this.doCopyFile(a,i.resource,n,l)}))}async doValidateMoveCopy(a,o,n,r,i,l){let s=!1;if(a===n){const{providerExtUri:k,isPathCaseSensitive:w}=this.getExtUri(a);if(w||(s=k.isEqual(o,r)),s&&i==="copy")throw new Error(y.localize(13,null,this.resourceForError(o),this.resourceForError(r)));if(!s&&k.isEqualOrParent(r,o))throw new Error(y.localize(14,null,this.resourceForError(o),this.resourceForError(r)))}const p=await this.exists(r);if(p&&!s){if(!l)throw new E.FileOperationError(y.localize(15,null,this.resourceForError(o),this.resourceForError(r)),4);if(a===n){const{providerExtUri:k}=this.getExtUri(a);if(k.isEqualOrParent(o,r))throw new Error(y.localize(16,null,this.resourceForError(o),this.resourceForError(r)))}}return{exists:p,isSameResourceWithDifferentPathCase:s}}getExtUri(a){const o=this.isPathCaseSensitive(a);return{providerExtUri:o?L.extUri:L.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(o,a);const n=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(a,0,n)),n}async mkdirp(a,o){const n=[],{providerExtUri:r}=this.getExtUri(a);for(;!r.isEqual(o,r.dirname(o));)try{if(((await a.stat(o)).type&E.FileType.Directory)==0)throw new Error(y.localize(17,null,this.resourceForError(o)));break}catch(i){if(E.toFileSystemProviderErrorCode(i)!==E.FileSystemProviderErrorCode.FileNotFound)throw i;n.push(r.basename(o)),o=r.dirname(o)}for(let i=n.length-1;i>=0;i--){o=r.joinPath(o,n[i]);try{await a.mkdir(o)}catch(l){if(E.toFileSystemProviderErrorCode(l)!==E.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(a,o){try{await this.doValidateDelete(a,o)}catch(n){return n}return!0}async doValidateDelete(a,o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!(o==null?void 0:o.useTrash)&&!(n.capabilities&4096))throw new Error(y.localize(18,null,this.resourceForError(a)));const i=await this.exists(a);if(!i)throw new E.FileOperationError(y.localize(19,null,this.resourceForError(a)),1);if(!!!(o==null?void 0:o.recursive)&&i){const s=await this.resolve(a);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error(y.localize(20,null,this.resourceForError(a)))}return n}async del(a,o){const n=await this.doValidateDelete(a,o),r=!!(o==null?void 0:o.useTrash),i=!!(o==null?void 0:o.recursive);await n.delete(a,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new E.FileOperationEvent(a,1))}watch(a,o={recursive:!1,excludes:[]}){let n=!1,r=()=>{n=!0};return this.doWatch(a,o).then(i=>{n?I.dispose(i):r=()=>I.dispose(i)},i=>this.logService.error(i)),I.toDisposable(()=>r())}async doWatch(a,o){const n=await this.withProvider(a),r=this.toWatchKey(n,a,o),i=this.activeWatchers.get(r)||{count:0,disposable:n.watch(a,o)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,I.toDisposable(()=>{i.count--,i.count===0&&(I.dispose(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(a,o,n){const{providerExtUri:r}=this.getExtUri(a);return[r.getComparisonKey(o),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>I.dispose(a.disposable)),this.activeWatchers.clear()}ensureWriteQueue(a,o){const{providerExtUri:n}=this.getExtUri(a),r=n.getComparisonKey(o);let i=this.writeQueues.get(r);return i||(i=new v.Queue,this.writeQueues.set(r,i),C.Event.once(i.onFinished)(()=>{this.writeQueues.delete(r),I.dispose(i)})),i}async doWriteBuffered(a,o,n){return this.ensureWriteQueue(a,o).queue(async()=>{const r=await a.open(o,{create:!0});try{P.isReadableStream(n)||P.isReadableBufferedStream(n)?await this.doWriteStreamBufferedQueued(a,r,n):await this.doWriteReadableBufferedQueued(a,r,n)}catch(i){throw E.ensureFileSystemProviderError(i)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,o,n){let r=0,i;if(P.isReadableBufferedStream(n)){if(n.buffer.length>0){const l=_.VSBuffer.concat(n.buffer);await this.doWriteBuffer(a,o,l,l.byteLength,r,0),r+=l.byteLength}if(n.ended)return;i=n.stream}else i=n;return new Promise(async(l,s)=>{i.on("data",async p=>{i.pause();try{await this.doWriteBuffer(a,o,p,p.byteLength,r,0)}catch(k){return s(k)}r+=p.byteLength,setTimeout(()=>i.resume())}),i.on("error",p=>s(p)),i.on("end",()=>l())})}async doWriteReadableBufferedQueued(a,o,n){let r=0,i;for(;(i=n.read())!==null;)await this.doWriteBuffer(a,o,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(a,o,n,r,i,l){let s=0;for(;s<r;)s+=await a.write(o,i+s,n.buffer,l+s,r-s)}async doWriteUnbuffered(a,o,n){return this.ensureWriteQueue(a,o).queue(()=>this.doWriteUnbufferedQueued(a,o,n))}async doWriteUnbufferedQueued(a,o,n){let r;n instanceof _.VSBuffer?r=n:P.isReadableStream(n)?r=await _.streamToBuffer(n):P.isReadableBufferedStream(n)?r=await _.bufferedStreamToBuffer(n):r=_.readableToBuffer(n),await a.writeFile(o,r.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(a,o,n,r){return this.ensureWriteQueue(n,r).queue(()=>this.doPipeBufferedQueued(a,o,n,r))}async doPipeBufferedQueued(a,o,n,r){let i,l;try{i=await a.open(o,{create:!1}),l=await n.open(r,{create:!0});const s=_.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,k=0,w=0;do w=await a.read(i,p,s.buffer,k,s.byteLength-k),await this.doWriteBuffer(n,l,s,w,p,k),p+=w,k+=w,k===s.byteLength&&(k=0);while(w>0)}catch(s){throw E.ensureFileSystemProviderError(s)}finally{await Promise.all([typeof i=="number"?a.close(i):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async doPipeUnbuffered(a,o,n,r){return this.ensureWriteQueue(n,r).queue(()=>this.doPipeUnbufferedQueued(a,o,n,r))}async doPipeUnbufferedQueued(a,o,n,r){return n.writeFile(r,await a.readFile(o),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(a,o,n,r){return this.ensureWriteQueue(n,r).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,o,n,r))}async doPipeUnbufferedToBufferedQueued(a,o,n,r){const i=await n.open(r,{create:!0});try{const l=await a.readFile(o);await this.doWriteBuffer(n,i,_.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw E.ensureFileSystemProviderError(l)}finally{await n.close(i)}}async doPipeBufferedToUnbuffered(a,o,n,r){const i=await _.streamToBuffer(this.readFileBuffered(a,o,c.CancellationToken.None));await this.doWriteUnbuffered(n,r,i)}throwIfFileSystemIsReadonly(a,o){if(a.capabilities&2048)throw new E.FileOperationError(y.localize(21,null,this.resourceForError(o)),6);return a}resourceForError(a){return a.scheme===d.Schemas.file?a.fsPath:a.toString(!0)}};f=De([xe(0,R.ILogService)],f),e.FileService=f}),define(he[61],de([0,1,21,48,4,24,6,5,15,2,22,28,17,16,151,85,169,171,168,179,44,84,14,18]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d,S,b,f,u,a,o,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class i extends I.Disposable{constructor(s,p){var k;super();this.logService=s,this.options=p,this.BUFFER_SIZE=((k=this.options)===null||k===void 0?void 0:k.bufferSize)||64*1024,this.onDidChangeCapabilities=C.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new C.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:p,symbolicLink:k}=await g.statLink(this.toFilePath(s));return{type:this.toType(p,k),ctime:p.birthtime.getTime(),mtime:p.mtime.getTime(),size:p.size}}catch(p){throw this.toFileSystemProviderError(p)}}async readdir(s){try{const p=await g.readdirWithFileTypes(this.toFilePath(s)),k=[];return await Promise.all(p.map(async w=>{try{let T;w.isSymbolicLink()?T=(await this.stat(R.joinPath(s,w.name))).type:T=this.toType(w),k.push([w.name,T])}catch(T){this.logService.trace(T)}})),k}catch(p){throw this.toFileSystemProviderError(p)}}toType(s,p){let k;return(p==null?void 0:p.dangling)?k=E.FileType.Unknown:s.isFile()?k=E.FileType.File:s.isDirectory()?k=E.FileType.Directory:k=E.FileType.Unknown,p&&(k|=E.FileType.SymbolicLink),k}async readFile(s){try{const p=this.toFilePath(s);return await g.readFile(p)}catch(p){throw this.toFileSystemProviderError(p)}}readFileStream(s,p,k){const w=a.newWriteableStream(T=>r.VSBuffer.concat(T.map(h=>r.VSBuffer.wrap(h))).buffer);return o.readFileIntoStream(this,s,w,T=>T.buffer,Object.assign(Object.assign({},p),{bufferSize:this.BUFFER_SIZE}),k),w}async writeFile(s,p,k){let w;try{const T=this.toFilePath(s);if(!k.create||!k.overwrite){if(await g.exists(T)){if(!k.overwrite)throw E.createFileSystemProviderError(c.localize(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!k.create)throw E.createFileSystemProviderError(c.localize(1,null),E.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(s,{create:!0}),await this.write(w,0,p,0,p.byteLength)}catch(T){throw this.toFileSystemProviderError(T)}finally{typeof w=="number"&&await this.close(w)}}async open(s,p){try{const k=this.toFilePath(s);let w;if(p.create){if(L.isWindows&&await g.exists(k))try{await g.truncate(k,0),w="r+"}catch(h){this.logService.trace(h)}w||(w="w")}else w="r";const T=await m.promisify(y.open)(k,w);return this.mapHandleToPos.set(T,0),p.create&&this.writeHandles.add(T),T}catch(k){throw this.toFileSystemProviderError(k)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await m.promisify(y.fdatasync)(s)}catch(p){this.canFlush=!1,this.logService.error(p)}return await m.promisify(y.close)(s)}catch(p){throw this.toFileSystemProviderError(p)}}async read(s,p,k,w,T){const h=this.normalizePos(s,p);let A=null;try{const N=await m.promisify(y.read)(s,k,w,T,h);return typeof N=="number"?A=N:A=N.bytesRead,A}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(s,h,A)}}normalizePos(s,p){return p===this.mapHandleToPos.get(s)?null:p}updatePos(s,p,k){const w=this.mapHandleToPos.get(s);typeof w=="number"&&(typeof p=="number"||(typeof k=="number"?this.mapHandleToPos.set(s,w+k):this.mapHandleToPos.delete(s)))}async write(s,p,k,w,T){return P.retry(()=>this.doWrite(s,p,k,w,T),100,3)}async doWrite(s,p,k,w,T){const h=this.normalizePos(s,p);let A=null;try{const N=await m.promisify(y.write)(s,k,w,T,h);return typeof N=="number"?A=N:A=N.bytesWritten,A}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(s,h,A)}}async mkdir(s){try{await m.promisify(y.mkdir)(this.toFilePath(s))}catch(p){throw this.toFileSystemProviderError(p)}}async delete(s,p){try{const k=this.toFilePath(s);await this.doDelete(k,p)}catch(k){throw this.toFileSystemProviderError(k)}}async doDelete(s,p){p.recursive?await g.rimraf(s,g.RimRafMode.MOVE):await g.unlink(s)}async rename(s,p,k){const w=this.toFilePath(s),T=this.toFilePath(p);if(w!==T)try{await this.validateTargetDeleted(s,p,"move",k.overwrite),await g.move(w,T)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error(c.localize(2,null,t.basename(w),t.basename(t.dirname(T)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(s,p,k){const w=this.toFilePath(s),T=this.toFilePath(p);if(w!==T)try{await this.validateTargetDeleted(s,p,"copy",k.overwrite),await g.copy(w,T)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error(c.localize(3,null,t.basename(w),t.basename(t.dirname(T)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(s,p,k,w){const T=this.toFilePath(s),h=this.toFilePath(p);let A=!1;if(!!(this.capabilities&1024)||(A=_.isEqual(T,h,!0)),A&&k==="copy")throw E.createFileSystemProviderError(c.localize(4,null),E.FileSystemProviderErrorCode.FileExists);if(!A&&await g.exists(h)){if(!w)throw E.createFileSystemProviderError(c.localize(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(p,{recursive:!0,useTrash:!1})}}watch(s,p){return p.recursive?this.watchRecursive(s,p.excludes):this.watchNonRecursive(s)}watchRecursive(s,p){const k={path:this.toFilePath(s),excludes:p},w=n.insert(this.recursiveFoldersToWatch,k);return this.refreshRecursiveWatchers(),I.toDisposable(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,p,k;if(this.recursiveWatcher instanceof f.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(I.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let w,T;((p=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||p===void 0?void 0:p.usePolling)?(w=S.FileWatcher,T=(k=this.options)===null||k===void 0?void 0:k.watcher):this.recursiveFoldersToWatch.length===1?L.isWindows?w=b.FileWatcher:w=S.FileWatcher:w=f.FileWatcher,this.recursiveWatcher=new w(this.recursiveFoldersToWatch,h=>this._onDidChangeFile.fire(d.toFileChanges(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===v.LogLevel.Trace,T),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))}}watchNonRecursive(s){const p=new u.FileWatcher(this.toFilePath(s),w=>this._onDidChangeFile.fire(d.toFileChanges(w)),w=>{w.type==="error"&&this._onDidWatchErrorOccur.fire(w.message),this.logService[w.type](w.message)},this.logService.getLevel()===v.LogLevel.Trace),k=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return I.combinedDisposable(p,k)}toFilePath(s){return t.normalize(s.fsPath)}toFileSystemProviderError(s){if(s instanceof E.FileSystemProviderError)return s;let p;switch(s.code){case"ENOENT":p=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":p=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":p=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":p=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":p=E.FileSystemProviderErrorCode.NoPermissions;break;default:p=E.FileSystemProviderErrorCode.Unknown}return E.createFileSystemProviderError(s,p)}dispose(){super.dispose(),I.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,I.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=i}),define(he[89],de([0,1,15,62,30,4,29,17,33,16,50,14,6,8,2]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let d=class extends E.Disposable{constructor(f,u,a){super();this.extensionManagementService=f,this.logService=a,this._onDidLanguagesChange=this._register(new P.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new S(u,a)),this._register(f.onDidInstallExtension(({local:o})=>this.onDidInstallExtension(o))),this._register(f.onDidUninstallExtension(({identifier:o})=>this.onDidUninstallExtension(o)))}getLanguageIds(){return this.cache.getLanguagePacks().then(f=>{const u=["en",...Object.keys(f)];return _.distinct(u)})}onDidInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",f.identifier.id),this.update().then(u=>{u&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(f){this.cache.getLanguagePacks().then(u=>{Object.keys(u).some(a=>u[a]&&u[a].extensions.some(o=>g.areSameExtensions(o.extensionIdentifier,f)))&&(this.logService.debug("Removing language packs from the extension",f.id),this.update().then(a=>{a&&this._onDidLanguagesChange.fire()}))})}update(){return Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]).then(([f,u])=>this.cache.update(u).then(a=>!_.equals(Object.keys(f),Object.keys(a))))}};d=De([xe(0,I.IExtensionManagementService),xe(1,C.INativeEnvironmentService),xe(2,t.ILogService)],d),e.LocalizationsService=d;let S=class extends E.Disposable{constructor(f,u){super();this.logService=u,this.languagePacks={},this.languagePacksFilePath=c.join(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(u=>{Object.keys(u).forEach(a=>delete u[a]),this.createLanguagePacksFromExtensions(u,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...u){for(const a of u)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,a);Object.keys(f).forEach(a=>this.updateHash(f[a]))}createLanguagePacksFromExtension(f,u){const a=u.identifier,o=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const n of o)if(u.location.scheme===v.Schemas.file&&R.isValidLocalization(n)){let r=f[n.languageId];r||(r={hash:"",extensions:[],translations:{}},f[n.languageId]=r);let i=r.extensions.filter(l=>g.areSameExtensions(l.extensionIdentifier,a))[0];i?i.version=u.manifest.version:r.extensions.push({extensionIdentifier:a,version:u.manifest.version});for(const l of n.translations)r.translations[l.id]=c.join(u.location.fsPath,l.path)}}updateHash(f){if(f){const u=m.createHash("md5");for(const a of f.extensions)u.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);f.hash=u.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return y.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch(o){return{}}}).then(a=>(u=f(a),a)).then(a=>{for(const n of Object.keys(a))a[n]||delete a[n];this.languagePacks=a,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),y.writeFile(this.languagePacksFilePath,o)}).then(()=>u,a=>this.logService.error(a))})}};S=De([xe(0,C.INativeEnvironmentService),xe(1,t.ILogService)],S)}),define(he[183],de([0,1,16,6]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=void 0;class I{constructor(g){this.service=g,this.onDidChangeLogLevel=m.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,t){switch(t){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${t}`)}call(g,t,R){switch(t){case"setLevel":return this.service.setLevel(R),Promise.resolve();case"consoleLog":return this.consoleLog(R[0],R[1]),Promise.resolve()}throw new Error(`Call not found: ${t}`)}consoleLog(g,t){let R=console.log;switch(g){case"error":R=console.error;break;case"warn":R=console.warn;break;case"info":R=console.info;break}R.call(console,...t)}}e.LoggerChannel=I;class E{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){E.setLevel(this.channel,g)}static setLevel(g,t){return g.call("setLevel",t)}consoleLog(g,t){this.channel.call("consoleLog",[g,t])}}e.LoggerChannelClient=E;class C extends y.DelegatedLogService{constructor(g,t){super(t);this.parent=g,this._register(g.onDidChangeLogLevel(R=>t.setLevel(R)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=C}),define(he[90],de([0,1,2,16,24]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogService=e.createRotatingLogger=void 0;async function E(t,R){try{const _=await new Promise((v,c)=>{Z(["spdlog"],v,c)});_.setAsyncMode(8192,500);const P=y.join(R,`${t}.log`);return _.createRotatingLoggerAsync(t,P,5*I.ByteSize.MB,6)}catch(_){console.error(_)}return null}function C(t,R,_,P){return Z.__$__nodeRequire("spdlog").createRotatingLogger(t,R,_,P)}e.createRotatingLogger=C;function L(t,R,_){switch(R){case m.LogLevel.Trace:t.trace(_);break;case m.LogLevel.Debug:t.debug(_);break;case m.LogLevel.Info:t.info(_);break;case m.LogLevel.Warning:t.warn(_);break;case m.LogLevel.Error:t.error(_);break;case m.LogLevel.Critical:t.critical(_);break;default:throw new Error("Invalid log level")}}class g extends m.AbstractLogService{constructor(R,_,P){super();this.name=R,this.logsFolder=_,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(P),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=E(this.name,this.logsFolder).then(R=>{if(R){this._logger=R,this._logger.setLevel(this.getLevel());for(const{level:_,message:P}of this.buffer)L(this._logger,_,P);this.buffer=[]}})),this._loggerCreationPromise}_log(R,_){this._logger?L(this._logger,R,_):this.getLevel()<=R&&this.buffer.push({level:R,message:_})}trace(R,..._){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format([R,..._]))}debug(R,..._){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format([R,..._]))}info(R,..._){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format([R,..._]))}warn(R,..._){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format([R,..._]))}error(R,..._){if(this.getLevel()<=m.LogLevel.Error)if(R instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=R.stack,this._log(m.LogLevel.Error,this.format(P))}else this._log(m.LogLevel.Error,this.format([R,..._]))}critical(R,..._){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format([R,..._]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(R){let _="";for(let P=0;P<R.length;P++){let v=R[P];if(typeof v=="object")try{v=JSON.stringify(v)}catch(c){}_+=(P>0?" ":"")+v}return _}}e.SpdLogService=g}),define(he[184],de([0,1,7,152,70]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var E;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(E=e.MarkerTag||(e.MarkerTag={}));var C;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(g){function t(c,d){return d-c}g.compare=t;const R=Object.create(null);R[g.Error]=m.localize(0,null),R[g.Warning]=m.localize(1,null),R[g.Info]=m.localize(2,null);function _(c){return R[c]||""}g.toString=_;function P(c){switch(c){case I.default.Error:return g.Error;case I.default.Warning:return g.Warning;case I.default.Info:return g.Info;case I.default.Ignore:return g.Hint}}g.fromSeverity=P;function v(c){switch(c){case g.Error:return I.default.Error;case g.Warning:return I.default.Warning;case g.Info:return I.default.Info;case g.Hint:return I.default.Ignore}}g.toSeverity=v}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var L;(function(g){const t="";function R(P){return _(P,!0)}g.makeKey=R;function _(P,v){let c=[t];return P.source?c.push(P.source.replace("\xA6","\\\xA6")):c.push(t),P.code?typeof P.code=="string"?c.push(P.code.replace("\xA6","\\\xA6")):c.push(P.code.value.replace("\xA6","\\\xA6")):c.push(t),P.severity!==void 0&&P.severity!==null?c.push(C.toString(P.severity)):c.push(t),P.message&&v?c.push(P.message.replace("\xA6","\\\xA6")):c.push(t),P.startLineNumber!==void 0&&P.startLineNumber!==null?c.push(P.startLineNumber.toString()):c.push(t),P.startColumn!==void 0&&P.startColumn!==null?c.push(P.startColumn.toString()):c.push(t),P.endLineNumber!==void 0&&P.endLineNumber!==null?c.push(P.endLineNumber.toString()):c.push(t),P.endColumn!==void 0&&P.endColumn!==null?c.push(P.endColumn.toString()):c.push(t),c.push(t),c.join("\xA6")}g.makeKeyOptionalMessage=_})(L=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=y.createDecorator("markerService")}),define(he[185],de([0,1,70,7,6]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=y.default,e.INotificationService=m.createDecorator("notificationService");var E;(function(t){t[t.WORKSPACE=0]="WORKSPACE",t[t.GLOBAL=1]="GLOBAL"})(E=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(t){t[t.OFF=0]="OFF",t[t.SILENT=1]="SILENT",t[t.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class L{constructor(){this.progress=new g,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=L;class g{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=g}),define(he[26],de([0,1,5,36,8,22]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(y.isWeb||typeof Z=="undefined"||typeof Z.__$__nodeRequire!="function")C={webBuiltInExtensions:[{name:"ms-vscode.github-browser",version:"0.0.14",repo:"https://github.com/microsoft/vscode-github-browser",metadata:{id:"c1bcff4b-4ecb-466e-b8f6-b02788b5fb5a",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","msjsdiag.debugger-for-chrome":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","felixfbecker.php-intellisense":"{**/*.php,**/php.ini}","felixfbecker.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py,**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-maven":{name:"Maven for Java"}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",telemetryOptOutUrl:"https://go.microsoft.com/fwlink/?linkid=870136",npsSurveyUrl:"https://www.research.net/r/Z2RMYRJ",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionAllowedProposedApi:["GitHub.codespaces","GitHub.vscode-pull-request-github-insiders","GitHub.vscode-pull-request-github","Microsoft.vscode-nmake-tools","ms-ai-tools.notebook-renderers","ms-dotnettools.dotnet-interactive-vscode","ms-python.gather","ms-python.python","ms-toolsai.jupyter","ms-toolsai.vscode-ai","ms-toolsai.vscode-ai-remote","ms-vscode-remote.remote-containers-nightly","ms-vscode-remote.remote-containers","ms-vscode-remote.remote-ssh-edit-nightly","ms-vscode-remote.remote-ssh-edit","ms-vscode-remote.remote-ssh-nightly","ms-vscode-remote.remote-ssh","ms-vscode-remote.remote-wsl-nightly","ms-vscode-remote.remote-wsl","ms-vscode-remote.remote-wsl-recommender","ms-vscode-remote.vscode-remote-extensionpack-nightly","ms-vscode-remote.vscode-remote-extensionpack","ms-vscode.azure-account","ms-vscode.azure-sphere-tools-ui","ms-vscode.azure-sphere-tools","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.js-debug-nightly","ms-vscode.js-debug","ms-vscode.lsif-browser","ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.vscode-selfhost-test-provider","ms-vsliveshare.cloudenv-explorer","ms-vsliveshare.cloudenv","ms-vsliveshare.vsliveshare","ms-vsonline.vsonline","sandy081.999-test-github-issue-notebooks"],tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"manasxx.background-cover":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"]},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["https://management.core.windows.net/.default","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.node-debug",version:"1.44.16",repo:"https://github.com/microsoft/vscode-node-debug",metadata:{id:"b6ded8fb-a0a0-4c1c-acbd-ab2a3bc995a6",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.node-debug2",version:"1.42.5",repo:"https://github.com/microsoft/vscode-node-debug2",metadata:{id:"36d19e17-7569-4841-a001-947eb18602b2",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.references-view",version:"0.0.77",repo:"https://github.com/microsoft/vscode-reference-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.8",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.53.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.11",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.5",repo:"https://github.com/microsoft/vscode-remote-release",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.53.2",commit:"622cb03f7e070a9670c94bae1a45d78d7181fbd4",date:"2021-02-11T11:36:16.134Z"},Object.keys(C).length===0&&Object.assign(C,{version:"1.53.0-dev",nameShort:y.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:y.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/master/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});else{const L=E.dirname(I.FileAccess.asFileUri("",Z));C=Z.__$__nodeRequire(E.joinPath(L,"product.json").fsPath);const g=Z.__$__nodeRequire(E.joinPath(L,"package.json").fsPath);m.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`}),Object.assign(C,{version:g.version})}e.default=C}),define(he[52],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=y.createDecorator("productService")}),define(he[31],de([0,1,11,107]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(C,L){m.ok(y.isString(C)),m.ok(y.isObject(L)),m.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,L)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new I}),define(he[186],de([0,1,31,6]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class E{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,t){this.schemasById[I(g)]=t,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new E;y.Registry.add(e.Extensions.JSONContribution,C)}),define(he[41],de([0,1,139,6,31,11,186]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=I.Registry.as(C.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new m.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new m.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,f=!0){this.registerConfigurations([b],f)}registerConfigurations(b,f=!0){const u=[];b.forEach(a=>{u.push(...this.validateAndRegisterProperties(a,f)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(b){const f=[],u=a=>{if(a.properties)for(const o in a.properties)f.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,a.properties[o]);a.allOf&&a.allOf.forEach(o=>u(o))};for(const a of b){u(a);const o=this.configurationContributors.indexOf(a);o!==-1&&this.configurationContributors.splice(o,1)}g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(b){const f=[],u=[];for(const a of b)for(const o in a)if(f.push(o),e.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]=Object.assign(Object.assign({},this.defaultValues[o]||{}),a[o]);const n={type:"object",default:this.defaultValues[o],description:y.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId};u.push(_(o)),this.configurationProperties[o]=n,this.defaultLanguageConfigurationOverridesNode.properties[o]=n}else{this.defaultValues[o]=a[o];const n=this.configurationProperties[o];n&&(this.updatePropertyDefaultValue(o,n),this.updateSchema(o,n))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(b){const f=[];for(const u of b)for(const a in u)if(f.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const o=this.configurationProperties[a];o&&(this.updatePropertyDefaultValue(a,o),this.updateSchema(a,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const f of b)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,f=!0,u=3){u=E.isUndefinedOrNull(b.scope)?u:b.scope;let a=[],o=b.properties;if(o)for(let r in o){if(f&&c(r)){delete o[r];continue}const i=o[r];if(this.updatePropertyDefaultValue(r,i),e.OVERRIDE_PROPERTY_PATTERN.test(r)?i.scope=void 0:i.scope=E.isUndefinedOrNull(i.scope)?u:i.scope,o[r].hasOwnProperty("included")&&!o[r].included){this.excludedConfigurationProperties[r]=o[r],delete o[r];continue}else this.configurationProperties[r]=o[r];!o[r].deprecationMessage&&o[r].markdownDeprecationMessage&&(o[r].deprecationMessage=o[r].markdownDeprecationMessage),a.push(r)}let n=b.allOf;if(n)for(let r of n)a.push(...this.validateAndRegisterProperties(r,f,u));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const f=u=>{let a=u.properties;if(a)for(const n in a)this.updateSchema(n,a[n]);let o=u.allOf;o&&o.forEach(f)};f(b)}updateSchema(b,f){switch(e.allSettings.properties[b]=f,f.scope){case 1:e.applicationSettings.properties[b]=f;break;case 2:e.machineSettings.properties[b]=f;break;case 6:e.machineOverridableSettings.properties[b]=f;break;case 3:e.windowSettings.properties[b]=f;break;case 4:e.resourceSettings.properties[b]=f;break;case 5:e.resourceSettings.properties[b]=f,this.resourceLanguageSettingsSchema.properties[b]=f;break}}removeFromSchema(b,f){switch(delete e.allSettings.properties[b],f.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const f=`[${b}]`,u={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,u),e.allSettings.properties[f]=u,e.applicationSettings.properties[f]=u,e.machineSettings.properties[f]=u,e.machineOverridableSettings.properties[f]=u,e.windowSettings.properties[f]=u,e.resourceSettings.properties[f]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,f){let u=this.defaultValues[b];E.isUndefined(u)&&(u=f.default),E.isUndefined(u)&&(u=P(f.type)),f.default=u}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function _(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=_;function P(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=P;const v=new t;I.Registry.add(e.Extensions.Configuration,v);function c(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?y.localize(5,null,S):v.getConfigurationProperties()[S]!==void 0?y.localize(6,null,S):null:y.localize(4,null)}e.validateProperty=c;function d(){const S=[],b=v.getConfigurationProperties();for(const f of Object.keys(b))S.push([f,b[f].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=d}),define(he[34],de([0,1,19,11,3,31,7,41]),function(Z,e,y,m,I,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=C.createDecorator("configurationService");function g(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof I.URI)}e.isConfigurationOverrides=g;var t;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(t=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function _(r,i){const l=i?r?i.keys.filter(A=>r.keys.indexOf(A)===-1):[...i.keys]:[],s=r?i?r.keys.filter(A=>i.keys.indexOf(A)===-1):[...r.keys]:[],p=[];if(i&&r){for(const A of r.keys)if(i.keys.indexOf(A)!==-1){const N=b(r.contents,A),B=b(i.contents,A);y.equals(N,B)||p.push(A)}}const k=[],w=A=>{const N={};for(const B of A)for(const W of B.identifiers)N[o(W)]=B;return N},T=i?w(i.overrides):{},h=r?w(r.overrides):{};if(Object.keys(T).length)for(const A of l){const N=T[A];N&&k.push([L.overrideIdentifierFromKey(A),N.keys])}if(Object.keys(h).length)for(const A of s){const N=h[A];N&&k.push([L.overrideIdentifierFromKey(A),N.keys])}if(Object.keys(T).length&&Object.keys(h).length)for(const A of p){const N=h[A],B=T[A];if(N&&B){const W=_({contents:N.contents,keys:N.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});k.push([L.overrideIdentifierFromKey(A),[...W.added,...W.removed,...W.updated]])}}return{added:l,removed:s,updated:p,overrides:k}}e.compare=_;function P(r,i){const l=[];for(const s of Object.keys(r))if(L.OVERRIDE_PROPERTY_PATTERN.test(s)){const p={};for(const k in r[s])p[k]=r[s][k];l.push({identifiers:[L.overrideIdentifierFromKey(s).trim()],keys:Object.keys(p),contents:v(p,i)})}return l}e.toOverrides=P;function v(r,i){const l=Object.create(null);for(let s in r)c(l,s,r[s],i);return l}e.toValuesTree=v;function c(r,i,l,s){const p=i.split("."),k=p.pop();let w=r;for(let T=0;T<p.length;T++){let h=p[T],A=w[h];switch(typeof A){case"undefined":A=w[h]=Object.create(null);break;case"object":break;default:s(`Ignoring ${i} as ${p.slice(0,T+1).join(".")} is ${JSON.stringify(A)}`);return}w=A}if(typeof w=="object"&&w!==null)try{w[k]=l}catch(T){s(`Ignoring ${i} as ${p.join(".")} is ${JSON.stringify(w)}`)}else s(`Ignoring ${i} as ${p.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=c;function d(r,i){const l=i.split(".");S(r,l)}e.removeFromValueTree=d;function S(r,i){const l=i.shift();if(i.length===0){delete r[l];return}if(Object.keys(r).indexOf(l)!==-1){const s=r[l];typeof s=="object"&&!Array.isArray(s)&&(S(s,i),Object.keys(s).length===0&&delete r[l])}}function b(r,i,l){function s(w,T){let h=w;for(const A of T){if(typeof h!="object"||h===null)return;h=h[A]}return h}const p=i.split("."),k=s(r,p);return typeof k=="undefined"?l:k}e.getConfigurationValue=b;function f(r,i,l){Object.keys(i).forEach(s=>{s!=="__proto__"&&(s in r?m.isObject(r[s])&&m.isObject(i[s])?f(r[s],i[s],l):l&&(r[s]=i[s]):r[s]=i[s])})}e.merge=f;function u(){const r=E.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=u;function a(){const r=Object.create(null),i=E.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let l in i){let s=i[l].default;c(r,l,s,p=>console.error(`Conflict in default settings: ${p}`))}return r}e.getDefaultValues=a;function o(r){return`[${r}]`}e.keyFromOverrideIdentifier=o;function n(r,i,l){const s=r.inspect(i),p=r.inspect(l);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:s.defaultValue}e.getMigratedSettingValue=n}),define(he[187],de([0,1,35,25,14,11,19,3,41,34,31,4,6]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(n={},r=[],i=[]){this._contents=n,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?t.getConfigurationValue(this.contents,n):this.contents}getOverrideValue(n,r){const i=this.getContentsForOverrideIdentifer(r);return i?n?t.getConfigurationValue(i,n):i:void 0}getKeysForOverrideIdentifier(n){for(const r of this.overrides)if(r.identifiers.indexOf(n)!==-1)return r.keys;return[]}override(n){const r=this.getContentsForOverrideIdentifer(n);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const l of I.distinct([...Object.keys(this.contents),...Object.keys(r)])){let s=this.contents[l],p=r[l];p&&(typeof s=="object"&&typeof p=="object"?(s=C.deepClone(s),this.mergeContents(s,p)):s=p),i[l]=s}return new v(i,this.keys,this.overrides)}merge(...n){const r=C.deepClone(this.contents),i=C.deepClone(this.overrides),l=[...this.keys];for(const s of n){this.mergeContents(r,s.contents);for(const p of s.overrides){const[k]=i.filter(w=>I.equals(w.identifiers,p.identifiers));k?this.mergeContents(k.contents,p.contents):i.push(C.deepClone(p))}for(const p of s.keys)l.indexOf(p)===-1&&l.push(p)}return new v(r,l,i)}freeze(){return this.isFrozen=!0,this}mergeContents(n,r){for(const i of Object.keys(r)){if(i in n&&E.isObject(n[i])&&E.isObject(r[i])){this.mergeContents(n[i],r[i]);continue}n[i]=C.deepClone(r[i])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?C.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const r of this.overrides)if(r.identifiers.indexOf(n)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,r){this.addKey(n),t.addToValueTree(this.contents,n,r,i=>{throw new Error(i)})}removeValue(n){this.removeKey(n)&&t.removeFromValueTree(this.contents,n)}addKey(n){let r=this.keys.length;for(let i=0;i<r;i++)n.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,n)}removeKey(n){let r=this.keys.indexOf(n);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=v;class c extends v{constructor(){const n=t.getDefaultValues(),r=t.getConfigurationKeys(),i=[];for(const l of Object.keys(n))g.OVERRIDE_PROPERTY_PATTERN.test(l)&&i.push({identifiers:[g.overrideIdentifierFromKey(l).trim()],keys:Object.keys(n[l]),contents:t.toValuesTree(n[l],s=>console.error(`Conflict in default settings file: ${s}`))});super(n,r,i)}}e.DefaultConfigurationModel=c;class d{constructor(n,r){this._name=n,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get errors(){return this._parseErrors}parseContent(n){if(!E.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r)}}parseRaw(n){this._raw=n;const r=this.doParseRaw(n);this._configurationModel=new v(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(n){let r={},i=null,l=[],s=[],p=[];function k(T){Array.isArray(l)?l.push(T):i&&(l[i]=T)}let w={onObjectBegin:()=>{let T={};k(T),s.push(l),l=T,i=null},onObjectProperty:T=>{i=T},onObjectEnd:()=>{l=s.pop()},onArrayBegin:()=>{let T=[];k(T),s.push(l),l=T,i=null},onArrayEnd:()=>{l=s.pop()},onLiteralValue:k,onError:(T,h,A)=>{p.push({error:T,offset:h,length:A})}};if(n)try{y.visit(n,w),r=l[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(n){if(this._scopes){const s=R.Registry.as(g.Extensions.Configuration).getConfigurationProperties();n=this.filterByScope(n,s,!0,this._scopes)}const r=t.toValuesTree(n,s=>console.error(`Conflict in settings file ${this._name}: ${s}`)),i=Object.keys(n),l=t.toOverrides(n,s=>console.error(`Conflict in settings file ${this._name}: ${s}`));return{contents:r,keys:i,overrides:l}}filterByScope(n,r,i,l){const s={};for(let p in n)if(g.OVERRIDE_PROPERTY_PATTERN.test(p)&&i)s[p]=this.filterByScope(n[p],r,!1,l);else{const k=this.getScope(p,r);(k===void 0||l.indexOf(k)!==-1)&&(s[p]=n[p])}return s}getScope(n,r){const i=r[n];return i?typeof i.scope!="undefined"?i.scope:3:void 0}}e.ConfigurationModelParser=d;class S extends _.Disposable{constructor(n,r,i,l){super();this.userSettingsResource=n,this.scopes=r,this.fileService=l,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(P.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(n.value.toString()||"{}"),this.parser.configurationModel}catch(n){return new v}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=S;class b{constructor(n,r,i=new v,l=new v,s=new m.ResourceMap,p=new v,k=new m.ResourceMap,w=!0){this._defaultConfiguration=n,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=l,this._folderConfigurations=s,this._memoryConfiguration=p,this._memoryConfigurationByResource=k,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new m.ResourceMap,this._userConfiguration=null}getValue(n,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(n)}updateValue(n,r,i={}){let l;i.resource?(l=this._memoryConfigurationByResource.get(i.resource),l||(l=new v,this._memoryConfigurationByResource.set(i.resource,l))):l=this._memoryConfiguration,r===void 0?l.removeValue(n):l.setValue(n,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,r,i){const l=this.getConsolidateConfigurationModel(r,i),s=this.getFolderConfigurationModelForResource(r.resource,i),p=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,k=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),w=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),h=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),A=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,N=s?r.overrideIdentifier?s.freeze().override(r.overrideIdentifier).getValue(n):s.freeze().getValue(n):void 0,B=r.overrideIdentifier?p.override(r.overrideIdentifier).getValue(n):p.getValue(n),W=l.getValue(n),H=I.distinct(I.flatten(l.overrides.map(K=>K.identifiers))).filter(K=>l.getOverrideValue(n,K)!==void 0);return{defaultValue:k,userValue:w,userLocalValue:T,userRemoteValue:h,workspaceValue:A,workspaceFolderValue:N,memoryValue:B,value:W,default:k!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,r.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,r.overrideIdentifier):void 0}:void 0,userRemote:h!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,r.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,r.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:s==null?void 0:s.freeze().getValue(n),override:r.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(n,r.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:p.getValue(n),override:r.overrideIdentifier?p.getOverrideValue(n,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(n){const r=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,r){this._folderConfigurations.set(n,r),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,r){const i=r.filter(l=>g.OVERRIDE_PROPERTY_PATTERN.test(l)).map(l=>{const s=g.overrideIdentifierFromKey(l),p=this._defaultConfiguration.getKeysForOverrideIdentifier(s),k=n.getKeysForOverrideIdentifier(s),w=[...k.filter(T=>p.indexOf(T)===-1),...p.filter(T=>k.indexOf(T)===-1),...p.filter(T=>!C.equals(this._defaultConfiguration.override(s).getValue(T),n.override(s).getValue(T)))];return[s,w]});return this.updateDefaultConfiguration(n),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(n){const{added:r,updated:i,removed:l,overrides:s}=t.compare(this.localUserConfiguration,n),p=[...r,...i,...l];return p.length&&this.updateLocalUserConfiguration(n),{keys:p,overrides:s}}compareAndUpdateRemoteUserConfiguration(n){const{added:r,updated:i,removed:l,overrides:s}=t.compare(this.remoteUserConfiguration,n);let p=[...r,...i,...l];return p.length&&this.updateRemoteUserConfiguration(n),{keys:p,overrides:s}}compareAndUpdateWorkspaceConfiguration(n){const{added:r,updated:i,removed:l,overrides:s}=t.compare(this.workspaceConfiguration,n);let p=[...r,...i,...l];return p.length&&this.updateWorkspaceConfiguration(n),{keys:p,overrides:s}}compareAndUpdateFolderConfiguration(n,r){const i=this.folderConfigurations.get(n),{added:l,updated:s,removed:p,overrides:k}=t.compare(i,r);let w=[...l,...s,...p];return(w.length||!i)&&this.updateFolderConfiguration(n,r),{keys:w,overrides:k}}compareAndDeleteFolderConfiguration(n){const r=this.folderConfigurations.get(n);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:l,removed:s,overrides:p}=t.compare(r,void 0);return{keys:[...i,...l,...s],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,r){let i=this.getConsolidatedConfigurationModelForResource(n,r);return n.overrideIdentifier?i.override(n.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:n},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&n){const l=r.getFolder(n);l&&(i=this.getFolderConsolidatedConfiguration(l.uri)||i);const s=this._memoryConfigurationByResource.get(n);s&&(i=i.merge(s))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let r=this._foldersConsolidatedConfigurations.get(n);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(n);l?(r=i.merge(l),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(n,r)):r=i}return r}getFolderConfigurationModelForResource(n,r){if(r&&n){const i=r.getFolder(n);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,r)=>{const{contents:i,overrides:l,keys:s}=this._folderConfigurations.get(r);return n.push([r,{contents:i,overrides:l,keys:s}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>n.add(r)),this.userConfiguration.freeze().keys.forEach(r=>n.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>n.add(i))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(l=>r.add(l))),[...r.values()]}static parse(n){const r=this.parseConfigurationModel(n.defaults),i=this.parseConfigurationModel(n.user),l=this.parseConfigurationModel(n.workspace),s=n.folders.reduce((p,k)=>(p.set(L.URI.revive(k[0]),this.parseConfigurationModel(k[1])),p),new m.ResourceMap);return new b(r,i,new v,l,s,new v,new m.ResourceMap,!1)}static parseConfigurationModel(n){return new v(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=b;function f(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,r=new Map;for(const l of o)l.keys.forEach(s=>n.add(s)),l.overrides.forEach(([s,p])=>{const k=m.getOrSet(r,s,new Set);p.forEach(w=>k.add(w))});const i=[];return r.forEach((l,s)=>i.push([s,[...l.values()]])),{keys:[...n.values()],overrides:i}}e.mergeChanges=f;class u{constructor(n,r,i,l){this.change=n,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=l,this._previousConfiguration=void 0;const s=new Set;n.keys.forEach(k=>s.add(k)),n.overrides.forEach(([,k])=>k.forEach(w=>s.add(w))),this.affectedKeys=[...s.values()];const p=new v;this.affectedKeys.forEach(k=>p.setValue(k,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,r){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(r){const l=this.previousConfiguration?this.previousConfiguration.getValue(n,r,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,s=this.currentConfiguraiton.getValue(n,r,this.currentWorkspace);return!C.equals(l,s)}return!0}return!1}doesAffectedKeysTreeContains(n,r){let i=t.toValuesTree({[r]:!0},()=>{}),l;for(;typeof i=="object"&&(l=Object.keys(i)[0]);){if(n=n[l],!n)return!1;i=i[l]}return!0}}e.ConfigurationChangeEvent=u;class a extends u{constructor(n,r,i,l){super({keys:n.allKeys(),overrides:[]},void 0,n,r);this.source=i,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=a}),define(he[91],de([0,1,31,41,4,34,187,6,17,22]),function(Z,e,y,m,I,E,C,L,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends I.Disposable{constructor(P,v){super();this.settingsResource=P,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,t.extUriBiasedIgnorePathCase,v)),this.configuration=new C.Configuration(new C.DefaultConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new g.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const P=await this.userConfiguration.loadConfiguration();this.configuration=new C.Configuration(new C.DefaultConfigurationModel,P)}getConfigurationData(){return this.configuration.toData()}getValue(P,v){const c=typeof P=="string"?P:void 0,d=E.isConfigurationOverrides(P)?P:E.isConfigurationOverrides(v)?v:{};return this.configuration.getValue(c,d,void 0)}updateValue(P,v,c,d){return Promise.reject(new Error("not supported"))}inspect(P){return this.configuration.inspect(P,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const P=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(P)}onDidChangeUserConfiguration(P){const v=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(P);this.trigger(c,v,1)}onDidDefaultConfigurationChange(P){const v=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new C.DefaultConfigurationModel,P);this.trigger(c,v,6)}trigger(P,v,c){const d=new C.ConfigurationChangeEvent(P,{data:v},this.configuration);d.source=c,d.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(P){switch(P){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(he[92],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=y.createDecorator("remoteAuthorityResolverService");var m;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound"})(m=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(C,L=m.Unknown,g){super(C);this._message=C,this._code=L,this._detail=g,this.isHandled=L===m.NotAvailable&&g===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(C){return C instanceof I&&C._code===m.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof I&&C._code===m.NoResolverFound}static isHandled(C){return C instanceof I&&C.isHandled}}e.RemoteAuthorityResolverError=I}),define(he[188],de([0,1,8]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function m(E){return E.scheme===y.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=m;function I(E){if(!!E){const C=E.indexOf("+");return C<0?E:E.substr(0,C)}}e.getRemoteName=I}),define(he[63],de([0,1,153,7,41,31,18]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=m.createDecorator("requestService");function L(_){return _.res.statusCode&&_.res.statusCode>=200&&_.res.statusCode<300||_.res.statusCode===1223}e.isSuccess=L;function g(_){return _.res.statusCode===204}async function t(_){if(!L(_))throw new Error("Server returned "+_.res.statusCode);return g(_)?null:(await C.streamToBuffer(_.stream)).toString()}e.asText=t;async function R(_){if(!L(_))throw new Error("Server returned "+_.res.statusCode);if(g(_))return null;const v=(await C.streamToBuffer(_.stream)).toString();try{return JSON.parse(v)}catch(c){throw c.message+=`:
`+v,c}}e.asJson=R,E.Registry.as(I.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:y.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:y.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:y.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:y.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[y.localize(4,null),y.localize(5,null),y.localize(6,null)],default:"override",description:y.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:y.localize(8,null)}}})}),define(he[189],de([0,1,27,18]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class I{constructor(L){this.service=L}listen(L,g){throw new Error("Invalid listen")}call(L,g,t){switch(g){case"request":return this.service.request(t[0],y.CancellationToken.None).then(async({res:R,stream:_})=>{const P=await m.streamToBuffer(_);return[{statusCode:R.statusCode,headers:R.headers},P]})}throw new Error("Invalid call")}}e.RequestChannel=I;class E{constructor(L){this.channel=L}async request(L,g){return E.request(this.channel,L,g)}static async request(L,g,t){const[R,_]=await L.call("request",[g]);return{res:R,stream:m.bufferToStream(_)}}}e.RequestChannelClient=E}),define(he[190],de([0,1,64,11]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function I(C){return C.protocol==="http:"?process.env.HTTP_PROXY||process.env.http_proxy||null:C.protocol==="https:"&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}async function E(C,L={}){const g=y.parse(C),t=L.proxyUrl||I(g);if(!t)return null;const R=y.parse(t);if(!/^https?:$/.test(R.protocol||""))return null;const _={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:m.isBoolean(L.strictSSL)?L.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((P,v)=>{Z(["http-proxy-agent"],P,v)}))(_):new(await new Promise((P,v)=>{Z(["https-proxy-agent"],P,v)}))(_)}e.getProxyAgent=E}),define(he[191],de([0,1,20,18]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function I(E,C,L){let g=L&&L.get("storage.serviceMachineId",0)||null;if(g)return g;try{const R=(await C.readFile(E.serviceMachineIdResource)).value.toString();g=y.isUUID(R)?R:null}catch(t){g=null}if(!g){g=y.generateUuid();try{await C.writeFile(E.serviceMachineIdResource,m.VSBuffer.fromString(g))}catch(t){}}return L&&L.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=I}),define(he[192],de([0,1,7,6,4,11]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=y.createDecorator("storageService");var L;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(L=e.WillSaveStateReason||(e.WillSaveStateReason={}));var g;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(g=e.StorageScope||(e.StorageScope={}));var t;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(t=e.StorageTarget||(e.StorageTarget={}));class R extends I.Disposable{constructor(){super(...arguments);this._onDidChangeValue=this._register(new m.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new m.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new m.Emitter),this.onWillSaveState=this._onWillSaveState.event,this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}emitDidChangeValue(c,d){d===C?(c===0?this._globalKeyTargets=void 0:c===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:c})):this._onDidChangeValue.fire({scope:c,key:d,target:this.getKeyTargets(c)[d]})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}store(c,d,S,b){if(E.isUndefinedOrNull(d)){this.remove(c,S);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,S,b),this.doStore(c,d,S)})}remove(c,d){this.withPausedEmitters(()=>{this.updateKeyTarget(c,d,void 0),this.doRemove(c,d)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,d){const S=[],b=this.getKeyTargets(c);for(const f of Object.keys(b))b[f]===d&&S.push(f);return S}updateKeyTarget(c,d,S){const b=this.getKeyTargets(d);typeof S=="number"?b[c]!==S&&(b[c]=S,this.doStore(C,JSON.stringify(b),d)):typeof b[c]=="number"&&(delete b[c],this.doStore(C,JSON.stringify(b),d))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(c){return c===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(c){const d=this.get(C,c);if(d)try{return JSON.parse(d)}catch(S){}return Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}flush(){return this._onWillSaveState.fire({reason:L.NONE}),this.doFlush()}}e.AbstractStorageService=R;class _ extends R{constructor(){super(...arguments);this.globalCache=new Map,this.workspaceCache=new Map}getCache(c){return c===0?this.globalCache:this.workspaceCache}get(c,d,S){const b=this.getCache(d).get(c);return E.isUndefinedOrNull(b)?S:b}getBoolean(c,d,S){const b=this.getCache(d).get(c);return E.isUndefinedOrNull(b)?S:b==="true"}getNumber(c,d,S){const b=this.getCache(d).get(c);return E.isUndefinedOrNull(b)?S:parseInt(b,10)}doStore(c,d,S){const b=String(d);this.getCache(S).get(c)!==b&&(this.getCache(S).set(c,b),this.emitDidChangeValue(S,c))}doRemove(c,d){!this.getCache(d).delete(c)||this.emitDidChangeValue(d,c)}logStorage(){P(this.globalCache,this.workspaceCache,"inMemory","inMemory")}async migrate(c){}async doFlush(){}async close(){}}e.InMemoryStorageService=_;async function P(v,c,d,S){const b=i=>{try{return JSON.parse(i)}catch(l){return i}},f=new Map,u=new Map;v.forEach((i,l)=>{f.set(l,i),u.set(l,b(i))});const a=new Map,o=new Map;c.forEach((i,l)=>{a.set(l,i),o.set(l,b(i))}),console.group(`Storage: Global (path: ${d})`);let n=[];f.forEach((i,l)=>{n.push({key:l,value:i})}),console.table(n),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${S})`);let r=[];a.forEach((i,l)=>{r.push({key:l,value:i})}),console.table(r),console.groupEnd(),console.log(o)}e.logStorage=P}),define(he[193],de([0,1,5,36,20,3]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function C(g,t,R,_,P,v,c,d,S){const b=Object.create(null);b["common.machineId"]=v,b.sessionID=I.generateUuid()+Date.now(),b.commitHash=_,b.version=P,b["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=y.PlatformToString(y.platform),b["common.nodePlatform"]=m.platform,b["common.nodeArch"]=R,b["common.product"]=S||"desktop";const f=L(c||[]);f&&(b["common.msftInternal"]=f);let u=0;const a=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),y.isLinuxSnap&&(b["common.snap"]="true");try{const o=await g.readFile(E.URI.file(d));b["common.source"]=o.value.toString().slice(0,30)}catch(o){}return b}e.resolveCommonProperties=C;function L(g){const t=m.env.USERDNSDOMAIN;if(!t)return!1;const R=t.toLowerCase();return g.some(_=>R===_)}}),define(he[194],de([0,1,14,12,4,19]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var C;(function(g){function t(R,_){return R.callstack<_.callstack?-1:R.callstack>_.callstack?1:0}g.compare=t})(C=e.ErrorEvent||(e.ErrorEvent={}));class L{constructor(t,R=L.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new I.DisposableStore,this._telemetryService=t,this._flushDelay=R;const _=m.errorHandler.addListener(P=>this._onErrorEvent(P));this._disposables.add(I.toDisposable(_)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(t){if(!!t){t.detail&&t.detail.stack&&(t=t.detail);let R=Array.isArray(t.stack)?t.stack.join(`
`):t.stack,_=t.message?t.message:E.safeStringify(t);!R||this._enqueue({msg:_,callstack:R})}}_enqueue(t){const R=y.binarySearch(this._buffer,t,C.compare);R<0?(t.count=1,this._buffer.splice(~R,0,t)):(this._buffer[R].count||(this._buffer[R].count=0),this._buffer[R].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let t of this._buffer)this._telemetryService.publicLogError2("UnhandledError",t);this._buffer.length=0}}e.default=L,L.ERROR_FLUSH_TIMEOUT=5*1e3}),define(he[42],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ITelemetryService=void 0,e.ITelemetryService=y.createDecorator("telemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(he[195],de([0,1,23,74,164,21,2,35,77,26,5,3,42,7,53,8,24]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=v.createDecorator(e.ID);async function b(n,r){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],l=new Map,s=new Map,p=2e4;function k(h,A,N,B){const W=A.substring(h.length+1);return new Promise(H=>{E.readdir(A,{withFileTypes:!0},async(K,re)=>{var V,J,ce;if(K){H();return}if(B.count>=p){B.count+=re.length,B.maxReached=!0,H();return}let $=re.length;if($===0){H();return}let O=re;B.count+re.length>p&&(B.maxReached=!0,$=p-B.count,O=re.slice(0,$)),B.count+=re.length;for(const F of O)if(F.isDirectory()){if(N.includes(F.name)||await k(h,C.join(A,F.name),N,B),--$==0){H();return}}else{const j=F.name.lastIndexOf(".");if(j>=0){const Q=F.name.substring(j+1);Q&&l.set(Q,((V=l.get(Q))!==null&&V!==void 0?V:0)+1)}for(const Q of i)((J=Q.relativePathPattern)===null||J===void 0?void 0:J.test(W))!==!1&&Q.filePattern.test(F.name)&&s.set(Q.tag,((ce=s.get(Q.tag))!==null&&ce!==void 0?ce:0)+1);if(--$==0){H();return}}})})}const w={count:0,maxReached:!1};await k(n,n,r,w);const T=await a(n);return{configFiles:f(s),fileTypes:f(l),fileCount:w.count,maxFilesReached:w.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=b;function f(n){return[...c.Iterable.map(n.entries(),([r,i])=>({name:r,count:i}))].sort((r,i)=>i.count-r.count)}function u(){const n={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/S.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/S.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},r=y.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=u;function a(n){let r=new Map,i=C.join(n,".vscode","launch.json");return new Promise((l,s)=>{E.exists(i,p=>{if(p)E.readFile(i,(k,w)=>{if(k)return l([]);const T=[],h=L.parse(w.toString(),T);if(T.length)return console.log(`Unable to parse ${i}`),l([]);if(L.getNodeType(h)==="object"&&h.configurations)for(const A of h.configurations){const N=A.type;N&&(r.has(N)?r.set(N,r.get(N)+1):r.set(N,1))}return l(f(r))});else return l([])})})}e.collectLaunchConfigs=a;let o=class{constructor(r){this.telemetryService=r}formatMachineInfo(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}formatEnvironment(r){const i=[];i.push(`Version:          ${t.default.nameShort} ${t.default.version} (${t.default.commit||"Commit unknown"}, ${t.default.date||"Date unknown"})`),i.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const l=y.cpus();return l&&l.length>0&&i.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),i.push(`Memory (System):  ${(y.totalmem()/S.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/S.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||i.push(`Load (avg):       ${y.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([g.listProcesses(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async l=>{let[s,p]=l,k=this.formatProcessList(r,s);return i.forEach(w=>{if(I.isRemoteDiagnosticError(w))k+=`
${w.errorMessage}`,p+=`
${w.errorMessage}`;else if(k+=`

Remote: ${w.hostName}`,w.processes&&(k+=`
${this.formatProcessList(r,w.processes)}`),w.workspaceMetadata){p+=`
|  Remote: ${w.hostName}`;for(const T of Object.keys(w.workspaceMetadata)){const h=w.workspaceMetadata[T];let A=`${h.fileCount} files`;h.maxFilesReached&&(A=`more than ${A}`),p+=`|    Folder (${T}): ${A}`,p+=this.formatWorkspaceStats(h)}}}),{processInfo:k,workspaceInfo:p}})}async getSystemInfo(r,i){const{memory:l,vmHint:s,os:p,cpus:k}=u(),w={os:p,memory:l,cpus:k,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return R.isWindows||(w.load=`${y.loadavg().map(T=>Math.round(T)).join(", ")}`),R.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(r,i){const l=[];return g.listProcesses(r.mainPID).then(async s=>(l.push(""),l.push(this.formatEnvironment(r)),l.push(""),l.push(this.formatProcessList(r,s)),r.windows.some(p=>p.folderURIs&&p.folderURIs.length>0&&!p.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.formatWorkspaceMetadata(r))),i.forEach(p=>{if(I.isRemoteDiagnosticError(p))l.push(`
${p.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${p.hostName}`),l.push(this.formatMachineInfo(p.machineInfo)),p.processes&&l.push(this.formatProcessList(r,p.processes)),p.workspaceMetadata)for(const k of Object.keys(p.workspaceMetadata)){const w=p.workspaceMetadata[k];let T=`${w.fileCount} files`;w.maxFilesReached&&(T=`more than ${T}`),l.push(`Folder (${k}): ${T}`),l.push(this.formatWorkspaceStats(w))}}),l.push(""),l.push(""),l.join(`
`)))}formatWorkspaceStats(r){const i=[],l=60;let s=0;const p=(h,A)=>{const N=` ${h}(${A})`;s+N.length>l?(i.push(k),k="|                 ",s=k.length):s+=N.length,k+=N};let k="|      File types:";const w=10;let T=r.fileTypes.length>w?w:r.fileTypes.length;for(let h=0;h<T;h++){const A=r.fileTypes[h];p(A.name,A.count)}if(i.push(k),r.configFiles.length>=0&&(k="|      Conf files:",s=0,r.configFiles.forEach(h=>{p(h.name,h.count)}),i.push(k)),r.launchConfigFiles.length>0){let h="|      Launch Configs:";r.launchConfigFiles.forEach(A=>{h+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),i.push(h)}return i.join(`
`)}expandGPUFeatures(r){const i=Math.max(...Object.keys(r).map(l=>l.length));return Object.keys(r).map(l=>`${l}:  ${" ".repeat(i-l.length)}  ${r[l]}`).join(`
                  `)}formatWorkspaceMetadata(r){const i=[],l=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(p=>{const k=_.URI.revive(p);if(k.scheme===d.Schemas.file){const w=k.fsPath;l.push(b(w,["node_modules",".git"]).then(T=>{let h=`${T.fileCount} files`;T.maxFilesReached&&(h=`more than ${h}`),i.push(`|    Folder (${C.basename(w)}): ${h}`),i.push(this.formatWorkspaceStats(T))}).catch(T=>{i.push(`|      Error: Unable to collect workspace stats for folder ${w} (${T.toString()})`)}))}else i.push(`|    Folder (${k.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(r,i){const l=new Map;r.windows.forEach(p=>l.set(p.pid,p.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(r.mainPID,l,s,i,0),s.join(`
`)}formatProcessItem(r,i,l,s,p){const k=p===0;let w;k?w=s.pid===r?`${t.default.applicationName} main`:"remote agent":(w=`${"  ".repeat(p)} ${s.name}`,s.name==="window"&&(w=`${w} (${i.get(s.pid)})`));const T=process.platform==="win32"?s.mem:y.totalmem()*(s.mem/100);l.push(`${s.load.toFixed(0).padStart(5," ")}	${(T/S.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(s.children)&&s.children.forEach(h=>this.formatProcessItem(r,i,l,h,p+1))}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const l=_.URI.revive(i);if(l.scheme===d.Schemas.file){const s=l.fsPath;try{const p=await b(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),p.fileTypes.forEach(k=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:k.name,count:k.count})}),p.launchConfigFiles.forEach(k=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:k.name,count:k.count})}),p.configFiles.forEach(k=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:k.name,count:k.count})})}catch(p){}}}}};o=De([xe(0,P.ITelemetryService)],o),e.DiagnosticsService=o}),define(he[93],de([0,1,12,30,33,19,42,63,58,29,27,16,24,3,52,192,191,7,22]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d,S,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished"})(u||(u={}));function a(...$){return String($.reduce((O,F)=>O|F,0))}var o;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class s{constructor(O=l){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(O,F=this.state.pageSize){return new s(Object.assign(Object.assign({},this.state),{pageNumber:O,pageSize:F}))}withFilter(O,...F){const j=[...this.state.criteria,...F.length?F.map(Q=>({filterType:O,value:Q})):[{filterType:O}]];return new s(Object.assign(Object.assign({},this.state),{criteria:j}))}withSortBy(O){return new s(Object.assign(Object.assign({},this.state),{sortBy:O}))}withSortOrder(O){return new s(Object.assign(Object.assign({},this.state),{sortOrder:O}))}withFlags(...O){return new s(Object.assign(Object.assign({},this.state),{flags:O.reduce((F,j)=>F|j,0)}))}withAssetTypes(...O){return new s(Object.assign(Object.assign({},this.state),{assetTypes:O}))}get raw(){const{criteria:O,pageNumber:F,pageSize:j,sortBy:Q,sortOrder:ne,flags:oe,assetTypes:ie}=this.state;return{filters:[{criteria:O,pageNumber:F,pageSize:j,sortBy:Q,sortOrder:ne}],assetTypes:ie,flags:oe}}get searchText(){const O=this.state.criteria.filter(F=>F.filterType===o.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function p($,O){const F=($||[]).filter(j=>j.statisticName===O)[0];return F?F.value:0}function k($){const O="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(j=>j.assetType.indexOf(O)===0).reduce((j,Q)=>{const ne=A($,Q.assetType);return ne&&j.push([Q.assetType.substring(O.length),ne]),j},[])}function w($){if($.properties){const O=$.properties.filter(Q=>Q.key===n.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),j=O.filter(Q=>F.test(Q.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return A($,n.Repository)}function T($){return{uri:`${$.fallbackAssetUri}/${n.VSIX}?redirect=true`,fallbackUri:`${$.fallbackAssetUri}/${n.VSIX}`}}function h($){const O=A($,n.Icon);if(O)return O;const F=m.DefaultIconPath;return{uri:F,fallbackUri:F}}function A($,O){return $.files.filter(j=>j.assetType===O)[0]?{uri:`${$.assetUri}/${O}`,fallbackUri:`${$.fallbackAssetUri}/${O}`}:null}function N($,O){const F=$.properties?$.properties.filter(Q=>Q.key===O):[],j=F.length>0&&F[0].value;return j?j.split(",").map(Q=>I.adoptToGalleryExtensionId(Q)):[]}function B($){const O=$.properties?$.properties.filter(F=>F.key===r.Engine):[];return O.length>0&&O[0].value||""}function W($){const O=$.properties?$.properties.filter(j=>j.key===r.LocalizedLanguages):[],F=O.length>0&&O[0].value||"";return F?F.split(","):[]}function H($){return $.indexOf("preview")!==-1}function K($){const O=$.properties?$.properties.find(F=>F.key===r.WebExtension):void 0;return!!O&&O.value==="true"}function re($){return $.files.some(O=>O.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?f.joinPath(v.URI.parse($.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function V($,O,F,j,Q){const ne={manifest:A(O,n.Manifest),readme:A(O,n.Details),changelog:A(O,n.Changelog),license:A(O,n.License),repository:w(O),download:T(O),icon:h(O),coreTranslations:k(O)};return{identifier:{id:I.getGalleryExtensionId($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:O.version,date:O.lastUpdated,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,description:$.shortDescription||"",installCount:p($.statistics,"install"),rating:p($.statistics,"averagerating"),ratingCount:p($.statistics,"ratingcount"),assetUri:v.URI.parse(O.assetUri),webResource:re(O),assetTypes:O.files.map(({assetType:oe})=>oe),assets:ne,properties:{dependencies:N(O,r.Dependency),extensionPack:N(O,r.ExtensionPack),engine:B(O),localizedLanguages:W(O),webExtension:K(O)},telemetryData:{index:(j.pageNumber-1)*j.pageSize+F,searchText:j.searchText,querySource:Q},preview:H($.flags)}}let J=class{constructor(O,F,j,Q,ne,oe,ie){this.requestService=O,this.logService=F,this.environmentService=j,this.telemetryService=Q,this.fileService=ne,this.productService=oe;const fe=oe.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=ce(oe.version,this.environmentService,this.fileService,ie)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,F){const j=[];let{total:Q,firstPage:ne,getPage:oe}=await this.query({names:O,pageSize:O.length},F);j.push(...ne);for(let ie=1;j.length<Q&&(ne=await oe(ie,F),ne.length);ie++)j.push(...ne);return j}async getCompatibleExtension(O,F){const j=await this.getCompatibleExtensionByEngine(O,F);return(j==null?void 0:j.properties.webExtension)?j.webResource?j:null:j}async getCompatibleExtensionByEngine(O,F){const j=m.isIExtensionIdentifier(O)?null:O;if(j&&j.properties.engine&&g.isEngineValid(j.properties.engine,this.productService.version))return j;const{id:Q,uuid:ne}=j?j.identifier:O;let oe=new s().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");ne?oe=oe.withFilter(o.ExtensionId,ne):oe=oe.withFilter(o.ExtensionName,Q);const{galleryExtensions:ie}=await this.queryGallery(oe,R.CancellationToken.None),[fe]=ie;if(!fe||!fe.versions.length)return null;if(F){const Pe=fe.versions.filter(Ne=>Ne.version===F)[0];if(Pe){const Ne=V(fe,Pe,0,oe);if(Ne.properties.engine&&g.isEngineValid(Ne.properties.engine,this.productService.version))return Ne}return null}const Ie=await this.getLastValidExtensionVersion(fe,fe.versions);return Ie?V(fe,Ie,0,oe):null}async query(O,F){const j=R.CancellationToken.isCancellationToken(O)?{}:O,Q=R.CancellationToken.isCancellationToken(O)?O:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ne=j.text||"";const oe=E.getOrDefault(j,ye=>ye.pageSize,50);let ie=new s().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,oe).withFilter(o.Target,"Microsoft.VisualStudio.Code");ne?(ne=ne.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,_e,Ce)=>(ie=ie.withFilter(o.Category,Ce||_e),"")),ne=ne.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,_e,Ce)=>(ie=ie.withFilter(o.Tag,Ce||_e),"")),ne=ne.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(o.Featured),"")),ne=ne.trim(),ne&&(ne=ne.length<200?ne:ne.substring(0,200),ie=ie.withFilter(o.SearchText,ne)),ie=ie.withSortBy(0)):j.ids?ie=ie.withFilter(o.ExtensionId,...j.ids):j.names?ie=ie.withFilter(o.ExtensionName,...j.names):ie=ie.withSortBy(4),typeof j.sortBy=="number"&&(ie=ie.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(ie=ie.withSortOrder(j.sortOrder));const{galleryExtensions:fe,total:Ie}=await this.queryGallery(ie,Q),Pe=fe.map((ye,_e)=>V(ye,ye.versions[0],_e,ie,j.source)),Ne=async(ye,_e)=>{if(_e.isCancellationRequested)throw y.canceled();const Ce=ie.withPage(ye+1),{galleryExtensions:ze}=await this.queryGallery(Ce,_e);return ze.map((je,me)=>V(je,je.versions[0],me,Ce,j.source))};return{firstPage:Pe,total:Ie,pageSize:ie.pageSize,getPage:Ne}}async queryGallery(O,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,u.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,a(u.Unpublished));const j=await this.commonHeadersPromise,Q=JSON.stringify(O.raw),ne=Object.assign(Object.assign({},j),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)}),oe=new Date().getTime();let ie,fe,Ie=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:ne},F),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:Ie};const Pe=await L.asJson(ie);if(Pe){const Ne=Pe.results[0],ye=Ne.extensions,_e=Ne.resultMetadata&&Ne.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return Ie=_e&&_e.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:Ie}}return{galleryExtensions:[],total:Ie}}catch(Pe){throw fe=Pe,Pe}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},O.telemetryData),{requestBodySize:String(Q.length),duration:new Date().getTime()-oe,success:!!ie&&L.isSuccess(ie),responseBodySize:ie==null?void 0:ie.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:fe?y.isPromiseCanceledError(fe)?"canceled":y.getErrorMessage(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ie)}))}}async reportStatistic(O,F,j,Q){if(!!this.isEnabled()){const ne=await this.commonHeadersPromise,oe=Object.assign(Object.assign({},ne),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${O}/extensions/${F}/${j}/stats?statType=${Q}`),headers:oe},R.CancellationToken.None)}catch(ie){}}}async download(O,F,j){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const Q=I.getGalleryExtensionTelemetryData(O),ne=new Date().getTime(),oe=Pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},Q),{duration:Pe})),ie=j===1?"install":j===2?"update":"",fe=ie?{uri:`${O.assets.download.uri}&${ie}=true`,fallbackUri:`${O.assets.download.fallbackUri}?${ie}=true`}:O.assets.download,Ie=await this.getAsset(fe);await this.fileService.writeFile(F,Ie.stream),oe(new Date().getTime()-ne)}async getReadme(O,F){if(O.assets.readme){const j=await this.getAsset(O.assets.readme,{},F);return await L.asText(j)||""}return""}async getManifest(O,F){if(O.assets.manifest){const j=await this.getAsset(O.assets.manifest,{},F),Q=await L.asText(j);return Q?JSON.parse(Q):null}return null}async getCoreTranslation(O,F){const j=O.assets.coreTranslations.filter(Q=>Q[0]===F.toUpperCase())[0];if(j){const Q=await this.getAsset(j[1]),ne=await L.asText(Q);return ne?JSON.parse(ne):null}return null}async getChangelog(O,F){if(O.assets.changelog){const j=await this.getAsset(O.assets.changelog,{},F);return await L.asText(j)||""}return""}async getAllVersions(O,F){let j=new s().withFlags(u.IncludeVersions,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");O.identifier.uuid?j=j.withFilter(o.ExtensionId,O.identifier.uuid):j=j.withFilter(o.ExtensionName,O.identifier.id);const Q=[],{galleryExtensions:ne}=await this.queryGallery(j,R.CancellationToken.None);return ne.length&&(F?await Promise.all(ne[0].versions.map(async oe=>{let ie;try{ie=await this.getEngine(oe)}catch(fe){}ie&&g.isEngineValid(ie,this.productService.version)&&Q.push({version:oe.version,date:oe.lastUpdated})})):Q.push(...ne[0].versions.map(oe=>({version:oe.version,date:oe.lastUpdated})))),Q}async getAsset(O,F={},j=R.CancellationToken.None){const Q=await this.commonHeadersPromise,ne={type:"GET"},oe=Object.assign(Object.assign({},Q),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),ne),{headers:oe});const ie=O.uri,fe=O.fallbackUri,Ie=Object.assign(Object.assign({},F),{url:ie});try{const Pe=await this.requestService.request(Ie,j);if(Pe.res.statusCode===200)return Pe;const Ne=await L.asText(Pe);throw new Error(`Expected 200, got back ${Pe.res.statusCode} instead.

${Ne}`)}catch(Pe){if(y.isPromiseCanceledError(Pe))throw Pe;const Ne=y.getErrorMessage(Pe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:Ne});const ye=Object.assign(Object.assign({},F),{url:fe});return this.requestService.request(ye,j)}}async getLastValidExtensionVersion(O,F){const j=this.getLastValidExtensionVersionFromProperties(O,F);return j||this.getLastValidExtensionVersionRecursively(O,F)}getLastValidExtensionVersionFromProperties(O,F){for(const j of F){const Q=B(j);if(!Q)return null;if(g.isEngineValid(Q,this.productService.version))return j}return null}async getEngine(O){const F=B(O);if(F)return F;const j=A(O,n.Manifest);if(!j)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},ne=await this.getAsset(j,{headers:Q}),oe=await L.asJson(ne);if(oe)return oe.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(O,F){if(!F.length)return null;const j=F[0],Q=await this.getEngine(j);return g.isEngineValid(Q,this.productService.version)?(j.properties=j.properties||[],j.properties.push({key:r.Engine,value:Q}),j):this.getLastValidExtensionVersionRecursively(O,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await L.asJson(O),j=new Map;if(F)for(const Q of F.malicious){const ne=j.get(Q)||{id:{id:Q},malicious:!0,slow:!1};ne.malicious=!0,j.set(Q,ne)}return[...j.values()]}};J=De([xe(0,L.IRequestService),xe(1,_.ILogService),xe(2,t.IEnvironmentService),xe(3,C.ITelemetryService),xe(4,P.IFileService),xe(5,c.IProductService),xe(6,b.optional(d.IStorageService))],J),e.ExtensionGalleryService=J;async function ce($,O,F,j){const Q={"X-Market-Client-Id":`VSCode ${$}`,"User-Agent":`VSCode ${$}`},ne=await S.getServiceMachineId(O,F,j);return Q["X-Market-User-Id"]=ne,Q}e.resolveMarketplaceHeaders=ce}),define(he[196],de([0,1,26,154,13,7,34,41,4,19,31]),function(Z,e,y,m,I,E,C,L,g,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let _=class{constructor(c,d){this._configurationService=d,this._experimentProperties={},this._disposables=new g.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp(I.escapeRegExpCharacters(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const b=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(c,d){this._experimentProperties[c]=d}setEnabled(c){this._enabled=c}_updateUserOptIn(){var c;const d=(c=this._configurationService)===null||c===void 0?void 0:c.getValue(P);this._userOptIn=d?d.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let d=c.sessionID,S=c["common.instanceId"],b=c["common.machineId"],f=c["common.msftInternal"];return{sessionId:d,instanceId:S,machineId:b,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(c,d,S){return this.isOptedIn?this._commonProperties.then(b=>{d=t.mixin(d,b),d=t.mixin(d,this._experimentProperties),d=t.cloneAndChange(d,f=>{if(typeof f=="string")return this._cleanupInfo(f,S)}),this._appender.log(c,d)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(c,d,S){return this.publicLog(c,d,S)}publicLogError(c,d){return this.sendErrorTelemetry?this.publicLog(c,d,!0):Promise.resolve(void 0)}publicLogError2(c,d){return this.publicLogError(c,d)}_cleanupInfo(c,d){let S=c;if(d){const b=[];for(let o of this._cleanupPatterns)for(;;){const n=o.exec(c);if(!n)break;b.push([n.index,o.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(S="";;){const o=u.exec(c);if(!o)break;!f.test(o[0])&&b.every(([n,r])=>o.index<n||o.index>=r)&&(S+=c.substring(a,o.index)+"<REDACTED: user-file-path>",a=u.lastIndex)}a<c.length&&(S+=c.substr(a))}for(let b of this._cleanupPatterns)S=S.replace(b,"");return S}};_.IDLE_START_EVENT_NAME="UserIdleStart",_.IDLE_STOP_EVENT_NAME="UserIdleStop",_=De([xe(1,E.optional(C.IConfigurationService))],_),e.TelemetryService=_;const P="telemetry";R.Registry.as(L.Extensions.Configuration).registerConfiguration({id:P,order:110,type:"object",title:m.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:y.default.privacyStatementUrl?m.localize(2,null,y.default.privacyStatementUrl):m.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(he[65],de([0,1,34,19,11]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(P,v){return Promise.resolve(void 0)}publicLog2(P,v){return this.publicLog(P,v)}publicLogError(P,v){return Promise.resolve(void 0)}publicLogError2(P,v){return this.publicLogError(P,v)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})}};function E(...P){return{log:(v,c)=>P.forEach(d=>d.log(v,c)),flush:()=>Promise.all(P.map(v=>v.flush()))}}e.combinedAppender=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(P,v){return v.onDidChangeConfiguration(c=>{c.source!==6&&P.publicLog2("updateConfiguration",{configurationSource:y.ConfigurationTargetToString(c.source),configurationKeys:R(c.sourceConfig)})})}e.configurationTelemetry=C;function L(P){const v=Object.create(null),c=Object.create(null),d=Object.create(null);t(P,d);for(let S in d){S=S.length>150?S.substr(S.length-149):S;const b=d[S];typeof b=="number"?c[S]=b:typeof b=="boolean"?c[S]=b?1:0:typeof b=="string"?v[S]=b.substring(0,1023):typeof b!="undefined"&&b!==null&&(v[S]=b)}return{properties:v,measurements:c}}e.validateTelemetryData=L;function g(P){if(!P)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(d=>{P.indexOf(`${d}+`)===0&&(v=d)}),v}e.cleanRemoteAuthority=g;function t(P,v,c=0,d){if(!!P)for(let S of Object.getOwnPropertyNames(P)){const b=P[S],f=d?d+S:S;Array.isArray(b)?v[f]=m.safeStringify(b):b instanceof Date?v[f]=b.toISOString():I.isObject(b)?c<2?t(b,v,c+1,f+"."):v[f]=m.safeStringify(b):v[f]=b}}function R(P){if(!P)return[];const v=[];return _(v,"",P),v}function _(P,v,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(d=>_(P,v?`${v}.${d}`:d,c[d])):P.push(v)}}),define(he[197],de([0,1,12,19,65]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function E(L){const g=await new Promise((R,_)=>{Z(["applicationinsights"],R,_)});let t;return g.defaultClient?(t=new g.TelemetryClient(L),t.channel.setUseDiskRetryCaching(!0)):(g.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),t=g.defaultClient),L.indexOf("AIF-")===0&&(t.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),t}class C{constructor(g,t,R){this._eventPrefix=g,this._defaultData=t,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(g){if(!!this._aiClient){if(typeof this._aiClient!="string"){g(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=E(this._aiClient)),this._asyncAIClient.then(t=>{g(t)},t=>{y.onUnexpectedError(t),console.error(t)})}}log(g,t){!this._aiClient||(t=m.mixin(t,this._defaultData),t=I.validateTelemetryData(t),this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+g,properties:t.properties,measurements:t.measurements})))}flush(){return this._aiClient?new Promise(g=>{this._withAIClient(t=>{t.flush({callback:()=>{this._aiClient=void 0,g(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=C}),define(he[198],de([0,1,12,194]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class I extends m.default{installErrorListeners(){y.setUnexpectedErrorHandler(L=>console.error(L));const C=[];process.on("unhandledRejection",(L,g)=>{C.push(g),setTimeout(()=>{const t=C.indexOf(g);t>=0&&g.catch(R=>{C.splice(t,1),console.warn(`rejected promise not handled within 1 second: ${R}`),R.stack&&console.warn(`stack trace: ${R.stack}`),y.onUnexpectedError(L)})},1e3)}),process.on("rejectionHandled",L=>{const g=C.indexOf(L);g>=0&&C.splice(g,1)}),process.on("uncaughtException",L=>{y.onUnexpectedError(L)})}}e.default=I}),define(he[94],de([0,1,3,22,7,25]),function(Z,e,y,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=I.createDecorator("contextService");var C;(function(P){P[P.EMPTY=1]="EMPTY",P[P.FOLDER=2]="FOLDER",P[P.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function L(P){const v=P;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=L;function g(P){const v=P;return!!(v&&typeof v=="object"&&y.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=g;class t{constructor(v,c,d,S){this._id=v,this._configuration=d,this._ignorePathCasing=S,this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(v){this._id=v.id,this._configuration=v.configuration,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=t;class R{constructor(v,c){this.raw=c,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return m.joinPath(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function _(P){return new R({uri:P,index:0,name:m.basenameOrAuthority(P)},{uri:P.toString()})}e.toWorkspaceFolder=_}),define(he[199],de([0,1,7,155,94,3,5,2,22,110,35,8,54,28,188]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:m.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(W){return(typeof W=="string"?L.extname(W):g.extname(W))===d}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=y.createDecorator("workspacesService");function b(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function f(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=f;function u(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=u;function a(W){const H=W;return typeof(H==null?void 0:H.id)=="string"&&E.URI.isUri(H.uri)}e.isSingleFolderWorkspaceIdentifier=a;function o(W){if(W.configuration)return{id:W.id,configPath:W.configuration};if(W.folders.length===1)return{id:W.id,uri:W.folders[0].uri}}e.toWorkspaceIdentifier=o;function n(W){const H=W;return typeof(H==null?void 0:H.id)=="string"&&E.URI.isUri(H.configPath)}e.isWorkspaceIdentifier=n;function r(W){if(W==null?void 0:W.uri)return{id:W.id,uri:E.URI.revive(W.uri)};if(W==null?void 0:W.configPath)return{id:W.id,configPath:E.URI.revive(W.configPath)}}e.reviveIdentifier=r;function i(W,H){return g.extUriBiasedIgnorePathCase.isEqualOrParent(W,H.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function l(W){return s(W)||p(W)}e.isStoredWorkspaceFolder=l;function s(W){const H=W;return typeof(H==null?void 0:H.path)=="string"&&(!H.name||typeof H.name=="string")}e.isRawFileWorkspaceFolder=s;function p(W){const H=W;return typeof(H==null?void 0:H.uri)=="string"&&(!H.name||typeof H.name=="string")}e.isRawUriWorkspaceFolder=p;function k(W,H,K,re,V=!C.isWindows,J){if(W.scheme!==re.scheme)return{name:K,uri:W.toString(!0)};let ce=H?void 0:J.relativePath(re,W);if(ce!==void 0)ce.length===0?ce=".":C.isWindows&&W.scheme===_.Schemas.file&&!V&&(ce=ce.replace(/\//g,"\\"));else if(W.scheme===_.Schemas.file)ce=W.fsPath,C.isWindows&&(ce=P.normalizeDriveLetter(ce),V&&(ce=v.toSlashes(ce)));else{if(!J.isEqualAuthority(W.authority,re.authority))return{name:K,uri:W.toString(!0)};ce=W.path}return{name:K,path:ce}}e.getStoredWorkspaceFolder=k;function w(W,H,K){let re=[],V=new Set;const J=K.dirname(H);for(let ce of W){let $=null;if(s(ce))ce.path&&($=K.resolvePath(J,ce.path));else if(p(ce))try{$=E.URI.parse(ce.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(O){console.warn(O)}if($){let O=K.getComparisonKey($);if(!V.has(O)){V.add(O);const F=ce.name||K.basenameOrAuthority($);re.push(new I.WorkspaceFolder({uri:$,name:F,index:re.length},ce))}}}return re}e.toWorkspaceFolders=w;function T(W,H,K,re,V){let J=h(H,W);const ce=V.dirname(H),$=V.dirname(re),O=[],F=A(J.folders);for(const oe of J.folders){const ie=s(oe)?V.resolvePath(ce,oe.path):E.URI.parse(oe.uri);let fe;K?fe=!1:fe=!s(oe)||L.isAbsolute(oe.path),O.push(k(ie,fe,oe.name,$,F,V))}const j={insertSpaces:!1,tabSize:4,eol:C.isLinux||C.isMacintosh?`
`:`\r
`},Q=t.setProperty(W,["folders"],O,j);let ne=t.applyEdits(W,Q);return J.remoteAuthority===c.getRemoteAuthority(re)&&(ne=t.applyEdits(ne,t.removeProperty(ne,["remoteAuthority"],j))),ne}e.rewriteWorkspaceFileForNewLocation=T;function h(W,H){let K=R.parse(H);if(K&&Array.isArray(K.folders))K.folders=K.folders.filter(re=>l(re));else throw new Error(`${W} looks like an invalid workspace file.`);return K}function A(W){return C.isWindows?W.some(H=>s(H)&&H.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function N(W,H){const K={workspaces:[],files:[]};if(W){const re=function(J,ce){for(let $=0;$<J.length;$++)try{ce(J[$],$)}catch(O){H.warn(`Error restoring recent entry ${JSON.stringify(J[$])}: ${O.toString()}. Skip entry.`)}},V=W;Array.isArray(V.workspaces3)&&re(V.workspaces3,(J,ce)=>{const $=Array.isArray(V.workspaceLabels)&&V.workspaceLabels[ce]||void 0;typeof J=="object"&&typeof J.id=="string"&&typeof J.configURIPath=="string"?K.workspaces.push({label:$,workspace:{id:J.id,configPath:E.URI.parse(J.configURIPath)}}):typeof J=="string"&&K.workspaces.push({label:$,folderUri:E.URI.parse(J)})}),Array.isArray(V.files2)&&re(V.files2,(J,ce)=>{const $=Array.isArray(V.fileLabels)&&V.fileLabels[ce]||void 0;typeof J=="string"&&K.files.push({label:$,fileUri:E.URI.parse(J)})})}return K}e.restoreRecentlyOpened=N;function B(W){const H={workspaces3:[],files2:[]};let K=!1;const re=[];for(const J of W.workspaces)f(J)?H.workspaces3.push(J.folderUri.toString()):H.workspaces3.push({id:J.workspace.id,configURIPath:J.workspace.configPath.toString()}),re.push(J.label||null),K=K||!!J.label;K&&(H.workspaceLabels=re),K=!1;const V=[];for(const J of W.files)H.files2.push(J.fileUri.toString()),V.push(J.label||null),K=K||!!J.label;return K&&(H.fileLabels=V),H}e.toStoreData=B}),define(he[95],de([0,1,6,17]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function I(C){let L=0,g=0,t=0;C>=1e3&&(t=Math.floor(C/1e3),C-=t*1e3),t>=60&&(g=Math.floor(t/60),t-=g*60),g>=60&&(L=Math.floor(g/60),g-=L*60);const R=L?`${L}h`:"",_=g?`${g}m`:"",P=t?`${t}s`:"",v=C?`${C}ms`:"";return`${R}${_}${P}${v}`}e.printTime=I;class E{constructor(L,g,t,R){this._logService=L,this._reconnectionToken=g,this._onClose=new y.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=t,this.protocol=R,this._disposed=!1,this._disconnectRunner1=new m.RunOnceScheduler(()=>{this._log(`The reconnection grace time of ${I(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new m.RunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${I(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${I(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(L){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${L}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${I(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(!this._disposed){this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const L=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),L.end(),this._onClose.fire(void 0)}}acceptReconnection(L,g,t){this._remoteAddress=L,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(g,t),this.protocol.endAcceptReconnection()}}e.ManagementConnection=E}),define(he[96],de([0,1,21,8,2,122,26]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const L=I.join(m.FileAccess.asFileUri("",Z).fsPath,"nls.metadata.json"),g=new Map;function t(P){return new Promise(v=>y.exists(P,v))}function R(P,v){return t(L).then(c=>{if(!c||!C.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let d=`${P}||${v}`,S=g.get(d);return S||(S=E.getNLSConfiguration(C.default.commit,v,L,P).then(b=>(_.is(b)&&(b._languagePackSupport=!0),b)),g.set(d,S)),S})}e.getNLSConfiguration=R;var _;(function(P){function v(c){let d=c;return d&&typeof d._languagePackId=="string"}P.is=v})(_=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(he[38],de([0,1,55,8]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createRemoteURITransformer=e.uriTransformerPath=void 0,e.uriTransformerPath=m.FileAccess.asFileUri("vs/server/uriTransformer.js",Z).fsPath;function I(E){const L=Z.__$__nodeRequire(e.uriTransformerPath)(E);return new y.URITransformer(L)}e.createRemoteURITransformer=I}),define(he[200],de([0,1,6,4,3,38,61,18,2,27]),function(Z,e,y,m,I,E,C,L,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemChannel=void 0;class R extends m.Disposable{constructor(v,c,d,S){super();this.logService=v,this.environmentService=c,this.uriTransformer=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new C.DiskFileSystemProvider(this.logService,{watcher:this.getWatcherOptions()})),this.registerListeners(S)}registerListeners(v){const c=this._register(new y.Emitter);this._register(c.event(d=>{v.fire(d.map(S=>({resource:this.uriTransformer.transformOutgoingURI(S.resource),type:S.type})))})),this._register(this.fileWatcher.onDidChangeFile(d=>c.fire(d))),this._register(this.fileWatcher.onDidErrorOccur(d=>v.fire(d)))}getWatcherOptions(){const v=this.environmentService.args.fileWatcherPolling,c=Number(v);if(c>0)return{usePolling:!0,pollingInterval:c}}watch(v,c,d){const S=I.URI.revive(this.uriTransformer.transformIncoming(c));return this.environmentService.extensionsPath&&(d.excludes=[...d.excludes||[],g.posix.join(this.environmentService.extensionsPath,"**")]),this.watcherRequests.set(v,this.fileWatcher.watch(S,d)),m.toDisposable(()=>{m.dispose(this.watcherRequests.get(v)),this.watcherRequests.delete(v)})}dispose(){super.dispose(),this.watcherRequests.forEach(v=>m.dispose(v)),this.watcherRequests.clear()}}class _ extends m.Disposable{constructor(v,c){super();this.logService=v,this.environmentService=c,this.BUFFER_SIZE=256*1024,this.uriTransformerCache=new Map,this.fileWatchers=new Map,this.fsProvider=this._register(new C.DiskFileSystemProvider(this.logService,{bufferSize:this.BUFFER_SIZE})),this.watchRequests=new Map}call(v,c,d){const S=this.getUriTransformer(v.remoteAuthority);switch(c){case"stat":return this.stat(S,d[0]);case"readdir":return this.readdir(S,d[0]);case"open":return this.open(S,d[0],d[1]);case"close":return this.close(d[0]);case"read":return this.read(d[0],d[1],d[2]);case"readFile":return this.readFile(S,d[0]);case"write":return this.write(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.writeFile(S,d[0],d[1],d[2]);case"rename":return this.rename(S,d[0],d[1],d[2]);case"copy":return this.copy(S,d[0],d[1],d[2]);case"mkdir":return this.mkdir(S,d[0]);case"delete":return this.delete(S,d[0],d[1]);case"watch":return Promise.resolve(this.watch(d[0],d[1],d[2],d[3]));case"unwatch":return Promise.resolve(this.unwatch(d[0],d[1]))}throw new Error(`IPC Command ${c} not found`)}listen(v,c,d){const S=this.getUriTransformer(v.remoteAuthority);switch(c){case"filechange":return this.onFileChange(S,d[0]);case"readFileStream":return this.onReadFileStream(S,d[0],d[1])}throw new Error(`Unknown event ${c}`)}onFileChange(v,c){const d=new y.Emitter({onFirstListenerAdd:()=>{this.fileWatchers.set(c,new R(this.logService,this.environmentService,v,d))},onLastListenerRemove:()=>{m.dispose(this.fileWatchers.get(c)),this.fileWatchers.delete(c)}});return d.event}onReadFileStream(v,c,d){const S=this.transformIncoming(v,c,!0),b=new t.CancellationTokenSource,f=new y.Emitter({onLastListenerRemove:()=>{b.cancel()}}),u=this.fsProvider.readFileStream(S,d,b.token);return u.on("data",a=>f.fire(L.VSBuffer.wrap(a))),u.on("error",a=>f.fire(a)),u.on("end",()=>{f.fire("end"),f.dispose(),b.dispose()}),f.event}getUriTransformer(v){let c=this.uriTransformerCache.get(v);return c||(c=E.createRemoteURITransformer(v),this.uriTransformerCache.set(v,c)),c}stat(v,c){const d=this.transformIncoming(v,c,!0);return this.fsProvider.stat(d)}readdir(v,c){const d=this.transformIncoming(v,c);return this.fsProvider.readdir(d)}open(v,c,d){const S=this.transformIncoming(v,c,!0);return this.fsProvider.open(S,d)}close(v){return this.fsProvider.close(v)}async read(v,c,d){const S=L.VSBuffer.alloc(d),b=0,f=await this.fsProvider.read(v,c,S.buffer,b,d);return[S,f]}async readFile(v,c){const d=this.transformIncoming(v,c,!0),S=await this.fsProvider.readFile(d);return L.VSBuffer.wrap(S)}write(v,c,d,S,b){return this.fsProvider.write(v,c,d.buffer,S,b)}writeFile(v,c,d,S){const b=this.transformIncoming(v,c);return this.fsProvider.writeFile(b,d.buffer,S)}rename(v,c,d,S){const b=I.URI.revive(v.transformIncoming(c)),f=I.URI.revive(v.transformIncoming(d));return this.fsProvider.rename(b,f,S)}copy(v,c,d,S){const b=this.transformIncoming(v,c),f=this.transformIncoming(v,d);return this.fsProvider.copy(b,f,S)}mkdir(v,c){const d=this.transformIncoming(v,c);return this.fsProvider.mkdir(d)}delete(v,c,d){const S=this.transformIncoming(v,c);return this.fsProvider.delete(S,d)}transformIncoming(v,c,d=!1){if(d&&c.path==="/vscode-resource"&&c.query){const S=JSON.parse(c.query).requestResourcePath;return I.URI.from({scheme:"file",path:S})}return I.URI.revive(v.transformIncoming(c))}watch(v,c,d,S){const b=v+c,f=this.fileWatchers.get(v);if(f){const u=f.watch(c,d,S);this.watchRequests.set(b,u)}}unwatch(v,c){const d=v+c,S=this.watchRequests.get(d);S&&(m.dispose(S),this.watchRequests.delete(d))}dispose(){super.dispose(),this.watchRequests.forEach(v=>m.dispose(v)),this.watchRequests.clear(),this.fileWatchers.forEach(v=>m.dispose(v)),this.fileWatchers.clear()}}e.RemoteAgentFileSystemChannel=_}),define(he[201],de([0,1,21,64,48,234,62,28,121,5,3,38,26,2,8,20]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const S={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function b(o,n,r,i){n.writeHead(r,{"Content-Type":"text/plain"}),n.end(i)}e.serveError=b;async function f(o,n,r,i,l=Object.create(null)){try{const s=await I.promisify(y.stat)(i),p=`W/"${[s.ino,s.size,s.mtime.getTime()].join("-")}"`;if(n.headers["if-none-match"]===p)return r.writeHead(304),r.end();l["Content-Type"]=S[v.extname(i)]||g.getMediaMime(i)||"text/plain",l.Etag=p,r.writeHead(200,l),y.createReadStream(i).pipe(r)}catch(s){return s.code!=="ENOENT"&&(o.error(s),console.error(s.toString())),r.writeHead(404,{"Content-Type":"text/plain"}),r.end("Not found")}}e.serveFile=f;const u=v.dirname(c.FileAccess.asFileUri("",Z).fsPath);class a{constructor(n,r,i){this._connectionToken=n,this._environmentService=r,this._logService=i,this._webviewEndpoint="https://{{uuid}}.vscode-webview-test.com/{{commit}}",this._mapCallbackUriToRequestId=new Map}async handle(n,r,i){try{const l=i.pathname;return l==="/favicon.ico"||l==="/manifest.json"||l==="/code-192.png"||l==="/code-512.png"?f(this._logService,n,r,v.join(u,"resources","server",l.substr(1))):/^\/static\//.test(l)?this._handleStatic(n,r,i):l==="/"?this._handleRoot(n,r,i):l==="/callback"?this._handleCallback(n,r,i):l==="/fetch-callback"?this._handleFetchCallback(n,r,i):b(n,r,404,"Not found.")}catch(l){return this._logService.error(l),console.error(l.toString()),b(n,r,500,"Internal Server Error.")}}_hasCorrectTokenCookie(n){return E.parse(n.headers.cookie||"")["vscode-tkn"]===this._connectionToken}async _handleStatic(n,r,i){const l=Object.create(null),s=decodeURIComponent(i.pathname),p=v.normalize(s.substr("/static/".length)),k=v.join(u,p);return L.isEqualOrParent(k,u,!t.isLinux)?f(this._logService,n,r,k,l):b(n,r,400,"Bad request.")}async _handleRoot(n,r,i){if(!n.headers.host)return b(n,r,400,"Bad request.");const l=i.query.tkn;if(typeof l=="string"){const H=Object.create(null);H["Set-Cookie"]=E.serialize("vscode-tkn",l,{sameSite:"strict",maxAge:60*60*24*7});const K=Object.create(null);for(let V in i.query)V!=="tkn"&&(K[V]=i.query[V]);const re=m.format({pathname:"/",query:K});return H.Location=re,r.writeHead(302,H),r.end()}if(this._environmentService.isBuilt&&!this._hasCorrectTokenCookie(n))return b(n,r,403,"Forbidden.");const s=n.headers.host,p=_.createRemoteURITransformer(s),{workspacePath:k,isFolder:w}=await this._getWorkspaceFromCLI();function T(H){return H.replace(/"/g,"&quot;")}let h;this._environmentService.driverHandle&&(h=!1);const A=c.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",Z).fsPath,N=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:d.generateUuid(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,B=(await I.promisify(y.readFile)(A)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",T(JSON.stringify({folderUri:k&&w?p.transformOutgoing(R.URI.file(k)):void 0,workspaceUri:k&&!w?p.transformOutgoing(R.URI.file(k)):void 0,remoteAuthority:s,webviewEndpoint:this._webviewEndpoint,_wrapWebWorkerExtHostInIframe:h,driver:this._environmentService.driverHandle==="web"?!0:void 0,settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>N?T(JSON.stringify(N)):""),W=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' 'unsafe-eval' https://az416426.vo.msecnd.net ${this._getScriptCspHashes(B).join(" ")} 'sha256-O98pkmgtvUCQGVoddaGy891K52PVRnySDRxRszVLPNQ=' http://${s};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview-test.com https://vscodeweb.azureedge.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ");return r.writeHead(200,{"Content-Type":"text/html","Set-Cookie":E.serialize("vscode-tkn",this._connectionToken,{sameSite:"strict",maxAge:60*60*24*7}),"Content-Security-Policy":W}),r.end(B)}_getScriptCspHashes(n){const r=/<script>([\s\S]+?)<\/script>/img,i=[];let l;for(;l=r.exec(n);){const s=C.createHash("sha256"),p=l[1].replace(/\r\n/g,`
`),k=s.update(Buffer.from(p)).digest().toString("base64");i.push(`'sha256-${k}'`)}return i}async _getWorkspaceFromCLI(){const n=process.env.VSCODE_CWD||process.cwd(),r=this._environmentService.args.workspace;if(r&&r.length>0){const l=L.sanitizeFilePath(r,n);if(await I.promisify(y.exists)(l))return{workspacePath:l}}const i=this._environmentService.args.folder;if(i&&i.length>0){const l=L.sanitizeFilePath(i,n);if(await I.promisify(y.exists)(l))return{workspacePath:l,isFolder:!0}}return{}}_getFirstQueryValue(n,r){const i=n.query[r];return Array.isArray(i)?i[0]:i}_getFirstQueryValues(n,r){const i=new Map;for(const l in n.query)if(!(r&&r.indexOf(l)>=0)){const s=this._getFirstQueryValue(n,l);typeof s=="string"&&i.set(l,s)}return i}async _handleCallback(n,r,i){const l=["vscode-requestId","vscode-scheme","vscode-authority","vscode-path","vscode-query","vscode-fragment"],[s,p,k,w,T,h]=l.map(B=>{const W=this._getFirstQueryValue(i,B);return W&&decodeURIComponent(W)});if(!s)return r.writeHead(400,{"Content-Type":"text/plain"}),r.end("Bad request.");let A=T,N=0;return this._getFirstQueryValues(i,l).forEach((B,W)=>{A||(A=""),A+=`${N++==0?"":"&"}${W}=${B}`}),this._mapCallbackUriToRequestId.set(s,R.URI.from({scheme:p||P.default.urlProtocol,authority:k,path:w,query:A,fragment:h}).toJSON()),f(this._logService,n,r,c.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",Z).fsPath,{"Content-Type":"text/html"})}async _handleFetchCallback(n,r,i){const l=this._getFirstQueryValue(i,"vscode-requestId");if(!l)return r.writeHead(400,{"Content-Type":"text/plain"}),r.end("Bad request.");const s=this._mapCallbackUriToRequestId.get(l);return s&&this._mapCallbackUriToRequestId.delete(l),r.writeHead(200,{"Content-Type":"text/json"}),r.end(JSON.stringify(s))}}e.WebClientServer=a}),define(he[202],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=y.createDecorator("IExtHostRpcService");class m{constructor(E){this.getProxy=E.getProxy.bind(E),this.set=E.set.bind(E),this.assertRegistered=E.assertRegistered.bind(E),this.drain=E.drain.bind(E)}}e.ExtHostRpcService=m}),define(he[97],de([0,1,45,20,8,2,5,49]),function(Z,e,y,m,I,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.NotebookCellsChangeType=e.addIdToOutput=e.isTransformedDisplayOutput=e.MimeTypeRendererResolver=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellOutputKind=e.CellKind=void 0;var g;(function(T){T[T.Markdown=1]="Markdown",T[T.Code=2]="Code"})(g=e.CellKind||(e.CellKind={}));var t;(function(T){T[T.Text=1]="Text",T[T.Error=2]="Error",T[T.Rich=3]="Rich"})(t=e.CellOutputKind||(e.CellOutputKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,runnable:!0,cellEditable:!0,cellRunnable:!0,cellHasExecutionOrder:!0,displayOrder:e.NOTEBOOK_DISPLAY_ORDER,custom:{},runState:R.Idle,languages:[],trusted:!0};var _;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle",T[T.Success=3]="Success",T[T.Error=4]="Error"})(_=e.NotebookCellRunState||(e.NotebookCellRunState={}));var P;(function(T){T[T.Core=0]="Core",T[T.Active=1]="Active",T[T.Lazy=2]="Lazy"})(P=e.MimeTypeRendererResolver||(e.MimeTypeRendererResolver={}));function v(T){return T.outputKind===t.Rich&&!!T.outputId}e.isTransformedDisplayOutput=v;const c=(T,h=m.generateUuid())=>T.outputKind===t.Rich?Object.assign(Object.assign({},T),{outputId:h}):T;e.addIdToOutput=c;var d;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.CellClearOutput=3]="CellClearOutput",T[T.CellsClearOutput=4]="CellsClearOutput",T[T.ChangeLanguage=5]="ChangeLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.ChangeCellContent=9]="ChangeCellContent",T[T.ChangeDocumentMetadata=10]="ChangeDocumentMetadata",T[T.Unknown=11]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var S;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.OutputsSplice=6]="OutputsSplice",T[T.Move=7]="Move",T[T.Unknown=8]="Unknown",T[T.CellContent=9]="CellContent"})(S=e.CellEditType||(e.CellEditType={}));function b(T){const h=f.parse(T);return h?h.notebook.toString():T.toString()}e.getCellUndoRedoComparisonKey=b;var f;(function(T){T.scheme=I.Schemas.vscodeNotebookCell;const h=/^ch(\d{7,})/;function A(H,K){return H.with({scheme:T.scheme,fragment:`ch${K.toString().padStart(7,"0")}${H.scheme!==I.Schemas.file?H.scheme:""}`})}T.generate=A;function N(H){if(H.scheme===T.scheme){const K=h.exec(H.fragment);if(!!K)return{handle:Number(K[1]),notebook:H.with({scheme:H.fragment.substr(K[0].length)||I.Schemas.file,fragment:null})}}}T.parse=N;function B(H,K){return H.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${K.toString().padStart(7,"0")}${H.scheme!==I.Schemas.file?H.scheme:""}`})}T.generateCellMetadataUri=B;function W(H){if(H.scheme===I.Schemas.vscodeNotebookCellMetadata){const K=h.exec(H.fragment);if(!!K)return{handle:Number(K[1]),notebook:H.with({scheme:H.fragment.substr(K[0].length)||I.Schemas.file,fragment:null})}}}T.parseCellMetadataUri=W})(f=e.CellUri||(e.CellUri={}));function u(T){return["application/json","text/markdown","image/png","text/plain"].indexOf(T)>-1}e.mimeTypeIsAlwaysSecure=u;function a(T){return["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain","text/x-javascript"].indexOf(T)>-1}e.mimeTypeSupportedByCore=a;function o(T,h){return C.isWindows&&(T=T.replace(/\//g,"\\"),h=h.replace(/\//g,"\\")),y.match(T,h)}function n(T,h,A,N){let B=0;for(let W=0;W<h.length;W++){if(o(h[W],T))return B;B++}for(let W=0;W<A.length;W++){if(o(A[W],T))return B;B++}for(let W=0;W<N.length;W++){if(o(N[W],T))return B;B++}return B}function r(T,h,A,N){return T.sort((W,H)=>n(W,h,A,N)-n(H,h,A,N))}e.sortMimeTypes=r;function i(T,h,A,N=(B,W)=>B===W){const B=[];function W(re,V,J){if(!(V===0&&J.length===0)){const ce=B[B.length-1];ce&&ce.start+ce.deleteCount===re?(ce.deleteCount+=V,ce.toInsert.push(...J)):B.push({start:re,deleteCount:V,toInsert:J})}}let H=0,K=0;for(;;){if(H===T.length){W(H,0,h.slice(K));break}if(K===h.length){W(H,T.length-H,[]);break}const re=T[H],V=h[K];if(N(re,V)){H+=1,K+=1;continue}A(V)?(W(H,1,[]),H+=1):(W(H,0,[V]),K+=1)}return B}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new L.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new L.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var l;(function(T){T.default="default",T.option="option"})(l=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(T){const h=T;return!!((typeof h.include=="string"||y.isRelativePattern(h.include))&&(typeof h.exclude=="string"||y.isRelativePattern(h.exclude)))}e.isDocumentExcludePattern=s;function p(T,h,A){if(Array.isArray(T.viewType)&&T.viewType.indexOf(h)>=0||T.viewType===h)return!0;if(T.filenamePattern){let N=s(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,B=s(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(y.match(N,E.basename(A.fsPath).toLowerCase()))return!(B&&y.match(B,E.basename(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=p;class k{constructor(h){this.textModel=h}getElements(){const h=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)h[A]=this.textModel.cells[A].getHashValue();return h}}e.CellSequence=k,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var w;(function(T){T[T.LEFT=0]="LEFT",T[T.RIGHT=1]="RIGHT"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}))});var ft=this&&this.__classPrivateFieldSet||function(Z,e,y){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,y),y},it=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(he[98],de([0,1,14,12,71,25,11,3,20,24,92,97]),function(Z,e,y,m,I,E,C,L,g,t,R,_){"use strict";var P,v,c,d,S,b,f,u,a,o,n,r,i,l,s,p,k,w,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TestState=e.TestMessageSeverity=e.TestRunState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.CellOutputKind=e.CellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTrigger=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function h(z){function M(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(M,z),Object.setPrototypeOf(M.prototype,z.prototype),M}let A=b=class{constructor(M){P.set(this,void 0),ft(this,P,M)}static from(...M){let te=M;return new b(function(){if(te){for(const be of te)be&&typeof be.dispose=="function"&&be.dispose();te=void 0}})}dispose(){typeof it(this,P)=="function"&&(it(this,P).call(this),ft(this,P,void 0))}};P=new WeakMap,A=b=De([h],A),e.Disposable=A;let N=f=class{constructor(M,te){if(M<0)throw m.illegalArgument("line must be non-negative");if(te<0)throw m.illegalArgument("character must be non-negative");this._line=M,this._character=te}static Min(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let be=1;be<M.length;be++){const Me=M[be];Me.isBefore(te)&&(te=Me)}return te}static Max(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let be=1;be<M.length;be++){const Me=M[be];Me.isAfter(te)&&(te=Me)}return te}static isPosition(M){if(!M)return!1;if(M instanceof f)return!0;let{line:te,character:be}=M;return typeof te=="number"&&typeof be=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,te=0){if(M===null||te===null)throw m.illegalArgument();let be;return typeof M=="undefined"?be=0:typeof M=="number"?be=M:(be=typeof M.lineDelta=="number"?M.lineDelta:0,te=typeof M.characterDelta=="number"?M.characterDelta:0),be===0&&te===0?this:new f(this.line+be,this.character+te)}with(M,te=this.character){if(M===null||te===null)throw m.illegalArgument();let be;return typeof M=="undefined"?be=this.line:typeof M=="number"?be=M:(be=typeof M.line=="number"?M.line:this.line,te=typeof M.character=="number"?M.character:this.character),be===this.line&&te===this.character?this:new f(be,te)}toJSON(){return{line:this.line,character:this.character}}};N=f=De([h],N),e.Position=N;let B=u=class{constructor(M,te,be,Me){let Ge,Ye;if(typeof M=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Me=="number"?(Ge=new N(M,te),Ye=new N(be,Me)):M instanceof N&&te instanceof N&&(Ge=M,Ye=te),!Ge||!Ye)throw new Error("Invalid arguments");Ge.isBefore(Ye)?(this._start=Ge,this._end=Ye):(this._start=Ye,this._end=Ge)}static isRange(M){return M instanceof u?!0:M?N.isPosition(M.start)&&N.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof u?this.contains(M._start)&&this.contains(M._end):M instanceof N?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const te=N.Max(M.start,this._start),be=N.Min(M.end,this._end);if(!te.isAfter(be))return new u(te,be)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const te=N.Min(M.start,this._start),be=N.Max(M.end,this.end);return new u(te,be)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,te=this.end){if(M===null||te===null)throw m.illegalArgument();let be;return M?N.isPosition(M)?be=M:(be=M.start||this.start,te=M.end||this.end):be=this.start,be.isEqual(this._start)&&te.isEqual(this.end)?this:new u(be,te)}toJSON(){return[this.start,this.end]}};B=u=De([h],B),e.Range=B;let W=a=class extends B{constructor(M,te,be,Me){let Ge,Ye;if(typeof M=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Me=="number"?(Ge=new N(M,te),Ye=new N(be,Me)):M instanceof N&&te instanceof N&&(Ge=M,Ye=te),!Ge||!Ye)throw new Error("Invalid arguments");super(Ge,Ye);this._anchor=Ge,this._active=Ye}static isSelection(M){return M instanceof a?!0:M?B.isRange(M)&&N.isPosition(M.anchor)&&N.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=a=De([h],W),e.Selection=W;class H{constructor(M,te,be){if(typeof M!="string"||M.length===0)throw m.illegalArgument("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw m.illegalArgument("port");if(typeof be!="undefined"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z\-]+$/.test(be)))throw m.illegalArgument("connectionToken");this.host=M,this.port=Math.round(te),this.connectionToken=be}}e.ResolvedAuthority=H;class K extends Error{constructor(M,te=R.RemoteAuthorityResolverErrorCode.Unknown,be){super(M);this._message=M,this._code=te,this._detail=be,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,K.prototype)}static NotAvailable(M,te){return new K(M,R.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(M){return new K(M,R.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=K;var re;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var V;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=o=class{constructor(M,te){this._range=M,this._newText=te}static isTextEdit(M){return M instanceof o?!0:M?B.isRange(M)&&typeof M.newText=="string":!1}static replace(M,te){return new o(M,te)}static insert(M,te){return o.replace(new B(M,M),te)}static delete(M){return o.replace(M,"")}static setEndOfLine(M){const te=new o(new B(new N(0,0),new N(0,0)),"");return te.newEol=M,te}get range(){return this._range}set range(M){if(M&&!B.isRange(M))throw m.illegalArgument("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw m.illegalArgument("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw m.illegalArgument("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};J=o=De([h],J),e.TextEdit=J;var ce;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell"})(ce=e.FileEditType||(e.FileEditType={}));let $=class{constructor(){this._edits=new Array}_allEntries(){return this._edits}renameFile(M,te,be,Me){this._edits.push({_type:1,from:M,to:te,options:be,metadata:Me})}createFile(M,te,be){this._edits.push({_type:1,from:void 0,to:M,options:te,metadata:be})}deleteFile(M,te,be){this._edits.push({_type:1,from:M,to:void 0,options:te,metadata:be})}replaceNotebookMetadata(M,te,be){this._edits.push({_type:3,metadata:be,uri:M,edit:{editType:5,metadata:Object.assign(Object.assign({},_.notebookDocumentMetadataDefaults),te)},notebookMetadata:te})}replaceNotebookCells(M,te,be,Me,Ge){(te!==be||Me.length>0)&&this._edits.push({_type:3,metadata:Ge,uri:M,edit:{editType:1,index:te,count:be-te,cells:Me.map(Ye=>Object.assign(Object.assign({},Ye),{outputs:Ye.outputs.map(Je=>_.addIdToOutput(Je))}))}})}replaceNotebookCellOutput(M,te,be,Me){this._edits.push({_type:3,metadata:Me,uri:M,edit:{editType:2,index:te,outputs:be.map(Ge=>Et.isNotebookCellOutput(Ge)?_.addIdToOutput(Ge.toJSON()):_.addIdToOutput(Ge))}})}replaceNotebookCellMetadata(M,te,be,Me){this._edits.push({_type:3,metadata:Me,uri:M,edit:{editType:3,index:te,metadata:be}})}replace(M,te,be,Me){this._edits.push({_type:2,uri:M,edit:new J(te,be),metadata:Me})}insert(M,te,be,Me){this.replace(M,new B(te,te),be,Me)}delete(M,te,be){this.replace(M,te,"",be)}has(M){return this._edits.some(te=>te._type===2&&te.uri.toString()===M.toString())}set(M,te){if(te)for(const be of te)be&&this._edits.push({_type:2,uri:M,edit:be});else{for(let be=0;be<this._edits.length;be++){const Me=this._edits[be];Me._type===2&&Me.uri.toString()===M.toString()&&(this._edits[be]=void 0)}y.coalesceInPlace(this._edits)}}get(M){const te=[];for(let be of this._edits)be._type===2&&be.uri.toString()===M.toString()&&te.push(be.edit);return te}entries(){const M=new E.ResourceMap;for(let te of this._edits)if(te._type===2){let be=M.get(te.uri);be||(be=[te.uri,[]],M.set(te.uri,be)),be[1].push(te.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};$=De([h],$),e.WorkspaceEdit=$;let O=n=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof n?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=n._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,te=this._tabstop++){if(typeof M=="function"){const be=new n;be._tabstop=this._tabstop,M(be),this._tabstop=be._tabstop,M=be.value}else M=n._escape(M);return this.value+="${",this.value+=te,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,te=this._tabstop++){const be=M.map(Me=>Me.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(M,te){if(typeof te=="function"){const be=new n;be._tabstop=this._tabstop,te(be),this._tabstop=be._tabstop,te=be.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,te&&(this.value+=":",this.value+=te),this.value+="}",this}};O=n=De([h],O),e.SnippetString=O;var F;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(F=e.DiagnosticTag||(e.DiagnosticTag={}));var j;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(j=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Q=r=class{constructor(M,te){if(this.uri=M,te)if(te instanceof B)this.range=te;else if(te instanceof N)this.range=new B(te,te);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof r?!0:M?B.isRange(M.range)&&L.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Q=r=De([h],Q),e.Location=Q;let ne=class{constructor(M,te){this.location=M,this.message=te}static is(M){return M?typeof M.message=="string"&&M.location&&B.isRange(M.location.range)&&L.URI.isUri(M.location.uri):!1}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.location.range.isEqual(te.location.range)&&M.location.uri.toString()===te.location.uri.toString()}};ne=De([h],ne),e.DiagnosticRelatedInformation=ne;let oe=class{constructor(M,te,be=j.Error){if(!B.isRange(M))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=M,this.message=te,this.severity=be}toJSON(){return{severity:j[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.severity===te.severity&&M.code===te.code&&M.severity===te.severity&&M.source===te.source&&M.range.isEqual(te.range)&&y.equals(M.tags,te.tags)&&y.equals(M.relatedInformation,te.relatedInformation,ne.isEqual)}};oe=De([h],oe),e.Diagnostic=oe;let ie=class{constructor(M,te){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:I.isMarkdownString(M)?this.contents=[M]:this.contents=[M],this.range=te}};ie=De([h],ie),e.Hover=ie;var fe;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(fe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ie=class{constructor(M,te=fe.Text){this.range=M,this.kind=te}toJSON(){return{range:this.range,kind:fe[this.kind]}}};Ie=De([h],Ie),e.DocumentHighlight=Ie;var Pe;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Pe=e.SymbolKind||(e.SymbolKind={}));var Ne;(function(z){z[z.Deprecated=1]="Deprecated"})(Ne=e.SymbolTag||(e.SymbolTag={}));let ye=i=class{constructor(M,te,be,Me,Ge){this.name=M,this.kind=te,this.containerName=Ge,typeof be=="string"&&(this.containerName=be),Me instanceof Q?this.location=Me:be instanceof B&&(this.location=new Q(Me,be)),i.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Pe[this.kind],location:this.location,containerName:this.containerName}}};ye=i=De([h],ye),e.SymbolInformation=ye;let _e=l=class{constructor(M,te,be,Me,Ge){this.name=M,this.detail=te,this.kind=be,this.range=Me,this.selectionRange=Ge,this.children=[],l.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(l.validate)}};_e=l=De([h],_e),e.DocumentSymbol=_e;var Ce;(function(z){z[z.Automatic=1]="Automatic",z[z.Manual=2]="Manual"})(Ce=e.CodeActionTrigger||(e.CodeActionTrigger={}));let ze=class{constructor(M,te){this.title=M,this.kind=te}};ze=De([h],ze),e.CodeAction=ze;let je=s=class{constructor(M){this.value=M}append(M){return new s(this.value?this.value+s.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+s.sep)}};je.sep=".",je=s=De([h],je),e.CodeActionKind=je,je.Empty=new je(""),je.QuickFix=je.Empty.append("quickfix"),je.Refactor=je.Empty.append("refactor"),je.RefactorExtract=je.Refactor.append("extract"),je.RefactorInline=je.Refactor.append("inline"),je.RefactorRewrite=je.Refactor.append("rewrite"),je.Source=je.Empty.append("source"),je.SourceOrganizeImports=je.Source.append("organizeImports"),je.SourceFixAll=je.Source.append("fixAll");let me=class{constructor(M,te){if(this.range=M,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=De([h],me),e.SelectionRange=me;class ve{constructor(M,te,be,Me,Ge,Ye){this.kind=M,this.name=te,this.detail=be,this.uri=Me,this.range=Ge,this.selectionRange=Ye}}e.CallHierarchyItem=ve;class Se{constructor(M,te){this.fromRanges=te,this.from=M}}e.CallHierarchyIncomingCall=Se;class ke{constructor(M,te){this.fromRanges=te,this.to=M}}e.CallHierarchyOutgoingCall=ke;let Re=class{constructor(M,te){this.range=M,this.command=te}get isResolved(){return!!this.command}};Re=De([h],Re),e.CodeLens=Re;let Fe=p=class{constructor(M,te=!1){v.set(this,void 0),ft(this,v,new I.MarkdownString(M,{supportThemeIcons:te}))}static isMarkdownString(M){return M instanceof p?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return it(this,v).value}set value(M){it(this,v).value=M}get isTrusted(){return it(this,v).isTrusted}set isTrusted(M){it(this,v).isTrusted=M}get supportThemeIcons(){return it(this,v).supportThemeIcons}appendText(M){return it(this,v).appendText(M),this}appendMarkdown(M){return it(this,v).appendMarkdown(M),this}appendCodeblock(M,te){return it(this,v).appendCodeblock(te!=null?te:"",M),this}};v=new WeakMap,Fe=p=De([h],Fe),e.MarkdownString=Fe;let We=class{constructor(M,te){this.label=M,this.documentation=te}};We=De([h],We),e.ParameterInformation=We;let Be=class{constructor(M,te){this.label=M,this.documentation=te,this.parameters=[]}};Be=De([h],Be),e.SignatureInformation=Be;let Ve=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ve=De([h],Ve),e.SignatureHelp=Ve;var ae;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(ae=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));let ge=class{constructor(M,te,be,Me,Ge){this.text=M,this.range=te,this.description=be,this.whitespaceBefore=Me,this.whitespaceAfter=Ge}};ge=De([h],ge),e.InlineHint=ge;var pe;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Oe=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(z){z[z.Deprecated=1]="Deprecated"})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));let ue=class{constructor(M,te){this.label=M,this.kind=te}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ue=De([h],ue),e.CompletionItem=ue;let Ee=class{constructor(M=[],te=!1){this.items=M,this.isIncomplete=te}};Ee=De([h],Ee),e.CompletionList=Ee;var G;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(G=e.ViewColumn||(e.ViewColumn={}));var q;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(q=e.StatusBarAlignment||(e.StatusBarAlignment={}));var U;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(U=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var D;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(D=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var x;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(x=e.TextEditorRevealType||(e.TextEditorRevealType={}));var X;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(X=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Y;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Y=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function M(te){switch(te){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=M}(X=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let se=class{constructor(M,te){if(te&&!L.URI.isUri(te))throw m.illegalArgument("target");if(!B.isRange(M)||M.isEmpty)throw m.illegalArgument("range");this.range=M,this.target=te}};se=De([h],se),e.DocumentLink=se;let le=class{constructor(M,te,be,Me){this.red=M,this.green=te,this.blue=be,this.alpha=Me}};le=De([h],le),e.Color=le;let we=class{constructor(M,te){if(te&&!(te instanceof le))throw m.illegalArgument("color");if(!B.isRange(M)||M.isEmpty)throw m.illegalArgument("range");this.range=M,this.color=te}};we=De([h],we),e.ColorInformation=we;let Te=class{constructor(M){if(!M||typeof M!="string")throw m.illegalArgument("label");this.label=M}};Te=De([h],Te),e.ColorPresentation=Te;var Le;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Le=e.ColorFormat||(e.ColorFormat={}));var Ae;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Ae=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var $e;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var He;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(He=e.TaskPanelKind||(e.TaskPanelKind={}));let Ue=k=class{constructor(M,te){if(typeof M!="string"||typeof te!="string")throw m.illegalArgument("name");this._id=M}static from(M){switch(M){case"clean":return k.Clean;case"build":return k.Build;case"rebuild":return k.Rebuild;case"test":return k.Test;default:return}}get id(){return this._id}};Ue.Clean=new k("clean","Clean"),Ue.Build=new k("build","Build"),Ue.Rebuild=new k("rebuild","Rebuild"),Ue.Test=new k("test","Test"),Ue=k=De([h],Ue),e.TaskGroup=Ue;function Xe(z){let M="";for(let te=0;te<z.length;te++)M+=z[te].replace(/,/g,",,")+",";return M}let Ke=class{constructor(M,te,be){if(typeof M!="string")throw m.illegalArgument("process");this._args=[],this._process=M,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=be):this._options=te)}get process(){return this._process}set process(M){if(typeof M!="string")throw m.illegalArgument("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let te of this._args)M.push(te);return Xe(M)}};Ke=De([h],Ke),e.ProcessExecution=Ke;let Qe=class{constructor(M,te,be){if(this._args=[],Array.isArray(te)){if(!M)throw m.illegalArgument("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw m.illegalArgument("command");this._command=M,this._args=te,this._options=be}else{if(typeof M!="string")throw m.illegalArgument("commandLine");this._commandLine=M,this._options=te}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw m.illegalArgument("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw m.illegalArgument("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)M.push(typeof te=="string"?te:te.value);return Xe(M)}};Qe=De([h],Qe),e.ShellExecution=Qe;var Ze;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Ze=e.ShellQuoting||(e.ShellQuoting={}));var qe;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(qe=e.TaskScope||(e.TaskScope={}));class nt{constructor(M){this._callback=M}computeId(){return"customExecution"+g.generateUuid()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=nt;let tt=w=class{constructor(M,te,be,Me,Ge,Ye){this.__deprecated=!1,this._definition=this.definition=M;let Je;typeof te=="string"?(this._name=this.name=te,this._source=this.source=be,this.execution=Me,Je=Ge,this.__deprecated=!0):te===qe.Global||te===qe.Workspace?(this.target=te,this._name=this.name=be,this._source=this.source=Me,this.execution=Ge,Je=Ye):(this.target=te,this._name=this.name=be,this._source=this.source=Me,this.execution=Ge,Je=Ye),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof Qe?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof nt?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:g.generateUuid()}}get definition(){return this._definition}set definition(M){if(M==null)throw m.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw m.illegalArgument("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const te=this._definition.type;(w.EmptyType===te||w.ProcessType===te||w.ShellType===te||w.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw m.illegalArgument("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};tt.ExtensionCallbackType="customExecution",tt.ProcessType="process",tt.ShellType="shell",tt.EmptyType="$empty",tt=w=De([h],tt),e.Task=tt;var ot;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(ot=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(M,te=gt.None){this.collapsibleState=te,L.URI.isUri(M)?this.resourceUri=M:this.label=M}};dt=De([h],dt),e.TreeItem=dt;var gt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(gt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(M,te){this.id=M,this.color=te}};ut=De([h],ut),e.ThemeIcon=ut,ut.File=new ut("file"),ut.Folder=new ut("folder");let _t=class{constructor(M){this.id=M}};_t=De([h],_t),e.ThemeColor=_t;var Gt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Gt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor(M,te){if(typeof M!="string"&&(!M||!L.URI.isUri(M)&&!L.URI.isUri(M.uri)))throw m.illegalArgument("base");if(typeof te!="string")throw m.illegalArgument("pattern");typeof M=="string"?(this.baseFolder=L.URI.file(M),this.base=M):L.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=te}};It=De([h],It),e.RelativePattern=It;let mt=class{constructor(M,te,be,Me){this.enabled=typeof M=="boolean"?M:!0,typeof te=="string"&&(this.condition=te),typeof be=="string"&&(this.hitCondition=be),typeof Me=="string"&&(this.logMessage=Me)}get id(){return this._id||(this._id=g.generateUuid()),this._id}};mt=De([h],mt),e.Breakpoint=mt;let kt=class extends mt{constructor(M,te,be,Me,Ge){super(te,be,Me,Ge);if(M===null)throw m.illegalArgument("location");this.location=M}};kt=De([h],kt),e.SourceBreakpoint=kt;let Pt=class extends mt{constructor(M,te,be,Me,Ge){super(te,be,Me,Ge);this.functionName=M}};Pt=De([h],Pt),e.FunctionBreakpoint=Pt;let Tt=class extends mt{constructor(M,te,be,Me,Ge,Ye,Je){super(Me,Ge,Ye,Je);if(!te)throw m.illegalArgument("dataId");this.label=M,this.dataId=te,this.canPersist=be}};Tt=De([h],Tt),e.DataBreakpoint=Tt;let Rt=class{constructor(M,te,be){this.command=M,this.args=te||[],this.options=be}};Rt=De([h],Rt),e.DebugAdapterExecutable=Rt;let Ct=class{constructor(M,te){this.port=M,this.host=te}};Ct=De([h],Ct),e.DebugAdapterServer=Ct;let Lt=class{constructor(M){this.path=M}};Lt=De([h],Lt),e.DebugAdapterNamedPipeServer=Lt;let At=class{constructor(M){this.implementation=M}};At=De([h],At),e.DebugAdapterInlineImplementation=At;let Dt=class{constructor(M,te){this.range=M,this.expression=te}};Dt=De([h],Dt),e.EvaluatableExpression=Dt;var xt;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(xt=e.FileChangeType||(e.FileChangeType={}));let Ot=T=class extends Error{constructor(M,te=t.FileSystemProviderErrorCode.Unknown,be){var Me;super(L.URI.isUri(M)?M.toString(!0):M);this.code=(Me=be==null?void 0:be.name)!==null&&Me!==void 0?Me:"Unknown",t.markAsFileSystemProviderError(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}static FileExists(M){return new T(M,t.FileSystemProviderErrorCode.FileExists,T.FileExists)}static FileNotFound(M){return new T(M,t.FileSystemProviderErrorCode.FileNotFound,T.FileNotFound)}static FileNotADirectory(M){return new T(M,t.FileSystemProviderErrorCode.FileNotADirectory,T.FileNotADirectory)}static FileIsADirectory(M){return new T(M,t.FileSystemProviderErrorCode.FileIsADirectory,T.FileIsADirectory)}static NoPermissions(M){return new T(M,t.FileSystemProviderErrorCode.NoPermissions,T.NoPermissions)}static Unavailable(M){return new T(M,t.FileSystemProviderErrorCode.Unavailable,T.Unavailable)}};Ot=T=De([h],Ot),e.FileSystemError=Ot;let Nt=class{constructor(M,te,be){this.start=M,this.end=te,this.kind=be}};Nt=De([h],Nt),e.FoldingRange=Nt;var Kt;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Kt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Xt;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Xt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Yt;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Yt=e.CommentMode||(e.CommentMode={}));class Qt{constructor(M,te=[]){this.tokenTypes=M,this.tokenModifiers=te}}e.SemanticTokensLegend=Qt;function Jt(z){return typeof z=="undefined"||C.isStringArray(z)}class Ft{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let te=0,be=M.tokenTypes.length;te<be;te++)this._tokenTypeStrToInt.set(M.tokenTypes[te],te);for(let te=0,be=M.tokenModifiers.length;te<be;te++)this._tokenModifierStrToInt.set(M.tokenModifiers[te],te)}}push(M,te,be,Me,Ge){if(typeof M=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Me=="number"&&(typeof Ge=="number"||typeof Ge=="undefined"))return typeof Ge=="undefined"&&(Ge=0),this._pushEncoded(M,te,be,Me,Ge);if(B.isRange(M)&&typeof te=="string"&&Jt(be))return this._push(M,te,be);throw m.illegalArgument()}_push(M,te,be){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Me=M.start.line,Ge=M.start.character,Ye=M.end.character-M.start.character,Je=this._tokenTypeStrToInt.get(te);let rt=0;if(be)for(const st of be){if(!this._tokenModifierStrToInt.has(st))throw new Error("`tokenModifier` is not in the provided legend");const at=this._tokenModifierStrToInt.get(st);rt|=1<<at>>>0}this._pushEncoded(Me,Ge,Ye,Je,rt)}_pushEncoded(M,te,be,Me,Ge){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const rt=this._data.length/5|0;let st=0,at=0;for(let lt=0;lt<rt;lt++){let ct=this._data[5*lt],vt=this._data[5*lt+1];ct===0?(ct=st,vt+=at):ct+=st,this._data[5*lt]=ct,this._data[5*lt+1]=vt,st=ct,at=vt}}let Ye=M,Je=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ye-=this._prevLine,Ye===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=be,this._data[this._dataLen++]=Me,this._data[this._dataLen++]=Ge,this._prevLine=M,this._prevChar=te}static _sortAndDeltaEncode(M){let te=[];const be=M.length/5|0;for(let Je=0;Je<be;Je++)te[Je]=Je;te.sort((Je,rt)=>{const st=M[5*Je],at=M[5*rt];if(st===at){const lt=M[5*Je+1],ct=M[5*rt+1];return lt-ct}return st-at});const Me=new Uint32Array(M.length);let Ge=0,Ye=0;for(let Je=0;Je<be;Je++){const rt=5*te[Je],st=M[rt+0],at=M[rt+1],lt=M[rt+2],ct=M[rt+3],vt=M[rt+4],Vt=st-Ge,yn=Vt===0?at-Ye:at,pt=5*Je;Me[pt+0]=Vt,Me[pt+1]=yn,Me[pt+2]=lt,Me[pt+3]=ct,Me[pt+4]=vt,Ge=st,Ye=at}return Me}build(M){return this._dataIsSortedAndDeltaEncoded?new Mt(new Uint32Array(this._data),M):new Mt(Ft._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Ft;class Mt{constructor(M,te){this.resultId=te,this.data=M}}e.SemanticTokens=Mt;class Zt{constructor(M,te,be){this.start=M,this.deleteCount=te,this.data=be}}e.SemanticTokensEdit=Zt;class en{constructor(M,te){this.resultId=te,this.edits=M}}e.SemanticTokensEdits=en;var tn;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(tn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var nn;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(nn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let yt=class{constructor(){}};yt.Back={iconPath:new ut("arrow-left")},yt=De([h],yt),e.QuickInputButtons=yt;var rn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(rn=e.ExtensionKind||(e.ExtensionKind={}));class sn{constructor(M,te,be){this.badge=M,this.tooltip=te,this.color=be}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=sn;let Ut=class{constructor(M){this.kind=M}};Ut=De([h],Ut),e.ColorTheme=Ut;var an;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(M,te,be){this.mime=M,this.value=te,this.metadata=be}static isNotebookCellOutputItem(M){return M instanceof zt}}e.NotebookCellOutputItem=zt;class Et{constructor(M,te){this.outputs=M,this.metadata=te}static isNotebookCellOutput(M){return M instanceof Et}toJSON(){let M={},te={},be=!1;for(let Me of this.outputs)M[Me.mime]=Me.value,Me.metadata&&(te[Me.mime]=Me.metadata,be=!0);return{outputKind:Ht.Rich,data:M,metadata:be?{custom:te}:void 0}}}e.NotebookCellOutput=Et;var on;(function(z){z[z.Markdown=1]="Markdown",z[z.Code=2]="Code"})(on=e.CellKind||(e.CellKind={}));var Ht;(function(z){z[z.Text=1]="Text",z[z.Error=2]="Error",z[z.Rich=3]="Rich"})(Ht=e.CellOutputKind||(e.CellOutputKind={}));var ln;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle",z[z.Success=3]="Success",z[z.Error=4]="Error"})(ln=e.NotebookCellRunState||(e.NotebookCellRunState={}));var cn;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(cn=e.NotebookRunState||(e.NotebookRunState={}));var un;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(un=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var hn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(hn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let jt=class{constructor(M,te){this.label=M,this.timestamp=te}};jt=De([h],jt),e.TimelineItem=jt;var fn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(fn=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var mn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(mn=e.StandardTokenType||(e.StandardTokenType={}));class gn{constructor(M,te){this.ranges=M,this.wordPattern=te}}e.LinkedEditingRanges=gn;var vn;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(vn=e.TestRunState||(e.TestRunState={}));var pn;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(pn=e.TestMessageSeverity||(e.TestMessageSeverity={}));let Wt=class{constructor(M,te=[],be){c.set(this,void 0),d.set(this,void 0),S.set(this,void 0),ft(this,c,M),ft(this,S,Object.freeze(te.map(Me=>Object.freeze(Me)))),ft(this,d,be)}get runState(){return it(this,c)}get duration(){return it(this,d)}get messages(){return it(this,S)}};c=new WeakMap,d=new WeakMap,S=new WeakMap,Wt=De([h],Wt),e.TestState=Wt;var wn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(he[99],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=y.createDecorator("environmentVariableService");var m;(function(I){I[I.Replace=1]="Replace",I[I.Append=2]="Append",I[I.Prepend=3]="Prepend"})(m=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(he[203],de([0,1,99,5]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class I{constructor(g){this.map=new Map,g.forEach((t,R)=>{const _=t.map.entries();let P=_.next();for(;!P.done;){const v=P.value[0];let c=this.map.get(v);if(c||(c=[],this.map.set(v,c)),c.length>0&&c[0].type===y.EnvironmentVariableMutatorType.Replace){P=_.next();continue}const d=P.value[1];c.unshift({extensionIdentifier:R,value:d.value,type:d.type}),P=_.next()}})}applyToProcessEnvironment(g){let t;m.isWindows&&(t={},Object.keys(g).forEach(R=>t[R.toLowerCase()]=R)),this.map.forEach((R,_)=>{const P=m.isWindows&&t[_.toLowerCase()]||_;R.forEach(v=>{switch(v.type){case y.EnvironmentVariableMutatorType.Append:g[P]=(g[P]||"")+v.value;break;case y.EnvironmentVariableMutatorType.Prepend:g[P]=v.value+(g[P]||"");break;case y.EnvironmentVariableMutatorType.Replace:g[P]=v.value;break}})})}diff(g){const t=new Map,R=new Map,_=new Map;if(g.map.forEach((P,v)=>{const c=this.map.get(v),d=E(P,c);d&&t.set(v,d)}),this.map.forEach((P,v)=>{const c=g.map.get(v),d=E(P,c);d&&_.set(v,d)}),this.map.forEach((P,v)=>{const c=g.map.get(v),d=C(P,c);d&&R.set(v,d)}),!(t.size===0&&R.size===0&&_.size===0))return{added:t,changed:R,removed:_}}}e.MergedEnvironmentVariableCollection=I;function E(L,g){if(!g)return L;const t=new Set;g.forEach(_=>t.add(_.extensionIdentifier));const R=[];return L.forEach(_=>{t.has(_.extensionIdentifier)||R.push(_)}),R.length===0?void 0:R}function C(L,g){if(!!g){const t=new Map;g.forEach(_=>t.set(_.extensionIdentifier,_));const R=[];return L.forEach(_=>{const P=t.get(_.extensionIdentifier);P&&(_.type!==P.type||_.value!==P.value)&&R.push(P)}),R.length===0?void 0:R}}}),define(he[100],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function y(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=y;function m(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=m}),define(he[101],de([0,1,159,49]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalContributionsDescriptor=e.DEFAULT_COMMANDS_TO_SKIP_SHELL=e.TERMINAL_COMMAND_ID=e.FlowControlConstants=e.TitleEventSource=e.LinuxDistro=e.ProcessState=e.DEFAULT_LOCAL_ECHO_EXCLUDE=e.SUGGESTIONS_FONT_WEIGHT=e.DEFAULT_BOLD_FONT_WEIGHT=e.DEFAULT_FONT_WEIGHT=e.MAXIMUM_FONT_WEIGHT=e.MINIMUM_FONT_WEIGHT=e.DEFAULT_LINE_HEIGHT=e.MINIMUM_LETTER_SPACING=e.DEFAULT_LETTER_SPACING=e.TERMINAL_ACTION_CATEGORY=e.TERMINAL_CONFIG_SECTION=e.TerminalCursorStyle=e.TERMINAL_CREATION_COMMANDS=e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY=e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=e.TERMINAL_VIEW_ID=void 0,e.TERMINAL_VIEW_ID="terminal",e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=new m.RawContextKey("terminalIsOpen",!1),e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=new m.RawContextKey("terminalFocus",!1),e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY="terminalShellType",e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=new m.RawContextKey(e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY,void 0),e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=new m.RawContextKey("terminalAltBufferActive",!1),e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=new m.RawContextKey("terminalA11yTreeFocus",!1),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=new m.RawContextKey("terminalTextSelected",!1),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=new m.RawContextKey("terminalFindVisible",!1),e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=new m.RawContextKey("terminalFindInputFocused",!1),e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=new m.RawContextKey("terminalFindFocused",!1),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=new m.RawContextKey("terminalProcessSupported",!1),e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY="terminal.integrated.isWorkspaceShellAllowed",e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY="terminal.integrated.neverMeasureRenderTime",e.TERMINAL_CREATION_COMMANDS=["workbench.action.terminal.toggleTerminal","workbench.action.terminal.new","workbench.action.togglePanel","workbench.action.terminal.focus"],e.TerminalCursorStyle={BLOCK:"block",LINE:"line",UNDERLINE:"underline"},e.TERMINAL_CONFIG_SECTION="terminal.integrated",e.TERMINAL_ACTION_CATEGORY=y.localize(0,null),e.DEFAULT_LETTER_SPACING=0,e.MINIMUM_LETTER_SPACING=-5,e.DEFAULT_LINE_HEIGHT=1,e.MINIMUM_FONT_WEIGHT=1,e.MAXIMUM_FONT_WEIGHT=1e3,e.DEFAULT_FONT_WEIGHT="normal",e.DEFAULT_BOLD_FONT_WEIGHT="bold",e.SUGGESTIONS_FONT_WEIGHT=["normal","bold","100","200","300","400","500","600","700","800","900"],e.DEFAULT_LOCAL_ECHO_EXCLUDE=["vim","vi","nano","tmux"];var I;(function(t){t[t.UNINITIALIZED=0]="UNINITIALIZED",t[t.LAUNCHING=1]="LAUNCHING",t[t.RUNNING=2]="RUNNING",t[t.KILLED_DURING_LAUNCH=3]="KILLED_DURING_LAUNCH",t[t.KILLED_BY_USER=4]="KILLED_BY_USER",t[t.KILLED_BY_PROCESS=5]="KILLED_BY_PROCESS"})(I=e.ProcessState||(e.ProcessState={}));var E;(function(t){t[t.Fedora=0]="Fedora",t[t.Ubuntu=1]="Ubuntu",t[t.Unknown=2]="Unknown"})(E=e.LinuxDistro||(e.LinuxDistro={}));var C;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence"})(C=e.TitleEventSource||(e.TitleEventSource={}));var L;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(L=e.FlowControlConstants||(e.FlowControlConstants={}));var g;(function(t){t.FIND_NEXT="workbench.action.terminal.findNext",t.FIND_PREVIOUS="workbench.action.terminal.findPrevious",t.TOGGLE="workbench.action.terminal.toggleTerminal",t.KILL="workbench.action.terminal.kill",t.QUICK_KILL="workbench.action.terminal.quickKill",t.CONFIGURE_TERMINAL_SETTINGS="workbench.action.terminal.openSettings",t.COPY_SELECTION="workbench.action.terminal.copySelection",t.SELECT_ALL="workbench.action.terminal.selectAll",t.DELETE_WORD_LEFT="workbench.action.terminal.deleteWordLeft",t.DELETE_WORD_RIGHT="workbench.action.terminal.deleteWordRight",t.DELETE_TO_LINE_START="workbench.action.terminal.deleteToLineStart",t.MOVE_TO_LINE_START="workbench.action.terminal.moveToLineStart",t.MOVE_TO_LINE_END="workbench.action.terminal.moveToLineEnd",t.NEW="workbench.action.terminal.new",t.NEW_WITH_CWD="workbench.action.terminal.newWithCwd",t.NEW_LOCAL="workbench.action.terminal.newLocal",t.NEW_IN_ACTIVE_WORKSPACE="workbench.action.terminal.newInActiveWorkspace",t.SPLIT="workbench.action.terminal.split",t.SPLIT_IN_ACTIVE_WORKSPACE="workbench.action.terminal.splitInActiveWorkspace",t.RELAUNCH="workbench.action.terminal.relaunch",t.FOCUS_PREVIOUS_PANE="workbench.action.terminal.focusPreviousPane",t.FOCUS_NEXT_PANE="workbench.action.terminal.focusNextPane",t.RESIZE_PANE_LEFT="workbench.action.terminal.resizePaneLeft",t.RESIZE_PANE_RIGHT="workbench.action.terminal.resizePaneRight",t.RESIZE_PANE_UP="workbench.action.terminal.resizePaneUp",t.RESIZE_PANE_DOWN="workbench.action.terminal.resizePaneDown",t.FOCUS="workbench.action.terminal.focus",t.FOCUS_NEXT="workbench.action.terminal.focusNext",t.FOCUS_PREVIOUS="workbench.action.terminal.focusPrevious",t.PASTE="workbench.action.terminal.paste",t.SELECT_DEFAULT_SHELL="workbench.action.terminal.selectDefaultShell",t.RUN_SELECTED_TEXT="workbench.action.terminal.runSelectedText",t.RUN_ACTIVE_FILE="workbench.action.terminal.runActiveFile",t.SWITCH_TERMINAL="workbench.action.terminal.switchTerminal",t.SCROLL_DOWN_LINE="workbench.action.terminal.scrollDown",t.SCROLL_DOWN_PAGE="workbench.action.terminal.scrollDownPage",t.SCROLL_TO_BOTTOM="workbench.action.terminal.scrollToBottom",t.SCROLL_UP_LINE="workbench.action.terminal.scrollUp",t.SCROLL_UP_PAGE="workbench.action.terminal.scrollUpPage",t.SCROLL_TO_TOP="workbench.action.terminal.scrollToTop",t.CLEAR="workbench.action.terminal.clear",t.CLEAR_SELECTION="workbench.action.terminal.clearSelection",t.MANAGE_WORKSPACE_SHELL_PERMISSIONS="workbench.action.terminal.manageWorkspaceShellPermissions",t.RENAME="workbench.action.terminal.rename",t.RENAME_WITH_ARG="workbench.action.terminal.renameWithArg",t.FIND_FOCUS="workbench.action.terminal.focusFind",t.FIND_HIDE="workbench.action.terminal.hideFind",t.QUICK_OPEN_TERM="workbench.action.quickOpenTerm",t.SCROLL_TO_PREVIOUS_COMMAND="workbench.action.terminal.scrollToPreviousCommand",t.SCROLL_TO_NEXT_COMMAND="workbench.action.terminal.scrollToNextCommand",t.SELECT_TO_PREVIOUS_COMMAND="workbench.action.terminal.selectToPreviousCommand",t.SELECT_TO_NEXT_COMMAND="workbench.action.terminal.selectToNextCommand",t.SELECT_TO_PREVIOUS_LINE="workbench.action.terminal.selectToPreviousLine",t.SELECT_TO_NEXT_LINE="workbench.action.terminal.selectToNextLine",t.TOGGLE_ESCAPE_SEQUENCE_LOGGING="toggleEscapeSequenceLogging",t.SEND_SEQUENCE="workbench.action.terminal.sendSequence",t.TOGGLE_FIND_REGEX="workbench.action.terminal.toggleFindRegex",t.TOGGLE_FIND_WHOLE_WORD="workbench.action.terminal.toggleFindWholeWord",t.TOGGLE_FIND_CASE_SENSITIVE="workbench.action.terminal.toggleFindCaseSensitive",t.NAVIGATION_MODE_EXIT="workbench.action.terminal.navigationModeExit",t.NAVIGATION_MODE_FOCUS_NEXT="workbench.action.terminal.navigationModeFocusNext",t.NAVIGATION_MODE_FOCUS_PREVIOUS="workbench.action.terminal.navigationModeFocusPrevious",t.SHOW_ENVIRONMENT_INFORMATION="workbench.action.terminal.showEnvironmentInformation",t.SEARCH_WORKSPACE="workbench.action.terminal.searchWorkspace",t.ATTACH_TO_REMOTE_TERMINAL="workbench.action.terminal.attachToSession"})(g=e.TERMINAL_COMMAND_ID||(e.TERMINAL_COMMAND_ID={})),e.DEFAULT_COMMANDS_TO_SKIP_SHELL=["workbench.action.terminal.clearSelection","workbench.action.terminal.clear","workbench.action.terminal.copySelection","workbench.action.terminal.deleteToLineStart","workbench.action.terminal.deleteWordLeft","workbench.action.terminal.deleteWordRight","workbench.action.terminal.focusFind","workbench.action.terminal.hideFind","workbench.action.terminal.findNext","workbench.action.terminal.findPrevious","workbench.action.terminal.toggleFindRegex","workbench.action.terminal.toggleFindWholeWord","workbench.action.terminal.toggleFindCaseSensitive","workbench.action.terminal.focusNextPane","workbench.action.terminal.focusNext","workbench.action.terminal.focusPreviousPane","workbench.action.terminal.focusPrevious","workbench.action.terminal.focus","workbench.action.terminal.kill","workbench.action.terminal.moveToLineEnd","workbench.action.terminal.moveToLineStart","workbench.action.terminal.newInActiveWorkspace","workbench.action.terminal.new","workbench.action.terminal.paste","workbench.action.terminal.resizePaneDown","workbench.action.terminal.resizePaneLeft","workbench.action.terminal.resizePaneRight","workbench.action.terminal.resizePaneUp","workbench.action.terminal.runActiveFile","workbench.action.terminal.runSelectedText","workbench.action.terminal.scrollDown","workbench.action.terminal.scrollDownPage","workbench.action.terminal.scrollToBottom","workbench.action.terminal.scrollToNextCommand","workbench.action.terminal.scrollToPreviousCommand","workbench.action.terminal.scrollToTop","workbench.action.terminal.scrollUp","workbench.action.terminal.scrollUpPage","workbench.action.terminal.sendSequence","workbench.action.terminal.selectAll","workbench.action.terminal.selectToNextCommand","workbench.action.terminal.selectToNextLine","workbench.action.terminal.selectToPreviousCommand","workbench.action.terminal.selectToPreviousLine","workbench.action.terminal.splitInActiveWorkspace","workbench.action.terminal.split","workbench.action.terminal.toggleTerminal","workbench.action.terminal.navigationModeExit","workbench.action.terminal.navigationModeFocusNext","workbench.action.terminal.navigationModeFocusPrevious","editor.action.toggleTabFocusMode","workbench.action.quickOpen","workbench.action.quickOpenPreviousEditor","workbench.action.showCommands","workbench.action.tasks.build","workbench.action.tasks.restartTask","workbench.action.tasks.runTask","workbench.action.tasks.reRunTask","workbench.action.tasks.showLog","workbench.action.tasks.showTasks","workbench.action.tasks.terminate","workbench.action.tasks.test","workbench.action.toggleFullScreen","workbench.action.terminal.focusAtIndex1","workbench.action.terminal.focusAtIndex2","workbench.action.terminal.focusAtIndex3","workbench.action.terminal.focusAtIndex4","workbench.action.terminal.focusAtIndex5","workbench.action.terminal.focusAtIndex6","workbench.action.terminal.focusAtIndex7","workbench.action.terminal.focusAtIndex8","workbench.action.terminal.focusAtIndex9","workbench.action.focusSecondEditorGroup","workbench.action.focusThirdEditorGroup","workbench.action.focusFourthEditorGroup","workbench.action.focusFifthEditorGroup","workbench.action.focusSixthEditorGroup","workbench.action.focusSeventhEditorGroup","workbench.action.focusEighthEditorGroup","workbench.action.focusNextPart","workbench.action.focusPreviousPart","workbench.action.nextPanelView","workbench.action.previousPanelView","workbench.action.nextSideBarView","workbench.action.previousSideBarView","workbench.action.debug.start","workbench.action.debug.stop","workbench.action.debug.run","workbench.action.debug.restart","workbench.action.debug.continue","workbench.action.debug.pause","workbench.action.debug.stepInto","workbench.action.debug.stepOut","workbench.action.debug.stepOver","workbench.action.nextEditor","workbench.action.previousEditor","workbench.action.nextEditorInGroup","workbench.action.previousEditorInGroup","workbench.action.openNextRecentlyUsedEditor","workbench.action.openPreviousRecentlyUsedEditor","workbench.action.openNextRecentlyUsedEditorInGroup","workbench.action.openPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenPreviousRecentlyUsedEditor","workbench.action.quickOpenLeastRecentlyUsedEditor","workbench.action.quickOpenPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenLeastRecentlyUsedEditorInGroup","workbench.action.focusActiveEditorGroup","workbench.action.focusFirstEditorGroup","workbench.action.focusLastEditorGroup","workbench.action.firstEditorInGroup","workbench.action.lastEditorInGroup","workbench.action.navigateUp","workbench.action.navigateDown","workbench.action.navigateRight","workbench.action.navigateLeft","workbench.action.togglePanel","workbench.action.quickOpenView","workbench.action.toggleMaximizedPanel"],e.terminalContributionsDescriptor={extensionPoint:"terminal",defaultExtensionKind:"workspace",jsonSchema:{description:y.localize(1,null),type:"object",properties:{types:{type:"array",description:y.localize(2,null),items:{type:"object",required:["command","title"],properties:{command:{description:y.localize(3,null),type:"string"},title:{description:y.localize(4,null),type:"string"}}}}}}}}),define(he[204],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class y{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,E,C=5){let L;return L=E(g=>{const t=typeof g=="string"?g:g.data;let R=this._terminalBufferMap.get(I);if(R){R.data.push(t);return}const _=setTimeout(()=>this._flushBuffer(I),C);R={data:[t],timeoutId:_,dispose:()=>{clearTimeout(_),this._flushBuffer(I),L.dispose()}},this._terminalBufferMap.set(I,R)}),L}stopBuffering(I){const E=this._terminalBufferMap.get(I);E&&E.dispose()}_flushBuffer(I){const E=this._terminalBufferMap.get(I);E&&(this._terminalBufferMap.delete(I),this._callback(I,E.data.join("")))}}e.TerminalDataBufferer=y}),define(he[205],de([0,1,2,5,113]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function E(o,n){if(!!n)if(m.isWindows)for(const r in n){let i=r;for(const s in o)if(r.toLowerCase()===s.toLowerCase()){i=s;break}const l=n[r];C(o,i,l)}else Object.keys(n).forEach(r=>{const i=n[r];C(o,r,i)})}e.mergeEnvironments=E;function C(o,n,r){typeof r=="string"?o[n]=r:delete o[n]}function L(o,n,r,i){o.TERM_PROGRAM="vscode",n&&(o.TERM_PROGRAM_VERSION=n),R(o,i)&&(o.LANG=_(r)),o.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=L;function g(o,n){if(!!n)for(const r of Object.keys(n)){const i=n[r];i&&(o[r]=i)}}function t(o,n){return Object.keys(n).forEach(r=>{const i=n[r];if(typeof i=="string")try{n[r]=o(i)}catch(l){n[r]=i}}),n}function R(o,n){if(n==="on")return!0;if(n==="auto"){const r=o.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function _(o){const n=o?o.split("-"):[],r=n.length;if(r===0)return"en_US.UTF-8";if(r===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in i&&n.push(i[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}e.getLangEnvVariable=_;function P(o,n,r,i,l,s){if(o.cwd){const k=typeof o.cwd=="object"?o.cwd.fsPath:o.cwd,w=v(k,r);return c(w||k)}let p;return!o.ignoreConfigurationCwd&&l&&(r&&(l=v(l,r,s)),l&&(y.isAbsolute(l)?p=l:i&&(p=y.join(i.fsPath,l)))),p||(p=i?i.fsPath:n||""),c(p)}e.getCwd=P;function v(o,n,r){if(n)try{return n(o)}catch(i){r==null||r.error("Could not resolve terminal cwd",i);return}return o}function c(o){return m.platform===3&&o&&o[1]===":"?o[0].toUpperCase()+o.substr(1):o}function d(o){let n=o;n.indexOf("\\")!==0&&(n=n.replace(/\\/g,"\\\\")),n.indexOf(" ")!==-1&&(n=n.replace(/ /g,"\\ "));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return n=n.replace(r,""),`'${n}'`}e.escapeNonWindowsPath=d;function S(o,n){if(!!n)return r=>n.resolve(o,r)}e.createVariableResolver=S;function b(o,n,r,i,l,s,p,k,w=m.platform){let T=null;k&&(T=u(o,n,"automationShell",w)),T||(T=u(o,n,"shell",w));let h=T||r;if(w===3&&!i&&l){const A=y.join(l,"Sysnative").replace(/\//g,"\\").toLowerCase();h&&h.toLowerCase().indexOf(A)===0&&(h=y.join(l,"System32",h.substr(A.length+1)))}if(h&&w===3&&(h=h.replace(/\//g,"\\")),s)try{h=s(h)}catch(A){p.error("Could not resolve shell",A)}return h}e.getDefaultShell=b;function f(o,n,r,i,l,s=m.platform){if(r&&u(o,n,"automationShell",s))return[];const p=s===3?"windows":s===1?"osx":"linux",k=o(`terminal.integrated.shellArgs.${p}`);let w=(n?k.value:k.userValue)||k.defaultValue;if(!w)return[];if(typeof w=="string"&&s===3)return i?i(w):w;if(i){const T=[];for(const h of w)try{T.push(i(h))}catch(A){l.error(`Could not resolve terminal.integrated.shellArgs.${p}`,A),T.push(h)}w=T}return w}e.getDefaultShellArgs=f;function u(o,n,r,i=m.platform){const s=o(`terminal.integrated.${r}.${i===3?"windows":i===1?"osx":"linux"}`);return(n?s.value:s.userValue)||s.defaultValue}function a(o,n,r,i,l,s,p){let k={};if(o.strictEnv)g(k,o.env);else{g(k,p);const w=Object.assign({},i?n.value:n.userValue);r&&(w&&t(r,w),o.env&&t(r,o.env)),I.sanitizeProcessEnvironment(k,"VSCODE_IPC_HOOK_CLI"),E(k,w),E(k,o.env),L(k,l,m.locale,s)}return k}e.createTerminalEnvironment=a});var wt=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],y;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),y={},m("next"),m("throw"),m("return"),y[Symbol.asyncIterator]=function(){return this},y);function m(E){y[E]=Z[E]&&function(C){return new Promise(function(L,g){C=Z[E](C),I(L,g,C.done,C.value)})}}function I(E,C,L,g){Promise.resolve(g).then(function(t){E({value:t,done:L})},C)}};define(he[206],de([0,1,23,5,15,101,14,2,76]),function(Z,e,y,m,I,E,C,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableShells=e.getWindowsBuildNumber=e.linuxDistro=void 0;let t=E.LinuxDistro.Unknown;if(m.isLinux){const d="/etc/os-release";I.fileExists(d).then(async S=>{if(!!S){const f=(await I.readFile(d)).toString();/NAME="?Fedora"?/.test(f)?t=E.LinuxDistro.Fedora:/NAME="?Ubuntu"?/.test(f)&&(t=E.LinuxDistro.Ubuntu)}})}e.linuxDistro=t;function R(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let S=0;return d&&d.length===4&&(S=parseInt(d[3])),S}e.getWindowsBuildNumber=R;function _(){return m.isWindows?P():v()}e.detectAvailableShells=_;async function P(){var d,S;const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${process.env.windir}\\${b?"Sysnative":"System32"}`;let u=!1;R()>=16299&&(u=!0);const a={"Command Prompt":[`${f}\\cmd.exe`],"WSL Bash":[`${f}\\${u?"wsl.exe":"bash.exe"}`],"Git Bash":[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`]};try{for(var o=wt(g.enumeratePowerShellInstallations()),n;n=await o.next(),!n.done;){const l=n.value;a[l.displayName]=[l.exePath]}}catch(l){d={error:l}}finally{try{n&&!n.done&&(S=o.return)&&await S.call(o)}finally{if(d)throw d.error}}const r=[];Object.keys(a).forEach(l=>r.push(c(l,a[l])));const i=await Promise.all(r);return C.coalesce(i)}async function v(){return(await I.readFile("/etc/shells","utf8")).split(`
`).filter(b=>b.trim().indexOf("#")!==0&&b.trim().length>0).map(b=>({label:L.basename(b),path:b}))}async function c(d,S){if(S.length===0)return Promise.resolve(void 0);const b=S.shift();if(b==="")return c(d,S);try{const f=await I.stat(L.normalize(b));if(f.isFile()||f.isSymbolicLink())return{label:d,path:b}}catch(f){try{const u=await I.lstat(L.normalize(b));if(u.isFile()||u.isSymbolicLink())return{label:d,path:b}}catch(u){}}return c(d,S)}}),define(he[102],de([0,1,5,15,2,11,19]),function(Z,e,y,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getMainProcessParentEnv=void 0;let L;async function g(R=process.env){if(L)return L;if(y.isLinux){const _=process.ppid,P=I.basename(process.argv[0]);let v=0,c=_,d=P;do v=c,(await m.readFile(`/proc/${v}/status`,"utf8")).split(`
`).forEach(a=>{a.indexOf("Name:")===0&&(d=a.replace(/^Name:\s+/,"")),a.indexOf("PPid:")===0&&(c=parseInt(a.replace(/^PPid:\s+/,"")))});while(d===P);const S=await m.readFile(`/proc/${v}/environ`,"utf8"),b={};S.split("\0").forEach(f=>{const u=f.indexOf("=");b[f.substr(0,u)]=f.substr(u+1)}),L=b}return y.isMacintosh&&(L={},["SHELL","SSH_AUTH_SOCK","Apple_PubSub_Socket_Render","XPC_FLAGS","XPC_SERVICE_NAME","HOME","LOGNAME","TMPDIR"].forEach(P=>{R[P]&&(L[P]=R[P])})),y.isWindows&&(L=R),L}e.getMainProcessParentEnv=g;async function t(R,_,P,v=process.env){if(I.isAbsolute(R))return await m.exists(R)?R:void 0;if(_===void 0&&(_=process.cwd()),I.dirname(R)!=="."){const b=I.join(_,R);return await m.exists(b)?b:void 0}const d=C.getCaseInsensitive(v,"PATH");if(P===void 0&&E.isString(d)&&(P=d.split(I.delimiter)),P===void 0||P.length===0){const b=I.join(_,R);return await m.exists(b)?b:void 0}for(let b of P){let f;if(I.isAbsolute(b)?f=I.join(b,R):f=I.join(_,b,R),await m.exists(f))return f;if(y.isWindows){let u=f+".com";if(await m.exists(u)||(u=f+".exe",await m.exists(u)))return u}}const S=I.join(_,R);return await m.exists(S)?S:void 0}e.findExecutable=t}),define(he[207],de([0,1,2,5,21,23,6,206,4,32,16,15,102,3,160]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0;const d=50,S=5;let b=class extends g.Disposable{constructor(a,o,n,r,i,l,s,p){var k;super();this._shellLaunchConfig=a,this._executableEnv=l,this._logService=p,this._currentTitle="",this._isDisposed=!1,this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new C.Emitter),this._onProcessExit=this._register(new C.Emitter),this._onProcessReady=this._register(new C.Emitter),this._onProcessTitleChanged=this._register(new C.Emitter);let w;m.isWindows?w=y.basename(this._shellLaunchConfig.executable||""):w="xterm-256color",this._initialCwd=o;const T=s&&process.platform==="win32"&&L.getWindowsBuildNumber()>=18309;this._ptyOptions={name:w,cwd:o,env:i,cols:n,rows:r,useConpty:T,conptyInheritCursor:T&&!!a.initialText},m.isWindows&&T&&n===0&&r===0&&((k=this._shellLaunchConfig.executable)===null||k===void 0?void 0:k.endsWith("Git\\bin\\bash.exe"))&&(this._delayedResizer=new f,this._register(this._delayedResizer.onTrigger(h=>{var A;(A=this._delayedResizer)===null||A===void 0||A.dispose(),this._delayedResizer=void 0,h.cols&&h.rows&&this.resize(h.cols,h.rows)})))}get exitMessage(){return this._exitMessage}get onProcessData(){return this._onProcessData.event}get onProcessExit(){return this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}get onProcessTitleChanged(){return this._onProcessTitleChanged.event}async start(){const o=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(n=>n!==void 0);if(o)return o;try{await this.setupPtyProcess(this._shellLaunchConfig,this._ptyOptions);return}catch(n){return this._logService.trace("IPty#spawn native exception",n),{message:`A native exception occurred during launch (${n.message})`}}}async _validateCwd(){try{if(!(await _.stat(this._initialCwd)).isDirectory())return{message:c.localize(0,null,this._initialCwd.toString())}}catch(a){if((a==null?void 0:a.code)==="ENOENT")return{message:c.localize(1,null,this._initialCwd.toString())}}}async _validateExecutable(){const a=this._shellLaunchConfig;if(!a.executable)throw new Error("IShellLaunchConfig.executable not set");try{const o=await _.stat(a.executable);if(!o.isFile()&&!o.isSymbolicLink())return{message:c.localize(2,null,a.executable)}}catch(o){if((o==null?void 0:o.code)==="ENOENT"){let n=a.cwd instanceof v.URI?a.cwd.path:a.cwd;const r=a.env&&a.env.PATH?a.env.PATH.split(y.delimiter):void 0;if(!await P.findExecutable(a.executable,n,r,this._executableEnv))return{message:c.localize(3,null,a.executable)}}}}async setupPtyProcess(a,o){const n=a.args||[];this._logService.trace("IPty#spawn",a.executable,n,o);const r=(await new Promise((i,l)=>{Z(["node-pty"],i,l)})).spawn(a.executable,n,o);this._ptyProcess=r,this._processStartupComplete=new Promise(i=>{this.onProcessReady(()=>i())}),r.onData(i=>{this._shellLaunchConfig.flowControl&&(this._unacknowledgedCharCount+=i.length,!this._isPtyPaused&&this._unacknowledgedCharCount>1e5&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > ${1e5})`),this._isPtyPaused=!0,r.pause())),this._onProcessData.fire(i),this._closeTimeout&&(clearTimeout(this._closeTimeout),this._queueProcessExit())}),r.onExit(i=>{this._exitCode=i.exitCode,this._queueProcessExit()}),this._setupTitlePolling(r),this._sendProcessId(r.pid)}dispose(){this._isDisposed=!0,this._titleInterval&&clearInterval(this._titleInterval),this._titleInterval=null,this._onProcessData.dispose(),this._onProcessExit.dispose(),this._onProcessReady.dispose(),this._onProcessTitleChanged.dispose(),super.dispose()}_setupTitlePolling(a){setTimeout(()=>{this._sendProcessTitle(a)},0),m.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==a.process&&this._sendProcessTitle(a)},200))}_queueProcessExit(){this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>this._kill(),250)}async _kill(){if(await this._processStartupComplete,!this._isDisposed){try{this._ptyProcess&&(this._logService.trace("IPty#kill"),this._ptyProcess.kill())}catch(a){}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}_sendProcessId(a){this._onProcessReady.fire({pid:a,cwd:this._initialCwd})}_sendProcessTitle(a){this._isDisposed||(this._currentTitle=a.process,this._onProcessTitleChanged.fire(this._currentTitle))}shutdown(a){a?this._kill():this._queueProcessExit()}input(a){if(!(this._isDisposed||!this._ptyProcess)){for(let o=0;o<=Math.floor(a.length/d);o++)this._writeQueue.push(a.substr(o*d,d));this._startWrite()}}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},S)}}_doWrite(){const a=this._writeQueue.shift();this._logService.trace("IPty#write",`${a.length} characters`),this._ptyProcess.write(a)}resize(a,o){if(!this._isDisposed&&!(typeof a!="number"||typeof o!="number"||isNaN(a)||isNaN(o))&&this._ptyProcess){if(a=Math.max(a,1),o=Math.max(o,1),this._delayedResizer){this._delayedResizer.cols=a,this._delayedResizer.rows=o;return}this._logService.trace("IPty#resize",a,o);try{this._ptyProcess.resize(a,o)}catch(n){if(this._logService.trace("IPty#resize exception "+n.message),this._exitCode!==void 0&&n.message!=="ioctl(2) failed, EBADF")throw n}}}acknowledgeDataEvent(a){var o;!this._shellLaunchConfig.flowControl||(this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-a,0),this._logService.trace(`Flow control: Ack ${a} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<5e3&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < ${5e3})`),(o=this._ptyProcess)===null||o===void 0||o.resume(),this._isPtyPaused=!1))}clearUnacknowledgedChars(){var a;!this._shellLaunchConfig.flowControl||(this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&((a=this._ptyProcess)===null||a===void 0||a.resume(),this._isPtyPaused=!1))}getInitialCwd(){return Promise.resolve(this._initialCwd)}getCwd(){if(m.isMacintosh){const a=E.release().split(".");if(a.length>0&&parseInt(a[0])<20)return new Promise(o=>{if(!this._ptyProcess){o(this._initialCwd);return}this._logService.trace("IPty#pid"),t.exec("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",(n,r,i)=>{!n&&r!==""?o(r.substring(r.indexOf("/"),r.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",n,r,i),o(this._initialCwd))})})}return m.isLinux?new Promise(a=>{if(!this._ptyProcess){a(this._initialCwd);return}this._logService.trace("IPty#pid"),I.readlink("/proc/"+this._ptyProcess.pid+"/cwd",(o,n)=>{o&&a(this._initialCwd),a(n)})}):new Promise(a=>{a(this._initialCwd)})}getLatency(){return Promise.resolve(0)}};b=De([xe(7,R.ILogService)],b),e.TerminalProcess=b;class f extends g.Disposable{constructor(){super();this._onTrigger=this._register(new C.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register({dispose:()=>{clearTimeout(this._timeout)}})}get onTrigger(){return this._onTrigger.event}dispose(){super.dispose(),clearTimeout(this._timeout)}}}),define(he[208],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=y.createDecorator("configurationService"),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(he[209],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=y.createDecorator("configurationResolverService")}),define(he[210],de([0,1,2,36,11,19,5,54,161]),function(Z,e,y,m,I,E,C,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class t{constructor(_,P,v){if(this._contributedVariables=new Map,this._context=_,this._labelService=P,v)if(C.isWindows){const c=Object.create(null);this._envVariables=c,Object.keys(v).forEach(d=>{c[d.toLowerCase()]=v[d]})}else this._envVariables=v}resolve(_,P){return this.recursiveResolve(_?_.uri:void 0,P)}resolveAnyBase(_,P,v,c){const d=E.deepClone(P);return C.isWindows&&d.windows?Object.keys(d.windows).forEach(S=>d[S]=d.windows[S]):C.isMacintosh&&d.osx?Object.keys(d.osx).forEach(S=>d[S]=d.osx[S]):C.isLinux&&d.linux&&Object.keys(d.linux).forEach(S=>d[S]=d.linux[S]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(_?_.uri:void 0,d,v,c)}resolveAny(_,P,v){return this.resolveAnyBase(_,P,v)}resolveAnyMap(_,P,v){const c=new Map;return{newConfig:this.resolveAnyBase(_,P,v,c),resolvedVariables:c}}resolveWithInteractionReplace(_,P,v,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,P,v,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,P){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,P)}recursiveResolve(_,P,v,c){if(I.isString(P))return this.resolveString(_,P,v,c);if(I.isArray(P))return P.map(d=>this.recursiveResolve(_,d,v,c));if(I.isObject(P)){let d=Object.create(null);return Object.keys(P).forEach(S=>{const b=this.resolveString(_,S,v,c);d[b]=this.recursiveResolve(_,P[S],v,c)}),d}return P}resolveString(_,P,v,c){return P.replace(t.VARIABLE_REGEXP,(S,b)=>{if(b.includes(t.VARIABLE_LHS))return S;let f=this.evaluateSingleVariable(S,b,_,v);return c&&c.set(b,f),f})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,P,v,c){let d;const S=P.split(":");S.length>1&&(P=S[0],d=S[1]);const b=()=>{const a=this._context.getFilePath();if(a)return a;throw new Error(g.localize(0,null,_))},f=()=>{const a=b();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error(g.localize(1,null,_,y.basename(a)))},u=()=>{if(d){const a=this._context.getFolderUri(d);if(a)return a;throw new Error(g.localize(2,null,_,d))}if(v)return v;throw this._context.getWorkspaceFolderCount()>1?new Error(g.localize(3,null,_)):new Error(g.localize(4,null,_))};switch(P){case"env":if(d){if(this._envVariables){const a=this._envVariables[C.isWindows?d.toLowerCase():d];if(I.isString(a))return a}return""}throw new Error(g.localize(5,null,_));case"config":if(d){const a=this._context.getConfigurationValue(v,d);if(I.isUndefinedOrNull(a))throw new Error(g.localize(6,null,_,d));if(I.isObject(a))throw new Error(g.localize(7,null,_,d));return a}throw new Error(g.localize(8,null,_));case"command":return this.resolveFromMap(_,d,c,"command");case"input":return this.resolveFromMap(_,d,c,"input");default:switch(P){case"workspaceRoot":case"workspaceFolder":return L.normalizeDriveLetter(this.fsPath(u()));case"cwd":return v||d?L.normalizeDriveLetter(this.fsPath(u())):m.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return y.basename(this.fsPath(u()));case"lineNumber":const a=this._context.getLineNumber();if(a)return a;throw new Error(g.localize(9,null,_));case"selectedText":const o=this._context.getSelectedText();if(o)return o;throw new Error(g.localize(10,null,_));case"file":return b();case"fileWorkspaceFolder":return f();case"relativeFile":return v||d?y.relative(this.fsPath(u()),b()):b();case"relativeFileDirname":const n=y.dirname(b());if(v||d){const l=y.relative(this.fsPath(u()),n);return l.length===0?".":l}return n;case"fileDirname":return y.dirname(b());case"fileExtname":return y.extname(b());case"fileBasename":return y.basename(b());case"fileBasenameNoExtension":const r=y.basename(b());return r.slice(0,r.length-y.extname(r).length);case"fileDirnameBasename":return y.basename(y.dirname(b()));case"execPath":const i=this._context.getExecPath();return i||_;case"pathSeparator":return y.sep;default:try{return this.resolveFromMap(_,P,c,void 0)}catch(l){return _}}}}resolveFromMap(_,P,v,c){if(P&&v){const d=c===void 0?v[P]:v[c+":"+P];if(typeof d=="string")return d;throw new Error(g.localize(11,null,_))}return _}}e.AbstractVariableResolverService=t,t.VARIABLE_LHS="${",t.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(he[66],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=y.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(he[211],de([0,1,175,98,3,56,71,184,66,11,235,46,19,14,97]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItem=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutputItem=e.NotebookCellOutput=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(G){function q(D){const{selectionStartLineNumber:x,selectionStartColumn:X,positionLineNumber:Y,positionColumn:se}=D,le=new m.Position(x-1,X-1),we=new m.Position(Y-1,se-1);return new m.Selection(le,we)}G.to=q;function U(D){const{anchor:x,active:X}=D;return{selectionStartLineNumber:x.line+1,selectionStartColumn:x.character+1,positionLineNumber:X.line+1,positionColumn:X.character+1}}G.from=U})(d=e.Selection||(e.Selection={}));var S;(function(G){function q(D){if(!!D){const{start:x,end:X}=D;return{startLineNumber:x.line+1,startColumn:x.character+1,endLineNumber:X.line+1,endColumn:X.character+1}}}G.from=q;function U(D){if(!!D){const{startLineNumber:x,startColumn:X,endLineNumber:Y,endColumn:se}=D;return new m.Range(x-1,X-1,Y-1,se-1)}}G.to=U})(S=e.Range||(e.Range={}));var b;(function(G){function q(U){switch(U){case 1:return m.StandardTokenType.Comment;case 0:return m.StandardTokenType.Other;case 4:return m.StandardTokenType.RegEx;case 2:return m.StandardTokenType.String}}G.to=q})(b=e.TokenType||(e.TokenType={}));var f;(function(G){function q(D){return new m.Position(D.lineNumber-1,D.column-1)}G.to=q;function U(D){return{lineNumber:D.line+1,column:D.character+1}}G.from=U})(f=e.Position||(e.Position={}));var u;(function(G){function q(D){switch(D){case m.DiagnosticTag.Unnecessary:return 1;case m.DiagnosticTag.Deprecated:return 2}}G.from=q;function U(D){switch(D){case 1:return m.DiagnosticTag.Unnecessary;case 2:return m.DiagnosticTag.Deprecated;default:return}}G.to=U})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(G){function q(D){let x;return D.code&&(t.isString(D.code)||t.isNumber(D.code)?x=String(D.code):x={value:String(D.code.value),target:D.code.target}),Object.assign(Object.assign({},S.from(D.range)),{message:D.message,source:D.source,code:x,severity:n.from(D.severity),relatedInformation:D.relatedInformation&&D.relatedInformation.map(o.from),tags:Array.isArray(D.tags)?v.coalesce(D.tags.map(u.from)):void 0})}G.from=q;function U(D){var x;const X=new m.Diagnostic(S.to(D),D.message,n.to(D.severity));return X.source=D.source,X.code=t.isString(D.code)?D.code:(x=D.code)===null||x===void 0?void 0:x.value,X.relatedInformation=D.relatedInformation&&D.relatedInformation.map(o.to),X.tags=D.tags&&v.coalesce(D.tags.map(u.to)),X}G.to=U})(a=e.Diagnostic||(e.Diagnostic={}));var o;(function(G){function q(D){return Object.assign(Object.assign({},S.from(D.location.range)),{message:D.message,resource:D.location.uri})}G.from=q;function U(D){return new m.DiagnosticRelatedInformation(new m.Location(D.resource,S.to(D)),D.message)}G.to=U})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(G){function q(D){switch(D){case m.DiagnosticSeverity.Error:return L.MarkerSeverity.Error;case m.DiagnosticSeverity.Warning:return L.MarkerSeverity.Warning;case m.DiagnosticSeverity.Information:return L.MarkerSeverity.Info;case m.DiagnosticSeverity.Hint:return L.MarkerSeverity.Hint}return L.MarkerSeverity.Error}G.from=q;function U(D){switch(D){case L.MarkerSeverity.Info:return m.DiagnosticSeverity.Information;case L.MarkerSeverity.Warning:return m.DiagnosticSeverity.Warning;case L.MarkerSeverity.Error:return m.DiagnosticSeverity.Error;case L.MarkerSeverity.Hint:return m.DiagnosticSeverity.Hint;default:return m.DiagnosticSeverity.Error}}G.to=U})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(G){function q(D){return typeof D=="number"&&D>=m.ViewColumn.One?D-1:D===m.ViewColumn.Beside?g.SIDE_GROUP:g.ACTIVE_GROUP}G.from=q;function U(D){if(typeof D=="number"&&D>=0)return D+1;throw new Error("invalid 'EditorGroupColumn'")}G.to=U})(r=e.ViewColumn||(e.ViewColumn={}));function i(G){return typeof G.range!="undefined"}function l(G){return G.length===0?!0:!!i(G[0])}e.isDecorationOptionsArr=l;var s;(function(G){function q(se){return se.map(G.from)}G.fromMany=q;function U(se){return se&&typeof se=="object"&&typeof se.language=="string"&&typeof se.value=="string"}function D(se){let le;if(U(se)){const{language:Ae,value:$e}=se;le={value:"```"+Ae+`
`+$e+"\n```\n"}}else m.MarkdownString.isMarkdownString(se)?le={value:se.value,isTrusted:se.isTrusted,supportThemeIcons:se.supportThemeIcons}:typeof se=="string"?le={value:se}:le={value:""};const we=Object.create(null);le.uris=we;const Te=Ae=>{try{let $e=I.URI.parse(Ae,!0);$e=$e.with({query:x($e.query,we)}),we[Ae]=$e}catch($e){}return""},Le=new R.Renderer;return Le.link=Te,Le.image=Ae=>Te(C.parseHrefAndDimensions(Ae).href),R(le.value,{renderer:Le}),le}G.from=D;function x(se,le){if(!se)return se;let we;try{we=_.parse(se)}catch(Le){}if(!we)return se;let Te=!1;return we=P.cloneAndChange(we,Le=>{if(I.URI.isUri(Le)){const Ae=`__uri_${Math.random().toString(16).slice(2,8)}`;return le[Ae]=Le,Te=!0,Ae}else return}),Te?JSON.stringify(we):se}function X(se){const le=new m.MarkdownString(se.value,se.supportThemeIcons);return le.isTrusted=se.isTrusted,le}G.to=X;function Y(se){if(!!se)return typeof se=="string"?se:G.from(se)}G.fromStrict=Y})(s=e.MarkdownString||(e.MarkdownString={}));function p(G){return l(G)?G.map(q=>({range:S.from(q.range),hoverMessage:Array.isArray(q.hoverMessage)?s.fromMany(q.hoverMessage):q.hoverMessage?s.from(q.hoverMessage):void 0,renderOptions:q.renderOptions})):G.map(q=>({range:S.from(q)}))}e.fromRangeOrRangeWithMessage=p;function k(G){return typeof G=="undefined"?G:typeof G=="string"?I.URI.file(G):G}e.pathOrURIToURI=k;var w;(function(G){function q(U){return typeof U=="undefined"?U:{contentText:U.contentText,contentIconPath:U.contentIconPath?k(U.contentIconPath):void 0,border:U.border,borderColor:U.borderColor,fontStyle:U.fontStyle,fontWeight:U.fontWeight,textDecoration:U.textDecoration,color:U.color,backgroundColor:U.backgroundColor,margin:U.margin,width:U.width,height:U.height}}G.from=q})(w=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var T;(function(G){function q(U){return typeof U=="undefined"?U:{backgroundColor:U.backgroundColor,outline:U.outline,outlineColor:U.outlineColor,outlineStyle:U.outlineStyle,outlineWidth:U.outlineWidth,border:U.border,borderColor:U.borderColor,borderRadius:U.borderRadius,borderSpacing:U.borderSpacing,borderStyle:U.borderStyle,borderWidth:U.borderWidth,fontStyle:U.fontStyle,fontWeight:U.fontWeight,textDecoration:U.textDecoration,cursor:U.cursor,color:U.color,opacity:U.opacity,letterSpacing:U.letterSpacing,gutterIconPath:U.gutterIconPath?k(U.gutterIconPath):void 0,gutterIconSize:U.gutterIconSize,overviewRulerColor:U.overviewRulerColor,before:U.before?w.from(U.before):void 0,after:U.after?w.from(U.after):void 0}}G.from=q})(T=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var h;(function(G){function q(U){if(typeof U=="undefined")return U;switch(U){case m.DecorationRangeBehavior.OpenOpen:return 0;case m.DecorationRangeBehavior.ClosedClosed:return 1;case m.DecorationRangeBehavior.OpenClosed:return 2;case m.DecorationRangeBehavior.ClosedOpen:return 3}}G.from=q})(h=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var A;(function(G){function q(U){return{isWholeLine:U.isWholeLine,rangeBehavior:U.rangeBehavior?h.from(U.rangeBehavior):void 0,overviewRulerLane:U.overviewRulerLane,light:U.light?T.from(U.light):void 0,dark:U.dark?T.from(U.dark):void 0,backgroundColor:U.backgroundColor,outline:U.outline,outlineColor:U.outlineColor,outlineStyle:U.outlineStyle,outlineWidth:U.outlineWidth,border:U.border,borderColor:U.borderColor,borderRadius:U.borderRadius,borderSpacing:U.borderSpacing,borderStyle:U.borderStyle,borderWidth:U.borderWidth,fontStyle:U.fontStyle,fontWeight:U.fontWeight,textDecoration:U.textDecoration,cursor:U.cursor,color:U.color,opacity:U.opacity,letterSpacing:U.letterSpacing,gutterIconPath:U.gutterIconPath?k(U.gutterIconPath):void 0,gutterIconSize:U.gutterIconSize,overviewRulerColor:U.overviewRulerColor,before:U.before?w.from(U.before):void 0,after:U.after?w.from(U.after):void 0}}G.from=q})(A=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(G){function q(D){return{text:D.newText,eol:D.newEol&&ke.from(D.newEol),range:S.from(D.range)}}G.from=q;function U(D){const x=new m.TextEdit(S.to(D.range),D.text);return x.newEol=typeof D.eol=="undefined"?void 0:ke.to(D.eol),x}G.to=U})(N=e.TextEdit||(e.TextEdit={}));var B;(function(G){function q(D,x,X){var Y;const se={edits:[]};if(D instanceof m.WorkspaceEdit)for(let le of D._allEntries())if(le._type===1)se.edits.push({_type:1,oldUri:le.from,newUri:le.to,options:le.options,metadata:le.metadata});else if(le._type===2){const we=x==null?void 0:x.getDocument(le.uri);se.edits.push({_type:2,resource:le.uri,edit:N.from(le.edit),modelVersionId:we==null?void 0:we.version,metadata:le.metadata})}else le._type===3&&se.edits.push({_type:3,metadata:le.metadata,resource:le.uri,edit:le.edit,notebookMetadata:le.notebookMetadata,notebookVersionId:(Y=X==null?void 0:X.lookupNotebookDocument(le.uri))===null||Y===void 0?void 0:Y.notebookDocument.version});return se}G.from=q;function U(D){const x=new m.WorkspaceEdit;for(const X of D.edits)X.edit?x.replace(I.URI.revive(X.resource),S.to(X.edit.range),X.edit.text):x.renameFile(I.URI.revive(X.oldUri),I.URI.revive(X.newUri),X.options);return x}G.to=U})(B=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(G){const q=Object.create(null);q[m.SymbolKind.File]=0,q[m.SymbolKind.Module]=1,q[m.SymbolKind.Namespace]=2,q[m.SymbolKind.Package]=3,q[m.SymbolKind.Class]=4,q[m.SymbolKind.Method]=5,q[m.SymbolKind.Property]=6,q[m.SymbolKind.Field]=7,q[m.SymbolKind.Constructor]=8,q[m.SymbolKind.Enum]=9,q[m.SymbolKind.Interface]=10,q[m.SymbolKind.Function]=11,q[m.SymbolKind.Variable]=12,q[m.SymbolKind.Constant]=13,q[m.SymbolKind.String]=14,q[m.SymbolKind.Number]=15,q[m.SymbolKind.Boolean]=16,q[m.SymbolKind.Array]=17,q[m.SymbolKind.Object]=18,q[m.SymbolKind.Key]=19,q[m.SymbolKind.Null]=20,q[m.SymbolKind.EnumMember]=21,q[m.SymbolKind.Struct]=22,q[m.SymbolKind.Event]=23,q[m.SymbolKind.Operator]=24,q[m.SymbolKind.TypeParameter]=25;function U(x){return typeof q[x]=="number"?q[x]:6}G.from=U;function D(x){for(const X in q)if(q[X]===x)return Number(X);return m.SymbolKind.Property}G.to=D})(W=e.SymbolKind||(e.SymbolKind={}));var H;(function(G){function q(D){switch(D){case m.SymbolTag.Deprecated:return 1}}G.from=q;function U(D){switch(D){case 1:return m.SymbolTag.Deprecated}}G.to=U})(H=e.SymbolTag||(e.SymbolTag={}));var K;(function(G){function q(D){return{name:D.name,kind:W.from(D.kind),tags:D.tags&&D.tags.map(H.from),containerName:D.containerName,location:$.from(D.location)}}G.from=q;function U(D){const x=new m.SymbolInformation(D.name,W.to(D.kind),D.containerName,$.to(D.location));return x.tags=D.tags&&D.tags.map(H.to),x}G.to=U})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var re;(function(G){function q(D){var x,X;const Y={name:D.name||"!!MISSING: name!!",detail:D.detail,range:S.from(D.range),selectionRange:S.from(D.selectionRange),kind:W.from(D.kind),tags:(X=(x=D.tags)===null||x===void 0?void 0:x.map(H.from))!==null&&X!==void 0?X:[]};return D.children&&(Y.children=D.children.map(q)),Y}G.from=q;function U(D){const x=new m.DocumentSymbol(D.name,D.detail,W.to(D.kind),S.to(D.range),S.to(D.selectionRange));return v.isNonEmptyArray(D.tags)&&(x.tags=D.tags.map(H.to)),D.children&&(x.children=D.children.map(U)),x}G.to=U})(re=e.DocumentSymbol||(e.DocumentSymbol={}));var V;(function(G){function q(U){const D=new m.CallHierarchyItem(W.to(U.kind),U.name,U.detail||"",I.URI.revive(U.uri),S.to(U.range),S.to(U.selectionRange));return D._sessionId=U._sessionId,D._itemId=U._itemId,D}G.to=q})(V=e.CallHierarchyItem||(e.CallHierarchyItem={}));var J;(function(G){function q(U){return new m.CallHierarchyIncomingCall(V.to(U.from),U.fromRanges.map(D=>S.to(D)))}G.to=q})(J=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ce;(function(G){function q(U){return new m.CallHierarchyOutgoingCall(V.to(U.to),U.fromRanges.map(D=>S.to(D)))}G.to=q})(ce=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(G){function q(D){return{range:D.range&&S.from(D.range),uri:D.uri}}G.from=q;function U(D){return new m.Location(D.uri,S.to(D.range))}G.to=U})($=e.location||(e.location={}));var O;(function(G){function q(D){const x=D,X=D;return{originSelectionRange:x.originSelectionRange?S.from(x.originSelectionRange):void 0,uri:x.targetUri?x.targetUri:X.uri,range:S.from(x.targetRange?x.targetRange:X.range),targetSelectionRange:x.targetSelectionRange?S.from(x.targetSelectionRange):void 0}}G.from=q;function U(D){return{targetUri:D.uri,targetRange:S.to(D.range),targetSelectionRange:D.targetSelectionRange?S.to(D.targetSelectionRange):void 0,originSelectionRange:D.originSelectionRange?S.to(D.originSelectionRange):void 0}}G.to=U})(O=e.DefinitionLink||(e.DefinitionLink={}));var F;(function(G){function q(D){return{range:S.from(D.range),contents:s.fromMany(D.contents)}}G.from=q;function U(D){return new m.Hover(D.contents.map(s.to),S.to(D.range))}G.to=U})(F=e.Hover||(e.Hover={}));var j;(function(G){function q(D){return{range:S.from(D.range),expression:D.expression}}G.from=q;function U(D){return new m.EvaluatableExpression(S.to(D.range),D.expression)}G.to=U})(j=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Q;(function(G){function q(D){return{range:S.from(D.range),kind:D.kind}}G.from=q;function U(D){return new m.DocumentHighlight(S.to(D.range),D.kind)}G.to=U})(Q=e.DocumentHighlight||(e.DocumentHighlight={}));var ne;(function(G){function q(U){switch(U){case 1:return m.CompletionTriggerKind.TriggerCharacter;case 2:return m.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return m.CompletionTriggerKind.Invoke}}G.to=q})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(G){function q(U){return{triggerKind:ne.to(U.triggerKind),triggerCharacter:U.triggerCharacter}}G.to=q})(oe=e.CompletionContext||(e.CompletionContext={}));var ie;(function(G){function q(D){switch(D){case m.CompletionItemTag.Deprecated:return 1}}G.from=q;function U(D){switch(D){case 1:return m.CompletionItemTag.Deprecated}}G.to=U})(ie=e.CompletionItemTag||(e.CompletionItemTag={}));var fe;(function(G){const q=new Map([[m.CompletionItemKind.Method,0],[m.CompletionItemKind.Function,1],[m.CompletionItemKind.Constructor,2],[m.CompletionItemKind.Field,3],[m.CompletionItemKind.Variable,4],[m.CompletionItemKind.Class,5],[m.CompletionItemKind.Interface,7],[m.CompletionItemKind.Struct,6],[m.CompletionItemKind.Module,8],[m.CompletionItemKind.Property,9],[m.CompletionItemKind.Unit,12],[m.CompletionItemKind.Value,13],[m.CompletionItemKind.Constant,14],[m.CompletionItemKind.Enum,15],[m.CompletionItemKind.EnumMember,16],[m.CompletionItemKind.Keyword,17],[m.CompletionItemKind.Snippet,27],[m.CompletionItemKind.Text,18],[m.CompletionItemKind.Color,19],[m.CompletionItemKind.File,20],[m.CompletionItemKind.Reference,21],[m.CompletionItemKind.Folder,23],[m.CompletionItemKind.Event,10],[m.CompletionItemKind.Operator,11],[m.CompletionItemKind.TypeParameter,24],[m.CompletionItemKind.Issue,26],[m.CompletionItemKind.User,25]]);function U(X){var Y;return(Y=q.get(X))!==null&&Y!==void 0?Y:9}G.from=U;const D=new Map([[0,m.CompletionItemKind.Method],[1,m.CompletionItemKind.Function],[2,m.CompletionItemKind.Constructor],[3,m.CompletionItemKind.Field],[4,m.CompletionItemKind.Variable],[5,m.CompletionItemKind.Class],[7,m.CompletionItemKind.Interface],[6,m.CompletionItemKind.Struct],[8,m.CompletionItemKind.Module],[9,m.CompletionItemKind.Property],[12,m.CompletionItemKind.Unit],[13,m.CompletionItemKind.Value],[14,m.CompletionItemKind.Constant],[15,m.CompletionItemKind.Enum],[16,m.CompletionItemKind.EnumMember],[17,m.CompletionItemKind.Keyword],[27,m.CompletionItemKind.Snippet],[18,m.CompletionItemKind.Text],[19,m.CompletionItemKind.Color],[20,m.CompletionItemKind.File],[21,m.CompletionItemKind.Reference],[23,m.CompletionItemKind.Folder],[10,m.CompletionItemKind.Event],[11,m.CompletionItemKind.Operator],[24,m.CompletionItemKind.TypeParameter],[25,m.CompletionItemKind.User],[26,m.CompletionItemKind.Issue]]);function x(X){var Y;return(Y=D.get(X))!==null&&Y!==void 0?Y:m.CompletionItemKind.Property}G.to=x})(fe=e.CompletionItemKind||(e.CompletionItemKind={}));var Ie;(function(G){function q(U,D){var x;const X=new m.CompletionItem(typeof U.label=="string"?U.label:U.label.name);return typeof U.label!="string"&&(X.label2=U.label),X.insertText=U.insertText,X.kind=fe.to(U.kind),X.tags=(x=U.tags)===null||x===void 0?void 0:x.map(ie.to),X.detail=U.detail,X.documentation=C.isMarkdownString(U.documentation)?s.to(U.documentation):U.documentation,X.sortText=U.sortText,X.filterText=U.filterText,X.preselect=U.preselect,X.commitCharacters=U.commitCharacters,E.Range.isIRange(U.range)?X.range=S.to(U.range):typeof U.range=="object"&&(X.range={inserting:S.to(U.range.insert),replacing:S.to(U.range.replace)}),X.keepWhitespace=typeof U.insertTextRules=="undefined"?!1:Boolean(U.insertTextRules&1),typeof U.insertTextRules!="undefined"&&U.insertTextRules&4?X.insertText=new m.SnippetString(U.insertText):(X.insertText=U.insertText,X.textEdit=X.range instanceof m.Range?new m.TextEdit(X.range,X.insertText):void 0),U.additionalTextEdits&&U.additionalTextEdits.length>0&&(X.additionalTextEdits=U.additionalTextEdits.map(Y=>N.to(Y))),X.command=D&&U.command?D.fromInternal(U.command):void 0,X}G.to=q})(Ie=e.CompletionItem||(e.CompletionItem={}));var Pe;(function(G){function q(D){return{label:D.label,documentation:D.documentation?s.fromStrict(D.documentation):void 0}}G.from=q;function U(D){return{label:D.label,documentation:C.isMarkdownString(D.documentation)?s.to(D.documentation):D.documentation}}G.to=U})(Pe=e.ParameterInformation||(e.ParameterInformation={}));var Ne;(function(G){function q(D){return{label:D.label,documentation:D.documentation?s.fromStrict(D.documentation):void 0,parameters:Array.isArray(D.parameters)?D.parameters.map(Pe.from):[],activeParameter:D.activeParameter}}G.from=q;function U(D){return{label:D.label,documentation:C.isMarkdownString(D.documentation)?s.to(D.documentation):D.documentation,parameters:Array.isArray(D.parameters)?D.parameters.map(Pe.to):[],activeParameter:D.activeParameter}}G.to=U})(Ne=e.SignatureInformation||(e.SignatureInformation={}));var ye;(function(G){function q(D){return{activeSignature:D.activeSignature,activeParameter:D.activeParameter,signatures:Array.isArray(D.signatures)?D.signatures.map(Ne.from):[]}}G.from=q;function U(D){return{activeSignature:D.activeSignature,activeParameter:D.activeParameter,signatures:Array.isArray(D.signatures)?D.signatures.map(Ne.to):[]}}G.to=U})(ye=e.SignatureHelp||(e.SignatureHelp={}));var _e;(function(G){function q(D){return{text:D.text,range:S.from(D.range),description:D.description&&s.fromStrict(D.description),whitespaceBefore:D.whitespaceBefore,whitespaceAfter:D.whitespaceAfter}}G.from=q;function U(D){return new m.InlineHint(D.text,S.to(D.range),C.isMarkdownString(D.description)?s.to(D.description):D.description,D.whitespaceBefore,D.whitespaceAfter)}G.to=U})(_e=e.InlineHint||(e.InlineHint={}));var Ce;(function(G){function q(D){return{range:S.from(D.range),url:D.target,tooltip:D.tooltip}}G.from=q;function U(D){let x;if(D.url)try{x=typeof D.url=="string"?I.URI.parse(D.url,!0):I.URI.revive(D.url)}catch(X){}return new m.DocumentLink(S.to(D.range),x)}G.to=U})(Ce=e.DocumentLink||(e.DocumentLink={}));var ze;(function(G){function q(D){const x=new m.ColorPresentation(D.label);return D.textEdit&&(x.textEdit=N.to(D.textEdit)),D.additionalTextEdits&&(x.additionalTextEdits=D.additionalTextEdits.map(X=>N.to(X))),x}G.to=q;function U(D){return{label:D.label,textEdit:D.textEdit?N.from(D.textEdit):void 0,additionalTextEdits:D.additionalTextEdits?D.additionalTextEdits.map(x=>N.from(x)):void 0}}G.from=U})(ze=e.ColorPresentation||(e.ColorPresentation={}));var je;(function(G){function q(D){return new m.Color(D[0],D[1],D[2],D[3])}G.to=q;function U(D){return[D.red,D.green,D.blue,D.alpha]}G.from=U})(je=e.Color||(e.Color={}));var me;(function(G){function q(D){return{range:S.from(D.range)}}G.from=q;function U(D){return new m.SelectionRange(S.to(D.range))}G.to=U})(me=e.SelectionRange||(e.SelectionRange={}));var ve;(function(G){function q(U){switch(U){case 2:return m.TextDocumentSaveReason.AfterDelay;case 1:return m.TextDocumentSaveReason.Manual;case 3:case 4:return m.TextDocumentSaveReason.FocusOut}}G.to=q})(ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Se;(function(G){function q(D){switch(D){case m.TextEditorLineNumbersStyle.Off:return 0;case m.TextEditorLineNumbersStyle.Relative:return 2;case m.TextEditorLineNumbersStyle.On:default:return 1}}G.from=q;function U(D){switch(D){case 0:return m.TextEditorLineNumbersStyle.Off;case 2:return m.TextEditorLineNumbersStyle.Relative;case 1:default:return m.TextEditorLineNumbersStyle.On}}G.to=U})(Se=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ke;(function(G){function q(D){if(D===m.EndOfLine.CRLF)return 1;if(D===m.EndOfLine.LF)return 0}G.from=q;function U(D){if(D===1)return m.EndOfLine.CRLF;if(D===0)return m.EndOfLine.LF}G.to=U})(ke=e.EndOfLine||(e.EndOfLine={}));var Re;(function(G){function q(U){if(typeof U=="object")return U.viewId;switch(U){case m.ProgressLocation.SourceControl:return 3;case m.ProgressLocation.Window:return 10;case m.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}G.from=q})(Re=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(G){function q(U){const D={start:U.start+1,end:U.end+1};return U.kind&&(D.kind=We.from(U.kind)),D}G.from=q})(Fe=e.FoldingRange||(e.FoldingRange={}));var We;(function(G){function q(U){if(U)switch(U){case m.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case m.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case m.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}G.from=q})(We=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Be;(function(G){function q(U){if(U)return{pinned:typeof U.preview=="boolean"?!U.preview:void 0,inactive:U.background,preserveFocus:U.preserveFocus,selection:typeof U.selection=="object"?S.from(U.selection):void 0,override:typeof U.override=="boolean"?!1:void 0}}G.from=q})(Be=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ve;(function(G){function q(D){return D instanceof m.RelativePattern||typeof D=="string"?D:U(D)?new m.RelativePattern(D.base,D.pattern):D}G.from=q;function U(D){const x=D;return x&&typeof x.base=="string"&&typeof x.pattern=="string"}})(Ve=e.GlobPattern||(e.GlobPattern={}));var ae;(function(G){function q(U){if(U)return Array.isArray(U)?U.map(q):typeof U=="string"?U:{language:U.language,scheme:U.scheme,pattern:typeof U.pattern=="undefined"?void 0:Ve.from(U.pattern),exclusive:U.exclusive}}G.from=q})(ae=e.LanguageSelector||(e.LanguageSelector={}));var ge;(function(G){function q(U){return U.toJSON()}G.from=q})(ge=e.NotebookCellOutput||(e.NotebookCellOutput={}));var pe;(function(G){function q(U){return{outputKind:c.CellOutputKind.Rich,data:{[U.mime]:U.value},metadata:U.metadata&&{custom:U.metadata}}}G.from=q})(pe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Oe;(function(G){function q(X){if(X!=null){if(X instanceof m.RelativePattern||typeof X=="string")return X;if(x(X))return new m.RelativePattern(X.base,X.pattern);if(D(X))return{include:Ve.from(X.include)||void 0,exclude:Ve.from(X.exclude)||void 0}}}G.from=q;function U(X){return typeof X=="string"?X:x(X)?{base:X.base,pattern:X.pattern}:{include:X.include,exclude:X.exclude}}G.to=U;function D(X){const Y=X,se=Ve.from(Y.include);if(!(se&&se instanceof m.RelativePattern||typeof se=="string"))return!1;const le=Ve.from(Y.exclude);return!!(le&&le instanceof m.RelativePattern||typeof le=="string")}function x(X){const Y=X;return Y&&typeof Y.base=="string"&&typeof Y.pattern=="string"}})(Oe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ee;(function(G){function q(U){return{backgroundColor:U.backgroundColor,borderColor:U.borderColor,top:U.top?w.from(U.top):void 0}}G.from=q})(ee=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ue;(function(G){function q(D){return{runState:D.runState,duration:D.duration,messages:D.messages.map(x=>({message:s.fromStrict(x.message)||"",severity:x.severity,expectedOutput:x.expectedOutput,actualOutput:x.actualOutput,location:x.location?$.from(x.location):void 0}))}}G.from=q;function U(D){return new m.TestState(D.runState,D.messages.map(x=>({message:typeof x.message=="string"?x.message:s.to(x.message),severity:x.severity,expectedOutput:x.expectedOutput,actualOutput:x.actualOutput,location:x.location&&$.to({range:x.location.range,uri:I.URI.revive(x.location.uri)})})),D.duration)}G.to=U})(ue=e.TestState||(e.TestState={}));var Ee;(function(G){function q(D,x){var X,Y,se;return{extId:(X=D.id)!==null&&X!==void 0?X:x?`${x}\0${D.label}`:D.label,label:D.label,location:D.location?$.from(D.location):void 0,debuggable:(Y=D.debuggable)!==null&&Y!==void 0?Y:!1,description:D.description,runnable:(se=D.runnable)!==null&&se!==void 0?se:!0,state:ue.from(D.state)}}G.from=q;function U(D){return{id:D.extId,label:D.label,location:D.location&&$.to({range:D.location.range,uri:I.URI.revive(D.location.uri)}),debuggable:D.debuggable,description:D.description,runnable:D.runnable,state:ue.to(D.state)}}G.toShallow=U})(Ee=e.TestItem||(e.TestItem={}))}),define(he[212],de([0,1,158,6,11,3,4,7,49,31,131,14,66]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.editorGroupToViewColumn=e.viewColumnToEditorGroup=e.computeEditorAriaLabel=e.EditorsOrder=e.pathsToEditors=e.Extensions=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCommandsContextActionRunner=e.TextEditorOptions=e.EditorOptions=e.isEditorInputWithOptions=e.EditorModel=e.SideBySideEditorInput=e.isEditorInputWithPreferredResource=e.EncodingMode=e.EditorInput=e.SaveReason=e.Verbosity=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=void 0,e.ActiveEditorDirtyContext=new g.RawContextKey("activeEditorIsDirty",!1),e.ActiveEditorPinnedContext=new g.RawContextKey("activeEditorIsNotPreview",!1),e.ActiveEditorStickyContext=new g.RawContextKey("activeEditorIsPinned",!1),e.ActiveEditorReadonlyContext=new g.RawContextKey("activeEditorIsReadonly",!1),e.ActiveEditorContext=new g.RawContextKey("activeEditor",null),e.ActiveEditorAvailableEditorIdsContext=new g.RawContextKey("activeEditorAvailableEditorIds",""),e.TextCompareEditorVisibleContext=new g.RawContextKey("textCompareEditorVisible",!1),e.TextCompareEditorActiveContext=new g.RawContextKey("textCompareEditorActive",!1),e.EditorGroupEditorsCountContext=new g.RawContextKey("groupEditorsCount",0),e.ActiveEditorGroupEmptyContext=new g.RawContextKey("activeEditorGroupEmpty",!1),e.ActiveEditorGroupIndexContext=new g.RawContextKey("activeEditorGroupIndex",0),e.ActiveEditorGroupLastContext=new g.RawContextKey("activeEditorGroupLast",!1),e.MultipleEditorGroupsContext=new g.RawContextKey("multipleEditorGroups",!1),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new g.RawContextKey("editorIsOpen",!1),e.InEditorZenModeContext=new g.RawContextKey("inZenMode",!1),e.IsCenteredLayoutContext=new g.RawContextKey("isCenteredLayout",!1),e.SplitEditorsVertically=new g.RawContextKey("splitEditorsVertically",!1),e.EditorAreaVisibleContext=new g.RawContextKey("editorAreaVisible",!0),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function v(B){const W=B;return typeof(W==null?void 0:W.getViewState)=="function"}e.isTextEditorPane=v;var c;(function(B){B[B.SHORT=0]="SHORT",B[B.MEDIUM=1]="MEDIUM",B[B.LONG=2]="LONG"})(c=e.Verbosity||(e.Verbosity={}));var d;(function(B){B[B.EXPLICIT=1]="EXPLICIT",B[B.AUTO=2]="AUTO",B[B.FOCUS_CHANGE=3]="FOCUS_CHANGE",B[B.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d=e.SaveReason||(e.SaveReason={}));class S extends C.Disposable{constructor(){super(...arguments);this._onDidChangeDirty=this._register(new m.Emitter),this.onDidChangeDirty=this._onDidChangeDirty.event,this._onDidChangeLabel=this._register(new m.Emitter),this.onDidChangeLabel=this._onDidChangeLabel.event,this._onDispose=this._register(new m.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}getName(){return`Editor ${this.getTypeId()}`}getDescription(W){}getTitle(W){return this.getName()}getAriaLabel(){return this.getTitle(0)}getPreferredEditorId(W){return _.firstOrDefault(W)}getTelemetryDescriptor(){return{typeId:this.getTypeId()}}isReadonly(){return!0}isUntitled(){return!1}isDirty(){return!1}isSaving(){return!1}async resolve(){return null}async save(W,H){return this}async saveAs(W,H){return this}async revert(W,H){}rename(W,H){}supportsSplitEditor(){return!0}matches(W){return this===W}isDisposed(){return this.disposed}dispose(){this.disposed||(this.disposed=!0,this._onDispose.fire()),super.dispose()}}e.EditorInput=S;var b;(function(B){B[B.Encode=0]="Encode",B[B.Decode=1]="Decode"})(b=e.EncodingMode||(e.EncodingMode={}));function f(B){const W=B;return W&&!!W.preferredResource}e.isEditorInputWithPreferredResource=f;class u extends S{constructor(W,H,K,re){super();this.name=W,this.description=H,this._secondary=K,this._primary=re,this.registerListeners()}registerListeners(){const W=m.Event.once(this.secondary.onDispose);this._register(W(()=>{this.isDisposed()||this.dispose()}));const H=m.Event.once(this.primary.onDispose);this._register(H(()=>{this.isDisposed()||this.dispose()})),this._register(this.primary.onDidChangeDirty(()=>this._onDidChangeDirty.fire())),this._register(this.primary.onDidChangeLabel(()=>this._onDidChangeLabel.fire()))}get resource(){}get primary(){return this._primary}get secondary(){return this._secondary}getTypeId(){return u.ID}getName(){return this.name?this.name:y.localize(0,null,this._secondary.getName(),this._primary.getName())}getDescription(){return this.description}isReadonly(){return this.primary.isReadonly()}isUntitled(){return this.primary.isUntitled()}isDirty(){return this.primary.isDirty()}isSaving(){return this.primary.isSaving()}save(W,H){return this.primary.save(W,H)}saveAs(W,H){return this.primary.saveAs(W,H)}revert(W,H){return this.primary.revert(W,H)}getTelemetryDescriptor(){const W=this.primary.getTelemetryDescriptor();return Object.assign(W,super.getTelemetryDescriptor())}matches(W){return W===this?!0:W instanceof u?this.primary.matches(W.primary)&&this.secondary.matches(W.secondary):!1}}e.SideBySideEditorInput=u,u.ID="workbench.editorinputs.sidebysideEditorInput";class a extends C.Disposable{constructor(){super(...arguments);this._onDispose=this._register(new m.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}async load(){return this}isResolved(){return!0}isDisposed(){return this.disposed}dispose(){this.disposed=!0,this._onDispose.fire(),super.dispose()}}e.EditorModel=a;function o(B){const W=B;return!!W&&!!W.editor}e.isEditorInputWithOptions=o;class n{static create(W){const H=new n;return H.overwrite(W),H}overwrite(W){return typeof W.forceReload=="boolean"&&(this.forceReload=W.forceReload),typeof W.revealIfVisible=="boolean"&&(this.revealIfVisible=W.revealIfVisible),typeof W.revealIfOpened=="boolean"&&(this.revealIfOpened=W.revealIfOpened),typeof W.preserveFocus=="boolean"&&(this.preserveFocus=W.preserveFocus),typeof W.activation=="number"&&(this.activation=W.activation),typeof W.pinned=="boolean"&&(this.pinned=W.pinned),typeof W.sticky=="boolean"&&(this.sticky=W.sticky),typeof W.inactive=="boolean"&&(this.inactive=W.inactive),typeof W.ignoreError=="boolean"&&(this.ignoreError=W.ignoreError),typeof W.index=="number"&&(this.index=W.index),(typeof W.override=="string"||W.override===!1)&&(this.override=W.override),typeof W.context=="number"&&(this.context=W.context),this}}e.EditorOptions=n;class r extends n{static from(W){if(!!(W==null?void 0:W.options))return r.create(W.options)}static create(W=Object.create(null)){const H=new r;return H.overwrite(W),H}overwrite(W){var H,K;return super.overwrite(W),W.selection&&(this.selection={startLineNumber:W.selection.startLineNumber,startColumn:W.selection.startColumn,endLineNumber:(H=W.selection.endLineNumber)!==null&&H!==void 0?H:W.selection.startLineNumber,endColumn:(K=W.selection.endColumn)!==null&&K!==void 0?K:W.selection.startColumn}),W.viewState&&(this.editorViewState=W.viewState),typeof W.selectionRevealType!="undefined"&&(this.selectionRevealType=W.selectionRevealType),this}hasOptionsDefined(){return!!this.editorViewState||!!this.selectionRevealType||!!this.selection}static fromEditor(W,H){const K=r.create(H);return K.editorViewState=I.withNullAsUndefined(W.saveViewState()),K}apply(W,H){var K,re;let V=!1;if(this.editorViewState)W.restoreViewState(this.editorViewState),V=!0;else if(this.selection){const J={startLineNumber:this.selection.startLineNumber,startColumn:this.selection.startColumn,endLineNumber:(K=this.selection.endLineNumber)!==null&&K!==void 0?K:this.selection.startLineNumber,endColumn:(re=this.selection.endColumn)!==null&&re!==void 0?re:this.selection.startColumn};W.setSelection(J),this.selectionRevealType===2?W.revealRangeNearTop(J,H):this.selectionRevealType===3?W.revealRangeNearTopIfOutsideViewport(J,H):this.selectionRevealType===1?W.revealRangeInCenterIfOutsideViewport(J,H):W.revealRangeInCenter(J,H),V=!0}return V}}e.TextEditorOptions=r;class i extends R.ActionRunner{constructor(W){super();this.context=W}run(W){return super.run(W,this.context)}}e.EditorCommandsContextActionRunner=i;var l;(function(B){B[B.PRIMARY=1]="PRIMARY",B[B.SECONDARY=2]="SECONDARY",B[B.BOTH=3]="BOTH"})(l=e.SideBySideEditor||(e.SideBySideEditor={}));class s{getOriginalUri(W,H){if(!!W){if((H==null?void 0:H.supportSideBySide)&&W instanceof u){if((H==null?void 0:H.supportSideBySide)===l.BOTH)return{primary:this.getOriginalUri(W.primary,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(W.secondary,{filterByScheme:H.filterByScheme})};W=H.supportSideBySide===l.PRIMARY?W.primary:W.secondary}const K=f(W)?W.preferredResource:W.resource;return!K||!H||!H.filterByScheme?K:this.filterUri(K,H.filterByScheme)}}getCanonicalUri(W,H){if(!!W){if((H==null?void 0:H.supportSideBySide)&&W instanceof u){if((H==null?void 0:H.supportSideBySide)===l.BOTH)return{primary:this.getCanonicalUri(W.primary,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(W.secondary,{filterByScheme:H.filterByScheme})};W=H.supportSideBySide===l.PRIMARY?W.primary:W.secondary}const K=W.resource;return!K||!H||!H.filterByScheme?K:this.filterUri(K,H.filterByScheme)}}filterUri(W,H){if(Array.isArray(H)){if(H.some(K=>W.scheme===K))return W}else if(H===W.scheme)return W}}e.EditorResourceAccessor=new s;var p;(function(B){B[B.LEFT=0]="LEFT",B[B.RIGHT=1]="RIGHT"})(p=e.CloseDirection||(e.CloseDirection={}));class k{constructor(){this.customEditorInputFactoryInstances=new Map,this.editorInputFactoryConstructors=new Map,this.editorInputFactoryInstances=new Map}start(W){const H=this.instantiationService=W.get(L.IInstantiationService);this.editorInputFactoryConstructors.forEach((K,re)=>{this.createEditorInputFactory(re,K,H)}),this.editorInputFactoryConstructors.clear()}createEditorInputFactory(W,H,K){const re=K.createInstance(H);this.editorInputFactoryInstances.set(W,re)}registerFileEditorInputFactory(W){this.fileEditorInputFactory=W}getFileEditorInputFactory(){return I.assertIsDefined(this.fileEditorInputFactory)}registerCustomEditorInputFactory(W,H){this.customEditorInputFactoryInstances.set(W,H)}getCustomEditorInputFactory(W){return this.customEditorInputFactoryInstances.get(W)}registerEditorInputFactory(W,H){return this.instantiationService?this.createEditorInputFactory(W,H,this.instantiationService):this.editorInputFactoryConstructors.set(W,H),C.toDisposable(()=>{this.editorInputFactoryConstructors.delete(W),this.editorInputFactoryInstances.delete(W)})}getEditorInputFactory(W){return this.editorInputFactoryInstances.get(W)}}e.Extensions={EditorInputFactories:"workbench.contributions.editor.inputFactories"},t.Registry.add(e.Extensions.EditorInputFactories,new k);async function w(B,W){if(!B||!B.length)return[];const H=await Promise.all(B.map(async K=>{const re=E.URI.revive(K.fileUri);if(!(!re||!W.canHandleResource(re))){const V=typeof K.exists=="boolean"?K.exists:await W.exists(re);if(!(!V&&K.openOnlyIfExists)){const J=V&&typeof K.lineNumber=="number"?{selection:{startLineNumber:K.lineNumber,startColumn:K.columnNumber||1},pinned:!0,override:K.overrideId}:{pinned:!0,override:K.overrideId};let ce;return V?ce={resource:re,options:J,forceFile:!0}:ce={resource:re,options:J,forceUntitled:!0},ce}}}));return _.coalesce(H)}e.pathsToEditors=w;var T;(function(B){B[B.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",B[B.SEQUENTIAL=1]="SEQUENTIAL"})(T=e.EditorsOrder||(e.EditorsOrder={}));function h(B,W,H,K){let re=B.getAriaLabel();return H&&!H.isPinned(B)&&(re=y.localize(1,null,re)),H&&H.isSticky(W!=null?W:B)&&(re=y.localize(2,null,re)),H&&K>1&&(re=`${re}, ${H.ariaLabel}`),re}e.computeEditorAriaLabel=h;function A(B,W){if(typeof W!="number"||W===P.ACTIVE_GROUP)return P.ACTIVE_GROUP;const H=B.getGroups(2);let K=H[W];if(K)return K.id;let re=H[0];return H.length===1&&re.count===0?re.id:P.SIDE_GROUP}e.viewColumnToEditorGroup=A;function N(B,W){let H=typeof W=="number"?B.getGroup(W):W;return H=H!=null?H:B.activeGroup,B.getGroups(2).indexOf(H)}e.editorGroupToViewColumn=N}),define(he[213],de([0,1,11,208,16,92,94,99,100,101,209,212,66,8,180]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let d=class{constructor(b,f,u,a,o,n,r,i,l,s){this._remoteAuthority=b,this._channel=f,this._configurationService=u,this._workspaceContextService=a,this._resolverService=o,this._environmentVariableService=n,this._remoteAuthorityResolverService=r,this._logService=i,this._editorService=l,this._labelService=s}_readSingleTerminalConfiguration(b){const f=this._configurationService.inspect(b);return{userValue:f.userValue,value:f.value,defaultValue:f.defaultValue}}async createTerminalProcess(b,f,u,a,o,n){await this._configurationService.whenRemoteConfigurationLoaded();const r=this._configurationService.getValue(t.TERMINAL_CONFIG_SECTION),i={"terminal.integrated.automationShell.windows":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.windows"),"terminal.integrated.automationShell.osx":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.osx"),"terminal.integrated.automationShell.linux":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.linux"),"terminal.integrated.shell.windows":this._readSingleTerminalConfiguration("terminal.integrated.shell.windows"),"terminal.integrated.shell.osx":this._readSingleTerminalConfiguration("terminal.integrated.shell.osx"),"terminal.integrated.shell.linux":this._readSingleTerminalConfiguration("terminal.integrated.shell.linux"),"terminal.integrated.shellArgs.windows":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.windows"),"terminal.integrated.shellArgs.osx":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.osx"),"terminal.integrated.shellArgs.linux":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.linux"),"terminal.integrated.env.windows":this._readSingleTerminalConfiguration("terminal.integrated.env.windows"),"terminal.integrated.env.osx":this._readSingleTerminalConfiguration("terminal.integrated.env.osx"),"terminal.integrated.env.linux":this._readSingleTerminalConfiguration("terminal.integrated.env.linux"),"terminal.integrated.inheritEnv":r.inheritEnv,"terminal.integrated.cwd":r.cwd,"terminal.integrated.detectLocale":r.detectLocale,"terminal.flowControl":r.flowControl},l=Object.create(null),s=f?y.withNullAsUndefined(this._workspaceContextService.getWorkspaceFolder(f)):void 0;let p;try{p=await this._resolverService.resolveWithInteraction(s,{shellLaunchConfig:b,configuration:i})}catch(H){this._logService.error(H)}if(p)for(const[H,K]of p.entries())(/^config:/.test(H)||H==="selectedText"||H==="lineNumber")&&(l[H]=K);const k=[];for(const[H,K]of this._environmentVariableService.collections.entries())k.push([H,g.serializeEnvironmentVariableCollection(K.map)]);const w=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),T=w.options&&w.options.extensionHostEnv,h=this._workspaceContextService.getWorkspace(),A=h.folders,N=f?this._workspaceContextService.getWorkspaceFolder(f):null,B=_.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:_.SideBySideEditor.PRIMARY,filterByScheme:[v.Schemas.file,v.Schemas.userData,v.Schemas.vscodeRemote]}),W={configuration:i,resolvedVariables:l,envVariableCollections:k,shellLaunchConfig:b,workspaceId:h.id,workspaceName:this._labelService.getWorkspaceLabel(h),workspaceFolders:A,activeWorkspaceFolder:N,activeFileResource:B,shouldPersistTerminal:u,cols:a,rows:o,isWorkspaceShellAllowed:n,resolverEnv:T};return await this._channel.call("$createTerminalProcess",W)}async startTerminalProcess(b){const f={id:b};return this._channel.call("$startTerminalProcess",f)}onTerminalProcessEvent(b){const f={id:b};return this._channel.listen("$onTerminalProcessEvent",f)}sendInputToTerminalProcess(b,f){const u={id:b,data:f};return this._channel.call("$sendInputToTerminalProcess",u)}sendCharCountToTerminalProcess(b,f){const u={id:b,charCount:f};return this._channel.call("$sendCharCountToTerminalProcess",u)}shutdownTerminalProcess(b,f){const u={id:b,immediate:f};return this._channel.call("$shutdownTerminalProcess",u)}resizeTerminalProcess(b,f,u){const a={id:b,cols:f,rows:u};return this._channel.call("$resizeTerminalProcess",a)}getTerminalInitialCwd(b){const f={id:b};return this._channel.call("$getTerminalInitialCwd",f)}getTerminalCwd(b){const f={id:b};return this._channel.call("$getTerminalCwd",f)}sendCommandResultToTerminalProcess(b,f,u,a){const o={id:b,reqId:f,isError:u,payload:a};return this._channel.call("$sendCommandResultToTerminalProcess",o)}orphanQuestionReply(b){const f={id:b};return this._channel.call("$orphanQuestionReply",f)}listTerminals(b){const f={isInitialization:b};return this._channel.call("$listTerminals",f)}setTerminalLayoutInfo(b){const u={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:b.tabs};return this._channel.call("$setTerminalLayoutInfo",u)}getTerminalLayoutInfo(){const f={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",f)}};d=De([xe(2,m.IWorkbenchConfigurationService),xe(3,C.IWorkspaceContextService),xe(4,R.IConfigurationResolverService),xe(5,L.IEnvironmentVariableService),xe(6,E.IRemoteAuthorityResolverService),xe(7,I.ILogService),xe(8,P.IEditorService),xe(9,c.ILabelService)],d),e.RemoteTerminalChannelClient=d}),define(he[214],de([0,1,185]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var m;(function(E){function C(L,g){if(L===g)return!0;let t=Object.keys(L),R=new Set;for(let _ of Object.keys(g))R.add(_);if(t.length!==R.size)return!1;for(let _ of t){if(L[_]!==g[_])return!1;R.delete(_)}return R.size===0}E.equals=C})(m=e.Translations||(e.Translations={}));class I{constructor(C){this._messageHandler=C}error(C,L){this._messageHandler(y.Severity.Error,C,L)}warn(C,L){this._messageHandler(y.Severity.Warning,C,L)}info(C,L){this._messageHandler(y.Severity.Info,C,L)}}e.Logger=I}),define(he[215],de([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class y{constructor(g,t){this.isMain=g,this.sid=t,this.nid=++y.count}}e.ProxyIdentifier=y,y.count=0;const m=[];function I(L){const g=new y(!0,L);return m[g.nid]=g,g}e.createMainContextProxyIdentifier=I;function E(L){const g=new y(!1,L);return m[g.nid]=g,g}e.createExtHostContextProxyIdentifier=E;function C(L){return m[L].sid}e.getStringIdentifierForProxy=C}),define(he[216],de([0,1,3,215,46]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var E;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(E=e.UIKind||(e.UIKind={}));var C;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var L;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(L=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var g;(function(f){f[f.Markdown=1]="Markdown",f[f.Code=2]="Code"})(g=e.CellKind||(e.CellKind={}));var t;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(t=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(f){f.name="$ident";function u(o,n){return Object.defineProperty(o,f.name,{value:n,enumerable:!0}),o}f.mixin=u;function a(o){return o[f.name]}f.of=a})(_=e.ObjectIdentifier||(e.ObjectIdentifier={}));class P{static mixin(u){return u._id=P._n++,u}}e.IdObject=P,P._n=0;var v;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n",f.label2="o"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(f){if(f&&f.edits)for(const u of f.edits)typeof u.resource=="object"?u.resource=y.URI.revive(u.resource):(u.newUri=y.URI.revive(u.newUri),u.oldUri=y.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=I.revive(u.metadata));return f}e.reviveWorkspaceEditDto=S;var b;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:m.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:m.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:m.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:m.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:m.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:m.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:m.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:m.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:m.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:m.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:m.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:m.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:m.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:m.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:m.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:m.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:m.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:m.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:m.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:m.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:m.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:m.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:m.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:m.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:m.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:m.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:m.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:m.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:m.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:m.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:m.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:m.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:m.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:m.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:m.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:m.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:m.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:m.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:m.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:m.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:m.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:m.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:m.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:m.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:m.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:m.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:m.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadTheming:m.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:m.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:m.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:m.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:m.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:m.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:m.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:m.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:m.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:m.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:m.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:m.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:m.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:m.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:m.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:m.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:m.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:m.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:m.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:m.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:m.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:m.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:m.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:m.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:m.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:m.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:m.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:m.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:m.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:m.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:m.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:m.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:m.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:m.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:m.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:m.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:m.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:m.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:m.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:m.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:m.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:m.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:m.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostTheming:m.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:m.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:m.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:m.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:m.createMainContextProxyIdentifier("ExtHostTesting")}}),define(he[217],de([0,1,11,98,211,19,216,14,16,46,56,79,3,4,7,202]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(n,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=n.getProxy(C.MainContext.MainThreadCommands),this._logService=r,this.converter=new b(this,i=>{const l=this._apiCommands.get(i);return(l==null?void 0:l.result)===u.Void?l:void 0},r),this._argumentProcessors=[{processArgument(i){return t.revive(i)}},{processArgument(i){return E.cloneAndChange(i,function(l){if(R.Range.isIRange(l))return I.Range.to(l);if(_.Position.isIPosition(l))return I.Position.to(l);if(R.Range.isIRange(l.range)&&P.URI.isUri(l.uri))return I.location.to(l);if(!Array.isArray(l))return l})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const r=this.registerCommand(!1,n.id,async(...i)=>{const l=n.args.map((p,k)=>{if(!p.validate(i[k]))throw new Error(`Invalid argument '${p.name}' when running '${n.id}', received: ${i[k]}`);return p.convert(i[k])}),s=await this.executeCommand(n.internalId,...l);return n.result.convert(s,i,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new m.Disposable(()=>{r.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,r,i,l,s){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:i,thisArg:l,description:s}),n&&this._proxy.$registerCommand(r),new m.Disposable(()=>{this._commands.delete(r)&&n&&this._proxy.$unregisterCommand(r)})}executeCommand(n,...r){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,r,!0)}async _doExecuteCommand(n,r,i){if(this._commands.has(n))return this._executeContributedCommand(n,r);{const l=E.cloneAndChange(r,function(s){if(s instanceof m.Position)return I.Position.from(s);if(s instanceof m.Range)return I.Range.from(s);if(s instanceof m.Location)return I.location.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(n,l,i);return t.revive(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(n,r,!1);throw s}}}async _executeContributedCommand(n,r){const i=this._commands.get(n);if(!i)throw new Error("Unknown command");let{callback:l,thisArg:s,description:p}=i;if(p)for(let k=0;k<p.args.length;k++)try{y.validateConstraint(r[k],p.args[k].constraint)}catch(w){throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${p.args[k].name}' - ${p.args[k].description}`)}try{return await l.apply(s,r)}catch(k){throw this._logService.error(k,n),new Error(`Running the contributed command: '${n}' failed.`)}}$executeContributedCommand(n,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(r=r.map(i=>this._argumentProcessors.reduce((l,s)=>s.processArgument(l),i)),this._executeContributedCommand(n,r)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),this._proxy.$getCommands().then(r=>(n&&(r=r.filter(i=>i[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(let[r,i]of this._commands){let{description:l}=i;l&&(n[r]=l)}return Promise.resolve(n)}};S=De([xe(0,d.IExtHostRpcService),xe(1,g.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class b{constructor(n,r,i){this._commands=n,this._lookupApiCommand=r,this._logService=i,this._cache=new Map,this._cachIdPool=0,this._delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._commands.registerCommand(!0,this._delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,r){if(!!n){const i={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return i;const l=this._lookupApiCommand(n.command);if(l)i.id=l.internalId,i.arguments=l.args.map((s,p)=>s.convert(n.arguments&&n.arguments[p]));else if(L.isNonEmptyArray(n.arguments)){const s=++this._cachIdPool;this._cache.set(s,n),r.add(v.toDisposable(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),i.$ident=s,i.id=this._delegatingCommandId,i.arguments=[s],this._logService.trace("CommandsConverter#CREATE",n.command,s)}return i}}fromInternal(n){const r=C.ObjectIdentifier.of(n);return typeof r=="number"?this._cache.get(r):{command:n.id,title:n.title,arguments:n.arguments}}_executeConvertedCommand(...n){const r=this._cache.get(n[0]);return this._logService.trace("CommandsConverter#EXECUTE",n[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class f{constructor(n,r,i,l){this.name=n,this.description=r,this.validate=i,this.convert=l}optional(){return new f(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,r){return new f(n!=null?n:this.name,r!=null?r:this.description,this.validate,this.convert)}}e.ApiCommandArgument=f,f.Uri=new f("uri","Uri of a text document",o=>P.URI.isUri(o),o=>o),f.Position=new f("position","A position in a text document",o=>m.Position.isPosition(o),I.Position.from),f.Range=new f("range","A range in a text document",o=>m.Range.isRange(o),I.Range.from),f.Selection=new f("selection","A selection in a text document",o=>m.Selection.isSelection(o),I.Selection.from),f.Number=new f("number","",o=>typeof o=="number",o=>o),f.String=new f("string","",o=>typeof o=="string",o=>o),f.CallHierarchyItem=new f("item","A call hierarchy item",o=>o instanceof m.CallHierarchyItem,I.CallHierarchyItem.to);class u{constructor(n,r){this.description=n,this.convert=r}}e.ApiCommandResult=u,u.Void=new u("no result",o=>o);class a{constructor(n,r,i,l,s){this.id=n,this.internalId=r,this.description=i,this.args=l,this.result=s}}e.ApiCommand=a}),define(he[218],de([0,1,162,2,51,35,14,136,11,3,15,33,58,40,214]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const d="package.json";class S{constructor(i,l,s,p,k){this._ourVersion=i,this._log=l,this._absoluteFolderPath=s,this._isBuiltin=p,this._isUnderDevelopment=k,this._absoluteManifestPath=m.join(s,d)}}class b extends S{static _fastParseJSON(i,l){try{return JSON.parse(i)}catch(s){return E.parse(i,l)}}parse(){return R.readFile(this._absoluteManifestPath).then(i=>{var l;const s=[],p=b._fastParseJSON(i.toString(),s);if(E.getNodeType(p)!=="object")this._log.error(this._absoluteFolderPath,y.localize(0,null,this._absoluteManifestPath));else{if(s.length===0)return p.__metadata&&(p.uuid=p.__metadata.id),p.isUserBuiltin=!!((l=p.__metadata)===null||l===void 0?void 0:l.isBuiltin),delete p.__metadata,p;s.forEach(k=>{this._log.error(this._absoluteFolderPath,y.localize(1,null,this._absoluteManifestPath,k.offset,k.length,L.getParseErrorMessage(k.error)))})}return null},i=>(i.code==="ENOENT"||this._log.error(this._absoluteFolderPath,y.localize(2,null,this._absoluteManifestPath,i.message)),null))}}class f extends S{constructor(i,l,s,p,k,w){super(i,l,s,p,k);this._nlsConfig=w}replaceNLS(i){const l=(A,N)=>{N.forEach(B=>{this._log.error(this._absoluteFolderPath,y.localize(3,null,A,L.getParseErrorMessage(B.error)))})},s=A=>{this._log.error(this._absoluteFolderPath,y.localize(4,null,A))};let p=m.extname(this._absoluteManifestPath),k=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-p.length);const w=`${i.publisher}.${i.name}`;let T=this._nlsConfig.translations[w],h;return T?h=R.readFile(T,"utf8").then(A=>{let N=[],B=E.parse(A,N);return N.length>0?(l(T,N),{values:void 0,default:`${k}.nls.json`}):E.getNodeType(B)!=="object"?(s(T),{values:void 0,default:`${k}.nls.json`}):{values:B.contents?B.contents.package:void 0,default:`${k}.nls.json`}},A=>({values:void 0,default:`${k}.nls.json`})):h=R.fileExists(k+".nls"+p).then(A=>{if(!!A)return f.findMessageBundles(this._nlsConfig,k).then(N=>N.localized?R.readFile(N.localized,"utf8").then(B=>{let W=[],H=E.parse(B,W);return W.length>0?(l(N.localized,W),{values:void 0,default:N.original}):E.getNodeType(H)!=="object"?(s(N.localized),{values:void 0,default:N.original}):{values:H,default:N.original}},B=>({values:void 0,default:N.original})):{values:void 0,default:N.original},N=>{})}),h.then(A=>{if(A===void 0)return i;let N=[];return f.resolveOriginalMessageBundle(A.default,N).then(B=>{if(N.length>0)return l(A.default,N),i;if(E.getNodeType(A)!=="object")return s(A.default),i;const W=A.values||Object.create(null);return f._replaceNLStrings(this._nlsConfig,i,W,B,this._log,this._absoluteFolderPath),i})},A=>i)}static resolveOriginalMessageBundle(i,l){return new Promise((s,p)=>{i?R.readFile(i).then(k=>{s(E.parse(k.toString(),l))},k=>{s(null)}):s(null)})}static findMessageBundles(i,l){return new Promise((s,p)=>{function k(w,T){let h=`${w}.nls.${T}.json`;R.fileExists(h).then(A=>{A&&s({localized:h,original:`${w}.nls.json`});let N=T.lastIndexOf("-");N===-1?s({localized:`${w}.nls.json`,original:null}):(T=T.substring(0,N),k(w,T))})}if(i.devMode||i.pseudo||!i.locale)return s({localized:l+".nls.json",original:null});k(l,i.locale)})}static _replaceNLStrings(i,l,s,p,k,w){function T(h,A,N){let B=h[A];if(g.isString(B)){let W=B,H=W.length;if(H>1&&W[0]==="%"&&W[H-1]==="%"){let K=W.substr(1,H-2),re=s[K];re===void 0&&p&&(re=p[K]),re?(i.pseudo&&(re="\uFF3B"+re.replace(/[aouei]/g,"$&$&")+"\uFF3D"),h[A]=N&&(A==="title"||A==="category")&&p?{value:re,original:p[K]}:re):k.warn(w,y.localize(5,null,K))}}else if(g.isObject(B))for(let W in B)B.hasOwnProperty(W)&&(W==="commands"?T(B,W,!0):T(B,W,N));else if(g.isArray(B))for(let W=0;W<B.length;W++)T(B,W,N)}for(let h in l)l.hasOwnProperty(h)&&T(l,h)}}class u extends S{validate(i){let l=i;l.isBuiltin=this._isBuiltin,l.isUserBuiltin=!this._isBuiltin&&!!l.isUserBuiltin,l.isUnderDevelopment=this._isUnderDevelopment;let s=[];return u.isValidExtensionDescription(this._ourVersion,this._absoluteFolderPath,l,s)?(s.forEach(p=>{this._log.warn(this._absoluteFolderPath,p)}),l.publisher||(l.publisher="undefined_publisher"),l.id=_.getExtensionId(l.publisher,l.name),l.identifier=new v.ExtensionIdentifier(l.id),l.extensionLocation=t.URI.file(this._absoluteFolderPath),l):(s.forEach(p=>{this._log.error(this._absoluteFolderPath,p)}),null)}static isValidExtensionDescription(i,l,s,p){return u.baseIsValidExtensionDescription(l,s,p)?I.valid(s.version)?P.isValidExtensionVersion(i,s,p):(p.push(y.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(i,l,s){if(!l)return s.push(y.localize(7,null)),!1;if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return s.push(y.localize(8,null)),!1;if(typeof l.name!="string")return s.push(y.localize(9,null,"name")),!1;if(typeof l.version!="string")return s.push(y.localize(10,null,"version")),!1;if(!l.engines)return s.push(y.localize(11,null,"engines")),!1;if(typeof l.engines.vscode!="string")return s.push(y.localize(12,null,"engines.vscode")),!1;if(typeof l.extensionDependencies!="undefined"&&!u._isStringArray(l.extensionDependencies))return s.push(y.localize(13,null,"extensionDependencies")),!1;if(typeof l.activationEvents!="undefined"){if(!u._isStringArray(l.activationEvents))return s.push(y.localize(14,null,"activationEvents")),!1;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return s.push(y.localize(15,null,"activationEvents","main")),!1}if(typeof l.main!="undefined"){if(typeof l.main!="string")return s.push(y.localize(16,null,"main")),!1;{const p=m.join(i,l.main);p.startsWith(i)||s.push(y.localize(17,null,p,i))}if(typeof l.activationEvents=="undefined")return s.push(y.localize(18,null,"activationEvents","main")),!1}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return s.push(y.localize(19,null,"browser")),!1;{const p=m.join(i,l.browser);p.startsWith(i)||s.push(y.localize(20,null,p,i))}if(typeof l.activationEvents=="undefined")return s.push(y.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(i){if(!Array.isArray(i))return!1;for(let l=0,s=i.length;l<s;l++)if(typeof i[l]!="string")return!1;return!0}}class a{constructor(i,l,s,p,k,w,T,h){this.ourVersion=i,this.commit=l,this.locale=s,this.devMode=p,this.absoluteFolderPath=k,this.isBuiltin=w,this.isUnderDevelopment=T,this.translations=h}static createNLSConfig(i){return{devMode:i.devMode,locale:i.locale,pseudo:i.locale==="pseudo",translations:i.translations}}static equals(i,l){return i.ourVersion===l.ourVersion&&i.commit===l.commit&&i.locale===l.locale&&i.devMode===l.devMode&&i.absoluteFolderPath===l.absoluteFolderPath&&i.isBuiltin===l.isBuiltin&&i.isUnderDevelopment===l.isUnderDevelopment&&i.mtime===l.mtime&&c.Translations.equals(i.translations,l.translations)}}e.ExtensionScannerInput=a;class o{constructor(i){this.root=i}resolveExtensions(){return R.readDirsInDir(this.root).then(i=>i.map(l=>({name:l,path:m.join(this.root,l)})))}}class n{static scanExtension(i,l,s,p,k,w){return s=m.normalize(s),new b(i,l,s,p,k).parse().then(h=>h===null?null:new f(i,l,s,p,k,w).replaceNLS(h)).then(h=>h===null?null:new u(i,l,s,p,k).validate(h))}static async scanExtensions(i,l,s=null){const p=i.absoluteFolderPath,k=i.isBuiltin,w=i.isUnderDevelopment;s||(s=new o(p));try{let T={};if(!k)try{const W=await R.readFile(m.join(p,".obsolete"),"utf8");T=JSON.parse(W)}catch(W){}let h=await s.resolveExtensions();h.sort((W,H)=>W.name<H.name?-1:1),k||(h=h.filter(W=>W.name.indexOf(".")!==0));const A=a.createNLSConfig(i);let N=await Promise.all(h.map(W=>this.scanExtension(i.ourVersion,l,W.path,k,w,A))),B=C.coalesce(N);return B=B.filter(W=>W!==null&&!T[new _.ExtensionIdentifierWithVersion({id:_.getGalleryExtensionId(W.publisher,W.name)},W.version).key()]),k||(B=_.groupByExtension(B,H=>({id:H.identifier.value,uuid:H.uuid})).map(H=>H.sort((K,re)=>I.rcompare(K.version,re.version))[0])),B.sort((W,H)=>W.extensionLocation.fsPath<H.extensionLocation.fsPath?-1:1),B}catch(T){return l.error(p,T),[]}}static scanOneOrMultipleExtensions(i,l){const s=i.absoluteFolderPath,p=i.isBuiltin,k=i.isUnderDevelopment;return R.fileExists(m.join(s,d)).then(w=>{if(w){const T=a.createNLSConfig(i);return this.scanExtension(i.ourVersion,l,s,p,k,T).then(h=>h===null?[]:[h])}return this.scanExtensions(i,l)},w=>(l.error(s,w),[]))}static scanSingleExtension(i,l){const s=i.absoluteFolderPath,p=i.isBuiltin,k=i.isUnderDevelopment,w=a.createNLSConfig(i);return this.scanExtension(i.ourVersion,l,s,p,k,w)}static mergeBuiltinExtensions(i,l){return Promise.all([i,l]).then(([s,p])=>{let k=Object.create(null);for(let T=0,h=s.length;T<h;T++)k[v.ExtensionIdentifier.toKey(s[T].identifier)]=s[T];for(let T=0,h=p.length;T<h;T++)k[v.ExtensionIdentifier.toKey(p[T].identifier)]=p[T];let w=Object.keys(k).map(T=>k[T]);return w.sort((T,h)=>{const A=m.basename(T.extensionLocation.fsPath),N=m.basename(h.extensionLocation.fsPath);return A<N?-1:A>N?1:0}),w})}}e.ExtensionScanner=n}),define(he[219],de([0,1,5,47,3,38,156,15,8,26,218,40,55,96,49,77,195,2]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let f=null;function u(){return f||(f=b.normalize(b.join(g.FileAccess.asFileUri("",Z).fsPath,"..","extensions"))),f}let a=null;function o(){return a||(a=b.normalize(b.join(g.FileAccess.asFileUri("",Z).fsPath,"..",".build","builtInExtensions"))),a}class n{constructor(i,l,s,p,k,w){this._connectionToken=i,this.environmentService=l,this.logService=p,this.telemetryService=k,this.telemetryAppender=w,this._logger=new class{error(h,A){p.error(h,A)}warn(h,A){p.warn(h,A)}info(h,A){p.info(h,A)}},l.args["install-builtin-extension"]?this.whenExtensionsReady=s.installExtensions([],l.args["install-builtin-extension"],!!l.args["do-not-sync"],!!l.args.force).then(null,h=>{p.error(h)}):this.whenExtensionsReady=Promise.resolve();const T=l.args["install-extension"];if(T){const h=T.map(A=>/\.vsix$/i.test(A)?I.URI.file(b.isAbsolute(A)?A:b.join(process.cwd(),A)):A);this.whenExtensionsReady.then(()=>s.installExtensions(h,[],!!l.args["do-not-sync"],!!l.args.force)).then(null,A=>{p.error(A)})}}async call(i,l,s){switch(l){case"disableTelemetry":{this.telemetryService.setEnabled(!1);return}case"getEnvironmentData":{const p=s,k=E.createRemoteURITransformer(p.remoteAuthority);let w=await this._getEnvironmentData();return w=P.transformOutgoingURIs(w,k),w}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const p=s,k=p.language;this.logService.trace(`Scanning extensions using UI language: ${k}`);const w=E.createRemoteURITransformer(p.remoteAuthority),T=p.extensionDevelopmentPath&&p.extensionDevelopmentPath.map(N=>I.URI.revive(w.transformIncoming(N))),h=T?T.filter(N=>N.scheme===g.Schemas.file).map(N=>N.fsPath):void 0;let A=await this._scanExtensions(k,h);return A=P.transformOutgoingURIs(A,w),this.logService.trace("Scanned Extensions",A),n._massageWhenConditions(A),A}case"scanSingleExtension":{await this.whenExtensionsReady;const p=s,k=p.language,w=p.isBuiltin,T=E.createRemoteURITransformer(p.remoteAuthority),h=I.URI.revive(T.transformIncoming(p.extensionLocation)),A=h.scheme===g.Schemas.file?h.fsPath:null;if(!A)return null;const N=await this._getTranslations(k);let B=await this._scanSingleExtension(A,w,k,N);return B?(B=P.transformOutgoingURIs(B,T),n._massageWhenConditions([B]),B):null}case"getDiagnosticInfo":{const p=s,k={machineInfo:S.getMachineInfo()},w=p.includeProcesses?d.listProcesses(process.pid):Promise.resolve();let T=[];const h={};if(p.folders){const A=E.createRemoteURITransformer("");T=p.folders.map(B=>I.URI.revive(A.transformIncoming(B))).filter(B=>B.scheme==="file").map(B=>S.collectWorkspaceStats(B.fsPath,["node_modules",".git"]).then(W=>{h[b.basename(B.fsPath)]=W}))}return Promise.all([w,...T]).then(([A,N])=>(k.processes=A||void 0,k.workspaceMetadata=p.folders?h:void 0,k))}case"logTelemetry":{const{eventName:p,data:k}=s;return this.telemetryAppender?this.telemetryAppender.log(p,k):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${l} not found`)}listen(i,l,s){throw new Error("Not supported")}static _massageWhenConditions(i){const l=(h,A)=>h.replace(/file/g,"vscode-remote"),s=h=>{let A="";return A+=h.global?"g":"",A+=h.ignoreCase?"i":"",A+=h.multiline?"m":"",new RegExp(l(h.source,!0),A)},p=new class{mapDefined(h){return c.ContextKeyDefinedExpr.create(h)}mapNot(h){return c.ContextKeyNotExpr.create(h)}mapEquals(h,A){return h==="resourceScheme"&&typeof A=="string"?c.ContextKeyEqualsExpr.create(h,l(A,!1)):c.ContextKeyEqualsExpr.create(h,A)}mapNotEquals(h,A){return h==="resourceScheme"&&typeof A=="string"?c.ContextKeyNotEqualsExpr.create(h,l(A,!1)):c.ContextKeyNotEqualsExpr.create(h,A)}mapGreater(h,A){return c.ContextKeyGreaterExpr.create(h,A)}mapGreaterEquals(h,A){return c.ContextKeyGreaterEqualsExpr.create(h,A)}mapSmaller(h,A){return c.ContextKeySmallerExpr.create(h,A)}mapSmallerEquals(h,A){return c.ContextKeySmallerEqualsExpr.create(h,A)}mapRegex(h,A){return h==="resourceScheme"&&A?c.ContextKeyRegexExpr.create(h,s(A)):c.ContextKeyRegexExpr.create(h,A)}mapIn(h,A){return c.ContextKeyInExpr.create(h,A)}},k=h=>{if(!(!h||!h.when||!/resourceScheme/.test(h.when))){const A=c.ContextKeyExpr.deserialize(h.when);if(!!A){const N=A.map(p);h.when=N.serialize()}}},w=h=>{if(Array.isArray(h))for(let A of h)k(A);else k(h)},T=h=>{for(let A in h)w(h[A])};i.forEach(h=>{h.contributes&&(h.contributes.menus&&T(h.contributes.menus),h.contributes.keybindings&&w(h.contributes.keybindings),h.contributes.views&&T(h.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken,appRoot:I.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:I.URI.file(this.environmentService.logsPath),extensionsPath:I.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:I.URI.file(b.join(this.environmentService.logsPath,`exthost${n._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:y.OS,marks:m.getMarks()}}async _getTranslations(i){const l=await v.getNLSConfiguration(i,this.environmentService.userDataPath);if(v.InternalNLSConfiguration.is(l))try{const s=await L.readFile(l._translationsConfigFile,"utf8");return JSON.parse(s)}catch(s){return Object.create(null)}else return Object.create(null)}async _scanExtensions(i,l){const s=await this._getTranslations(i),[p,k,w]=await Promise.all([this._scanBuiltinExtensions(i,s),this._scanInstalledExtensions(i,s),this._scanDevelopedExtensions(i,s,l)]);let T=new Map;p.forEach(A=>{!A||T.set(_.ExtensionIdentifier.toKey(A.identifier),A)}),k.forEach(A=>{!A||(T.has(_.ExtensionIdentifier.toKey(A.identifier))&&console.warn(C.localize(0,null,T.get(_.ExtensionIdentifier.toKey(A.identifier)).extensionLocation.fsPath,A.extensionLocation.fsPath)),T.set(_.ExtensionIdentifier.toKey(A.identifier),A))}),w.forEach(A=>{!A||T.set(_.ExtensionIdentifier.toKey(A.identifier),A)});const h=[];return T.forEach(A=>h.push(A)),h}_scanDevelopedExtensions(i,l,s){if(s){const p=s.map(k=>R.ExtensionScanner.scanOneOrMultipleExtensions(new R.ExtensionScannerInput(t.default.version,t.default.commit,i,!0,k,!1,!0,l),this._logger));return Promise.all(p).then(k=>{let w=[];for(let T of k)w=w.concat(T);return w})}return Promise.resolve([])}_scanBuiltinExtensions(i,l){const s=t.default.version,p=t.default.commit,k=!!process.env.VSCODE_DEV,w=new R.ExtensionScannerInput(s,p,i,k,u(),!0,!1,l),T=R.ExtensionScanner.scanExtensions(w,this._logger);let h=T;if(k){class A{constructor(K){this.builtInExtensions=K}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(K=>({name:K.name,path:b.join(o(),K.name)})))}}const N=Promise.resolve(t.default.builtInExtensions||[]),B=new R.ExtensionScannerInput(s,p,i,k,o(),!0,!1,{}),W=N.then(H=>new A(H)).then(H=>R.ExtensionScanner.scanExtensions(B,this._logger,H));h=R.ExtensionScanner.mergeBuiltinExtensions(T,W)}return h}_scanInstalledExtensions(i,l){const s=!!process.env.VSCODE_DEV,p=new R.ExtensionScannerInput(t.default.version,t.default.commit,i,s,this.environmentService.extensionsPath,!1,!1,l);return R.ExtensionScanner.scanExtensions(p,this._logger)}_scanSingleExtension(i,l,s,p){const k=!!process.env.VSCODE_DEV,w=new R.ExtensionScannerInput(t.default.version,t.default.commit,s,k,i,l,!1,p);return R.ExtensionScanner.scanSingleExtension(w,this._logger)}}e.RemoteAgentEnvironmentChannel=n,n._namePool=1}),define(he[220],de([0,1,6,4,3,20,18,44,12,39]),function(Z,e,y,m,I,E,C,L,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class R extends m.Disposable{constructor(P){super();this.session=E.generateUuid(),this._onDidChange=this._register(new y.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new y.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new y.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event;const v=P.getConnection();this.channel=v.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),this.setCaseSensitive(!0),(async()=>{const c=await P.getEnvironment();this.setCaseSensitive((c==null?void 0:c.os)===3)})(),this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(P=>{if(Array.isArray(P)){const v=P;this._onDidChange.fire(v.map(c=>({resource:I.URI.revive(c.resource),type:c.type})))}else{const v=P;this._onDidWatchErrorOccur.fire(v)}}))}setCaseSensitive(P){let v=2|4|16|8;P&&(v|=1024),this._capabilities=v,this._onDidChangeCapabilities.fire(void 0)}stat(P){return this.channel.call("stat",[P])}open(P,v){return this.channel.call("open",[P,v])}close(P){return this.channel.call("close",[P])}async read(P,v,c,d,S){const[b,f]=await this.channel.call("read",[P,v,S]);return c.set(b.buffer.slice(0,f),d),f}async readFile(P){return(await this.channel.call("readFile",[P])).buffer}readFileStream(P,v,c){const d=L.newWriteableStream(b=>C.VSBuffer.concat(b.map(f=>C.VSBuffer.wrap(f))).buffer),S=this.channel.listen("readFileStream",[P,v])(b=>{if(b instanceof C.VSBuffer)d.write(b.buffer);else{if(b==="end")d.end();else{let f=b;f instanceof Error||(f=new Error(t.toErrorMessage(f))),d.end(f)}S.dispose()}});return c.onCancellationRequested(()=>{d.end(g.canceled()),S.dispose()}),d}write(P,v,c,d,S){return this.channel.call("write",[P,v,C.VSBuffer.wrap(c),d,S])}writeFile(P,v,c){return this.channel.call("writeFile",[P,C.VSBuffer.wrap(v),c])}delete(P,v){return this.channel.call("delete",[P,v])}mkdir(P){return this.channel.call("mkdir",[P])}readdir(P){return this.channel.call("readdir",[P])}rename(P,v,c){return this.channel.call("rename",[P,v,c])}copy(P,v,c){return this.channel.call("copy",[P,v,c])}watch(P,v){const c=Math.random();return this.channel.call("watch",[this.session,c,P,v]),m.toDisposable(()=>this.channel.call("unwatch",[this.session,c]))}}e.RemoteFileSystemProvider=R}),define(he[103],de([0,1,7]),function(Z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=y.createDecorator("remoteAgentService")}),define(he[67],de([0,1,138,2,21,17,15,236,237,11]),function(Z,e,y,m,I,E,C,L,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(n,r){let i=r.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=n,this.cause=r}}e.ExtractError=R;function _(o){const n=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,i)=>r+i,n&61440)}function P(o){if(o instanceof R)return o;let n;return/end of central directory record signature not found/.test(o.message)&&(n="CorruptZip"),new R(n,o)}function v(o,n,r,i,l,s){const p=m.dirname(n),k=m.join(i,p);if(!k.startsWith(i))return Promise.reject(new Error(y.localize(0,null,n)));const w=m.join(i,n);let T;return s.onCancellationRequested(()=>{T&&T.destroy()}),Promise.resolve(C.mkdirp(k)).then(()=>new Promise((h,A)=>{if(!s.isCancellationRequested)try{T=I.createWriteStream(w,{mode:r}),T.once("close",()=>h()),T.once("error",A),o.once("error",A),o.pipe(T)}catch(N){A(N)}}))}function c(o,n,r,i){let l=E.createCancelablePromise(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{l.cancel(),o.close()}),new Promise((p,k)=>{const w=new E.Sequencer,T=h=>{h.isCancellationRequested||(s++,o.readEntry())};o.once("error",k),o.once("close",()=>l.then(()=>{i.isCancellationRequested||o.entryCount===s?p():k(new R("Incomplete",new Error(y.localize(1,null,s,o.entryCount))))},k)),o.readEntry(),o.on("entry",h=>{if(!i.isCancellationRequested){if(!r.sourcePathRegex.test(h.fileName)){T(i);return}const A=h.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(A)){const W=m.join(n,A);l=E.createCancelablePromise(H=>C.mkdirp(W).then(()=>T(H)).then(void 0,k));return}const N=S(o,h),B=_(h);l=E.createCancelablePromise(W=>w.queue(()=>N.then(H=>v(H,A,B,n,r,W).then(()=>T(W)))).then(null,k))}})})}function d(o,n=!1){return new Promise((r,i)=>{L.open(o,n?{lazyEntries:!0}:void 0,(l,s)=>{l?i(P(l)):r(t.assertIsDefined(s))})})}function S(o,n){return new Promise((r,i)=>{o.openReadStream(n,(l,s)=>{l?i(P(l)):r(t.assertIsDefined(s))})})}function b(o,n){return new Promise((r,i)=>{const l=new g.ZipFile;n.forEach(p=>{p.contents?l.addBuffer(typeof p.contents=="string"?Buffer.from(p.contents,"utf8"):p.contents,p.path):p.localPath&&l.addFile(p.localPath,p.path)}),l.end();const s=I.createWriteStream(o);l.outputStream.pipe(s),l.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>r(o))})}e.zip=b;function f(o,n,r={},i){const l=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=d(o,!0);return r.overwrite&&(s=s.then(p=>C.rimraf(n).then(()=>p))),s.then(p=>c(p,n,{sourcePathRegex:l},i))}e.extract=f;function u(o,n){return d(o).then(r=>new Promise((i,l)=>{r.on("entry",s=>{s.fileName===n&&S(r,s).then(p=>i(p),p=>l(p))}),r.once("close",()=>l(new Error(y.localize(2,null,n))))}))}function a(o,n){return u(o,n).then(r=>new Promise((i,l)=>{const s=[];r.once("error",l),r.on("data",p=>s.push(p)),r.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=a}),define(he[221],de([0,1,67,145]),function(Z,e,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function I(E){return y.buffer(E,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch(L){throw new Error(m.localize(0,null))}})}e.getManifest=I}),define(he[222],de([0,1,51,4,15,2,16,30,33,17,3,29,167,146,52,67,5,14,8]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d,S,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const u="scanningSystem",a="scanningUser",o="extracting",n="deleting",r="renaming";let i=class extends m.Disposable{constructor(s,p,k,w){super();this.beforeRemovingExtension=s,this.logService=p,this.environmentService=k,this.productService=w,this._devSystemExtensionsPath=null,this.systemExtensionsPath=k.builtinExtensionsPath,this.extensionsPath=k.extensionsPath,this.uninstalledPath=E.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new t.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(s){const p=[];(s===null||s===0)&&p.push(this.scanSystemExtensions().then(null,k=>Promise.reject(new L.ExtensionManagementError(this.joinErrors(k).message,u)))),(s===null||s===1)&&p.push(this.scanUserExtensions(!0).then(null,k=>Promise.reject(new L.ExtensionManagementError(this.joinErrors(k).message,a))));try{const k=await Promise.all(p);return b.flatten(k)}catch(k){throw this.joinErrors(k)}}async scanUserExtensions(s){this.logService.trace("Started scanning user extensions");let[p,k]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return k=k.filter(w=>!p[new g.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]),s&&(k=g.groupByExtension(k,T=>T.identifier).map(T=>T.sort((h,A)=>y.rcompare(h.manifest.version,A.manifest.version))[0])),this.logService.trace("Scanned user extensions:",k.length),k}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(s,p,k){const w=s.key(),T=E.join(this.extensionsPath,`.${w}`),h=E.join(this.extensionsPath,w);try{await I.rimraf(h)}catch(N){try{await I.rimraf(h)}catch(B){}throw new L.ExtensionManagementError(v.localize(0,null,h,s.id),n)}await this.extractAtLocation(s,p,T,k);try{await this.rename(s,T,h,Date.now()+2*60*1e3),this.logService.info("Renamed to",h)}catch(N){this.logService.info("Rename failed. Deleting from extracted location",T);try{I.rimraf(T)}catch(B){}throw N}let A=null;try{A=await this.scanExtension(w,this.extensionsPath,1)}catch(N){}if(A)return A;throw new Error(v.localize(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(s,p){this.setMetadata(s,p),p.isMachineScoped=p.isMachineScoped||void 0,p.isBuiltin=p.isBuiltin||void 0;const k=E.join(s.location.fsPath,"package.json"),w=await I.readFile(k,"utf8"),{manifest:T}=await this.parseManifest(w);return T.__metadata=p,await I.writeFile(k,JSON.stringify(T,null,"	")),s}getUninstalledExtensions(){return this.withUninstalledExtensions(s=>s)}async withUninstalledExtensions(s){return this.uninstalledFileLimiter.queue(async()=>{let p;try{p=await I.readFile(this.uninstalledPath,"utf8")}catch(T){if(T.code!=="ENOENT")throw T}let k={};if(p)try{k=JSON.parse(p)}catch(T){}const w=s(k);return Object.keys(k).length?await I.writeFile(this.uninstalledPath,JSON.stringify(k)):await I.rimraf(this.uninstalledPath),w})}async removeExtension(s,p){this.logService.trace(`Deleting ${p} extension from disk`,s.identifier.id,s.location.fsPath),await I.rimraf(s.location.fsPath),this.logService.info("Deleted from disk",s.identifier.id,s.location.fsPath)}async removeUninstalledExtension(s){await this.removeExtension(s,"uninstalled"),await this.withUninstalledExtensions(p=>delete p[new g.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version).key()])}async extractAtLocation(s,p,k,w){this.logService.trace(`Started extracting the extension from ${p} to ${k}`);try{await I.rimraf(k)}catch(T){throw new L.ExtensionManagementError(this.joinErrors(T).message,n)}try{await d.extract(p,k,{sourcePath:"extension",overwrite:!0},w),this.logService.info(`Extracted extension to ${k}:`,s.id)}catch(T){try{await I.rimraf(k)}catch(h){}throw new L.ExtensionManagementError(T.message,T instanceof d.ExtractError&&T.type?T.type:o)}}async rename(s,p,k,w){try{await I.rename(p,k)}catch(T){if(S.isWindows&&T&&T.code==="EPERM"&&Date.now()<w)return this.logService.info(`Failed renaming ${p} to ${k} with 'EPERM' error. Trying again...`,s.id),this.rename(s,p,k,w);throw new L.ExtensionManagementError(T.message||v.localize(2,null,p,k),T.code||r)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const s=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return s;const p=this.scanDevSystemExtensions(),[k,w]=await Promise.all([s,p]);return[...k,...w]}async scanExtensionsInDir(s,p){const k=new t.Limiter(10),w=await I.readdir(s);return(await Promise.all(w.map(h=>k.queue(()=>this.scanExtension(h,s,p))))).filter(h=>h&&h.identifier)}async scanExtension(s,p,k){if(k===1&&s.indexOf(".")===0)return null;const w=E.join(p,s);try{const T=await I.readdir(w),{manifest:h,metadata:A}=await this.readManifest(w),N=T.filter(V=>/^readme(\.txt|\.md|)$/i.test(V))[0],B=N?R.URI.file(E.join(w,N)):void 0,W=T.filter(V=>/^changelog(\.txt|\.md|)$/i.test(V))[0],H=W?R.URI.file(E.join(w,W)):void 0,K={id:g.getGalleryExtensionId(h.publisher,h.name)},re={type:k,identifier:K,manifest:h,location:R.URI.file(w),readmeUrl:B,changelogUrl:H,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:k===0};return A&&this.setMetadata(re,A),re}catch(T){return this.logService.trace(T),null}}async scanDefaultSystemExtensions(){const s=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",s.length),s}async scanDevSystemExtensions(){const s=this.getDevSystemExtensionsList();if(s.length){const p=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",p.length),p.filter(k=>s.some(w=>g.areSameExtensions(k.identifier,{id:w})))}else return[]}setMetadata(s,p){s.publisherDisplayName=p.publisherDisplayName||null,s.publisherId=p.publisherId||null,s.identifier.uuid=p.id,s.isMachineScoped=!!p.isMachineScoped,s.isBuiltin=s.type===0||!!p.isBuiltin}async removeUninstalledExtensions(){const s=await this.getUninstalledExtensions(),p=await this.scanAllUserExtensions(),k=new Set;for(const h of p)s[new g.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()]||k.add(h.identifier.id.toLowerCase());const w=g.groupByExtension(p,h=>h.identifier);await Promise.all(w.map(async h=>{const A=h.sort((N,B)=>y.rcompare(N.manifest.version,B.manifest.version))[0];k.has(A.identifier.id.toLowerCase())||await this.beforeRemovingExtension(A)}));const T=p.filter(h=>s[new g.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()]);await Promise.all(T.map(h=>this.removeUninstalledExtension(h)))}async removeOutdatedExtensions(){const s=await this.scanAllUserExtensions(),p=[],k=g.groupByExtension(s,w=>w.identifier);p.push(...b.flatten(k.map(w=>w.sort((T,h)=>y.rcompare(T.manifest.version,h.manifest.version)).slice(1)))),await Promise.all(p.map(w=>this.removeExtension(w,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(s=>s.name)}joinErrors(s){const p=Array.isArray(s)?s:[s];return p.length===1?p[0]instanceof Error?p[0]:new Error(p[0]):p.reduce((k,w)=>new Error(`${k.message}${k.message?",":""}${w instanceof Error?w.message:w}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=E.normalize(E.join(f.FileAccess.asFileUri("",Z).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(s){const p=[I.readFile(E.join(s,"package.json"),"utf8").then(h=>this.parseManifest(h)),I.readFile(E.join(s,"package.nls.json"),"utf8").then(void 0,h=>h.code!=="ENOENT"?Promise.reject(h):"{}").then(h=>JSON.parse(h))],[{manifest:k,metadata:w},T]=await Promise.all(p);return{manifest:P.localizeManifest(k,T),metadata:w}}parseManifest(s){return new Promise((p,k)=>{try{const w=JSON.parse(s),T=w.__metadata||null;p({manifest:w,metadata:T})}catch(w){k(new Error(v.localize(3,null)))}})}};i=De([xe(1,C.ILogService),xe(2,_.INativeEnvironmentService),xe(3,c.IProductService)],i),e.ExtensionsScanner=i}),define(he[104],de([0,1,144,2,15,4,14,67,30,33,29,17,6,51,3,26,5,16,176,39,42,58,22,20,83,7,8,27,221,181,222,182]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d,S,b,f,u,a,o,n,r,i,l,s,p,k,w,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const A="unsetUninstalled",N="downloading",B="validating",W="local",H="unknown";let K=class extends E.Disposable{constructor(V,J,ce,$,O,F){super();this.environmentService=V,this.galleryService=J,this.logService=ce,this.downloadService=$,this.telemetryService=O,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new P.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new P.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new P.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new P.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const j=this._register(F.createInstance(h.ExtensionsLifecycle));this.extensionsScanner=this._register(F.createInstance(T.ExtensionsScanner,Q=>j.postUninstall(Q))),this.manifestCache=this._register(new f.ExtensionsManifestCache(V,this)),this.extensionsDownloader=this._register(F.createInstance(w.ExtensionsDownloader)),this._register(E.toDisposable(()=>{this.installingExtensions.forEach(Q=>Q.cancel()),this.uninstallingExtensions.forEach(Q=>Q.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(V){this.logService.trace("ExtensionManagementService#zip",V.identifier.id);const J=await this.collectFiles(V),ce=await L.zip(n.joinPath(this.environmentService.tmpDir,r.generateUuid()).fsPath,J);return c.URI.file(ce)}async unzip(V){return this.logService.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const J=await this.downloadVsix(V),ce=m.resolve(J.fsPath);return k.getManifest(ce)}async collectFiles(V){const J=async $=>{let O=await I.readdir($);O=O.map(Q=>m.join($,Q));const F=await Promise.all(O.map(Q=>I.stat(Q)));let j=Promise.resolve([]);return F.forEach((Q,ne)=>{const oe=O[ne];Q.isFile()&&(j=j.then(ie=>[...ie,oe])),Q.isDirectory()&&(j=j.then(ie=>J(oe).then(fe=>[...ie,...fe])))}),j};return(await J(V.location.fsPath)).map($=>({path:`extension/${m.relative(V.location.fsPath,$)}`,localPath:$}))}async install(V,J={}){return this.logService.trace("ExtensionManagementService#install",V.toString()),_.createCancelablePromise(async ce=>{const $=await this.downloadVsix(V),O=m.resolve($.fsPath),F=await k.getManifest(O),j={id:t.getGalleryExtensionId(F.publisher,F.name)};let Q=1;if(F.engines&&F.engines.vscode&&!o.isEngineValid(F.engines.vscode,d.default.version))throw new Error(y.localize(0,null,j.id,d.default.version));const ne=new t.ExtensionIdentifierWithVersion(j,F.version),ie=(await this.getInstalled(1)).find(Ie=>t.areSameExtensions(j,Ie.identifier));if(ie)if(J.isMachineScoped=J.isMachineScoped||ie.isMachineScoped,J.isBuiltin=J.isBuiltin||ie.isBuiltin,Q=2,ne.equals(new t.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version)))try{await this.extensionsScanner.removeExtension(ie,"existing")}catch(Ie){throw new Error(y.localize(1,null,F.displayName||F.name))}else v.gt(ie.manifest.version,F.version)&&await this.uninstallExtension(ie);else{const Ie=await this.unsetUninstalledAndGetLocal(ne);if(Ie)try{await this.extensionsScanner.removeExtension(Ie,"existing")}catch(Pe){throw new Error(y.localize(2,null,F.displayName||F.name))}}this.logService.info("Installing the extension:",j.id),this._onInstallExtension.fire({identifier:j,zipPath:O});let fe;try{fe=await this.getGalleryMetadata(t.getGalleryExtensionId(F.publisher,F.name))}catch(Ie){}try{const Ie=await this.installFromZipPath(ne,O,Object.assign(Object.assign({},fe||{}),J),J,Q,ce);return this.logService.info("Successfully installed the extension:",j.id),Ie}catch(Ie){throw this.logService.error("Failed to install the extension:",j.id,Ie.message),Ie}})}async downloadVsix(V){if(V.scheme===s.Schemas.file)return V;if(!this.downloadService)throw new Error("Download service is not available");const J=n.joinPath(this.environmentService.tmpDir,r.generateUuid());return await this.downloadService.download(V,J),J}async installFromZipPath(V,J,ce,$,O,F){try{const j=await this.installExtension({zipPath:J,identifierWithVersion:V,metadata:ce},F);try{await this.installDependenciesAndPackExtensions(j,void 0,$)}catch(Q){C.isNonEmptyArray(j.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",j.identifier.id,Q.message),C.isNonEmptyArray(j.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",j.identifier.id,Q.message)}return this._onDidInstallExtension.fire({identifier:V,zipPath:J,local:j,operation:O}),j}catch(j){throw this._onDidInstallExtension.fire({identifier:V,zipPath:J,operation:O,error:j}),j}}async canInstall(V){return!0}async installFromGallery(V,J={}){if(!this.galleryService.isEnabled())throw new Error(y.localize(3,null));try{V=await this.checkAndGetCompatibleVersion(V)}catch(O){const F=O&&O.code?O.code:H;throw this.logService.error("Failed to install extension:",V.identifier.id,O?O.message:F),this.reportTelemetry(this.getTelemetryEvent(1),t.getGalleryExtensionTelemetryData(V),void 0,O),O instanceof Error&&(O.name=F),O}const ce=new t.ExtensionIdentifierWithVersion(V.identifier,V.version).key();let $=this.installingExtensions.get(ce);return $||($=_.createCancelablePromise(O=>this.doInstallFromGallery(V,J,O)),this.installingExtensions.set(ce,$),$.finally(()=>this.installingExtensions.delete(ce))),$}async doInstallFromGallery(V,J,ce){const $=new Date().getTime();let O=1;this.logService.info("Installing extension:",V.identifier.id),this._onInstallExtension.fire({identifier:V.identifier,gallery:V});try{const j=(await this.getInstalled(1)).find(oe=>t.areSameExtensions(oe.identifier,V.identifier));j&&(O=2);const Q=await this.downloadInstallableExtension(V,O);Q.metadata.isMachineScoped=J.isMachineScoped||(j==null?void 0:j.isMachineScoped),Q.metadata.isBuiltin=J.isBuiltin||(j==null?void 0:j.isBuiltin);const ne=await this.installExtension(Q,ce);try{await this.extensionsDownloader.delete(c.URI.file(Q.zipPath))}catch(oe){}if(!J.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(ne,j,J)}catch(oe){try{await this.uninstall(ne)}catch(ie){}throw oe}return j&&v.neq(j.manifest.version,V.version)&&await this.setUninstalled(j),this.logService.info("Extensions installed successfully:",V.identifier.id),this._onDidInstallExtension.fire({identifier:V.identifier,gallery:V,local:ne,operation:O}),this.reportTelemetry(this.getTelemetryEvent(O),t.getGalleryExtensionTelemetryData(V),new Date().getTime()-$,void 0),ne}catch(F){const j=F&&F.code?F.code:H;throw this.logService.error("Failed to install extension:",V.identifier.id,F?F.message:j),this._onDidInstallExtension.fire({identifier:V.identifier,gallery:V,operation:O,error:j}),this.reportTelemetry(this.getTelemetryEvent(O),t.getGalleryExtensionTelemetryData(V),new Date().getTime()-$,F),F instanceof Error&&(F.name=j),F}}async checkAndGetCompatibleVersion(V){if(await this.isMalicious(V))throw new g.ExtensionManagementError(y.localize(4,null),g.INSTALL_ERROR_MALICIOUS);const J=await this.galleryService.getCompatibleExtension(V);if(!J)throw new g.ExtensionManagementError(y.localize(5,null,V.identifier.id,d.default.version),g.INSTALL_ERROR_INCOMPATIBLE);return J}async reinstallFromGallery(V){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.galleryService.isEnabled())throw new Error(y.localize(6,null));const J=await this.findGalleryExtension(V);if(!J)throw new Error(y.localize(7,null));await this.setUninstalled(V);try{await this.extensionsScanner.removeUninstalledExtension(V)}catch(ce){throw new Error(y.localize(8,null,u.toErrorMessage(ce)))}await this.installFromGallery(J)}getTelemetryEvent(V){return V===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(V){const J=await this.getExtensionsReport();return t.getMaliciousExtensionsSet(J).has(V.identifier.id)}async downloadInstallableExtension(V,J){const ce={id:V.identifier.uuid,publisherId:V.publisherId,publisherDisplayName:V.publisherDisplayName};let $;try{this.logService.trace("Started downloading extension:",V.identifier.id);const O=await this.extensionsDownloader.downloadExtension(V,J);this.logService.info("Downloaded extension:",V.identifier.id,$),$=O.fsPath}catch(O){throw new g.ExtensionManagementError(this.joinErrors(O).message,N)}try{const O=await k.getManifest($);return{zipPath:$,identifierWithVersion:new t.ExtensionIdentifierWithVersion(V.identifier,O.version),metadata:ce}}catch(O){throw new g.ExtensionManagementError(this.joinErrors(O).message,B)}}async installExtension(V,J){try{const ce=await this.unsetUninstalledAndGetLocal(V.identifierWithVersion);if(ce)return V.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ce,V.metadata):ce}catch(ce){throw S.isMacintosh?new g.ExtensionManagementError(y.localize(9,null),A):new g.ExtensionManagementError(y.localize(10,null),A)}return this.extractAndInstall(V,J)}async unsetUninstalledAndGetLocal(V){return await this.isUninstalled(V)?(this.logService.trace("Removing the extension from uninstalled list:",V.id),await this.unsetUninstalled(V),this.logService.info("Removed the extension from uninstalled list:",V.id),(await this.getInstalled(1)).find($=>new t.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).equals(V))||null):null}async extractAndInstall({zipPath:V,identifierWithVersion:J,metadata:ce},$){let O=await this.extensionsScanner.extractUserExtension(J,V,$);return this.logService.info("Installation completed.",J.id),ce&&(O=await this.extensionsScanner.saveMetadataForLocalExtension(O,ce)),O}async installDependenciesAndPackExtensions(V,J,ce){if(!!this.galleryService.isEnabled()){const $=V.manifest.extensionDependencies||[];if(V.manifest.extensionPack)for(const O of V.manifest.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(F=>t.areSameExtensions({id:F},{id:O}))||$.every(F=>!t.areSameExtensions({id:F},{id:O}))&&$.push(O);if($.length){const O=await this.getInstalled(),F=$.filter(j=>O.every(({identifier:Q})=>!t.areSameExtensions(Q,{id:j})));if(F.length){const Q=(await this.galleryService.query({names:F,pageSize:$.length},p.CancellationToken.None)).firstPage;try{await Promise.all(Q.map(ne=>this.installFromGallery(ne,ce)))}catch(ne){try{await this.rollback(Q)}catch(oe){}throw ne}}}}}async rollback(V){const ce=(await this.getInstalled(1)).filter($=>V.some(O=>new t.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).equals(new t.ExtensionIdentifierWithVersion(O.identifier,O.version))));await Promise.all(ce.map($=>this.uninstall($)))}async uninstall(V,J={}){this.logService.trace("ExtensionManagementService#uninstall",V.identifier.id);const ce=await this.getInstalled(1),$=ce.find(O=>t.areSameExtensions(O.identifier,V.identifier));if(!$)throw new Error(y.localize(11,null,V.manifest.displayName||V.manifest.name));try{await this.checkForDependenciesAndUninstall($,ce,J)}catch(O){throw this.joinErrors(O)}}async updateMetadata(V,J){return this.logService.trace("ExtensionManagementService#updateMetadata",V.identifier.id),V=await this.extensionsScanner.saveMetadataForLocalExtension(V,Object.assign(Object.assign({},V.manifest.__metadata||{}),J)),this.manifestCache.invalidate(),V}async updateExtensionScope(V,J){return this.logService.trace("ExtensionManagementService#updateExtensionScope",V.identifier.id),V=await this.extensionsScanner.saveMetadataForLocalExtension(V,Object.assign(Object.assign({},V.manifest.__metadata||{}),{isMachineScoped:J})),this.manifestCache.invalidate(),V}async getGalleryMetadata(V){const J=await this.findGalleryExtensionByName(V);return J?{id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId}:void 0}async findGalleryExtension(V){if(V.identifier.uuid){const J=await this.findGalleryExtensionById(V.identifier.uuid);return J||this.findGalleryExtensionByName(V.identifier.id)}return this.findGalleryExtensionByName(V.identifier.id)}async findGalleryExtensionById(V){return(await this.galleryService.query({ids:[V],pageSize:1},p.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(V){return(await this.galleryService.query({names:[V],pageSize:1},p.CancellationToken.None)).firstPage[0]}joinErrors(V){const J=Array.isArray(V)?V:[V];return J.length===1?J[0]instanceof Error?J[0]:new Error(J[0]):J.reduce((ce,$)=>new Error(`${ce.message}${ce.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}async checkForDependenciesAndUninstall(V,J,ce){try{await this.preUninstallExtension(V);const $=ce.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(V,J);await this.uninstallExtensions(V,$,J,ce)}catch($){throw await this.postUninstallExtension(V,new g.ExtensionManagementError($ instanceof Error?$.message:$,W)),$}await this.postUninstallExtension(V)}async uninstallExtensions(V,J,ce,$){const O=[V,...J];if(!$.donotCheckDependents)for(const F of O)this.checkForDependents(F,O,ce,V);await Promise.all([this.uninstallExtension(V),...J.map(F=>this.doUninstall(F))])}checkForDependents(V,J,ce,$){const O=this.getDependents(V,ce);if(O.length){const F=O.filter(j=>J.indexOf(j)===-1);if(F.length)throw new Error(this.getDependentsErrorMessage(V,F,$))}}getDependentsErrorMessage(V,J,ce){return ce===V?J.length===1?y.localize(12,null,ce.manifest.displayName||ce.manifest.name,J[0].manifest.displayName||J[0].manifest.name):J.length===2?y.localize(13,null,ce.manifest.displayName||ce.manifest.name,J[0].manifest.displayName||J[0].manifest.name,J[1].manifest.displayName||J[1].manifest.name):y.localize(14,null,ce.manifest.displayName||ce.manifest.name,J[0].manifest.displayName||J[0].manifest.name,J[1].manifest.displayName||J[1].manifest.name):J.length===1?y.localize(15,null,ce.manifest.displayName||ce.manifest.name,V.manifest.displayName||V.manifest.name,J[0].manifest.displayName||J[0].manifest.name):J.length===2?y.localize(16,null,ce.manifest.displayName||ce.manifest.name,V.manifest.displayName||V.manifest.name,J[0].manifest.displayName||J[0].manifest.name,J[1].manifest.displayName||J[1].manifest.name):y.localize(17,null,ce.manifest.displayName||ce.manifest.name,V.manifest.displayName||V.manifest.name,J[0].manifest.displayName||J[0].manifest.name,J[1].manifest.displayName||J[1].manifest.name)}getAllPackExtensionsToUninstall(V,J,ce=[]){if(ce.indexOf(V)!==-1)return[];ce.push(V);const $=V.manifest.extensionPack?V.manifest.extensionPack:[];if($.length){const O=J.filter(j=>!j.isBuiltin&&$.some(Q=>t.areSameExtensions({id:Q},j.identifier))),F=[];for(const j of O)F.push(...this.getAllPackExtensionsToUninstall(j,J,ce));return[...O,...F]}return[]}getDependents(V,J){return J.filter(ce=>ce.manifest.extensionDependencies&&ce.manifest.extensionDependencies.some($=>t.areSameExtensions({id:$},V.identifier)))}async doUninstall(V){try{await this.preUninstallExtension(V),await this.uninstallExtension(V)}catch(J){throw await this.postUninstallExtension(V,new g.ExtensionManagementError(J instanceof Error?J.message:J,W)),J}await this.postUninstallExtension(V)}async preUninstallExtension(V){if(!await I.exists(V.location.fsPath))throw new Error(y.localize(18,null));this.logService.info("Uninstalling extension:",V.identifier.id),this._onUninstallExtension.fire(V.identifier)}async uninstallExtension(V){let J=this.uninstallingExtensions.get(V.identifier.id);return J||(J=_.createCancelablePromise(async()=>{const ce=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...ce.filter($=>t.areSameExtensions($.identifier,V.identifier)))}),this.uninstallingExtensions.set(V.identifier.id,J),J.finally(()=>this.uninstallingExtensions.delete(V.identifier.id))),J}async postUninstallExtension(V,J){if(J)this.logService.error("Failed to uninstall extension:",V.identifier.id,J.message);else if(this.logService.info("Successfully uninstalled extension:",V.identifier.id),V.identifier.uuid)try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"uninstall")}catch($){}this.reportTelemetry("extensionGallery:uninstall",t.getLocalExtensionTelemetryData(V),void 0,J);const ce=J?J instanceof g.ExtensionManagementError?J.code:H:void 0;this._onDidUninstallExtension.fire({identifier:V.identifier,error:ce})}getInstalled(V=null){return this.extensionsScanner.scanExtensions(V)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(V){return(await this.filterUninstalled(V)).length===1}filterUninstalled(...V){return this.extensionsScanner.withUninstalledExtensions(J=>{const ce=[];for(const $ of V)J[$.key()]&&ce.push($.key());return ce})}setUninstalled(...V){const J=V.map(ce=>new t.ExtensionIdentifierWithVersion(ce.identifier,ce.manifest.version));return this.extensionsScanner.withUninstalledExtensions(ce=>(J.forEach($=>ce[$.key()]=!0),ce))}unsetUninstalled(V){return this.extensionsScanner.withUninstalledExtensions(J=>delete J[V.key()])}getExtensionsReport(){const V=new Date().getTime();return(!this.reportedExtensions||V-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=V),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const V=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${V.length} reported extensions from service`),V}catch(V){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(V,J,ce,$){const O=$?$ instanceof g.ExtensionManagementError?$.code:H:void 0;this.telemetryService.publicLogError(V,Object.assign(Object.assign({},J),{success:!$,duration:ce,errorcode:O}))}};K=De([xe(0,R.INativeEnvironmentService),xe(1,g.IExtensionGalleryService),xe(2,b.ILogService),xe(3,l.optional(i.IDownloadService)),xe(4,a.ITelemetryService),xe(5,l.IInstantiationService)],K),e.ExtensionManagementService=K}),define(he[43],de([0,1,62,75,223,6,37,2,23,20,4,18,78,12,5]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(k){this.socket=k}dispose(){this.socket.destroy()}onData(k){const w=T=>k(_.VSBuffer.wrap(T));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(k){return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(k){return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(k){if(!this.socket.destroyed)try{this.socket.write(k.buffer)}catch(w){if(w.code==="EPIPE")return;v.onUnexpectedError(w)}}end(){this.socket.end()}drain(){return new Promise((k,w)=>{if(this.socket.bufferSize===0){k();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),k()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=d;var S;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var b;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(b||(b={}));class f extends R.Disposable{constructor(k,w,T,h){super();this._onDidZlibFlush=this._register(new E.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=k,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=h,w?(this._zlibInflate=I.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),v.onUnexpectedError(A),this._onClose.fire()}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=I.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),v.onUnexpectedError(A),this._onClose.fire()}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new P.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):_.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this._onData.event(k)}onClose(k){return this._onClose.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){this._totalOutgoingDataBytes+=k.byteLength,this._zlibDeflate?(this._zlibDeflate.write(k.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(_.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(k,!1)}_write(k,w){let T=2;k.byteLength<126?T+=0:k.byteLength<2**16?T+=2:T+=8;const h=_.VSBuffer.alloc(T);if(w?h.writeUInt8(194,0):h.writeUInt8(130,0),k.byteLength<126)h.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){h.writeUInt8(126,1);let A=1;h.writeUInt8(k.byteLength>>>8&255,++A),h.writeUInt8(k.byteLength>>>0&255,++A)}else{h.writeUInt8(127,1);let A=1;h.writeUInt8(0,++A),h.writeUInt8(0,++A),h.writeUInt8(0,++A),h.writeUInt8(0,++A),h.writeUInt8(k.byteLength>>>24&255,++A),h.writeUInt8(k.byteLength>>>16&255,++A),h.writeUInt8(k.byteLength>>>8&255,++A),h.writeUInt8(k.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=h.byteLength+k.byteLength,this.socket.write(_.VSBuffer.concat([h,k]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(k){if(k.byteLength!==0){for(this._totalIncomingWireBytes+=k.byteLength,this._incomingData.acceptChunk(k);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),h=(w.readUInt8(0)&128)>>>7,A=w.readUInt8(1),N=(A&128)>>>7,B=A&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=h,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),T=w.readUInt8(1),h=(T&128)>>>7;let A=T&127,N=1;A===126?A=w.readUInt8(++N)*2**8+w.readUInt8(++N):A===127&&(A=w.readUInt8(++N)*0+w.readUInt8(++N)*0+w.readUInt8(++N)*0+w.readUInt8(++N)*0+w.readUInt8(++N)*2**24+w.readUInt8(++N)*2**16+w.readUInt8(++N)*2**8+w.readUInt8(++N));let B=0;h&&(B=w.readUInt8(++N)*2**24+w.readUInt8(++N)*2**16+w.readUInt8(++N)*2**8+w.readUInt8(++N)),this._state.state=3,this._state.readLen=A,this._state.mask=B}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);u(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(_.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await E.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=f;function u(p,k){if(k!==0){let w=p.byteLength>>>2;for(let W=0;W<w;W++){const H=p.readUInt32BE(W*4);p.writeUInt32BE(H^k,W*4)}let T=w*4,h=p.byteLength-T;const A=k>>>24&255,N=k>>>16&255,B=k>>>8&255;h>=1&&p.writeUInt8(p.readUInt8(T)^A,T),h>=2&&p.writeUInt8(p.readUInt8(T+1)^N,T+1),h>=3&&p.writeUInt8(p.readUInt8(T+2)^B,T+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function o(){const p=t.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let k;return e.XDG_RUNTIME_DIR?k=L.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):k=L.join(g.tmpdir(),`vscode-ipc-${p}.sock`),r(k),k}e.createRandomIPCHandle=o;function n(p,k,w){const T=y.createHash("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${w}-${k}-sock`;let h;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?h=L.join(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${w}-${k}.sock`):h=L.join(p,`${w}-${k}.sock`),r(h),h}e.createStaticIPCHandle=n;function r(p){const k=a[c.platform];typeof k=="number"&&p.length>=k&&console.warn(`WARNING: IPC handle "${p}" is longer than ${k} chars, try a shorter --user-data-dir`)}class i extends C.IPCServer{constructor(k){super(i.toClientConnectionEvent(k));this.server=k}static toClientConnectionEvent(k){const w=E.Event.fromNodeEventEmitter(k,"connection");return E.Event.map(w,T=>({protocol:new P.Protocol(new d(T)),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function l(p){return new Promise((k,w)=>{const T=m.createServer();T.on("error",w),T.listen(p,()=>{T.removeListener("error",w),k(new i(T))})})}e.serve=l;function s(p,k){return new Promise((w,T)=>{const h=m.createConnection(p,()=>{h.removeListener("error",T),w(P.Client.fromSocket(new d(h),k))});h.once("error",T)})}e.connect=s}),define(he[224],de([0,1,23,124,2,22,108,26,133,8,3,43]),function(Z,e,y,m,I,E,C,L,g,t,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataDir=e.parsePathArg=e.parseSearchPort=e.parseExtensionHostPort=e.NativeEnvironmentService=void 0;class P{constructor(u){if(this._args=u,!u.logsPath){const a=g.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");u.logsPath=I.join(this.userDataPath,"logs",a)}this.logsPath=u.logsPath}get args(){return this._args}get appRoot(){return I.dirname(t.FileAccess.asFileUri("",Z).fsPath)}get userHome(){return R.URI.file(y.homedir())}get userDataPath(){const u=process.env.VSCODE_PORTABLE;return u?I.join(u,"user-data"):b(this._args,process)}get appSettingsHome(){return R.URI.file(I.join(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(y.tmpdir())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return E.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return E.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return R.URI.file(I.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return E.joinPath(R.URI.file(I.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return E.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return E.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=process.env.VSCODE_PORTABLE;return u?R.URI.file(I.join(u,"argv.json")):E.joinPath(this.userHome,L.default.dataFolderName,"argv.json")}get snippetsHome(){return E.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file(I.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return I.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=S(this._args["builtin-extensions-dir"],process);return u||I.normalize(I.join(t.FileAccess.asFileUri("",Z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=S(this._args["extensions-download-dir"],process);return u||I.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=S(this._args["extensions-dir"],process);if(u)return u;const a=process.env.VSCODE_EXTENSIONS;if(a)return a;const o=process.env.VSCODE_PORTABLE;return o?I.join(o,"extensions"):E.joinPath(this.userHome,L.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this._args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(a=>/^[^:/?#]+?:\/\//.test(a)?R.URI.parse(a):R.URI.file(I.normalize(a)))}get extensionTestsLocationURI(){const u=this._args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?R.URI.parse(u):R.URI.file(I.normalize(u))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const u=this._args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return v(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get sharedIPCHandle(){return _.createStaticIPCHandle(this.userDataPath,"shared",L.default.version)}get serviceMachineIdResource(){return E.joinPath(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return R.URI.file(I.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}De([C.memoize],P.prototype,"appRoot",null),De([C.memoize],P.prototype,"userHome",null),De([C.memoize],P.prototype,"userDataPath",null),De([C.memoize],P.prototype,"appSettingsHome",null),De([C.memoize],P.prototype,"tmpDir",null),De([C.memoize],P.prototype,"userRoamingDataHome",null),De([C.memoize],P.prototype,"settingsResource",null),De([C.memoize],P.prototype,"userDataSyncHome",null),De([C.memoize],P.prototype,"userDataSyncLogResource",null),De([C.memoize],P.prototype,"sync",null),De([C.memoize],P.prototype,"machineSettingsResource",null),De([C.memoize],P.prototype,"globalStorageHome",null),De([C.memoize],P.prototype,"workspaceStorageHome",null),De([C.memoize],P.prototype,"keybindingsResource",null),De([C.memoize],P.prototype,"keyboardLayoutResource",null),De([C.memoize],P.prototype,"argvResource",null),De([C.memoize],P.prototype,"snippetsHome",null),De([C.memoize],P.prototype,"isExtensionDevelopment",null),De([C.memoize],P.prototype,"untitledWorkspacesHome",null),De([C.memoize],P.prototype,"installSourcePath",null),De([C.memoize],P.prototype,"builtinExtensionsPath",null),De([C.memoize],P.prototype,"extensionsPath",null),De([C.memoize],P.prototype,"extensionDevelopmentLocationURI",null),De([C.memoize],P.prototype,"extensionTestsLocationURI",null),De([C.memoize],P.prototype,"debugExtensionHost",null),De([C.memoize],P.prototype,"sharedIPCHandle",null),De([C.memoize],P.prototype,"serviceMachineIdResource",null),De([C.memoize],P.prototype,"telemetryLogResource",null),e.NativeEnvironmentService=P;function v(f,u){return d(f["inspect-extensions"],f["inspect-brk-extensions"],5870,u,f.debugId)}e.parseExtensionHostPort=v;function c(f,u){return d(f["inspect-search"],f["inspect-brk-search"],5876,u)}e.parseSearchPort=c;function d(f,u,a,o,n){const i=Number(u||f)||(o?null:a),l=i?Boolean(!!u):!1;return{port:i,break:l,debugId:n}}function S(f,u){if(!!f){const a=I.resolve(f);return I.normalize(f)===a?a:I.resolve(u.env.VSCODE_CWD||u.cwd(),f)}}e.parsePathArg=S;function b(f,u){return S(f["user-data-dir"],u)||I.resolve(m.getDefaultUserDataPath())}e.parseUserDataDir=b}),define(he[105],de([0,1,223,64,4,11,12,190,34,16,18]),function(Z,e,y,m,I,E,C,L,g,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let _=class extends I.Disposable{constructor(v,c){super();this.logService=c,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,c){this.logService.trace("RequestService#request",v.url);const{proxyUrl:d,strictSSL:S}=this,b=v.agent?v.agent:await L.getProxyAgent(v.url||"",{proxyUrl:d,strictSSL:S});return v.agent=b,v.strictSSL=S,this.authorization&&(v.headers=Object.assign(Object.assign({},v.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(v,c)}async getNodeRequest(v){return(m.parse(v.url).protocol==="https:"?await new Promise((S,b)=>{Z(["https"],S,b)}):await new Promise((S,b)=>{Z(["http"],S,b)})).request}_request(v,c){return new Promise(async(d,S)=>{let b;const f=m.parse(v.url),u=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),a={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:E.isBoolean(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(a.auth=v.user+":"+v.password),b=u(a,o=>{const n=E.isNumber(v.followRedirects)?v.followRedirects:3;if(o.statusCode&&o.statusCode>=300&&o.statusCode<400&&n>0&&o.headers.location)this._request(Object.assign(Object.assign({},v),{url:o.headers.location,followRedirects:n-1}),c).then(d,S);else{let r=o;o.headers["content-encoding"]==="gzip"&&(r=o.pipe(y.createGunzip())),d({res:o,stream:R.streamToBufferReadableStream(r)})}}),b.on("error",S),v.timeout&&b.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&b.write(v.data),b.end(),c.onCancellationRequested(()=>{b.abort(),S(C.canceled())})})}async resolveProxy(v){}};_=De([xe(0,g.IConfigurationService),xe(1,t.ILogService)],_),e.RequestService=_}),define(he[106],de([0,1,32,96,38,8,2,18,6,43,178,5]),function(Z,e,y,m,I,E,C,L,g,t,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function P(b={},f,u,a){const o=await m.getNLSConfiguration(f,u.userDataPath),n=await R.resolveShellEnv(a,u.args,process.env),r=u.isBuilt?C.join(u.appRoot,"bin"):C.join(u.appRoot,"resources","server","bin-dev"),i=process.env;let l=b.PATH||n.PATH||i.PATH;l?l=r+C.delimiter+l:l=r;const s=Object.assign(Object.assign(Object.assign(Object.assign({},i),n),{VSCODE_AMD_ENTRYPOINT:"vs/server/remoteExtensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(o,void 0,0)}),b);return u.args["without-browser-env-var"]||(s.BROWSER=C.join(r,"helpers",_.isWindows?"browser.cmd":"browser.sh")),d(s,"PATH",l),S(s),s}e.buildUserEnvironment=P;class v{constructor(f,u,a,o,n,r){this.socket=f,this.socketDrain=u,this.initialDataChunk=a,this.skipWebSocketFrames=o,this.permessageDeflate=n,this.inflateBytes=r}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class c{constructor(f,u,a,o,n,r){this._environmentService=f,this._logService=u,this._reconnectionToken=a,this._onClose=new g.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=o,this._extensionHostProcess=null,this._connectionData=c._toConnectionData(n,r),this._connectionData.socket.pause(),this._log("New connection established.")}_log(f){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${f}`)}_logError(f){this._logService.error(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${f}`)}static _toConnectionData(f,u){return f instanceof t.NodeSocket?new v(f.socket,f.drain(),u,!0,!1,L.VSBuffer.alloc(0)):new v(f.socket.socket,f.drain(),u,!1,f.permessageDeflate,f.recordedInflateBytes)}async _sendSocketToExtensionHost(f,u){await u.socketDrain;const a=u.toIExtHostSocketMessage();f.send(a,u.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!!this._extensionHostProcess){const f={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(f)}}acceptReconnection(f,u,a){this._remoteAddress=f,this._log("The client has reconnected.");const o=c._toConnectionData(u,a);if(o.socket.pause(),!this._extensionHostProcess){this._connectionData=o;return}this._sendSocketToExtensionHost(this._extensionHostProcess,o)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(f){try{let u=[];f.port&&!process.pkg&&(u=[`--inspect${f.break?"-brk":""}=0.0.0.0:${f.port}`]);const o={env:await P(f.env,f.language,this._environmentService,this._logService),execArgv:u,silent:!0},n=["--type=extensionHost",`--uriTransformerPath=${I.uriTransformerPath}`],r=this._environmentService.args["use-host-proxy"];r!==void 0&&n.push(`--useHostProxy=${r}`),this._extensionHostProcess=y.fork(E.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,n,o);const i=this._extensionHostProcess.pid;this._log(`<${i}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const l=g.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),s=g.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");l(k=>console.log("EXTHOST-STDOUT::::::::"+k)),s(k=>console.log("EXTHOST-STDERR::::::::"+k)),this._extensionHostProcess.on("message",k=>{k&&k.type==="__$console"&&(console.log("EXTHOST-LOG:::::"),console.log(k.arguments))}),this._extensionHostProcess.on("error",k=>{this._logError(`<${i}> Extension Host Process had an error`),this._logService.error(k),this._cleanResources()}),this._extensionHostProcess.on("exit",(k,w)=>{this._log(`<${i}> Extension Host Process exited with code: ${k}, signal: ${w}.`),this._cleanResources()});const p=k=>{k.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",p),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",p)}catch(u){console.error("ExtensionHostConnection errored"),u&&console.error(u)}}}e.ExtensionHostConnection=c;function d(b,f,u){const a=Object.keys(b).filter(n=>n.toLowerCase()===f.toLowerCase()),o=a.length>0?a[0]:f;b[o]=u}function S(b){for(let f of Object.keys(b))b[f]===null&&delete b[f]}}),define(he[68],de([0,1,157,224,57]),function(Z,e,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={port:{type:"string"},connectionToken:{type:"string"},"connection-secret":{type:"string",description:y.localize(0,null)},host:{type:"string"},"socket-path":{type:"string"},driver:{type:"string"},"start-server":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},fileWatcherPolling:{type:"string"},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"without-browser-env-var":{type:"boolean"},"disable-telemetry":I.OPTIONS["disable-telemetry"],"extensions-dir":I.OPTIONS["extensions-dir"],"extensions-download-dir":I.OPTIONS["extensions-download-dir"],"install-extension":I.OPTIONS["install-extension"],"install-builtin-extension":I.OPTIONS["install-builtin-extension"],"uninstall-extension":I.OPTIONS["uninstall-extension"],"locate-extension":I.OPTIONS["locate-extension"],"list-extensions":I.OPTIONS["list-extensions"],force:I.OPTIONS.force,"show-versions":I.OPTIONS["show-versions"],category:I.OPTIONS.category,"do-not-sync":I.OPTIONS["do-not-sync"],"force-disable-user-env":I.OPTIONS["force-disable-user-env"],folder:{type:"string"},workspace:{type:"string"},"web-user-data-dir":{type:"string"},"use-host-proxy":{type:"string"},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},_:I.OPTIONS._};class E extends m.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=E}),define(he[225],de([0,1,29,60,16,59,91,34,63,105,65,42,30,93,104,86,26,4,88,61,8,24,52,90,103,68,87,50,89,12,3,2]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d,S,b,f,u,a,o,n,r,i,l,s,p,k,w,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class A extends b.Disposable{constructor(H,K){super();this.args=H,this.remoteDataFolder=K,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async K=>{const re=K.get(I.ILogService),V=K.get(P.IExtensionManagementCLIService);try{await this.doRun(V)}catch(J){throw re.error(J),console.error(w.getErrorMessage(J)),J}})}async initServices(){const H=new m.ServiceCollection,K=new l.ServerEnvironmentService(this.args);H.set(y.IEnvironmentService,K),H.set(y.INativeEnvironmentService,K);const re=new r.SpdLogService(i.RemoteExtensionLogFileName,K.logsPath,I.getLogLevel(K));H.set(I.ILogService,re),re.trace(`Remote configuration data at ${this.remoteDataFolder}`),re.trace("process arguments:",this.args),H.set(n.IProductService,Object.assign({_serviceBrand:void 0},S.default));const V=this._register(new f.FileService(re));H.set(o.IFileService,V),V.registerProvider(a.Schemas.file,this._register(new u.DiskFileSystemProvider(re)));const J=this._register(new C.ConfigurationService(K.settingsResource,V));return await J.initialize(),H.set(L.IConfigurationService,J),H.set(g.IRequestService,new E.SyncDescriptor(t.RequestService)),H.set(_.ITelemetryService,R.NullTelemetryService),H.set(P.IExtensionGalleryService,new E.SyncDescriptor(v.ExtensionGalleryService)),H.set(P.IExtensionManagementService,new E.SyncDescriptor(c.ExtensionManagementService)),H.set(P.IExtensionManagementCLIService,new E.SyncDescriptor(s.ExtensionManagementCLIService)),H.set(p.ILocalizationsService,new E.SyncDescriptor(k.LocalizationsService)),new d.InstantiationService(H)}async doRun(H){if(this.args["list-extensions"])return H.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"])return H.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],!!this.args["do-not-sync"],!!this.args.force);if(this.args["uninstall-extension"])return H.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return H.locateExtension(this.args["locate-extension"])}asExtensionIdOrVSIX(H){return H.map(K=>/\.vsix$/i.test(K)?T.URI.file(h.isAbsolute(K)?K:h.join(process.cwd(),K)):K)}}function N(W){setTimeout(()=>process.exit(W),0)}async function B(W,H){const K=new A(W,H);try{await K.run(),N(0)}catch(re){N(1)}finally{K.dispose()}}e.run=B}),define(he[226],de([0,1,43,238,21,217,3,199,16]),function(Z,e,y,m,I,E,C,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class t{constructor(P,v,c){this._commands=P,this.logService=v,this._ipcHandlePath=c,this._server=m.createServer((d,S)=>this.onRequest(d,S)),this.setup().catch(d=>(v.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",P=>this.logService.error(P))}catch(P){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(P,v){const c=[];P.setEncoding("utf8"),P.on("data",d=>c.push(d)),P.on("end",()=>{const d=JSON.parse(c.join(""));switch(d.type){case"open":this.open(d,v);break;case"openExternal":this.openExternal(d,v);break;case"status":this.getStatus(d,v);break;case"command":this.runCommand(d,v).catch(this.logService.error);break;case"extensionManagement":this.manageExtensions(d,v).catch(this.logService.error);break;default:v.writeHead(404),v.write(`Unknown message type: ${d.type}`,S=>{S&&this.logService.error(S)}),v.end();break}})}open(P,v){let{fileURIs:c,folderURIs:d,forceNewWindow:S,diffMode:b,addMode:f,forceReuseWindow:u,gotoLineMode:a,waitMarkerFilePath:o}=P;const n=[];if(Array.isArray(d))for(const r of d)try{n.push({folderUri:C.URI.parse(r)})}catch(i){}if(Array.isArray(c))for(const r of c)try{L.hasWorkspaceFileExtension(r)?n.push({workspaceUri:C.URI.parse(r)}):n.push({fileUri:C.URI.parse(r)})}catch(i){}if(n.length){const r=o?C.URI.file(o):void 0,l={forceNewWindow:S,diffMode:b,addMode:f,gotoLineMode:a,forceReuseWindow:u,preferNewWindow:!u&&!r&&!f,waitMarkerFileURI:r};this._commands.executeCommand("_files.windowOpen",n,l)}v.writeHead(200),v.end()}async openExternal(P,v){for(const c of P.uris)await this._commands.executeCommand("_remoteCLI.openExternal",C.URI.parse(c),{allowTunneling:!0});v.writeHead(200),v.end()}async manageExtensions(P,v){console.log("server: manageExtensions");try{const c=b=>b==null?void 0:b.map(f=>/\.vsix$/i.test(f)?C.URI.parse(f):f),d={list:P.list,install:c(P.install),uninstall:c(P.uninstall),force:P.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",d,{allowTunneling:!0});v.writeHead(200),v.write(S)}catch(c){v.writeHead(500),v.write(String(c))}v.end()}async getStatus(P,v){try{const c=await this._commands.executeCommand("_issues.getSystemStatus");v.writeHead(200),v.write(c),v.end()}catch(c){v.writeHead(500),v.write(String(c),d=>{d&&this.logService.error(d)}),v.end()}}async runCommand(P,v){try{const{command:c,args:d}=P,S=await this._commands.executeCommand(c,...d);v.writeHead(200),v.write(JSON.stringify(S),b=>{b&&this.logService.error(b)}),v.end()}catch(c){v.writeHead(500),v.write(String(c),d=>{d&&this.logService.error(d)}),v.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=t;let R=class extends t{constructor(P,v){super(P,v,y.createRandomIPCHandle())}};R=De([xe(0,E.IExtHostCommands),xe(1,g.ILogService)],R),e.CLIServer=R}),define(he[227],de([0,1,6,3,23,2,26,5,205,207,4,204,102,210,38,100,203,226,43,19,106,17,95,81]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d,S,b,f,u,a,o,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;const i=1024*1024;class l extends v.AbstractVariableResolverService{constructor(h,A,N,B){super({getFolderUri:W=>{const H=A.filter(K=>K.name===W);if(H&&H.length>0)return H[0].uri},getWorkspaceFolderCount:()=>A.length,getConfigurationValue:(W,H)=>B[`config:${H}`],getExecPath:()=>h.VSCODE_EXEC_PATH,getFilePath:()=>{if(N)return E.normalize(N.fsPath)},getSelectedText:()=>B.selectedText,getLineNumber:()=>B.lineNumber},void 0,h)}}class s{constructor(h,A){this._logService=h,this._environmentService=A,this._terminals=new Map,this._workspaceLayoutInfos=new Map,this._terminals=new Map}async call(h,A,N){switch(A){case"$createTerminalProcess":{const B=c.createRemoteURITransformer(h.remoteAuthority),W=N;return this._createTerminalProcess(B,W)}case"$startTerminalProcess":{const B=N;return this._startTerminalProcess(B)}case"$sendInputToTerminalProcess":{const B=N;return this._sendInputToTerminalProcess(B)}case"$sendCharCountToTerminalProcess":{const B=N;return this._sendCharCountToTerminalProcess(B)}case"$shutdownTerminalProcess":{const B=N;return this._shutdownTerminalProcess(B)}case"$resizeTerminalProcess":{const B=N;return this._resizeTerminalProcess(B)}case"$getTerminalInitialCwd":{const B=N;return this._getTerminalInitialCwd(B)}case"$getTerminalCwd":{const B=N;return this._getTerminalCwd(B)}case"$sendCommandResultToTerminalProcess":{const B=N;return this._sendCommandResultToTerminalProcess(B)}case"$orphanQuestionReply":{const B=N;return this._orphanQuestionReply(B)}case"$listTerminals":{const B=N;return this._listTerminals(B)}case"$getTerminalLayoutInfo":{const B=N;return this._getTerminalLayoutInfo(B)}case"$setTerminalLayoutInfo":{const B=N;return this._setTerminalLayoutInfo(B)}}throw new Error(`IPC Command ${A} not found`)}async _createTerminalProcess(h,A){const N={name:A.shellLaunchConfig.name,executable:A.shellLaunchConfig.executable,args:A.shellLaunchConfig.args,cwd:typeof A.shellLaunchConfig.cwd=="string"||typeof A.shellLaunchConfig.cwd=="undefined"?A.shellLaunchConfig.cwd:m.URI.revive(h.transformIncoming(A.shellLaunchConfig.cwd)),env:A.shellLaunchConfig.env,flowControl:A.configuration["terminal.flowControl"]},B=await a.buildUserEnvironment(A.resolverEnv,L.language,this._environmentService,this._logService),W=fe=>({uri:m.URI.revive(h.transformIncoming(fe.uri)),name:fe.name,index:fe.index,toResource:()=>{throw new Error("Not implemented")}}),H=A.workspaceFolders.map(W),K=A.activeWorkspaceFolder?W(A.activeWorkspaceFolder):void 0,re=A.activeFileResource?m.URI.revive(h.transformIncoming(A.activeFileResource)):void 0,V=new l(B,H,re,A.resolvedVariables),J=g.createVariableResolver(K,V),ce=L.isWindows?"terminal.integrated.env.windows":L.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux";if(!N.executable)N.executable=await this._getDefaultShell(!1,A.configuration,J,A.isWorkspaceShellAllowed,B),N.args=this._getDefaultShellArgs(!1,A.configuration,J,A.isWorkspaceShellAllowed);else if(J&&(N.executable=J(N.executable),N.args))if(Array.isArray(N.args)){const fe=[];for(const Ie of N.args)fe.push(J(Ie));N.args=fe}else N.args=J(N.args);const $=g.getCwd(N,I.homedir(),J,K==null?void 0:K.uri,A.configuration["terminal.integrated.cwd"],this._logService);N.cwd=$;const O=A.configuration[ce],F=A.configuration["terminal.integrated.inheritEnv"]?B:await this._getNonInheritedEnv(B),j=g.createTerminalEnvironment(N,O,J,A.isWorkspaceShellAllowed,C.default.version,A.configuration["terminal.integrated.detectLocale"],F);if(!N.strictEnv){const fe=[];for(const[Ne,ye]of A.envVariableCollections)fe.push([Ne,{map:d.deserializeEnvironmentVariableCollection(ye)}]);const Ie=new Map(fe);new S.MergedEnvironmentVariableCollection(Ie).applyToProcessEnvironment(j)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:N,initialCwd:$,cols:A.cols,rows:A.rows,env:j});const Q=f.createRandomIPCHandle();j.VSCODE_IPC_HOOK_CLI=Q;const ne=s._nextTerminalId++,oe=new t.TerminalProcess(N,$,A.cols,A.rows,j,B,!1,this._logService),ie=new k(ne,oe,A.workspaceId,A.workspaceName,A.shouldPersistTerminal,A.cols,A.rows,h,Q,this._logService,()=>{ie.dispose(),this._terminals.delete(ne)});return this._terminals.set(ne,ie),{terminalId:ne,resolvedShellLaunchConfig:N}}async _startTerminalProcess(h){const A=this._terminals.get(h.id);if(!A)return{message:"Missing terminal"};const N=await A.start();if(N)return N}async _getDefaultShell(h,A,N,B,W){const H=K=>A[K];return g.getDefaultShell(H,B,await r.getSystemShell(L.platform),W.hasOwnProperty("PROCESSOR_ARCHITEW6432"),W.windir,N,this._logService,h)}_getDefaultShellArgs(h,A,N,B){const W=H=>A[H];return g.getDefaultShellArgs(W,B,h,N,this._logService)}_getNonInheritedEnv(h){return P.getMainProcessParentEnv(h)}_getTerminalOrThrow(h){const A=this._terminals.get(h);if(!A)throw new Error("Missing terminal");return A}_sendInputToTerminalProcess(h){this._getTerminalOrThrow(h.id).input(h.data)}_sendCharCountToTerminalProcess(h){this._getTerminalOrThrow(h.id).acknowledgeCharCount(h.charCount)}_shutdownTerminalProcess(h){this._getTerminalOrThrow(h.id).shutdown(h.immediate)}_resizeTerminalProcess(h){this._getTerminalOrThrow(h.id).resize(h.cols,h.rows)}_getTerminalInitialCwd(h){return this._getTerminalOrThrow(h.id).getInitialCwd()}_getTerminalCwd(h){return this._getTerminalOrThrow(h.id).getCwd()}_sendCommandResultToTerminalProcess(h){this._getTerminalOrThrow(h.id).sendCommandResult(h.reqId,h.isError,h.payload)}_orphanQuestionReply(h){this._getTerminalOrThrow(h.id).orphanQuestionReply()}async _listTerminals(h){if(h.isInitialization)for(const[,W]of this._terminals)W.reduceGraceTime();const A=Array.from(this._terminals.entries()).filter(([W,H])=>H.shouldPersistTerminal);this._logService.info(`Listing ${A.length} persistent terminals, ${this._terminals.size} total terminals`);const N=A.map(async([W,H])=>this._terminalToDto(W,H));return(await Promise.all(N)).filter(W=>W.isOrphan)}async _terminalToDto(h,A){const[N,B]=await Promise.all([A.getCwd(),A.isOrphaned()]);return{id:h,title:A.title,pid:A.pid,workspaceId:A.workspaceId,workspaceName:A.workspaceName,cwd:N,isOrphan:B}}_setTerminalLayoutInfo(h){this._workspaceLayoutInfos.set(h.workspaceId,h)}async _getTerminalLayoutInfo(h){const A=this._workspaceLayoutInfos.get(h.workspaceId);if(A){const B=(await Promise.all(A.tabs.map(async W=>this._expandTerminalTab(W)))).filter(W=>W.terminals.length>0);return this._logService.info(`Terminal layout retrieved: ${JSON.stringify(B.map(W=>W.terminals.length))}`),{tabs:B}}}async _expandTerminalTab(h){const N=(await Promise.all(h.terminals.map(B=>this._expandTerminalInstance(B)))).filter(B=>B.terminal!==null);return{isActive:h.isActive,activeTerminalProcessId:h.activeTerminalProcessId,terminals:N}}async _expandTerminalInstance(h){const A=this._terminals.get(h.terminal),N=A&&await this._terminalToDto(h.terminal,A);return{terminal:N!=null?N:null,relativeSize:h.relativeSize}}listen(h,A,N){switch(A){case"$onTerminalProcessEvent":{const B=N;return this._onTerminalProcessEvent(B)}default:break}throw new Error("Not supported")}_onTerminalProcessEvent(h){const A=this._terminals.get(h.id);if(!A)throw new Error("Missing terminal");return A.events}}e.RemoteTerminalChannel=s,s._nextTerminalId=1;class p{constructor(h,A){this._entries=[{cols:h,rows:A,data:[]}],this._totalDataLength=0}recordResize(h,A){if(this._entries.length>0&&this._entries[this._entries.length-1].data.length===0&&this._entries.pop(),this._entries.length>0){const N=this._entries[this._entries.length-1];if(N.cols===h&&N.rows===A)return;if(N.cols===0&&N.rows===0){N.cols=h,N.rows=A;return}}this._entries.push({cols:h,rows:A,data:[]})}recordData(h){for(this._entries[this._entries.length-1].data.push(h),this._totalDataLength+=h.length;this._totalDataLength>i;){const N=this._entries[0],B=this._totalDataLength-i;B>=N.data[0].length?(this._totalDataLength-=N.data[0].length,N.data.shift(),N.data.length===0&&this._entries.shift()):(N.data[0]=N.data[0].substr(B),this._totalDataLength-=B)}}generateReplayEvent(){return this._entries.forEach(h=>{h.data.length>0&&(h.data=[h.data.join("")])}),{type:"replay",events:this._entries.map(h=>{var A;return{cols:h.cols,rows:h.rows,data:(A=h.data[0])!==null&&A!==void 0?A:""}})}}}class k extends R.Disposable{constructor(h,A,N,B,W,H,K,re,V,J,ce){super();this._id=h,this._terminalProcess=A,this.workspaceId=N,this.workspaceName=B,this.shouldPersistTerminal=W,this._uriTransformer=re,this._logService=J,this._onExit=ce,this._lastReqId=0,this._pendingCommands=new Map,this._orphanRequestQueue=new o.Queue,this._title="",this._pid=-1,this._recorder=new p(H,K),this._seenFirstListener=!1,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new o.RunOnceScheduler(()=>{this._logService.info(`The reconnection grace time of ${n.printTime(108e5)} has expired, so the terminal process with pid ${this._pid} will be shutdown.`),this.shutdown(!0)},108e5)),this._disconnectRunner2=this._register(new o.RunOnceScheduler(()=>{this._logService.info(`The short reconnection grace time of ${n.printTime(3e5)} has expired, so the terminal process with pid ${this._pid} will be shutdown.`),this.shutdown(!0)},3e5)),this._events=this._register(new y.Emitter({onListenerDidAdd:()=>{this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this._seenFirstListener&&this._triggerReplay(),this._seenFirstListener=!0},onLastListenerRemove:()=>{this.shouldPersistTerminal?this._disconnectRunner1.schedule():this.shutdown(!0)}})),this.events=this._events.event,this._bufferer=new _.TerminalDataBufferer((O,F)=>{const j={type:"data",data:F};this._events.fire(j)}),this._register(this._terminalProcess.onProcessReady(O=>{this._pid=O.pid;const F={type:"ready",pid:O.pid,cwd:O.cwd};this._events.fire(F)})),this._register(this._terminalProcess.onProcessTitleChanged(O=>{this._title=O;const F={type:"titleChanged",title:O};this._events.fire(F)})),this._register(this._bufferer.startBuffering(this._id,this._terminalProcess.onProcessData)),this._register(this._terminalProcess.onProcessData(O=>{this._recorder.recordData(O)})),this._register(this._terminalProcess.onProcessExit(O=>{this._bufferer.stopBuffering(this._id);const F={type:"exit",exitCode:O};this._events.fire(F),this._onExit()}));const $={executeCommand:(O,...F)=>this._executeCommand(O,F)};this._register(new b.CLIServerBase($,this._logService,V))}get pid(){return this._pid}get title(){return this._title}start(){return this._terminalProcess.start()}shutdown(h){return this._terminalProcess.shutdown(h)}input(h){return this._terminalProcess.input(h)}acknowledgeCharCount(h){return this._terminalProcess.acknowledgeDataEvent(h)}resize(h,A){return this._recorder.recordResize(h,A),this._terminalProcess.resize(h,A)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}_triggerReplay(){const h=this._recorder.generateReplayEvent();let A=0;for(const N of h.events)A+=N.data.length;this._logService.info(`Replaying ${A} chars and ${h.events.length} size events.`),this._events.fire(h),this._terminalProcess.clearUnacknowledgedChars()}_executeCommand(h,A){let N,B;const W=new Promise((V,J)=>{N=V,B=J}),H=++this._lastReqId;this._pendingCommands.set(H,{resolve:N,reject:B});const K=u.cloneAndChange(A,V=>{if(V&&V.$mid===1)return this._uriTransformer.transformOutgoing(V);if(V&&V instanceof m.URI)return this._uriTransformer.transformOutgoingURI(V)}),re={type:"execCommand",reqId:H,commandId:h,commandArgs:K};return this._events.fire(re),W}sendCommandResult(h,A,N){const B=this._pendingCommands.get(h);if(!!B){this._pendingCommands.delete(h);const W=u.cloneAndChange(N,H=>{if(H&&H.$mid===1)return this._uriTransformer.transformIncoming(H)});A?B.reject(W):B.resolve(W)}}async orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const h=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,h.open()}}reduceGraceTime(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){if(this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled())return!0;if(!this._orphanQuestionBarrier){this._orphanQuestionBarrier=new w(4e3),this._orphanQuestionReplyTime=0;const h={type:"orphan?"};this._events.fire(h)}return await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500}}class w extends o.Barrier{constructor(h){super();this._timeout=setTimeout(()=>this.open(),h)}open(){clearTimeout(this._timeout),super.open()}}}),define(he[228],de([0,1,62,21,75,64,23,47,229,18,4,20,15,126,5,78,43,106,95,38,16,8,26,29,60,59,91,34,63,105,65,42,30,93,104,86,83,165,50,89,197,196,193,74,88,61,24,52,37,6,219,200,220,189,166,198,163,183,201,3,28,68,2,213,227,117,90,103,87]),function(Z,e,y,m,I,E,C,L,g,t,R,_,P,v,c,d,S,b,f,u,a,o,n,r,i,l,s,p,k,w,T,h,A,N,B,W,H,K,re,V,J,ce,$,O,F,j,Q,ne,oe,ie,fe,Ie,Pe,Ne,ye,_e,Ce,ze,je,me,ve,Se,ke,Re,Fe,We,Be,Ve,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const ge=5*60*1e3,pe=`

*
* Visual Studio Code Server
*
* Reminder: You may only use this software with Visual Studio family products,
* as described in the license https://aka.ms/vscode-remote/license
*

`,Oe="monacoworkbench";class ee extends oe.IPCServer{constructor(){const Y=new ie.Emitter;super(Y.event);this._onDidConnectEmitter=Y}acceptConnection(Y,se){this._onDidConnectEmitter.fire({protocol:Y,onDidClientDisconnect:se})}}function ue(X){return X<10?`0${X}`:String(X)}function Ee(){const X=new Date;return`${ue(X.getHours())}:${ue(X.getMinutes())}:${ue(X.getSeconds())}`}class G extends a.AbstractLogService{constructor(Y=a.DEFAULT_LOG_LEVEL){super();this.setLevel(Y),this.useColors=Boolean(process.stdout.isTTY)}trace(Y,...se){this.getLevel()<=a.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Ee()}][0m`,Y,...se):console.log(`[${Ee()}]`,Y,...se))}debug(Y,...se){this.getLevel()<=a.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Ee()}][0m`,Y,...se):console.log(`[${Ee()}]`,Y,...se))}info(Y,...se){this.getLevel()<=a.LogLevel.Info&&(this.useColors?console.log(`[90m[${Ee()}][0m`,Y,...se):console.log(`[${Ee()}]`,Y,...se))}warn(Y,...se){this.getLevel()<=a.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Ee()}][0m`,Y,...se):console.warn(`[${Ee()}]`,Y,...se))}error(Y,...se){this.getLevel()<=a.LogLevel.Error&&(this.useColors?console.error(`[91m[${Ee()}][0m`,Y,...se):console.error(`[${Ee()}]`,Y,...se))}critical(Y,...se){this.getLevel()<=a.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Ee()}][0m`,Y,...se):console.error(`[${Ee()}]`,Y,...se))}dispose(){}flush(){}}class q extends R.Disposable{constructor(Y,se,le,we,Te){super();this._environmentService=Y,this._connectionToken=se,this._connectionTokenIsMandatory=le;const Le=x(this._environmentService);Le.trace(`Remote configuration data at ${Te}`),Le.trace("process arguments:",this._environmentService.args),Le.info(pe),this._logService=new a.MultiplexLogService([new G(a.getLogLevel(this._environmentService)),Le]),this._socketServer=new ee,this._uriTransformerCache=Object.create(null),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),we?this._webClientServer=new je.WebClientServer(this._connectionToken,this._environmentService,this._logService):this._webClientServer=null,this._logService.info("Extension host agent started.")}async initialize(){const Y=await this._createServices();return setTimeout(()=>this._cleanupOlderLogs(this._environmentService.logsPath).then(null,se=>this._logService.error(se)),1e4),Y}async _createServices(){const Y=new i.ServiceCollection;this._socketServer.registerChannel(Ce.ExtensionHostDebugBroadcastChannel.ChannelName,new Ce.ExtensionHostDebugBroadcastChannel);const se=new oe.StaticRouter($e=>$e.clientId==="renderer");this._socketServer.registerChannel("logger",new ze.LoggerChannel(this._logService)),Y.set(r.IEnvironmentService,this._environmentService),Y.set(r.INativeEnvironmentService,this._environmentService),Y.set(a.ILogService,this._logService),Y.set(ne.IProductService,Object.assign({_serviceBrand:void 0},n.default));const le=this._register(new F.FileService(this._logService));Y.set(Q.IFileService,le),le.registerProvider(o.Schemas.file,this._register(new j.DiskFileSystemProvider(this._logService))),Y.set(p.IConfigurationService,new l.SyncDescriptor(s.ConfigurationService,[this._environmentService.machineSettingsResource,le])),Y.set(k.IRequestService,new l.SyncDescriptor(w.RequestService));let we=T.NullAppender;if(!this._environmentService.args["disable-telemetry"]&&n.default.enableTelemetry){n.default.aiConfig&&n.default.aiConfig.asimovKey&&(we=new J.AppInsightsAppender(Oe,null,n.default.aiConfig.asimovKey),this._register(R.toDisposable(()=>we.flush())));const $e=await O.getMachineId(),He={appender:we,commonProperties:$.resolveCommonProperties(le,C.release(),process.arch,n.default.commit,n.default.version+"-remote",$e,n.default.msftInternalDomains,this._environmentService.installSourcePath,"remoteAgent"),piiPaths:[this._environmentService.appRoot]};Y.set(h.ITelemetryService,new l.SyncDescriptor(ce.TelemetryService,[He]))}else Y.set(h.ITelemetryService,T.NullTelemetryService);Y.set(A.IExtensionGalleryService,new l.SyncDescriptor(N.ExtensionGalleryService));const Te=this._socketServer.getChannel("download",se);Y.set(H.IDownloadService,new K.DownloadServiceChannelClient(Te,()=>this._getUriTransformer("renderer"))),Y.set(A.IExtensionManagementService,new l.SyncDescriptor(B.ExtensionManagementService));const Le=new W.InstantiationService(Y);Y.set(re.ILocalizationsService,Le.createInstance(V.LocalizationsService));const Ae=Le.createInstance(ae.ExtensionManagementCLIService);return Y.set(A.IExtensionManagementCLIService,Ae),Le.invokeFunction($e=>{const He=new fe.RemoteAgentEnvironmentChannel(this._connectionToken,this._environmentService,Ae,this._logService,$e.get(h.ITelemetryService),we);this._socketServer.registerChannel("remoteextensionsenvironment",He),this._socketServer.registerChannel(Re.REMOTE_TERMINAL_CHANNEL_NAME,new Fe.RemoteTerminalChannel(this._logService,this._environmentService));const Ue=new Ie.RemoteAgentFileSystemChannel(this._logService,this._environmentService);this._socketServer.registerChannel(Pe.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Ue),this._socketServer.registerChannel("request",new Ne.RequestChannel($e.get(k.IRequestService)));const Xe=$e.get(A.IExtensionManagementService),Ke=new ye.ExtensionManagementChannel(Xe,Qe=>this._getUriTransformer(Qe.remoteAuthority));return this._socketServer.registerChannel("extensions",Ke),Xe.removeDeprecatedExtensions(),this._register(new _e.default($e.get(h.ITelemetryService))),{telemetryService:$e.get(h.ITelemetryService)}})}_getUriTransformer(Y){return this._uriTransformerCache[Y]||(this._uriTransformerCache[Y]=u.createRemoteURITransformer(Y)),this._uriTransformerCache[Y]}async handleRequest(Y,se){if(Y.method!=="GET")return je.serveError(Y,se,405,`Unsupported method ${Y.method}`);if(!Y.url)return je.serveError(Y,se,400,"Bad request.");const le=E.parse(Y.url,!0),we=le.pathname;if(!we)return je.serveError(Y,se,400,"Bad request.");if(we==="/version")return se.writeHead(200,{"Content-Type":"text/plain"}),se.end(n.default.commit||"");if(we==="/delay-shutdown")return this._delayShutdown(),se.writeHead(200),se.end("OK");if(we==="/vscode-remote-resource"){if(le.query.tkn!==this._connectionToken)return je.serveError(Y,se,403,"Forbidden.");const Te=le.query.path;if(typeof Te!="string")return je.serveError(Y,se,400,"Bad request.");let Le;try{Le=me.URI.from({scheme:o.Schemas.file,path:Te}).fsPath}catch($e){return je.serveError(Y,se,400,"Bad request.")}const Ae=Object.create(null);return this._environmentService.isBuilt&&(ve.isEqualOrParent(Le,this._environmentService.builtinExtensionsPath,!c.isLinux)||ve.isEqualOrParent(Le,this._environmentService.extensionsPath,!c.isLinux))&&(Ae["Cache-Control"]="public, max-age=31536000"),je.serveFile(this._logService,Y,se,Le,Ae)}if(this._webClientServer){this._webClientServer.handle(Y,se,le);return}return se.writeHead(404,{"Content-Type":"text/plain"}),se.end("Not found")}handleUpgrade(Y,se){let le=_.generateUuid(),we=!1,Te=!1;if(Y.url){const Xe=E.parse(Y.url,!0).query;typeof Xe.reconnectionToken=="string"&&(le=Xe.reconnectionToken),Xe.reconnection==="true"&&(we=!0),Xe.skipWebSocketFrames==="true"&&(Te=!0)}if(Y.headers.upgrade!=="websocket"){se.end("HTTP/1.1 400 Bad Request");return}const Le=Y.headers["sec-websocket-key"],Ae=y.createHash("sha1");Ae.update(Le+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const $e=Ae.digest("base64"),He=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${$e}`];let Ue=!1;if(!Te&&Y.headers["sec-websocket-extensions"]){const Xe=Array.isArray(Y.headers["sec-websocket-extensions"])?Y.headers["sec-websocket-extensions"]:[Y.headers["sec-websocket-extensions"]];for(const Ke of Xe)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(Ke)){if(/\b(permessage-deflate)\b/.test(Ke)){Ue=!0,He.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(Ke)){Ue=!0,He.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}se.write(He.join(`\r
`)+`\r
\r
`),se.setTimeout(0),Te?this._handleWebSocketConnection(new S.NodeSocket(se),we,le):this._handleWebSocketConnection(new S.WebSocketNodeSocket(new S.NodeSocket(se),Ue,null,!0),we,le)}handleServerError(Y){this._logService.error("Error occurred in server"),this._logService.error(Y)}async _cleanupOlderLogs(Y){const se=ke.basename(Y),le=ke.dirname(Y),Le=(await P.readdir(le)).filter($e=>/^\d{8}T\d{6}$/.test($e)).sort().filter($e=>$e!==se),Ae=Le.slice(0,Math.max(0,Le.length-9));await Promise.all(Ae.map($e=>P.rimraf(ke.join(le,$e))))}_getRemoteAddress(Y){let se;return Y instanceof S.NodeSocket?se=Y.socket:se=Y.socket.socket,se.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(Y,se,le){const we=se.getSocket();this._logService.error(`${Y} ${le}.`);const Te={type:"error",reason:le};se.sendControl(t.VSBuffer.fromString(JSON.stringify(Te))),se.dispose(),await we.drain(),we.dispose()}_handleWebSocketConnection(Y,se,le){const we=this._getRemoteAddress(Y),Te=`[${we}][${le.substr(0,8)}]`,Le=new d.PersistentProtocol(Y);let Ae;try{const Ke=Z.__$__nodeRequire("vsda");Ae=new Ke.validator}catch(Ke){}let $e;(function(Ke){Ke[Ke.WaitingForAuth=0]="WaitingForAuth",Ke[Ke.WaitingForConnectionType=1]="WaitingForConnectionType",Ke[Ke.Done=2]="Done",Ke[Ke.Error=3]="Error"})($e||($e={}));let He=0;const Ue=Ke=>{He=3,Xe.dispose(),this._rejectWebSocketConnection(Te,Le,Ke)},Xe=Le.onControlMessage(Ke=>{if(He===0){let Qe;try{Qe=JSON.parse(Ke.toString())}catch(nt){return Ue("Malformed first message")}if(Qe.type!=="auth")return Ue("Invalid first message");if(this._connectionTokenIsMandatory&&Qe.auth!==this._connectionToken)return Ue("Unauthorized client refused: auth mismatch");let Ze="VS Code Headless is cool";if(Ae)try{Ze=Ae.createNewMessage(Ze)}catch(nt){}const qe={type:"sign",data:Ze};Le.sendControl(t.VSBuffer.fromString(JSON.stringify(qe))),He=1}else if(He===1){let Qe;try{Qe=JSON.parse(Ke.toString())}catch(tt){return Ue("Malformed second message")}if(Qe.type!=="connectionType")return Ue("Invalid second message");if(typeof Qe.signedData!="string")return Ue("Invalid second message field type");const Ze=Qe.commit,qe=n.default.commit;if(Ze&&qe&&Ze!==qe)return Ue("Client refused: version mismatch");let nt=!1;if(Qe.signedData===this._connectionToken)nt=!0;else if(Ae)try{nt=Ae.validate(Qe.signedData)==="ok"}catch(tt){}if(!nt){if(this._environmentService.isBuilt)return Ue("Unauthorized client refused");this._logService.error(`${Te} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let tt in this._managementConnections)this._managementConnections[tt].shortenReconnectionGraceTimeIfNecessary();for(let tt in this._extHostConnections)this._extHostConnections[tt].shortenReconnectionGraceTimeIfNecessary();He=2,Xe.dispose(),this._handleConnectionType(we,Te,Le,Y,se,le,Qe)}})}async _handleConnectionType(Y,se,le,we,Te,Le,Ae){const $e=Ae.desiredConnectionType===1?`${se}[ManagementConnection]`:Ae.desiredConnectionType===2?`${se}[ExtensionHostConnection]`:se;if(Ae.desiredConnectionType===1)if(Te){if(!this._managementConnections[Le])return this._rejectWebSocketConnection($e,le,"Unknown reconnection token");le.sendControl(t.VSBuffer.fromString(JSON.stringify({type:"ok"})));const He=le.readEntireBuffer();le.dispose(),this._managementConnections[Le].acceptReconnection(Y,we,He)}else{if(this._managementConnections[Le])return this._rejectWebSocketConnection($e,le,"Duplicate reconnection token");le.sendControl(t.VSBuffer.fromString(JSON.stringify({type:"ok"})));const He=new f.ManagementConnection(this._logService,Le,Y,le);this._socketServer.acceptConnection(He.protocol,He.onClose),this._managementConnections[Le]=He,He.onClose(()=>{delete this._managementConnections[Le]})}else if(Ae.desiredConnectionType===2){const He=Ae.args||{language:"en"},Ue=await this._updateWithFreeDebugPort(He);if(Ue.port&&this._logService.trace(`${$e} - startParams debug port ${Ue.port}`),this._logService.trace(`${$e} - startParams language: ${Ue.language}`),this._logService.trace(`${$e} - startParams env: ${JSON.stringify(Ue.env)}`),Te){if(!this._extHostConnections[Le])return this._rejectWebSocketConnection($e,le,"Unknown reconnection token");le.sendControl(t.VSBuffer.fromString(JSON.stringify(Ue.port?{debugPort:Ue.port}:{})));const Xe=le.readEntireBuffer();le.dispose(),this._extHostConnections[Le].acceptReconnection(Y,we,Xe)}else{if(this._extHostConnections[Le])return this._rejectWebSocketConnection($e,le,"Duplicate reconnection token");le.sendControl(t.VSBuffer.fromString(JSON.stringify(Ue.port?{debugPort:Ue.port}:{})));const Xe=le.readEntireBuffer();le.dispose();const Ke=new b.ExtensionHostConnection(this._environmentService,this._logService,Le,Y,we,Xe);this._extHostConnections[Le]=Ke,Ke.onClose(()=>{delete this._extHostConnections[Le],this._onDidCloseExtHostConnection()}),Ke.start(Ue)}}else if(Ae.desiredConnectionType===3){const He=Ae.args;this._createTunnel(le,He)}else return this._rejectWebSocketConnection($e,le,"Unknown initial data received")}async _createTunnel(Y,se){const le=Y.getSocket().socket,we=Y.readEntireBuffer();Y.dispose(),le.pause();const Te=await this._connectTunnelSocket(se.port);we.byteLength>0&&Te.write(we.buffer),Te.on("end",()=>le.end()),Te.on("close",()=>le.end()),Te.on("error",()=>le.destroy()),le.on("end",()=>Te.end()),le.on("close",()=>Te.end()),le.on("error",()=>Te.destroy()),Te.pipe(le),le.pipe(Te)}_connectTunnelSocket(Y){return new Promise((se,le)=>{const we=I.createConnection({port:Y},()=>{we.removeListener("error",le),we.pause(),se(we)});we.once("error",le)})}_updateWithFreeDebugPort(Y){return typeof Y.port=="number"?v.findFreePort(Y.port,10,5e3).then(se=>(Y.port=se,Y)):(Y.debugId=void 0,Y.port=void 0,Y.break=void 0,Promise.resolve(Y))}async _onDidCloseExtHostConnection(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown()))}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},ge))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}}e.RemoteExtensionHostAgentServer=q;function U(X){if(X["connection-secret"]){X.connectionToken&&(console.warn("Please do not use the argument connectionToken at the same time as connection-secret."),process.exit(1));let Y=m.readFileSync(X["connection-secret"]).toString();return Y=Y.replace(/\r?\n$/,""),/^[0-9A-Za-z\-]+$/.test(Y)||(console.warn(`The secret defined in ${X["connection-secret"]} does not adhere to the characters 0-9, a-z, A-Z or -.`),process.exit(1)),{connectionToken:Y,connectionTokenIsMandatory:!0}}else return{connectionToken:X.connectionToken||_.generateUuid(),connectionTokenIsMandatory:!1}}async function D(X,Y,se){const le=new Se.ServerEnvironmentService(Y);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Ze=ke.join(process.env.HOMEDRIVE,"node_modules"),qe=ke.dirname(ke.join(process.env.HOMEDRIVE,process.env.HOMEPATH)),nt=ke.join(qe,"node_modules");if(m.existsSync(Ze)||m.existsSync(nt)){const tt=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Ze}
* ${nt}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;x(le).warn(tt),console.warn(tt),process.exit(0)}}const{connectionToken:we,connectionTokenIsMandatory:Te}=U(Y),Le=m.existsSync(o.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",Z).fsPath);Le&&X&&typeof X!="string"&&console.log(`Web UI available at http://localhost${X.port===80?"":`:${X.port}`}/?tkn=${we}`);const Ae=new q(le,we,Te,Le,se),$e=await Ae.initialize(),{telemetryService:He}=$e;L.mark("code/server/ready");const Ue=g.performance.now(),Xe=global.vscodeServerStartTime,Ke=global.vscodeServerListenTime,Qe=global.vscodeServerCodeLoadedTime;if(He.publicLog2("serverStart",{startTime:Xe,startedTime:Ke,codeLoadedTime:Qe,readyTime:Ue}),Y["print-startup-performance"]){const Ze=We.LoaderStats.get();let qe="";qe+=`

### Load AMD-module
`,qe+=We.LoaderStats.toMarkdownTable(["Module","Duration"],Ze.amdLoad),qe+=`

### Load commonjs-module
`,qe+=We.LoaderStats.toMarkdownTable(["Module","Duration"],Ze.nodeRequire),qe+=`

### Invoke AMD-module factory
`,qe+=We.LoaderStats.toMarkdownTable(["Module","Duration"],Ze.amdInvoke),qe+=`

### Invoke commonjs-module
`,qe+=We.LoaderStats.toMarkdownTable(["Module","Duration"],Ze.nodeEval),qe+=`Start-up time: ${Ke-Xe}
`,qe+=`Code loading time: ${Qe-Xe}
`,qe+=`Initialized time: ${Ue-Xe}
`,qe+=`
`,console.log(qe)}return Ae}e.createServer=D;const x=function(){let X;return function(se){return X||(X=new Be.SpdLogService(Ve.RemoteExtensionLogFileName,se.logsPath,a.getLogLevel(se))),X}}()}),define(he[239],de([0,1,23,21,8,225,228,57,2,229,68,47]),function(Z,e,y,m,I,E,C,L,g,t,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,_.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=t.performance.now();const P={onMultipleValues:(r,i)=>{console.error(`Option ${r} can only be defined once. Using value ${i}.`)},onUnknownOption:r=>{console.error(`Ignoring option ${r}: not supported for server.`)}},v=L.parseArgs(process.argv.slice(2),R.serverOptions,P),c=process.env.VSCODE_AGENT_FOLDER||g.join(y.homedir(),".vscode-remote"),d=g.join(c,"data"),S=g.join(d,"User"),b=g.join(S,"globalStorage"),f=g.join(d,"Machine");v["user-data-dir"]=d;const u=g.dirname(I.FileAccess.asFileUri("",Z).fsPath),a=g.join(u,"extensions");v["builtin-extensions-dir"]=a,v["extensions-dir"]=v["extensions-dir"]||g.join(c,"extensions"),[c,v["extensions-dir"],d,S,f,b].forEach(r=>{try{m.existsSync(r)||m.mkdirSync(r)}catch(i){console.error(i)}});function o(){E.run(v,c)}e.spawnCli=o;function n(r){return C.createServer(r,v,c)}e.createServer=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/622cb03f7e070a9670c94bae1a45d78d7181fbd4/core/vs/server/remoteExtensionHostAgent.js.map
